<?
/*
Filename: agents.php

Method: Direct
Output: Direct

Description: Shows list of agents within the website.

Author: Jeff Kee
*/
global $settings;

include 'start.php';
check_login(5);

$scriptinclude = 'agents.js';
//$folder = 'resources';
include 'header.php';

// First figure out if they are at (billable) agents cap or not.
if($settings['agent_classes']) {
	// agent_classes table is active, so we count agents under those tables.
	$count_query = array(
		'billable'=> 1,
		'publish'=> 1,
	);
} else {
	// agent_classes table is blank. ignore the billab. e
	$count_query = array(
		'publish'=> 1,
	);
}

$agent_count = list_agents($count_query, 'fname', 'ASC', 100000, 1, true, false);

$agent_limit = $settings['agents_limit'];

// default labels & css classes for the "add agent" button.
$agent_limit_class = '';
$allow_add = true;
$add_button_label = 'Add Realtor&reg;/Member';

if ($agent_count >= $agent_limit) {
    // count is over the limit for sure.
    $agent_limit_class = 'over_limit';
    if($settings['agent_classes']===false) {
        // agent classes not used, disable.
		$allow_add = false;
    } else {
		// agent classes is used, so still enable adding non-agent seats
		$allow_add = true;
		$add_button_label = 'Add Unlicensed Member';
    }
}

// this part validates whether the user is logged in as a administrator or not
?>

<div class="container">
	<div class="row">
		<div class="col-md-12">
			<h1 id="admin_page__title" class="text-center">Your Team of Agents</h1>
		</div>
	</div>

    <div class="row agent_limit">
        <div class="col-md-12">
            <h4 class="text-center  <?= $agent_limit_class ?>"> 
                <?= $agent_count ?> / <?= $agent_limit ?> Billable Seats Used
            </h4>
        </div>
    </div> 
     
	<div class="row">
		<div class="col-sm-4 col-sm-offset-4">
            <? if (!$allow_add) { ?>
                <div class="agentslist_legend" data-toggle="tooltip" data-placement="bottom" title="Email support for added extra agent seats & billing adjustment.">
                    <a class="btn btn-primary outgrown btn-block btn-lg bottom_20" href="mailto:support@brixwork.com" >We have outgrown!</a>
                </div>
            <? } else { ?>
                <a class="btn btn-primary btn-block btn-lg bottom_20" href="agents_mod.php?mode=new" ><span class="glyphicon glyphicon-plus"></span>&nbsp;<?=$add_button_label?></a>
            <? } ?>
		</div>
	</div>
    
	<div class="row">
		<div class="col-md-6">
			<div class="row form-group" id="agentslist_perpage">
				<div class="col-md-6 hidden-sm" id="agentslist_perpage_label">
					<p class="text-right hidden-xs hidden-sm">Agents Per Page:</p>
					<p class="text-center hidden-md hidden-lg">Agents Per Page:</p>
				</div>
				<div class="col-md-6 bottom_20">
					<select id="perpage" class="form-control">
						<option value="10">10 per page</option>
						<option value="20">20 per page</option>
						<option value="50">50 per page</option>
						<option value="100">100 per page</option>
					</select>
				</div>
			</div>
		</div>
		<div class="col-md-6">
			<div class="row bottom_20" id="agentslist_legends">
				<div class="col-sm-6 col-xs-12 agentslist_legend opacity50" data-toggle="tooltip" data-placement="bottom" title="These agents are hidden from public view at the moment.">
					<p class="text-left"><img src="holder.js/18x18/#aaa:#aaa" class="img-rounded" /> - Hidden Agent</p>
				</div>
				<div class="col-sm-6 col-xs-12 agentslist_legend " data-toggle="tooltip" data-placement="bottom" title="Critical data such as phone number or email are missing.">
					<p class="text-left"><img src="holder.js/18x18/#fcf8e3:#fcf8e3" class="img-rounded" /> - Missing Data</p>
				</div>
				
			</div>
		</div>
	</div>


	<div class="row bottom_20" id="agents_filter_container">
		<div class="col-md-1"><h6>Filter By:</h6></div>
		<div class="col-md-3">
			<label for="buildings_filter_name">First Name (starts with): </label>
			<input type="text" class="form-control agents_filter" id="agents_filter_fname" name="fname" placeholder="i.e. John" size="20" />
		</div>
		<div class="col-md-3">
			<label for="buildings_filter_street">Last Name (starts with): </label>
			<input type="text" class="form-control agents_filter" id="agents_filter_lname" name="lname" placeholder="i.e. Hasman" size="20" />
		</div>
		<div class="col-md-2">
			<label for="buildings_filter_street">Agent ID: </label>
			<input type="text" class="form-control agents_filter" id="agents_filter_agentid" name="agentid" placeholder="i.e. V0123" size="20" />
		</div>
		<div class="col-md-3">
			<label for="agents_filter_trigger">&nbsp;</label><div class="clearfix"></div>
			<button class="btn btn-primary btn-md" id="agents_filter_trigger">Filter</button>&nbsp;<button class="btn btn-danger btn-md" id="agents_filter_clear">Clear</button>
		</div>
	</div>

</div>


<div class="container" id="agentslist">
	<?
		// AJAX loaded list of homes here.
	?>
</div>

<?
// Delete agent on the fly
$deleteagent = "modifyagent('delete',window.agent_delete_id,1);";
modal_html('Delete?', '<p>Gonna be auto filled</p>', 'delete_agent', 'Delete', 'Not Yet', $deleteagent, '');
include 'footer.php';

?>
