<?php
/*
Filename: ajax_listagents.php

Method: AJAX
Output: AJAX/HTML

Description: Generates the agents list with wide icons that display each agent like a business card.

Author: Jeff Kee
*/
include 'start.php';

check_login(5);


$orderby = 'ord';

$ascordesc = 'ASC';

if($_REQUEST['perpage']!='') {
	$perpage = $_REQUEST['perpage'];
} else {
	$perpage = 10;
}

if($_REQUEST['page']!='') {
	$page = $_REQUEST['page'];
} else {
	$page = 1;
}

$orderby = 'ord';
$ascordesc = 'ASC';


if( isset($_REQUEST['filters']) && is_array($_REQUEST['filters']) && count($_REQUEST['filters'])>0) {
	$query = param_to_query($_REQUEST['filters']);
	$filters = true;
} else {
	$filters = false;
}

$destinationfolder = 'agents';
$destinationtable = 'agents';
$agents = list_agents($query, $orderby, $ascordesc, $perpage, $page);
$agentscount = list_agents($query, $orderby, $ascordesc, $perpage, $page, true, false);

if($agents==false) {
	echo '<div class="row"><div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-6 col-sm-offset-3 col-xs-12" style="padding-top:50px;">';
	echo alert_display('<p><strong>No Agents yet!</strong> Use the New Agent button above to enter your first team member.</p>', 'warning');
	echo '
	</div>
	</div>
	';
} else {
	$sum = $agentscount;
	$numpages = ceil($sum/$perpage);
	$count = 1;
	$end = $numpages; 
	$pagelinkshtml = '<div class="row"><div class="col-md-12 text-center"><div class="btn-group pagination-centered bottom_20" role="toolbar" aria-label="agents pages">';
	while($count<=$end) {
		if($page==$count) {$addclass = 'primary';} else {$addclass='default';}
		$pagelinkshtml.='<button type="button" href="#" class="btn btn-'.$addclass.' agents_pagelink" rel="'.$count.'">'.$count.'</button>';
		$count++;
	}
	$pagelinkshtml.= '</div></div></div>'; // close .row, .col-md-12, .btn-group all in one go.
	echo $pagelinkshtml; // spit out the pagelink HTML and be done with it. 
	/* END OF PAGE LINKS FOR NAV */
		
	
	echo '<div class="row"><div class="col-md-12" id="agentscontainer">'; // open .row and #homestable
	foreach($agents as $value) {
		$thisagent = new agent;
		$thisagent->initialize($value);
		
		$addclass = '';
		
		if($thisagent->publish==1) {
			$addclass .= ' agent_publish';
		}
		
		if($thisagent->email=='' || $thisagent->cell=='') {
			// OWN LISTING without photos, so ask for photos.
			$addclass .= ' agent_missingdata';
		}

		if($filters===false) {
			$imgclass = array('img-responsive', 'orderhandle');
		} else {
			$imgclass = array('img-responsive');
		}

		echo '<div class="row bottom_20 agent_row '.$addclass.'" id="agent_'.$thisagent->id.'">';
		
		echo '<div class="col-md-2 bottom_20">
			'.$thisagent->get_main_images(0, 640, 460, $settings['sitepath'].'admin/images/noimage.jpg', $imgclass).'
		</div>';
		
		echo '<div class="col-md-6">
			<h2>'.$thisagent->displayname.'</h2>
			<h4 class="bottom_20">'.$thisagent->position.'</h4>
			<h5 class="bottom_20">'.$thisagent->agentid.'</h5>
			<p class="agent_social">
			'.($thisagent->facebook!='' ? '<a href="'.$thisagent->facebook.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View Facebook Page"><img src="'.$settings['sitepath'].'admin/images/facebook_grey.png" /></a> ' : '').'
			'.($thisagent->linkedin!='' ? '<a href="'.$thisagent->linkedin.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View LinkedIn Page"><img src="'.$settings['sitepath'].'admin/images/linkedin_grey.png" /></a> ' : '').'
			'.($thisagent->twitter!='' ? '<a href="https://twitter.com/'.$thisagent->twitter.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View Twitter Page"><img src="'.$settings['sitepath'].'admin/images/twitter_grey.png" /></a> ' : '').'
			'.($thisagent->googleplus!='' ? '<a href="'.$thisagent->googleplus.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View Google+ Page"><img src="'.$settings['sitepath'].'admin/images/googleplus_grey.png" /></a> ' : '').'
			'.($thisagent->youtubechannel!='' ? '<a href="'.$thisagent->youtubechannel.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View Youtube Page"><img src="'.$settings['sitepath'].'admin/images/youtube_grey.png" /></a> ' : '').'
			'.($thisagent->pinterest!='' ? '<a href="'.$thisagent->pinterest.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View Pinterest Page"><img src="'.$settings['sitepath'].'admin/images/pinterest_grey.png" /></a> ' : '').'
			'.($thisagent->instagram!='' ? '<a href="'.$thisagent->instagram.'" target="_blank" data-toggle="tooltip" data-placement="bottom" title="View Instagram Page"><img src="'.$settings['sitepath'].'admin/images/instagram_grey.png" /></a> ' : '').'
			</p>
		</div>';
		
		echo '<div class="col-md-4">
			<h5>Contact '.$thisagent->fname.'</h5>
			<p>
				'.($thisagent->cell!='' ? '<strong><a href="tel:'.$thisagent->cell.'">'.$thisagent->cell.'</a></strong><br />' : '').'
				'.($thisagent->email !='' ? '<strong><a href="mailto:'.$thisagent->email.'">'.$thisagent->email.'</a></strong><br />' : '').'
			</p>
			
		</div>';
		
		echo '<div class="clearfix"></div>'; // clear it all before next row of BUTTONS

		echo '<div class="col-md-2"><a class="btn btn-primary btn-block" href="mainimage.php?idr='.$thisagent->id.'&folder='.$destinationfolder.'"><span class="glyphicon glyphicon-picture"></span>&nbsp;&nbsp;Lead Photo</a></div>'; // PDF & Videos button

		echo '<div class="col-md-2"><a class="btn btn-primary btn-block" href="attach.php?idr='.$thisagent->id.'&folder='.$destinationfolder.'"><span class="glyphicon glyphicon-tags"></span>&nbsp;&nbsp;Attachments</a></div>'; // PDF & Videos button

		echo '<div class="col-md-2 col-xs-6 hidden-xs bottom_10"><a class="btn btn-primary btn-block" href="gallery.php?idr='.$thisagent->id.'&folder='.$destinationfolder.'"><span class="glyphicon glyphicon-camera"></span>&nbsp;&nbsp;Gallery <span class="badge">'.($thisagent->photos ? count($thisagent->photos) : '0').'</span></a></div>';

		switch ($thisagent->publish) {
			case 0:
			$hiddenselected = " selected";
			$publishedselected = "";
			break;
		
			case 1:
			$hiddenselected = "";
			$publishedselected = " selected";
			break;
		}
		
		echo '<div class="col-md-2"><select class="form-control agent_publish_toggle" rel="'.$thisagent->id.'">
		<option value="0"'.$hiddenselected.'>Hidden</option>
		<option value="1"'.$publishedselected.'>Published</option>
		</select></div>'; // publish toggle
		
		
		echo '<div class="col-xs-2"><a class="btn btn-default" href="agents_mod.php?idr='.$thisagent->id.'&mode=modify"><span class="glyphicon glyphicon-pencil"></span>&nbsp;&nbsp;Edit</a>&nbsp;<a class="btn btn-danger agent_delete" href="#" rel="'.$thisagent->id.'"><span class="glyphicon glyphicon-minus"></span></a></div>'; // home edit button and delet buttons
	
		echo '</div>'; // end of .row	
	}
	
	echo "</div></div>"; // close .row and #homestable
	
	echo $pagelinkshtml;
}

require_once 'ajax_footer.php';
?>

