<?php
/*
Filename: ajax_listareas.php

Method: AJAX
Output: AJAX/HTML

Description: Lists all areas & subareas, expandable via click right away. 

Author: Jeff Kee
*/
include 'start.php';

check_login($login_lv);
$destinationfolder = 'areas';
$destinationtable = 'areas';
	
$areas = get_areas();
	
if ( $areas==false ):
	echo '<div class="row"><div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-6 col-sm-offset-3 col-xs-12" style="padding-top:50px;">';
	echo alert_display('<p><strong>No Areas yet!</strong> We can start by adding your first one!</p>', 'warning');
	echo '
	</div>
	</div>';

else:

	foreach ($areas as $areaid):
		$thisarea = new area;
		$thisarea->initialize($areaid);
		$thisarea->get_num_listings();
		
		$addclass = '';// start with blank.
		
		if($thisarea->publish==1) {
			$addclass .= ' areas_publish';
		}
			
		if($thisarea->feature==1) {
			$addclass .= ' areas_feature';
		}
		
		echo '<div class="row areas_row '.$addclass.'" id="area_'.$thisarea->id.'">';
		
		echo '<div class="col-sm-5 col-xs-10"><p>
		<a rel="'.$thisarea->id.'" class="btn btn-default btn-xs areas_toggle" id="areas_toggle_'.$thisarea->id.'"><span class="glyphicon glyphicon-plus"></span></a>&nbsp;&nbsp;
		<span class="area_title">'.$thisarea->name.'</span>
		
		</p></div>';
		
		echo '<div class="col-sm-2 col-xs-2"><p>';
		echo '<a href="subareas_mod.php?mode=new&area='.$thisarea->id.'" class="btn btn-primary btn-xs add_new_subarea_button" rel="'.$thisarea->id.'">&nbsp;<span class="glyphicons glyphicon-plus"></span><span class="hidden-xs">&nbsp;&nbsp;Add Subarea</span>&nbsp;</a>';
		echo '</p></div>';
		
		echo '<div class="col-sm-5 col-xs-12 areas_functions form-inline">
			<p>
			<a class="btn btn-warning btn-sm area_mod" href="areas_mod.php?idr='.$thisarea->id.'&mode=modify" rel="'.$thisarea->id.'"><span class="glyphicon glyphicon-pencil"></span>&nbsp;&nbsp;Edit</a>&nbsp;
		
			<button class="btn btn-danger btn-sm area_delete" href="#" rel="'.$thisarea->id.'" '.($thisarea->numlistings>0 ? ' data-toggle="tooltip" data-placement="bottom" title="There are '.$thisarea->numlistings.' listings under '.$thisarea->name.', it cannot be deleted."' : '').' data-numlistings="'.$thisarea->numlistings.'"><span class="glyphicon glyphicon-minus"></span></button>';
		
		switch ($thisarea->feature) {
			case 0:
			$hiddenselected = " selected";
			$publishedselected = "";
			break;
		
			case 1:
			$hiddenselected = "";
			$publishedselected = " selected";
			break;
		}
		
		echo '
			<select class="form-control input-xs area_feature_toggle '.$selectclass.'" rel="'.$thisarea->id.'">
			<option value="0"'.$hiddenselected.'>-</option>
			<option value="1"'.$publishedselected.'>Featured</option>
			</select>
		'; // publish toggle
		
		switch ($thisarea->publish) {
			case 0:
			$hiddenselected = " selected";
			$publishedselected = "";
			break;
		
			case 1:
			$hiddenselected = "";
			$publishedselected = " selected";
			break;
		}
		
		echo '
			<select class="form-control input-xs area_publish_toggle '.$selectclass.'" rel="'.$thisarea->id.'">
			<option value="0"'.$hiddenselected.'>Hidden</option>
			<option value="1"'.$publishedselected.'>Published</option>
			</select>
		'; // publish toggle
		
		
		echo '</p></div>';
		
		$subareas = get_subareas($thisarea->id);
		
		if($subareas) {
			echo '<div class="col-md-12 col-xs-12 subareas_set" id="subareas_'.$thisarea->id.'" rel="'.$thisarea->id.'">';
			foreach ($subareas as $subarea) {
				$thissubarea = new subarea;
				$thissubarea->initialize($subarea);
				$thissubarea->get_num_listings();
				// display the sub-items!
				$addclass = '';// start with blank.
				if($thisarea->publish==1) {
					// each subarea doesn't get its own publish status, so go with the parent area. 
					$addclass .= ' areas_publish';
				}
				echo '<div class="row subareas_row '.$addclass.'" id="subarea_'.$thissubarea->id.'">';
			
				echo '<div class="col-md-7 col-xs-12"><p class="subareas_label">
				<span class="subarea_title">'.$thissubarea->name.'</span>
				</p></div>';
				
				
				echo '<div class="col-md-5 col-xs-12 subareas_buttons form-inline">
				<p>
						
						<a class="btn btn-warning btn-sm" href="subareas_mod.php?idr='.$thissubarea->id.'&mode=modify"><span class="glyphicon glyphicon-pencil"></span><span class="hidden-xs">&nbsp;&nbsp;Edit</span></a>&nbsp;
						
						<a class="btn btn-danger btn-sm subarea_delete" href="#" rel="'.$thissubarea->id.'" '.($thissubarea->numlistings>0 ? ' data-toggle="tooltip" data-placement="bottom" title="There are '.$thissubarea->numlistings.' listings under '.$thissubarea->name.', it cannot be deleted."' : '').' data-numlistings="'.$thissubarea->numlistings.'"><span class="glyphicon glyphicon-minus"></span></a>
					</p>
				</div>';
				
				echo '</div>';
			}
			echo '</div>';
		}

		echo "</div>";
	endforeach;
endif;

require_once 'ajax_footer.php';

