<?
/*
Filename: ajax_listbuildinglist.php

Method: AJAX (from homes_mod.php and buildings.php) 
Output: JSON

Description: Returns a list of buildings that match the number, street & city search set. 
used in the Homes mod screen to find buildings that match the entry, OR for the buildings list screen for adding (featuring) new buildings. 

Author: Jeff Kee
*/

include 'start.php';

check_login(0);
$destinationfolder = 'buildings';
$destinationtable = 'buildings';
if(
	($_REQUEST['street']!='' && $_REQUEST['number']!='' && $_REQUEST['city'])
	||
	$_REQUEST['name']!=''
	||
	$_REQUEST['mainid']!=''
) { // min required variables!

	if($_REQUEST['name']!='' ) {
		$query['name'] = $_REQUEST['name'];
	} else if($_REQUEST['mainid']) {
		$query['id'] = $_REQUEST['mainid'];
		$getsubbuildings = true;
	} else {
		$street_array = separate_streetname(trim($_REQUEST['street']));
		//returns array($streetname, $streettype, $street_dir, $street_suffix);
		$query['street'] = $street_array[0];
		$query['number'] = $_REQUEST['number'];
		if($_REQUEST['street_dir']!='') {
			$query['street_dir'] = $_REQUEST['street_dir'];
		}
		$query['city'] = $_REQUEST['city'];
	}
	$barray = get_buildings($query, array('name', 'street', 'number'), array('ASC', 'ASC', 'ASC'), 10, 1, false, true);

	// we need sub-buildings so run from previous $barray for NEW array!
	if($getsubbuildings==true) {
		// just got a mainid, so means return the SUB buildings as array!
		$mainbuilding = new building;
		$mainbuilding->initialize($barray[$query['id']]['id'], $barray[$query['id']]); // only one result for top building, presumably. 
		$barray = $mainbuilding->load_subbuildings(); // override with subbuildings for barray!

	}

	if(!$barray) {
		$count = 0;
		$buildings = '';
		// $dropdown = '<option value="">Select a Building</option>';
	} else {
		$count = count($barray);
		$bcount=0;

		foreach($barray as $bkey => $bid) {
			$thisbuilding = new building;
			if(is_array($bid)) {
				// if data is fed.
				$thisbuilding->initialize($bkey, $bid);
			} else {
				// only ID
				$thisbuilding->initialize($bid);
			}

			$thisbuilding->load_subbuildings();
			$buildings[$bcount] = array(
				'value' => $thisbuilding->id,
				'id' => $thisbuilding->id,
				'selected' => ($_REQUEST['buildingid']==$thisbuilding->id ? true : false),
				'display' => ($thisbuilding->defaultname!=true ? $thisbuilding->name.' ('.$thisbuilding->address.')' : $thisbuilding->name),
				'city'=> $thisbuilding->city,
				'area'=> $thisbuilding->area,
				'feature'=>$thisbuilding->feature,
				'mainid'=>$thisbuilding->mainid,
				'subids'=>$thisbuilding->subids
			);
			$bcount++;
		}


	}
} else {
	$count = 0;
	$buildings = '';
}

$json_array = array('count'=>$count, 'buildings'=>$buildings);
echo json_encode($json_array);


require_once 'ajax_footer.php';

?>

