<?php
/*
Filename: ajax_listbuildinglist.php

Method: AJAX (from homes_mod.php and buildings.php) 
Output: HTML

Description: Returns a list of buildings that match the number, street & city search set. 
used in the Homes mod screen to find buildings that match the entry, OR for the buildings list screen for adding (featuring) new buildings. 

Author: Jeff Kee
*/

include 'start.php';

check_login($loginlevel);
$destinationfolder = 'buildings';
$destinationtable = 'buildings';

$query['feature'] = 1;

if( isset($_REQUEST['filters']) && is_array($_REQUEST['filters']) && count($_REQUEST['filters'])>0) {
	$filters = param_to_query($_REQUEST['filters']);
	$query = array_merge($query, $filters);
} else {
	$filters = false;
}

// $_REQUEST['debug'] = 1;

$orderby = 'ord';
$ascordesc = 'ASC';
$perpage = ($_REQUEST['perpage']!='' ? $_REQUEST['perpage'] : 10);
$page = ($_REQUEST['page']!='' ? $_REQUEST['page'] : 1);

$buildings 		= get_buildings($query, $orderby,$ascordesc,$perpage,$page);
$buildingscount = get_buildings($query,$orderby,$ascordesc,$perpage,$page, true);

if(!$buildings) {
	echo '<div class="row"><div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-6 col-sm-offset-3 col-xs-12" style="padding-top:50px;">';
	echo alert_display('<p><strong>No featured buildings!</strong> You need to set up some buildings to feature on your site. Note that not all websites are equipped with the building feature.</p>', 'warning');
	if($settings['mls_integrated']==1) {
		echo '<p>Many buildings may already be in your database as per the MLS&reg; feed. Please use the search tool above to find out.</p>';
	}
	echo '
	</div>
	</div>
	';
} else {
	$sum = $buildingscount;
	$numpages = ceil($sum/$perpage);
	$count = 1;
	$end = $numpages;
	$pagelinkshtml = '<div class="row"><div class="col-md-12 text-center"><div class="btn-group pagination-centered bottom_20" role="toolbar" aria-label="homes pages">';
	while($count<=$end) {
		if($page==$count) {$addclass = 'primary';} else {$addclass='default';}
		$pagelinkshtml.='<button type="button" href="#" class="btn btn-'.$addclass.' buildings_pagelink" rel="'.$count.'">'.$count.'</button>';
		$count++;
	}
	$pagelinkshtml.= '</div></div></div>'; // close .row, .col-md-12, .btn-group all in one go.
	echo $pagelinkshtml; // spit out the pagelink HTML and be done with it. 
	/* END OF PAGE LINKS FOR NAV */
	
	echo '<div class="row"><div class="col-md-12" id="buildingstable">'; // open .row and #homestable
	
	$row=0;
	$taborder=1;
	foreach($buildings as $bid){
		$thisbuilding = new building;
		$thisbuilding->initialize($bid);
		//$thisbuilding->get_listings();
		
		$addclass = '';
		
		if($thisbuilding->feature==1) {
			$addclass .= ' home_feature';
		}
		
		if($thisbuilding->publish==1 || true) {
			$addclass .= ' home_publish'; // for now, all homes are published by default!
		}
		
		if($thisbuilding->data['status']!=0) { // 0 means active, no longer presale stage.
			$addclass .= ' home_sold'; // to keep classes consistent, we'll still use home_sold for the red. 
		}
		
		if($thisbuilding->photos==false && $thisbuilding->feature==1) {
			// featured building without photos, so ask for it!
			$addclass .= ' home_nophotos';
		}
		
		echo '<div class="row bottom_5 home_row '.$addclass.' source_0" id="building_'.$thisbuilding->id.'">'; // start .row for each home #id
			if($filters===false) {
				$imgclass = array('img-responsive', 'orderhandle');
			} else {
				$imgclass = array('img-responsive');
			}
			echo '<div class="col-sm-1 col-xs-2 home_main_image">'.$thisbuilding->get_main_images(0, 640, 460, $settings['sitepath'].'admin/images/noimage.jpg', $imgclass).'</div>'; // major photo grid. note the class orderhandle on <a> allows reorder.

			echo '<div class="col-sm-11 col-xs-10 home_brief">';
				echo '<div class="row">';
				echo '<div class="col-sm-8"><p class="home_address"><a href="'.$thisbuilding->get_building_link($settings['urltrail'],$base='listings/').'">'.($thisbuilding->defaultname ? $thisbuilding->address : $thisbuilding->name.' ('.$thisbuilding->address.')').', '.$thisbuilding->areacity.'</a></p></div>';
				echo '<div class="col-sm-4">
						<small><!--<span class="label label-'.($thisbuilding->numlistings>0 ? 'success' : 'warning').'">'.($thisbuilding->numlistings>0 ? $thisbuilding->numlistings.' Listings' : 'No Listings').'</span>-->
					'.($thisbuilding->subids ? '<span class="label label-default">'.count($thisbuilding->subids).' Sub-Buildings</span>' : '').'
					'.($thisbuilding->rental===true || $thisbuilding->rental===false ? '<span class="label label-'.($thisbuilding->rental==true ? 'success' : 'info').' building_rental">'.($thisbuilding->rental===true ? 'Rentals Allowed</span>': 'No Rentals').'</span>': '').'
					'.($thisbuilding->pets===true || $thisbuilding->pets===false ? '<span class="label label-'.($thisbuilding->pets==true ? 'success' : 'info').' building_pets">'.($thisbuilding->pets===true ? 'Pets Allowed</span>': 'No Pets').'</span>': '').'
					</small>
				</div>';
				echo '</div>';
			echo '</div>';// end of .home_brief.

			echo '<div class="col-sm-11 col-xs-10 home_controls">';
				echo '<div class="row">';
					echo '<div class="col-sm-4 col-xs-3">
							<a class="btn btn-primary btn-xs" href="mainimage.php?idr='.$thisbuilding->id.'&folder='.$destinationfolder.'"><span class="glyphicon glyphicon-picture"></span><span class="hidden-xs">&nbsp;&nbsp;Lead Photos</span></a>
							<a class="btn btn-primary btn-xs" href="gallery.php?idr='.$thisbuilding->id.'&folder='.$destinationfolder.'"><span class="glyphicon glyphicon-camera"></span><span class="hidden-xs">&nbsp;&nbsp;Gallery</span> <span class="badge hidden-xs">'.($thisbuilding->photos ? count($thisbuilding->photos) : '0').'</span></a>
							<a class="btn btn-primary btn-xs" href="attach.php?idr='.$thisbuilding->id.'&folder='.$destinationfolder.'"><span class="glyphicon glyphicon-tags"></span><span class="hidden-xs">&nbsp;&nbsp;Attach</span></a>
						</div>';

					echo '<div class="col-sm-4 col-xs-5">';
						echo '<select class="form-control building_status_toggle" rel="'.$thisbuilding->id.'">';
						$statusmax = 5;
						$statuscount = 0;
						while($statuscount<$statusmax) {
							echo '<option value="'.$statuscount.'"'.($thisbuilding->data['status']==$statuscount ? 'selected="selected"': '').'>'.$settings['building_status_display'][$statuscount].'</option>';
							$statuscount++;
						}
						echo '
						</select>&nbsp;';
						switch ($thisbuilding->feature) {
							case 0:
								$notfeaturedselected = " selected";
								$featuredselected = "";
								break;

							case 1:
								$notfeaturedselected = "";
								$featuredselected = " selected";
								break;
						}

						echo '<select class="form-control building_feature_toggle" rel="'.$thisbuilding->id.'" data-toggle="tooltip" data-placement="bottom" title="Un-featuring building will simply hide it from your featured building pages, but will not remove the whole building.">
							<option value="0"'.$notfeaturedselected.'>Not Featured</option>
							<option value="1"'.$featuredselected.'>Featured</option>
						</select>';

					echo '</div>';
					echo '<div class="col-sm-4 col-xs-4">';
						echo '<a href="'.generateQrCode($thisbuilding->get_building_link($settings['urltrail'],'listings/')).'" class="btn btn-default btn-xs hidden-xs" target="_blank" data-toggle="tooltip" data-placement="bottom" title="Generate a direct QR code"><span class="glyphicon glyphicon-qrcode"></span></a>';
						echo '<a class="btn btn-default btn-xs" href="buildings_mod.php?idr='.$thisbuilding->id.'&mode=modify"><span class="glyphicon glyphicon-pencil"></span><span class="hidden-xs">&nbsp;&nbsp;Edit</span></a>';

						$dupids = $thisbuilding->get_duplicate_buildings();
						if($dupids!==false) {
							foreach($dupids as $dupid) {
								unset($dupbuilding);
								$dupbuilding = new building;
								$dupbuilding->initialize($dupid);
								$dupbuilding->get_listings();
								echo '<input type="hidden" class="dupbuilding_'.$thisbuilding->id.'" name="dupbuilding['.$thisbuilding->id.']" value="'.$dupbuilding->id.'" rel="'.$thisbuilding->id.'" data-address="'.$dupbuilding->address.'" data-numlistings="'.$dupbuilding->numlistings.'" '.($dupbuilding->defaultname!==true ? ' data-bname="'.$dupbuilding->name.'"' : ' data-bname=""').' data-description="'.limit_string_at_space(strip_tags($dupbuilding->desc), 50, '&hellip;').'" data-mainimage="'.$dupbuilding->get_main_images_path(0, $settings['sitepath'].'admin/images/noimage.jpg').'" />'; // field with IDs to denote
							}
						}

						echo ($dupids ? '<a class="btn btn-xs btn-danger dupbuilding_resolve" rel="'.$thisbuilding->id.'">'.count($dupids).' Duplicates</a>' : '&nbsp;');

					echo '</div>';
				echo '</div>'; // end of .row within .home_controls.
			echo '</div>'; // end of .home_controls
		echo '</div>'; // end of .home_row
	}
	echo "</div></div>"; // close .row and #buildingstable
	echo $pagelinkshtml;
}

require_once 'ajax_footer.php';
?>
