<?php
/*
Filename: ajax_listhomes.php

Method: AJAX
Output: AJAX HTML

Description: Generates the homes list with wide icons that display each home, edit/photo attachment screens etc. This is called in by the homes.php screen, fully HTML'd results. Not suitable for other purposes such as the MLS search. 

Author: Jeff Kee
*/
include 'start.php';

check_login(0);
$destinationfolder = 'homes';
$destinationtable = 'homes';

// $query['source'] = 0; // no longer doing source 0 only, now doing all featured. 
$query['ownlisting'] = 1; // source=0 or feature=1 listings!

if( isset($_REQUEST['filters']) && is_array($_REQUEST['filters']) && count($_REQUEST['filters'])>0) {
	$filters = param_to_query($_REQUEST['filters']);
	$query = array_merge($query, $filters);
} else {
	$filters = false;
}

$orderby = 'ord';
$ascordesc = 'ASC';
$perpage = ($_GET['perpage']!='' ? $_GET['perpage'] : 10);
$page = ($_GET['page']!='' ? $_GET['page'] : 1);

$homes = get_properties('',$query,$orderby,$ascordesc,$perpage,$page);
$homescount = get_properties('',$query,$orderby,$ascordesc,$perpage,$page, true);



if($homes==false) {

	echo '<div class="row"><div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-6 col-sm-offset-3 col-xs-12" style="padding-top:50px;">';
	echo alert_display('<p><strong>No listings yet!</strong> Seems like you don\'t have any of your own listings yet.</p>', 'warning');
	if($settings['mls_integrated']!=1) {
		echo '<p>Before you add your first listing, please check out the <a href="admin_findarea.php">Areas section</a> to make sure you have the right city and sub-areas ready to drop your home into.</p>';
	}
	echo '
	</div>
	</div>
';

} else {
	/* PAGE LINKS FOR NAV */
	$sum = $homescount;
	$numpages = ceil($sum/$perpage);
	$count = 1;
	$end = $numpages;
	$pagelinkshtml = '<div class="row"><div class="col-md-12 text-center"><div class="btn-group pagination-centered bottom_20" role="toolbar" aria-label="homes pages">';
	while($count<=$end) {
		if($page==$count) {$addclass = 'primary';} else {$addclass='default';}
		$pagelinkshtml.='<button type="button" href="#" class="btn btn-'.$addclass.' homes_pagelink" rel="'.$count.'">'.$count.'</button>';
		$count++;
	}
	$pagelinkshtml.= '</div></div></div>'; // close .row, .col-md-12, .btn-group all in one go.
	echo $pagelinkshtml; // spit out the pagelink HTML and be done with it.
	/* END OF PAGE LINKS FOR NAV */
	echo '<div class="row"><div class="col-md-12" id="homestable">'; // open .row and #homestable
	foreach($homes as $homeid){
		$analytics = gAnalytics($homeid,true);
		$thishome = new home;
		$thishome->initialize($homeid);

		$addclass = '';

		if($thishome->feature==1) {
			$addclass .= ' home_feature';
		}

		if($thishome->publish==1) {
			$addclass .= ' home_publish';
		}

		if($thishome->sold!=0) {
			$addclass .= ' home_sold';
		}

		if($thishome->photos==false && $thishome->source==0) {
			// OWN LISTING without photos, so ask for photos.
			$addclass .= ' home_nophotos';
		}


		echo '<div class="row bottom_5 home_row '.$addclass.' source_'.$thishome->source.'" id="home_'.$thishome->id.'">'; // start .row for each home #id

		if($filters===false) {
			$imgclass = array('img-responsive', 'orderhandle');
		} else {
			$imgclass = array('img-responsive');
		}

		echo '<div class="col-sm-1 col-xs-2 home_main_image">'.$thishome->get_main_images(0, 320, 230, $settings['sitepath'].'admin/images/noimage.jpg', $imgclass).'</div>'; // major photo grid. note the class orderhandle on <a> allows reorder.

		echo '<div class="col-sm-11 col-xs-10 home_brief">';

			echo '<div class="row">';
			// critical info.. address label etc.
				if($_COOKIE['username'] == 'brixwork') {
					echo '<div class="col-sm-4 col-xs-12"><p class="home_address"><a href="'.$thishome->get_property_link($settings['url_trail']).'" target="_blank">'.$thishome->fulladdress.'</a>'.($thishome->building!='' ? '<p class="home_building"> in <a href="buildings_mod.php?idr='.$thishome->bldg->id.'&mode=modify" data-toggle="tooltip" data-placement="bottom" title="Edit this building">'.$thishome->building.'</a></p>' : '').'</p></div>';

					echo '<div class="col-sm-3 col-xs-12"><p class="gaCount">'.(($analytics) ? '<a href="javascript:;" class="gaSummary" data-id="'.$thishome->id.'">'.$analytics.' visits in the last 7 days</a>' : '').'</p></div>';
				} else {
					echo '<div class="col-sm-7 col-xs-12"><p class="home_address"><a href="'.$thishome->get_property_link($settings['url_trail']).'" target="_blank">'.$thishome->fulladdress.'</a>'.($thishome->building!='' ? '<p class="home_building"> in <a href="buildings_mod.php?idr='.$thishome->bldg->id.'&mode=modify" data-toggle="tooltip" data-placement="bottom" title="Edit this building">'.$thishome->building.'</a></p>' : '').'</p></div>';
				}
				echo '<div class="col-sm-2 col-xs-4"><p>
					'.($thishome->mls!='' ? '<strong>'.$thishome->mls.'</strong>' : 'No MLS&reg; #').'
					</p></div>';
				echo '<div class="col-sm-3 col-xs-8">
					<p><span class="home_price">'.($thishome->for_rent ? $thishome->rental_price_display : $thishome->data['price']).'</span><span class="home_type">'.$thishome->type.'</span>
					
					'.($_COOKIE['username'] == 'brixwork' ? '<a class="btn btn-info btn-xs home_debug" href="home_debug.php?idr='.$thishome->id.'" target="_blank">Debug '.$thishome->id.'</a>' : '').'</p>

					</div>';
			echo '</div>'; // end of .row under .home_brief.

		echo '</div>'; // .. end of .home_brief

		echo '<div class="col-sm-11 col-xs-10 home_controls">';
			// all the buttons, dropdowns etc.

			// get publish seleted ready.
			switch ($thishome->publish) {
				case 0:
					$hiddenselected = " selected";
					$publishedselected = "";
					break;

				case 1:
					$hiddenselected = "";
					$publishedselected = " selected";
					break;
			}
			// get SOLD seleted ready.
			switch ($thishome->sold) {
				case 0:
					$activeselected = " selected";
					$soldselected = "";
					$bothselected = "";
					break;

				case 1:
					$activeselected = "";
					$soldselected = " selected";
					$bothselected = "";
					break;

				case 2:
					$activeselected = "";
					$soldselected = "";
					$bothselected = " selected";
					break;
			}
			// get publish FEATURE ready.
			switch ($thishome->feature) {
				case 0:
					$notfeaturedselected = " selected";
					$featuredselected = "";
					break;

				case 1:
					$notfeaturedselected = "";
					$featuredselected = " selected";
					break;
			}


			echo '<div class="row">';
				echo '<div class="col-sm-4 col-xs-3">
					'.($thishome->source==0 ? '
					<a class="btn btn-primary btn-xs" href="mainimage.php?idr='.$thishome->id.'&folder='.$destinationfolder.'">
						<span class="glyphicon glyphicon-picture"></span>
						<span class="hidden-xs">&nbsp;&nbsp;Lead Photos</span>
					</a>
					<a class="btn btn-primary btn-xs" href="gallery.php?idr='.$thishome->id.'&folder='.$destinationfolder.'">
						<span class="glyphicon glyphicon-camera"></span>
						<span class="hidden-xs">&nbsp;&nbsp;Gallery</span> <span class="badge hidden-xs">'.($thishome->photos ? count($thishome->photos) : '0').'</span>
					</a>
					<a class="btn btn-primary btn-xs" href="attach.php?idr='.$thishome->id.'&folder='.$destinationfolder.'">
						<span class="glyphicon glyphicon-tags"></span>
						<span class="hidden-xs">&nbsp;&nbsp;Attach</span>
						'.($thishome->video_exists() ? ' <span class="glyphicon glyphicon-play-circle"></span>' : '').'
						'.($thishome->floorplan_exists() || $thishome->featuresheet_exists() ? ' <span class="glyphicon glyphicon-print"></span>' : '').'
					</a>' : '<p class="home_brokerage hidden-xs">'.$thishome->providedby.'</p>').'<a href="'.generateQrCode($thishome->get_property_link($settings['url-trail']), 450).'" class="btn btn-default btn-xs mobile_qr_button" target="_blank" data-toggle="tooltip" data-placement="bottom" title="Generate a direct QR code"><span class="glyphicon glyphicon-qrcode"></span></a>
					
					</div>';
				
				// echo '<div class="col-sm-2">'.($thishome->source==0 ?  '' : '&nbsp;').'</div>';
				echo '<div class="col-sm-5 col-xs-5">';
				echo ($thishome->source==0 ? '<select class="form-control home_publish_toggle" rel="'.$thishome->id.'">

		<option value="0"'.$hiddenselected.'>Hidden</option>
		<option value="1"'.$publishedselected.'>Published</option>
		</select>&nbsp;': '');

		echo ($thishome->source==0 ? '<select class="form-control  home_sold_toggle" rel="'.$thishome->id.'">
		<option value="0"'.$activeselected.'>Active</option>
		<option value="1"'.$soldselected.'>Sold</option>
		<option value="2"'.$bothselected.'>Show On Both</option>
		</select>&nbsp;' : '');
		echo '<select class="form-control home_feature_toggle" rel="'.$thishome->id.'" '.($thishome->source==1 ? 'data-toggle="tooltip" data-placement="bottom" title="Un-featuring an MLS&reg; featured item that is not your own will simply take it off your feature pages."' : '').'>
			<option value="0"'.$notfeaturedselected.'>Not Featured</option>
			<option value="1"'.$featuredselected.'>Featured</option>
		</select>';
		echo '</div>';


		echo '<div class="col-sm-3 col-xs-4"><a href="'.generateQrCode($thishome->get_property_link($settings['url-trail']), 450).'" class="btn btn-default btn-xs hidden-xs" target="_blank" data-toggle="tooltip" data-placement="bottom" title="Generate a direct QR code"><span class="glyphicon glyphicon-qrcode"></span></a>'.($thishome->source==0 ? '<a class="btn btn-default btn-xs" href="homes_mod.php?idr='.$thishome->id.'&mode=modify"><span class="glyphicon glyphicon-pencil"></span><span class="hidden-xs">&nbsp;&nbsp;Edit</span></a><a class="btn btn-danger btn-xs home_delete" href="#" rel="'.$thishome->id.'"><span class="glyphicon glyphicon-minus"></span><span class="hidden-xs">&nbsp;&nbsp;Delete</span></a>' : '').'</div>';
		echo '</div>';
		echo '</div>';  // .. end of .home_controls

		echo '</div>'; // end .row for each home #id
	}


	echo "</div></div>"; // close .row and #homestable

	echo $pagelinkshtml;
}

require_once 'ajax_footer.php';
?>

