<?php
/*
Filename: ajax_listlinks.php

Method: AJAX
Output: AJAX/JSON

Description: Master file that loads up the buildings list, as well as the buildings quick search module to help users organize & choose buildings to feature on the website. 

Author: Jeff Kee
*/

include 'start.php';

//$folder = 'resources';

check_login($loginlevel);

$destinationfolder = 'resources'; // although the primary query is through the resourcecategories table, the resources is the money table anyway.
$destinationtable = 'resources';

$linkssql = "SELECT * FROM `resourcecategories` WHERE `id`!='' ORDER BY `ord` ";
$linksresult = $mysqli->query($linkssql);

$categories = get_resource_link_categories('','','',false, true);

if($linksresult==false) {
	echo '<div class="row"><div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-6 col-sm-offset-3 col-xs-12" style="padding-top:50px;">';
	echo alert_display('<p><strong>No Resource Categories yet!</strong> We can start by adding your first one!</p>', 'warning');
	echo '
	</div>
	</div>
	';

} else {
	foreach($categories as $categoryid=>$category){
		
		$addclass = '';// start with blank.
		$query['categoryid'] = $category['id']; // just get category id.
		$links = get_resource_links($query, 'ord', 'asc', false, true); // see if there's things under this category?
		if($links) {
			$addclass .= ' categories_publish';
		}
		
		echo '<div class="row categories_row '.$addclass.'" id="category_'.$category['id'].'">';
		
		echo '<div class="col-sm-5 col-xs-10"><p>
		'.($links ? '<a rel="'.$category['id'].'" class="btn btn-default btn-xs resources_toggle" id="categories_toggle_'.$category['id'].'"><span class="glyphicon glyphicon-plus"></span></a>&nbsp;&nbsp;' : '<a class="btn btn-default btn-xs disabled"><span class="glyphicon glyphicon-plus"></span></a>&nbsp;&nbsp;').
		'<span class="category_title">'.$category['title'].'</span>
		
		</p></div>';
		echo '<div class="col-sm-4 col-xs-2"><p>';
		echo '<a href="resources_mod.php?mode=new&category='.$category['id'].'" class="btn btn-primary btn-xs">&nbsp;<span class="glyphicons glyphicon-plus"></span><span class="hidden-xs">&nbsp;&nbsp;Add Link</span>&nbsp;</a>';
		echo '</p></div>';
		
		echo '<div class="col-sm-3 col-xs-12 categories_functions form-inline">
			<p>
			<button class="btn btn-warning btn-sm category_mod" href="#" rel="'.$category['id'].'"><span class="glyphicon glyphicon-pencil"></span>&nbsp;&nbsp;Edit</button>&nbsp;
		
			'.($links===false ? '<a class="btn btn-danger btn-sm category_delete" href="#" rel="'.$category['id'].'"><span class="glyphicon glyphicon-minus"></span></a>' :'').'</p>';
		
		echo '</div>';
		
		if($links) {
			echo '<div class="col-md-12 col-xs-12 resources_set" id="resources_'.$category['id'].'" rel="'.$category['id'].'">';
			foreach ($links as $linkid) {
				// display the sub-items!
				$link = new resource; 
				$link->initialize($linkid['id'], $linkid);
				$addclass = '';
				if($link->publish==1) {
					$addclass .= ' resource_publish';
				}
				echo '<div class="row resources_row '.$addclass.'" id="resource_'.$link->id.'">';
			
				echo '<div class="col-md-5 col-xs-12"><p class="resources_label">
				<span class="resource_title">'.$link->get_title().'</span>
				'.$link->get_link_tag('visit website', '_blank', ' (', ')', false).'
				'.($link->areacity!='' ? '&nbsp;&nbsp;<small><i>'.$link->areacity.'</i></small>' : '').'
				</p></div>';
				
				switch ($link->publish) {
					case 0:
					$hiddenselected = " selected";
					$publishedselected = "";
					break;
				
					case 1:
					$hiddenselected = "";
					$publishedselected = " selected";
					break;
				}
				
				echo '<div class="col-md-7 col-xs-12 resources_functions form-inline">
				<div class="row">
					<div class="col-md-8 col-xs-6 bottom_10 resources_buttons">
						<a class="btn btn-primary btn-sm hidden-xs hidden-sm " href="mainimage.php?idr='.$link->id.'&folder='.$destinationtable.'"><span class="glyphicon glyphicon-picture"></span><span class="hidden-xs">&nbsp;&nbsp;Lead Images</span></a>&nbsp;
						
						<a class="btn btn-primary btn-sm hidden-xs hidden-sm " href="attach.php?idr='.$link->id.'&folder='.$destinationtable.'"><span class="glyphicon glyphicon-tags"></span><span class="hidden-xs">&nbsp;&nbsp;Attachments</span></a>&nbsp;
						
						<a class="btn btn-default btn-sm" href="resources_mod.php?idr='.$link->id.'&mode=modify"><span class="glyphicon glyphicon-pencil"></span><span class="hidden-xs">&nbsp;&nbsp;Edit</span></a>&nbsp;
						
						<a class="btn btn-danger btn-sm resource_delete" href="#" rel="'.$link->id.'"><span class="glyphicon glyphicon-minus"></span></a>
					</div>
					<div class="col-md-4 col-xs-6 bottom_10">
						<select class="form-control resource_publish_toggle" rel="'.$link->id.'">
							<option value="0"'.$hiddenselected.'>Hidden</option>
							<option value="1"'.$publishedselected.'>Published</option>
						</select>
					</div>
				</div>';
				
				echo '</div>';
				
				echo '</div>';
			}
			echo '</div>';
		}
	
		echo '</div>';
	}
}

require_once 'ajax_footer.php';
?>

