\<?
/*
Filename: ajax_listphotos.php

Method: AJAX
Output: AJAX/HTML

Description: Master file that loads up the buildings list, as well as the buildings quick search module to help users organize & choose buildings to feature on the website. 

Author: Jeff Kee
*/
include 'start.php';

check_login(0);

$folder = $_REQUEST['folder'];
$idr = trim($_REQUEST['homeid']); // used to be home ID, but now it accepts it all.. homes, pages etc. more modular. Just pass it to $idr so it's universal below. 
$photorefcolumn = substr($folder, 0, strlen($folder)-1); // remove the s from the folder tables, as it references to the `home` or `building` columns of the `photos` table. 



if($_REQUEST['folder']=='') {
	// if table is not set, default to homes.
	$destinationtable = 'homes';
	$destinationfolder = 'homes';
} else {
	$destinationtable = $_REQUEST['folder'];
	$destinationfolder = $_REQUEST['folder'];
}

if($destinationtable=='pages') {
	$page = new page;
	$page->initialize($idr);
	$subject = $page->title;
	$object = $page;
} else if($destinationtable=='resources') {
	$resource = new resource;
	$resource->initialize($idr);
	$subject = $resource->title;
	$object = $resource;
} else if($destinationtable=='agents') {
	$agent = new agent;
	$agent->initialize($idr);
	$subject = $agent->displayname;
	$object = $agent;
} else if($destinationtable=='buildings') {
	$building = new building;
	$building->initialize($idr);
	$subject = $building->name;
	$object = $building;
} else if($destinationtable=='homes') {
	$home = new home;
	$home->initialize($idr);
	$subject = $home->fulladdress;
	$object = $home;
} else {
	die('invalid object type!');
}



if($object->getphotos()===false) {
	echo '<div class="row"><div class="col-md-6 col-md-offset-3 col-sm-6 col-sm-offset-3 col-xs-12" style="padding-top:50px;">';
	echo alert_display('<p><strong>No Photos yet!</strong>Upload some files using the Upload module. You can click to select files, or drag &amp; drop into it!</p>', 'warning');
	echo '
	</div>
	</div>
	';
} else {
	$photocount = 0;
	
	foreach($object->photos as $photo) {

		echo '<div class="row photo_row form-group bottom_5" id="photo_'.$photo['id'].'">';
			echo '<div class="col-sm-2">
				<div class="thumbnail">
					<img src="'.$photo['mobilepath'].'" class="orderhandle img-full" alt="thumbnail">
				</div>
			</div>';
			
			if($photo['s3']==1) {
				$fullsize = $thumbsize = $mobilesize = true;

			} else {
				if(file_exists("../".$folder."/".$idr.'/original/'.$photo['filename'])) {
					$fullsize = $settings['sitepath'].$folder.'/'.$idr.'/original/'.$photo['filename'];
				} else {
					$fullsize = false;
				}

				if(file_exists("../".$folder."/".$idr.'/thumbs/'.$photo['filename'])) {
					$thumbsize = $settings['sitepath'].$folder.'/'.$idr.'/thumbs/'.$photo['filename'];
				} else {
					$thumbsize = false;
				}

				if(file_exists("../".$folder."/".$idr.'/mobile/'.$photo['filename'])) {
					$mobilesize = $settings['sitepath'].$folder.'/'.$idr.'/mobile/'.$photo['filename'];
				} else {
					$mobilesize = false;
				}

			}

			// DIFFERENT IMAGE SIZES BUTTON SHOULD ONLY BE VISIBLE TO BRIXWORK LOGIN!
			echo '<div class="col-sm-8">
				<input type="text" class="form-control input-sm photo_title bottom_10" size="25" name="title[]" rel="'.$photo['id'].'" id="title_'.$photo['id'].'" value="'.$photo['title'].'" tabindex="'.($photocount+1).'" '.($photocount==0 ? ' data-toggle="popover" title="Quick Titles" data-content="Hit ENTER after editing this field, and you will be taken to the next field automatically!" data-placement="bottom" data-trigger="focus"' : '').' />
			
				<p class="hidden-sm hidden-xs"> 
					<a class="btn btn-info btn-xs" href="'.$photo['filepath'].'" target="_blank"><span class="glyphicon glyphicon-search"></span>&nbsp;&nbsp;Web Size</a>&nbsp;
					'.($fullsize ? '<a class="btn btn-default btn-xs" href="'.$photo['originalfilepath'].'" target="_blank"><span class="glyphicon glyphicon-search"></span>&nbsp;&nbsp;Original</a>&nbsp;' : '').'
					'.($thumbsize ? '<a class="btn btn-default btn-xs" href="'.$photo['thumbnailpath'].'" target="_blank"><span class="glyphicon glyphicon-search"></span>&nbsp;&nbsp;Thumbnail</a>&nbsp;' : '').'
					'.($mobilesize ? '<a class="btn btn-default btn-xs" href="'.$photo['mobilepath'].'" target="_blank"><span class="glyphicon glyphicon-search"></span>&nbsp;&nbsp;Mobile</a>' : '');

//			echo '<br />
//					<small>
//					<strong>Location</strong>: '.($photo['s3']==1 ? $settings['s3_url'].$settings['s3_bucket'].'/'.getS3FilePath($settings, $idr, $destinationtable) : $settings['sitepath'].$folder.'/'.$idr.'/').'<br />
//					<strong>Name</strong>: '.$photo['filename'].'
//					</small><br />';
			
			echo '
				</p>
			</div>';
			
			echo '<div class="col-sm-2">
				<div class="checkbox" '.($photocount==0 ? ' data-toggle="popover" title="To Delete" data-content="Select photos to delete first." data-placement="bottom" data-trigger="manual"' : '').'>
					<label for="delete_'.$photo['id'].'"><input class="deletephoto_checkbox" type="checkbox" id="delete_'.$photo['id'].'" value="'.$photo['id'].'" name="deletephotos"  />To Delete</label>
				</div>
			</div>';
			echo '<hr />';
		echo "</div>";
		$photocount++;
	}
}

require_once 'ajax_footer.php';
?>

