<?php
/*
Filename: ajax_modifyagents.php
Location: /Volumes/Macintosh HD/Users/jeffkee/Documents/Work Docs/Brixwork/Brixwork-for-Realtors/dev/admin

Method: AJAX
Output: AJAX/JSON

Description: Modifies agents publish status etc. on the fly. 

Author: Jeff Kee
*/
include 'start.php';

// start.php runs validate_login() function
$destinationfolder = 'agents';
$destinationtable = 'agents';

/*
Values Entered
$_REQUEST['change'] = indicates type of change.
$_REQUEST['value'] = indicates target value.
$_REQUEST['field'] = indicates target value.
$_REQUEST['idr'] = id of teh target home.
*/

$log_file = 'logs/log.' . date('Y.m.d') . '.log';
if (is_writable(dirname($log_file))) {
	$handle = fopen($log_file, 'a+');
} else {
	$handle = null;
}


switch($_REQUEST['change']) {

	case "publishstatus":
		$sql = 'UPDATE `'.$destinationtable.'` SET `publish`="'.$_REQUEST['value'].'" WHERE id="'.$_REQUEST['idr'].'"';
		$execute = $mysqli->query($sql);
		if($mysqli->affected_rows==1) {
			$code = 1;
			$message = 'Publish status changed for '.$_REQUEST['idr'].'.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$_REQUEST['idr'].' publish status.';
		}
		$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
		break;

	case "order":
		// order can either go up or down, and it can also make something go straight to the top or straight to the bottom
		if($_REQUEST['perpage']!='' && $_REQUEST['page']!='') {
			$agents = list_agents('', 'ord', 'ASC', $_REQUEST['perpage'],$_REQUEST['page']);
			$ordstart = ($_REQUEST['perpage']*($_REQUEST['page']-1))+1; // figure out where the order scheme starts depending on which page people are on.
			if(count($_REQUEST['agent'])==count($agents)) {
				$updatecount = 0;
				// only execute if the # of photos found on the home equals the length of the order array.
				foreach($_REQUEST['agent'] as $ord=>$agentid) {
					$updatesql = "UPDATE `".$destinationtable."` SET ord='".$ordstart."' WHERE id='".$agentid."'";
					$updateresult = $mysqli->query($updatesql);
					if(!$updateresult) {
						$message.='Query Error: '.$updatesql;
					} else {
						$updatecount++;
					}
					$ordstart++;
				}
				if(count($agents)==$updatecount) {
					$code = 1; // 1 for success
					$message = $updatecount.' agent row orders updated.';
				} else {
					$code = 0; // 0 for failure, something got missed.
					$message = 'SOmething went wrong! Final order was '.$ordcount.' and we had '.count($agents).' '.$mysqli->error;
				}
			} else {
				$code = 0;
				$message = 'Invalid request - please refresh the page and try again.';
			}
		} else {
			$code = 0;
			$message = 'Invalid request - page data is necessary for an order change request.';
		}
		break;

	case "delete":
		$agent = new agent;
		$agent->initialize($_REQUEST['idr']);
		rmdir_files('../agents/'.$agent->id);
		$sql = "DELETE FROM agents WHERE id='".$agent->id."'";
		$mysqli->query($sql);

		if($mysqli->affected_rows > 0) {
			$code = 1;
			$message = 'Agent ID '.$agent->id.' ('.$agent->displayname.') was removed successfully!';
		} else {
			$code = 0;
			$message = 'Your Agent Was Not Deleted Successfuly: '.$mysqli->error.'<br /><br />Query Attempted:<br />'.$sql;
		}
		break;

	case "youtube":
		$videoid = getyoutubeid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "vimeo":
		$videoid = getvimeoid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "pdf_label":
		$sql = 'SELECT pdf_labels FROM '.$destinationtable.' WHERE id = '.$_REQUEST['idr'];
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['pdf_labels']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET pdf_labels = '$labels' WHERE id = ".$_REQUEST['idr'];
		$result = $mysqli->query($sql);
		if($mysqli->affected_rows>0) {
			$code = 1;
			$message = $labels."\n";
			$message .= 'AJAX Updated pdf label key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for building '.$_REQUEST['idr'];
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	default:
		$code = 0;
		$message = 'Invalid change request: '.$_REQUEST['change'];
		break;
} // end of the switch statement

// finally package it all to a JSON output and spit it out! 
$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
echo json_encode($json_array);

require_once 'ajax_footer.php';