<?php
/*
Filename: ajax_modifybuildings.php

Method: AJAX
Output: AJAX JSON

Description: Performs AJAX based functions that add new bulidings, modify the status of buildings, groups them, detaches them, changes primary, deletes them, etc. 

Author: Jeff Kee
*/
require_once 'start.php';

// start.php runs validate_login() function.
$destinationfolder = 'buildings';
$destinationtable = 'buildings';
/*
Values Entered
$_REQUEST['change'] = indicates type of change.
$_REQUEST['value'] = indicates target value.
$_REQUEST['field'] = indicates target value.
$_REQUEST['idr'] = id of teh target building.
*/
$cityid = gettablefield($destinationfolder, 'city', $_REQUEST['idr']);
// prepare statement to set city to publish=1 for any enabled building.. otehrwise the search wont work!
if ($cityid) {
	$citypublishsql = "UPDATE `areas` SET `publish`=1 WHERE `id`='".$cityid."'";
} else {
	$citypublishsql = "";
}

switch ($_REQUEST['change']) {
	case "add":
		// add new building, probably from the homes mod screen on the fly.
		/*
			Values for this
		$_REQUEST['building_name'] = will contain building name.
		$_REQUEST['number'] = indicates target value.
		$_REQUEST['street'] = id of teh target building.
		$_REQUEST['city'] = id of teh target building.
		$_REQUEST['area'] = id of teh target building.
		*/
		if ($_REQUEST['building_name']!='' && $_REQUEST['number']!='' && $_REQUEST['street']!='' && $_REQUEST['city']!='') {
			$postvars['name'] = stripslashes(trim($_REQUEST['building_name']));
			$postvars['number'] = $_REQUEST['number'];

			$street_array = separate_streetname($_REQUEST['street']); // returns array($streetname, $streettype, $street_dir, $street_suffix); , have this ready in case it's all merged in and no explicit dir, suffix etc. are set.
			$postvars['street'] = $_REQUEST['street'];
			$postvars['street_name'] =($_REQUEST['street_name']!='' ? $_REQUEST['street_name'] : $street_array[0]);
			$postvars['street_type'] = ($_REQUEST['street_type']!='' ? $_REQUEST['street_type'] : $street_array[1]);

			$postvars['street_dir'] = ($_REQUEST['street_dir']!='' ? $_REQUEST['street_dir'] : $street_array[2]);

			$postvars['street_suffix'] = ($_REQUEST['street_suffix']!='' ? $_REQUEST['street_suffix'] : $street_array[3]);


			$postvars['city'] = $_REQUEST['city'];
			$postvars['area'] = $_REQUEST['area']; // can be blank.
			$postvars['area_alt'] = $_REQUEST['area_alt']; // can be blank.
			if ($_REQUEST['lat']!='') {
				$postvars['lat'] = $_REQUEST['lat'];
				$postvars['long'] = $_REQUEST['lng']; // long means osmething in javascript so the AJAX sends it as lng, convert to long.
			} else {
				// geocode the lat long!
				// get street and streettype separated
				$latlngresult = get_google_geocode($postvars['number'], $postvars['street'], $postvars['street_type'], $postvars['street_dir'], $postvars['city']);
				if ($latlngresult[0]===true) {
					$postvars['lat'] = $latlngresult[1];
					$postvars['long'] = $latlngresult[2];
				}
			}

			$postvars['create_date'] = $postvars['modify_date'] = $postvars['timestamp'] = $now; // default!
			$postvars['phpfile'] = $_SERVER['HTTP_REFERER']; // this ajax file means nothing, trace which UI php file triggered this call.
			$postvars['feature'] = 1; // manually entered building, chances are user wants to feature!
			$postvars['publish'] = 0; // manually entered building, let user decide to actually publish

			$buildingid = form_to_table($destinationtable, $postvars);
			if (is_numeric($buildingid)) {
				// now update the city that this building is part of to become publish = 1.
				$mysqli->query($citypublishsql);

				// mainid is set, so lets make the main building a primary, and newly created buliding a sub-building.


				$code = 1;
				$_REQUEST['idr'] = $buildingid;
				$message = $_REQUEST['building_name'].' was added succssfully!';

				if ($_REQUEST['mainid']!='') {
					$mainbuilding = new building;
					$mainbuilding->initialize($_REQUEST['mainid']);
					$mainbuildingresult = $mainbuilding->make_primary_building($buildingid);
					if ($mainbuildingresult===true) {
						$message.=' Attached to main building ID '.$mainbuilding->id;
					}
				}


			} else {
				$code = 0;
				$message = 'There was an error: '.$buildingid.'. Please try again or contact support.';
			}
		} else {
			$code = 0;
			$message = 'Not enough data presented to add. Please check entries.';

		}
		break;

	case "featurestatus":
		if($_REQUEST['value']==1) {
			$ordersql = "UPDATE `".$destinationtable."` SET `ord`=`ord`+1 WHERE `feature`=1";

		} else {
			$thisorder = gettablefield($destinationtable, 'ord', $_REQUEST['idr']);
			$ordersql = "UPDATE `".$destinationtable."` SET `ord`=`ord`-1 WHERE `feature`=1 AND `ord`>'".$thisorder."'";
		}
		$mysqli->query($ordersql);// move all other ones DOWN one order so new building is at top!

		$sql = 'UPDATE '.$destinationtable.' SET feature="'.$_REQUEST['value'].'" '.($_REQUEST['value']==1 ? ', `ord`="1.0"' : ', `ord`="0.0"').' WHERE id="'.$_REQUEST['idr'].'"';
		$mysqli->query($sql);
		if($mysqli->affected_rows>0) {
			// now update the city that this building is part of to become publish = 1.
			if($_REQUEST['value']==1) {
				$mysqli->query($citypublishsql);
			}
			$code = 1;
			$message = 'Building ID '.$_REQUEST['idr'].' feature status updated to '.($_REQUEST['value']==1 ? 'FEATURED' : 'NOT FEATURED').'.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$_REQUEST['idr'].' feature status - '.$sql;
		}
		break;

	case "salestatus":
		$sql = 'UPDATE '.$destinationtable.' SET status="'.$_REQUEST['value'].'" WHERE id="'.$_REQUEST['idr'].'"';
		$mysqli->query($sql);
		if($mysqli->affected_rows>0) {
			$code = 1;
			$message = 'Building ID '.$_REQUEST['idr'].' sale status updated to '.$settings['building_status_display'][$_REQUEST['value']].'.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$_REQUEST['idr'].' sale status - '.$sql;
		}
		break;

	case "primary_building":
		// simply switch which is primary building - not adding any new subbuildings.
		if($_REQUEST['idr']!=0) {
			$thisbuilding = new building;
			$thisbuilding->initialize($_REQUEST['idr']);
			if($thisbuilding->make_primary_building()) {
				$code = 1;
				$message = 'Success!';
			} else {
				$message = $mysqli->error;
			}
		} else {
			$code = 0;
			$message = 'Invalid building ID!';
		}
		break;

	case "attach_building":
		if ($_REQUEST['mainid']>0){
			$thisbuilding = new building;
			$thisbuilding->initialize($_REQUEST['mainid']);
			if($thisbuilding->make_primary_building($_REQUEST['idr'])) {
				$code = 1;
				$message = 'Success!';
			} else {
				$code = 0;
				$message = 'Failed: '.$mysqli->error;
			}
		} else {
			$code = 0;
			$message = 'Invalid main building ID';
		}
		break;

	case "detach_building":
		$thisbuilding = new building;
		$thisbuilding->initialize($_REQUEST['idr']);
		if ($thisbuilding->detach_building()) {
			$code = 1;
			$message = 'Success!';
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "order":
		// order can either go up or down, and it can also make something go straight to the top or straight to the bottom
		if ($_REQUEST['perpage']!='' && $_REQUEST['page']!='') {
			$buildings = get_buildings(array('feature'=>1), 'ord', 'ASC', $_REQUEST['perpage'], $_REQUEST['page']);
			$ordstart = ($_REQUEST['perpage']*($_REQUEST['page']-1))+1; // figure out where the order scheme starts depending on which page people are on. If it's first page it will be #1.
			if (count($_REQUEST['building'])==count($buildings)) {
				$updatecount = 0;
				// only execute if the # of photos found on the home equals the length of the order array.
				foreach ($_REQUEST['building'] as $ord=>$buildingid) {
					$updatesql = "UPDATE `buildings` SET ord='".$ordstart."' WHERE id='".$buildingid."'";
					$updateresult = $mysqli->query($updatesql);
					if (!$updateresult) {
						$message.='Query Error: '.$updatesql;
					} else {
						$updatecount++;
					}
					$ordstart++;
				}
				if (count($buildings)==$updatecount) {
					$code = 1; // 1 for success
					$message = 'Reorder successful.';
				} else {
					$code = 0; // 0 for failure, something got missed.
				}
			} else {
				$code = 0;
				$message = 'Invalid request - please refresh the page and try again.';
			}
		} else {
			$code = 0;
			$message = 'Invalid request - page data is necessary for an order change request.';
		}
		break;


	case "youtube":
		$videoid = getyoutubeid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;


	case "vimeo":
		$videoid = getvimeoid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "pdf_label":
		$sql = 'SELECT pdf_labels FROM '.$destinationtable.' WHERE id = '.$_REQUEST['idr'];
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['pdf_labels']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET pdf_labels = '$labels' WHERE id = ".$_REQUEST['idr'];
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = 'AJAX Updated pdf label key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for building '.$_REQUEST['idr'];
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "alt_tags":
		$sql = 'SELECT alt_tags FROM '.$destinationtable.' WHERE id = '.$_REQUEST['idr'];
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['alt_tags']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET alt_tags = '$labels' WHERE id = ".$_REQUEST['idr'];
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = $labels."\n";
			$message .= 'AJAX Updated Alt Tags key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for page '.$_REQUEST['idr'];
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "publishstatus":
		$sql = 'UPDATE '.$destinationtable.' SET publish="'.$_REQUEST['value'].'" WHERE id="'.$_REQUEST['idr'].'"';
		$result = $mysqli->query($sql);

		if ($mysqli->affected_rows > 0) {
			$code = 1;
			$message = 'AJAX updated Publish Status key = '.$_REQUEST['key'].' to value = '.$_REQUEST['value'];
		}
		else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	default:
		$code = 0;
		$message = 'Invalid change request: '.$_REQUEST['change'];
		break;
} // end of the switch statement

// finally package it all to a JSON output and spit it out! 
$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
echo json_encode($json_array);

require_once 'ajax_footer.php';