<?php
/*
Filename: ajax_modifybuildingfeatures.php

Method: AJAX
Output: AJAX JSON

Description: Master file that loads up the buildings list, as well as the buildings quick search module to help users organize & choose buildings to feature on the website. 

Author: Jeff Kee
*/
include 'start.php';

// start.php runs validate_login() function.
$destinationfolder = 'homefeatures';
$destinationtable = 'homefeatures';

/*
Values Entered
$_REQUEST['change'] = indicates type of change.
$_REQUEST['value'] = indicates target value.
$_REQUEST['field'] = indicates target value.
$_REQUEST['idr'] = id of teh target home.
*/


switch($_REQUEST['change']) {
	// with each building's features being able to switch orders, do we even need this?? - 2014-12-24, Jeff Kee
	case "order":
		// order can either go up or down, and it can also make something go straight to the top or straight to the bottom
		$currentord = gettablefield($destinationtable,'ord',$_REQUEST['idr']);
		$minord = getendfield($destinationtable,'ord','MIN');
		$maxord = getendfield($destinationtable,'ord','MAX');

		if($_REQUEST['value']=="top") {
			if ($currentord==$minord) {
				// already at the top.. nothing needed to be done.
				$code = 1;
				$message = $_REQUEST['idr'].' is already at the top.';
			}
			else {
				if ($minord==0) {
					$mysqli->query("UPDATE ".$destinationtable." SET ord = ord+1");
				}
				$mysqli->query("UPDATE ".$destinationtable." SET ord='0.00' WHERE id='".$_REQUEST['idr']."'");
				$code = 0;
				$message = $_REQUEST['idr'].' set to top.';
			}
		}
		else if($_REQUEST['value']=="bottom") {
			if($currentord==$maxord) {
				// already at the bottom.. nothing needed to be done.
				$code = 1;
				$message = $_REQUEST['idr'].' already at bottom.';
			}
			else {
				$targetord = $maxord+1.5;
				$mysqli->query("UPDATE ".$destinationtable." SET ord='".$targetord."' WHERE id='".$_REQUEST['idr']."'");
				$code = 0;
				$message = $_REQUEST['idr'].' set to '.$targetord.'.';
			}
		}
		if($_REQUEST['value']=="up") {
			if($currentord==$minord) {
				// already at the top.. nothing needed to be done.
				$code = 1;
				$message = $_REQUEST['idr'].' already at top.';
			}
			else {
				$targetord = $currentord-1.5;
				$mysqli->query("UPDATE ".$destinationtable." SET ord='".$targetord."' WHERE id='".$_REQUEST['idr']."'");
				$code = 0;
				$message = $_REQUEST['idr'].' set to '.$targetord.'';
			}
		}
		else if($_REQUEST['value']=="down") {
			if($currentord==$maxord) {
				// already at the top.. nothing needed to be done.
				$code = 1;
				$message = $_REQUEST['idr'].' already at bottom.';
			}
			else {
				$targetord = $currentord+1.5;
				$mysqli->query("UPDATE ".$destinationtable." SET ord='".$targetord."' WHERE id='".$_REQUEST['idr']."'");
				$code = 0;
				$message = $_REQUEST['idr'].' set to '.$targetord.'';
			}
		}
		// after the orders were shuffled, let's straighten out the numbers for good!!
		$ordreset = $mysqli->query("SELECT * FROM ".$destinationtable." ORDER BY ord");
		$count=1;
		while ($reset = $ordreset->fetch_assoc()) {
			$update = "UPDATE ".$destinationtable." SET ord='".$count."' WHERE id='".$reset['id']."'";
			$mysqli->query($update);
			$count++;
		}

		$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
		break;

	case "delete":
		if($_REQUEST['idr']!='') {
			$sql = 'DELETE FROM '.$destinationtable.' WHERE id='.$_REQUEST['idr'].'';
			$mysqli->query($sql);
			if($mysqli->affected_rows>0) {
				$code = 1;
				$message = 'Home Feature '.$_REQUEST['id'].' deleted successfully.';
			} else {
				$code = 0;
				$message = 'Home Feature '.$_REQUEST['id'].' delete failed: '.$sql.'.';
			}
			$json_array = array('code'=>$code, 'id'=>$buildingid, 'message'=>$message, 'feature_id'=>$_REQUEST['idr']);
		}
		break;

	/*
	Values Entered
	$_REQUEST['change'] = indicates type of change.
	$_REQUEST['value'] = indicates target value.
	$_REQUEST['field'] = indicates target value.
	$_REQUEST['idr'] = id of teh target building.
	*/
	case "add":
		$maxord = getendfield($destinationtable,'ord','MAX');
		$targetord = $maxord+1;
		$sql = 'INSERT INTO `'.$destinationtable.'` (`name`, `ord`) VALUES ("'.$mysqli->real_escape_string(trim($_REQUEST['value'])).'","'.$targetord.'")';
		$result = $mysqli->query($sql);
		$insertid = $mysqli->insert_id;
		if ($result) {
			$code = 1;
			$message = 'Home feature "'.$_REQUEST['value'].'" added to row '.$insertid.' successfully.';
		}
		else {
			$code = 0;
			$message = 'There was an error: '.$mysqli->error.'. Please try again or contact support.';
		}

		$json_array = array('code'=>$code, 'id'=>$insertid, 'message'=>$message);
		break;


	default:
		$code = 1;
		$message = 'Misunderstood request type '.$_REQUEST['change'].'.';
		break;
} // end of the switch statement


// finally package it all to a JSON output and spit it out! 
echo json_encode($json_array);

require_once 'ajax_footer.php';