<?php
include 'start.php';

//start.php runs validate_login() function.
$destinationfolder = 'homes';
$destinationtable = 'homes';
$objectid  = $mysqli->real_escape_string(trim($_REQUEST['idr'] ?: '')); // SQL injection prevent.

/*
Values Entered
$_REQUEST['change'] = indicates type of change.
$_REQUEST['value'] = indicates target value.
$_REQUEST['field'] = indicates target value.
$_REQUEST['idr'] = id of teh target home.
*/
$log_file = 'logs/homes_log.' . date('Y.m.d') . '.log';
if (is_writable(dirname($log_file))) {
	$handle = fopen($log_file, 'a+');
} else {
	$handle = null;
}

$logparams = array();
$logparams['objecttype'] = $destinationtable; // is it homes/buildings/pages or agents?
$logparams['objectid'] = $objectid; // is it homes/buildings/pages or agents?

switch($_REQUEST['change']) {
	case "soldstatus":
		// Change to SOLD status, and change modify date to make it recent.
		$sql = "UPDATE `".$destinationtable."` SET `sold`=".$_REQUEST['value'].", `modify_date`= '".$now."' WHERE `id`=".$_REQUEST['idr'];
		$execute = $mysqli->query($sql);
		if($mysqli->affected_rows==1) {
			$code = 1;
			$message = 'Successfully changed '.$_REQUEST['idr'].' sold status.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$_REQUEST['idr'].' sold status.';
		}
		break;

	case "featurestatus":
		// update the featured status of a listing from the HOMES list.
		// DO NOT CHANGE Modify date, we don't want overrides from MLS being blocke.d
		// needs to be deprecated in favour of the "feature" case, because that one is more robust to import & process even non-localized MLS listings.
		$result = $mysqli->query('SELECT source, ord FROM homes WHERE id = '.$_REQUEST['idr']);
		$resultArray = $result->fetch_assoc();

		if ($resultArray['source'] == 1) {
			if ($_REQUEST['value'] == 1) {
				$ord = 1;
				$increment = '+1';
				$sqlAppend = '';
			} else {
				$ord = 0;
				$increment = '-1';
				$sqlAppend = ' AND ord > '.$resultArray['ord'];
			}

			$sql = "UPDATE homes SET ord = ord ".$increment." WHERE (source = 0 OR (source = 1 AND feature = 1))".$sqlAppend; // We should also account for featured MLS listings.
			log_error("EXECUTING SQL QUERY: ".$sql);
			$mysqli->query($sql);
		}

		$sql = "UPDATE `".$destinationtable."` SET `feature`=".$_REQUEST['value']." WHERE `id`=".$_REQUEST['idr'];
		$execute = $mysqli->query($sql);

		if ($mysqli->affected_rows==1) {
			$code = 1;
			$message = 'Home ID '.$_REQUEST['idr'].' feature status updated to '.($_REQUEST['value']==1 ? 'FEATURED' : 'NOT FEATURED').'.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$_REQUEST['idr'].' feature status.';
		}
		break;

	case "publishstatus":
		$sql = 'UPDATE '.$destinationtable.' SET publish="'.$_REQUEST['value'].'" WHERE id="'.$_REQUEST['idr'].'"';
		$execute = $mysqli->query($sql);
		if ($mysqli->affected_rows==1) {
			$code = 1;
			$message = 'Publish status changed for '.$_REQUEST['idr'].'.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$_REQUEST['idr'].' publish status.';
		}
		break;

	case "feature":
		// Modify MLS listing that was previously NOT featured as "featured"!
		// do NOT change modify date as this will prevent re-crawl of updated data such as price etc.!
		$homesql = "SELECT `id` FROM `".$destinationtable."` WHERE `mls`='".$mysqli->real_escape_string($_REQUEST['mls'])."'";
		$homeresult = $mysqli->query($homesql);

		if ($homeresult->num_rows==0) {
			// import it first from a RETS core!
			if ($settings['mls_import_url']!='') {
				// if separate MLS import url is set such as kamloops or other region...
				$importurl = $settings['mls_import_url'];
			} else {
				// otherwise default to demo.brixwork.com which is master_url, for MLS from REBGV MLS feed.
				$importurl = 'https://vancouver.brixwork.com/';
			}

			include '../cron/cron_functions.php';// loads up all cities etc.
			include '../admin/includes/retsimport_vars.php';// loads up all cities etc.

			$getarray['hash'] = md5('58300774'.$_REQUEST['mls']);
			$getarray['mls'] = $_REQUEST['mls'];

			$jsonfeed = curl_get_file_contents($importurl.'admin/api/listing.php?hash='.$getarray['hash'].'&mls='.$getarray['mls'], 'GET');

			$json = json_decode($jsonfeed, true); // fetch from the listing API from main server.
			if ($json['code']==1) {
				$listing = $json['listing'][0]; // isolate the $listing var using teh listing portion only if result was good.
				/* Decide what city & subarea to fall under */
				$cityareafound = 0; // first, set cityareafound flag to false.
				if (count($subareaswithpolygon)>0 && is_array($subareaswithpolygon)) {
					// there are polygoned results, let's check homes against it.
					reset($subareaswithpolygon);
					foreach($subareaswithpolygon as $subareawithpolygon) {
						if($subareawithpolygon->listing_in_polygon($listing['lat'].','.$listing['long'])) {
							$listing['area_alt'] = $subareawithpolygon->id;
							$listing['city'] = $subareawithpolygon->area; // select the city that this subarea is supposed to belong to according to owner of site.
							$cityareafound = 1;
							log_error($listing['lat'].",".$listing['long']." was found in to ".$subareawithpolygon->name.". (for home: ".$listing['mls']."): \n");
							echo $listing['lat'].','.$listing['long'].' was found in to '.$subareawithpolygon->name.'.<br />';
						}
					}
				}

				$value_data['city'] = $listing['cityname'];
				$value_data['area'] = $listing['areaname']; // preparing $value_data pair to run through match_cities() function.

				if ($cityareafound==0) {
					// polygon search results didn't return.. match by string name.
					list($listing['area'], $listing['city']) = match_cities($value_data, $cities, $subareas); // regular city/area as per MLS.
				} else {
					// polygon found something, but still get the primary area in.
					list($listing['area'], $discard['city']) = match_cities($value_data, $cities, $subareas); // the area becomes the default MLS area, while area_alt has the custom subarea based on polygon. City is kept the same was what polygon belongs in.
				}
				$listing['timestamp'] = $now;
				$listing['source'] = 1; // MLS integrated listings are source=1 as well
				$listing['publish'] = 1; // MLS integrated listings are source=1 as well
				$insertid = form_to_table($destinationtable,$listing);
				if(!is_numeric($insertid)) {
					$code = 0;
					$message = 'Failed to internalize MLS # '.$_REQUEST['mls'].' from '.$importurl.': '.$insertid.'.';
				}
			} else {
				$code = 0;
				$message = 'The MLS # '.$_REQUEST['mls'].' was not found locally nor on '.$importurl.'.';
			}
		}

		$result = $mysqli->query("SELECT source, ord FROM homes WHERE `mls`='".$mysqli->real_escape_string($_REQUEST['mls'])."'");
		$resultArray = $result->fetch_assoc();

		if ($resultArray['source'] == 1) {
			if ($_REQUEST['value'] == 1) {
				$ord = 1;
				$increment = '+1';
				$sqlAppend = '';
			} else {
				$ord = 0;
				$increment = '-1';
				$sqlAppend = ' AND ord > '.$resultArray['ord'];
			}

			$sql = "UPDATE homes SET ord = ord ".$increment." WHERE (source = 0 OR (source = 1 AND feature = 1))".$sqlAppend; // We should also account for featured MLS listings.
			log_error("EXECUTING SQL QUERY: ".$sql);
			$mysqli->query($sql);
		}

		$sql = 'UPDATE '.$destinationtable.' SET `feature`="'.$_REQUEST['value'].'", `ord`='.$ord.' WHERE `mls`="'.$_REQUEST['mls'].'"';
		$execute = $mysqli->query($sql);

		if ($mysqli->affected_rows==1) {
			$code = 1;
			$idsql = "SELECT `id`, `city` FROM `homes`  WHERE `mls`='".$_REQUEST['mls']."'";
			$idresult = $mysqli->query($idsql);
			$data = $idresult->fetch_assoc();
			$_REQUEST['idr'] = $data['id'];
			/*
			if($_REQUEST['value']==1) {
				// now we need to set the area under this home to be publish!
				$areasql = "UPDATE `areas` SET `publish`=1 WHERE `id`='".$data['city']."'";
				$mysqli->query($areasql);
				echo $areasql;
			}
			*/
			$message = 'Listing '.$_REQUEST['mls'].' feature status updated to '.($_REQUEST['value']==1 ? 'FEATURED' : 'NOT FEATURED').'.';
		} else {
			$code = 0;
			if($message!='') {
				$message = 'Failed to change ID '.$_REQUEST['mls'].' feature status. Error: '.$mysqli->error.', affected rows '.$mysqli->affected_rows.'.';
			}
		}
		break;


	case "source":
		if ($_REQUEST['mls']!='') {
			$homesql = "SELECT `id` FROM `".$destinationtable."` WHERE `mls`='".$mysqli->real_escape_string($_REQUEST['mls'])."'";
			$homeresult = $mysqli->query($homesql);
			if ($homeresult->num_rows==0) {
				// nothing found, fetch from remote then import. If it got to this point, the listing must exist.
				if ($settings['mls_import_url']!='') {
					// if separate MLS import url is set such as kamloops or other region...
					$importurl = $settings['mls_import_url'];
				} else {
					// otherwise default to demo.brixwork.com which is master_url, for MLS from REBGV MLS feed.
					$importurl = 'https://vancouver.brixwork.com/';
				}

				include '../cron/cron_functions.php';// loads up all cities etc.
				include '../admin/includes/retsimport_vars.php';// loads up all cities etc.

				$getarray['hash'] = md5('58300774'.$_REQUEST['mls']);
				$getarray['mls'] = $_REQUEST['mls'];

				$listing_fetch_url = $importurl.'admin/api/listing.php?hash='.$getarray['hash'].'&mls='.$getarray['mls'];
				$jsonfeed = curl_get_file_contents($listing_fetch_url, 'GET');

				$json = json_decode($jsonfeed, true); // fetch from the listing API from main server.
				if ($json['code']==1) {
					$listing = $json['listing'][0]; // isolate the $listing var using teh listing portion only if result was good.
					/* Decide what city & subarea to fall under */
					$cityareafound = 0; // first, set cityareafound flag to false.
					if (count($subareaswithpolygon)>0 && is_array($subareaswithpolygon)) {
						// there are polygoned results, let's check homes against it.
						reset($subareaswithpolygon);
						foreach($subareaswithpolygon as $subareawithpolygon) {
							if($subareawithpolygon->listing_in_polygon($listing['lat'].','.$listing['long'])) {
								$listing['area_alt'] = $subareawithpolygon->id;
								$listing['city'] = $subareawithpolygon->area; // select the city that this subarea is supposed to belong to according to owner of site.
								$cityareafound = 1;
								log_error($listing['lat'].",".$listing['long']." was found in to ".$subareawithpolygon->name.". (for home: ".$listing['mls']."): \n");
								echo $listing['lat'].','.$listing['long'].' was found in to '.$subareawithpolygon->name.'.<br />';
							}
						}
					}

					$value_data['city'] = $listing['cityname'];
					$value_data['area'] = $listing['areaname']; // preparing $value_data pair to run through match_cities() function, since polygon failed.

					if ($cityareafound==0) {
						// polygon search results didn't return.. match by string name.
						list($listing['area'], $listing['city']) = match_cities($value_data, $cities, $subareas); // regular city/area as per MLS.
					} else {
						// polygon found something, but still get the primary area in.
						list($listing['area'], $discard['city']) = match_cities($value_data, $cities, $subareas); // the area becomes the default MLS area, while area_alt has the custom subarea based on polygon. City is kept the same was what polygon belongs in.
					}
					$listing['timestamp'] = $now;
					$listing['source'] = 1; // MLS integrated listings are source=1 as well - keep it that way so remote photo fetch works via JSON.
					$updatephotos = 1;
					$insertid = form_to_table($destinationtable,$listing);
					// echo "Inserted new home ".$insertid."<br />".PHP_EOL;
					if ($insertid) {
						$newhome = new home;
						$newhome->initialize($insertid);
						// echo "Photo Count: ".(count($newhome->photos))."<br />".PHP_EOL;
						list($code, $_REQUEST['idr'], $message) = $newhome->convert_ownlisting();
					} else {
						$code = 0;
						$message = 'The MLS # '.$_REQUEST['mls'].' was found on '.$importurl.' but ';
					}

				} else {
					$code = 0;
					$message = 'The MLS # '.$_REQUEST['mls'].' was not found locally nor on '.$importurl.'.';
				}
			} else {
				// found the row local, process it over!
				$homearray = $homeresult->fetch_assoc();
				$homeid = $homearray['id'];
				$newhome = new home;
				$newhome->initialize($homeid);
				// echo "Photo Count: ".count($newhome->photos)."<br />".PHP_EOL;
				list($code, $_REQUEST['idr'], $message) = $newhome->convert_ownlisting();
			}
		} else {
			// mls value seems to be blank!
			$code = 0;
			$_REQUEST['idr'] = false;
			$message = "Invalid MLS Value: ".$_REQUEST['mls']." sent to server.";
		}
		break;


	case "order":
		// order can either go up or down, and it can also make something go straight to the top or straight to the bottom
		if ($_REQUEST['perpage']!='' && $_REQUEST['page']!='') {
			$homes = get_properties('',array('ownlisting'=>1), 'ord', 'ASC',$_REQUEST['perpage'],$_REQUEST['page']);
			$ordstart = ($_REQUEST['perpage']*($_REQUEST['page']-1))+1; // figure out where the order scheme starts depending on which page people are on.
			if (count($_REQUEST['home'])==count($homes)) {
				$updatecount = 0;
				// only execute if the # of photos found on the home equals the length of the order array.
				foreach($_REQUEST['home'] as $ord=>$homeid) {
					$updatesql = "UPDATE `homes` SET ord='".$ordstart."' WHERE id='".$homeid."'";
					$updateresult = $mysqli->query($updatesql);
					if(!$updateresult) {
						$message.='Query Error: '.$updatesql;
					} else {
						$updatecount++;
					}
					$ordstart++;
				}
				if (count($_REQUEST['home'])==$updatecount) {
					$code = 1; // 1 for success
					$message = 'Reorder successful.';
				} else {
					$code = 0; // 0 for failure, something got missed.
					$message = 'Count was off - '.$updatecount.' homes modified, but found '.count($_REQUEST['home']).' homes based on query.';
				}
			} else {
				$code = 0;
				$message = 'Invalid request - please refresh the page and try again.';
			}
		} else {
			$code = 0;
			$message = 'Invalid request - page data is necessary for an order change request.';
		}
		break;


	case "youtube":
		$videoid = getyoutubeid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "vimeo":
		$videoid = getvimeoid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "virtualtour":
		// required field name = virtualtour
		$src_link = $_REQUEST['value'];
		$sql = "UPDATE ".$destinationtable." SET `virtualtour`='".$mysqli->real_escape_string($src_link)."' WHERE id='".$_REQUEST['idr']."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = ($src_link ?: ''); // return blank if its blank...
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "pdf_label":
		$sql = 'SELECT pdf_labels FROM '.$destinationtable.' WHERE id = '.$_REQUEST['idr'];
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['pdf_labels']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET pdf_labels = '$labels' WHERE id = ".$_REQUEST['idr'];
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = $labels."\n";
			$message .= 'AJAX Updated pdf label key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for building '.$_REQUEST['idr'];
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;


	case "alt_tags":
		$sql = 'SELECT alt_tags FROM '.$destinationtable.' WHERE id = '.$_REQUEST['idr'];
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['alt_tags']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET alt_tags = '$labels' WHERE id = ".$_REQUEST['idr'];
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$message = $labels."\n";
			$message .= 'AJAX Updated Alt Tags key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for page '.$_REQUEST['idr'];
		} else {
			$code = 0;
			$message = $mysqli->error;
		}
		break;

	case "delete":
		// delete home function here!
		log_error("Deleting home ID ".$listing['id']." (MLS # ".$listing['mls']." as per click from ".$_SERVER['REMOTE_ADDR']." and current user is ".$_COOKIE['username']." \n");

		if ($_REQUEST['idr']!='') {
			$result = $mysqli->query('SELECT ord FROM homes WHERE id = '.$_REQUEST['idr']);
			$resultArray = $result->fetch_assoc();
			$current_order = $resultArray['ord'];

			$sql = "UPDATE `homes` SET ord = ord - 1 WHERE (source = 0 OR (source = 1 AND feature = 1)) AND ord > ".$current_order;

			$result = $mysqli->query($sql);

			$removeresult = remove_home($_REQUEST['idr']);
		} else {
			$removeresult=false;
		}
		if ($removeresult) {
			$code = 1;
			$message = 'Successfully removed home '.$_REQUEST['idr'].'.';
		} else {
			$code = 0;
			$message = 'Failed to remove home '.$_REQUEST['idr'].'- error from MySQL was '.$mysqli->error.'.';
		}
	break;

	default:
		$code = 0;
		$message = 'Invalid change request: '.$_REQUEST['change'];
		break;
} // end of the switch statement

// finally package it all to a JSON output and spit it out! 
$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
echo json_encode($json_array);

require_once 'ajax_footer.php';