<?php
/*
Filename: ajax_modifyresourcecategories.php

Method: AJAX
Output: AJAX/JSON

Description: Makes changes to resource categories, change title, add new, or order change.

Author: Jeff Kee
*/
include 'start.php';
// start.php runs validate_login() function
$destinationfolder = 'resourcecategories';
$destinationtable = 'resourcecategories';

switch($_REQUEST['change']) {
	case "add":
		// add new category.
		/*
			Values for this
		$_REQUEST['category_name'] = will contain building name.
		*/
		if ($_REQUEST['category_name']!='') {
			$postvars['title'] = stripslashes(trim($_REQUEST['category_name']));
			$postvars['ord'] = (getendfield($destinationtable,'ord','MAX')*1) + 1;
			$categoryid = form_to_table($destinationtable, $postvars);
			if(is_numeric($categoryid)) {
				$code = 1;
				$message = $_REQUEST['category_name'].' was added succssfully!';
			} else {
				$code = 0;
				$message = 'There was an error: '.$categoryid.'. Please try again or contact support.';
			}
		}
		break;

	case "title":
		// add new category.
		/*
			Values for this
		$_REQUEST['category_name'] = will contain building name.
		*/
		if ($_REQUEST['value']!='' && $_REQUEST['idr']) {
			$postvars['title'] = stripslashes(trim($_REQUEST['value']));
			$categoryid = form_to_table($destinationtable, $postvars, $_REQUEST['idr']);
			if(is_numeric($categoryid)) {
				$code = 1;
				$message = $_REQUEST['category_name'].' was changed succssfully!';
			} else {
				$code = 0;
				$message = 'There was an error: '.$categoryid.'. Please try again or contact support.';
			}
		}
		break;

	case "order":
		$categories = list_resources();
		$ordstart = 0; // start with lowest order... 0

		$ordcount = $ordstart;
		foreach ($_REQUEST['category'] as $cid) {
			if(in_array($cid, $categories)) {
				$update = "UPDATE `".$destinationtable."` SET ord='".$ordcount."' WHERE id='".$cid."'";
				$mysqli->query($update);
				$ordcount++;
			} else {
				echo $cid.' was not found in the array!.';
			}
		}

		if ($ordcount==count($categories)) {
			$code = 1;
			$message = 'Success - '.$ordcount.' category orders set right!';
		} else {
			$code = 0;
			$message = 'Something went wrong! Final order was '.$ordcount.' and we had '.count($categories).' '.$mysqli->error;
		}
		break;

	case "delete":
		if ($_REQUEST['idr']!='') {
			$links = list_resources($_REQUEST['idr']);
			if(!$links) {
				// links returend false which means it's empty, therefore deleteable!
				$sql = "DELETE FROM `".$destinationtable."` WHERE `id`='".$_REQUEST['idr']."'";
				$mysqli->query($sql);
				if($mysqli->affected_rows > 0 || 1==1) {
					$code = 1;
					$message = 'Category ID '.$_REQUEST['idr'].' was removed successfully!';
				} else {
					$code = 0;
					$message = 'Your Page Was Not Deleted Successfuly: '.$mysqli->error.'<br /><br />Query Attempted:<br />'.$sql;
				}
			} else {
				$code = 0;
				$message = 'Your Category Was Not Deleted Successfuly: Category ID '.$_REQUEST['idr'].' has '.count($links).' links under it to be removed first.';
			}
		} else {
			$code = 0;
			$message = 'Your Category Was Not Deleted Successfuly: Request ID '.$_REQUEST['idr'].' was not valid.';
		}
		break;

	default:
		$code = 0;
		$message = 'No change request was made, or data was invalid.';
		break;
} // end of the switch statement

// finally package it all to a JSON output and spit it out! 
$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
echo json_encode($json_array);

require_once 'ajax_footer.php';