<?php
/*
Filename: ajax_modifyresources.php

Method: AJAX
Output: AJAX/JSON

Description: Makes changes to resources under specific categories, such as order change, publish status change, or delete.  

Author: Jeff Kee
*/
include 'start.php';

// start.php runs validate_login() function.
$destinationfolder = 'resources';
$destinationtable = 'resources';

switch($_REQUEST['change']) {
    case "publishstatus":
        $sql = "UPDATE `".$destinationtable."` SET `publish`='".$_REQUEST['value']."' WHERE `id`='".$_REQUEST['idr']."'";
        $result = $mysqli->query($sql);
        if ($mysqli->affected_rows==1) {
            $code = 1;
            $message = 'Success';
        } else {
            $code = 0;
            $message = 'Your page publish status could not be changed: Error: '.$mysqli->error;
        }
        break;

    case "order":
        if ($_REQUEST['category']!='') {
            $query['categoryid'] = $_REQUEST['category'];
            $resources = get_resource_links($query, 'ord', 'asc', false, false); // ID is enough.
            $ordstart = 0; // start with lowest order... 0

            $ordcount = $ordstart;
            foreach ($_REQUEST['resource'] as $resourceid) {
                if(in_array($resourceid, $resources)) {
                    $update = "UPDATE ".$destinationtable." SET `ord`='".$ordcount."' WHERE `id`='".$mysqli->real_escape_string($resourceid)."'";
                    $mysqli->query($update);
                    $ordcount++;
                } else {
                    $code = 0;
                    $message = $resourceid.' was not found in the array!';
                }
            }

            if ($ordcount==count($resources)) {
                $code = 1;
                $message = 'Success - '.$ordcount.' page orders set right!';
            } else {
                $code = 0;
                $message = 'Something went wrong! Final order was '.$ordcount.' and we had '.count($resources).' '.$mysqli->error;
            }
        }
        break;

    case "pdf_label":
        $sql = 'SELECT pdf_labels FROM '.$destinationtable.' WHERE id = '.$mysqli->real_escape_string($_REQUEST['idr']);
        $result = $mysqli->query($sql);

        $labels = null;
        if ($array = $result->fetch_assoc()) {
            $labels = unserialize($array['pdf_labels']);
        }

        $labels[$_REQUEST['key']] = $_REQUEST['value'];
        ksort($labels);

        $labels = $mysqli->real_escape_string( serialize( $labels ) );

        $sql = "UPDATE $destinationtable SET pdf_labels = '$labels' WHERE id = ".$_REQUEST['idr'];
        $result = $mysqli->query($sql);
        if ($mysqli->affected_rows>0) {
            $code = 1;
            $message = $labels."\n";
            $message .= 'AJAX Updated pdf label key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for building '.$_REQUEST['idr'];
        } else {
            $code = 0;
            $message = $mysqli->error;
        }
        break;

    case "alt_tags":
        $sql = 'SELECT alt_tags FROM '.$destinationtable.' WHERE id = '.$_REQUEST['idr'];
        $result = $mysqli->query($sql);

        $labels = null;
        if ($array = $result->fetch_assoc()) {
            $labels = unserialize($array['alt_tags']);
        }

        $labels[$_REQUEST['key']] = $_REQUEST['value'];
        ksort($labels);

        $labels = $mysqli->real_escape_string( serialize( $labels ) );

        $sql = "UPDATE $destinationtable SET alt_tags = '$labels' WHERE id = ".$_REQUEST['idr'];
        $result = $mysqli->query($sql);
        if ($mysqli->affected_rows>0) {
            $code = 1;
            $message = $labels."\n";
            $message .= 'AJAX Updated Alt Tags key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for page '.$_REQUEST['idr'];
        } else {
            $code = 0;
            $message = $mysqli->error;
        }
        break;

    case "delete":
        if ($_REQUEST['idr']!='') {
            if($result = remove_object('resources', $_REQUEST['idr'])) {
                $code = 1;
                $message = 'Resource ID '.$_REQUEST['idr'].' was removed successfully!';
            } else {
                $code = 0;
                $message = 'Your Resource Was Not Deleted Successfully.<br />';
            }
        } else {
            $code = 0;
            $message = 'Your Resource was not deleted successfully: Request ID '.$_REQUEST['idr'].' was not valid.';
        }
        break;

    default:
        $code = 0;
        $message = 'Invalid change request: '.$_REQUEST['change'];
        break;
} // end of the switch statement

// finally package it all to a JSON output and spit it out! 
$json_array = array('code'=>$code, 'id'=>$_REQUEST['idr'], 'message'=>$message);
echo json_encode($json_array);

require_once 'ajax_footer.php';