<?php
/*
Filename: attach.php

Method: Direct
Output: Direct

Description: Master file that handles all the file uploads for main images, PDFs, youtube attachment etc. Not to be confused with the Gallery upload module!

Author: Jeff Kee
*/

include 'start.php';
check_login(9);
global $settings;
if($_REQUEST['folder']=='') {
	// if table is not set, default to homes.
	$destinationtable = 'homes';
	$destinationfolder = 'homes';
} else {
	$destinationtable = $_REQUEST['folder'];
	$destinationfolder = $_REQUEST['folder'];
}

if($destinationtable=='pages') {
	$page = new page;
	$page->initialize($_REQUEST['idr']);
	$subject = $page->title;
	$object = $page;
	$returnurl = 'pages.php';
} else if($destinationtable=='resources') {
	$resource = new resource;
	$resource->initialize($_REQUEST['idr']);
	$subject = $resource->title;
	$object = $resource;
	$returnurl = 'links.php';
} else if($destinationtable=='agents') {
	$agent = new agent;
	$agent->initialize($_REQUEST['idr']);
	$subject = $agent->displayname;
	$object = $agent;
	$returnurl = 'agents.php';
} else if($destinationtable=='buildings') {
	$building = new building;
	$building->initialize($_REQUEST['idr']);
	$subject = $building->name;
	$object = $building;
	$returnurl = 'buildings.php';
} else if($destinationtable=='homes') {
	$home = new home;
	$home->initialize($_REQUEST['idr']);
	$subject = $home->fulladdress;
	$object = $home;
	$returnurl = 'homes.php';
} else {
	die('invalid object type!');
}

if(!$object) { // invalid object, bounce them out!
	header('Location: '.$settings['sitepath'].'admin/');
}
$scriptinsert = "<script type=\"text/javascript\">";

// define the variables used throughout the JS UI modules.

$scriptinsert .= "
/*
$(document).bind('drop dragover', function (e) {
	console.log('caught default drag into window area');
    e.preventDefault();
});
*/

window.destinationfolder = '".$destinationfolder."';
window.idr = '".$_GET['idr']."';


";

// determine number of main images.
if(is_object($page)) {
	// in case of pages only the # of attached images can be set separately.

	if(is_array($page->mainwidth) && $page->mainheight) {
		$minnum = min(count($page->mainwidth), count($page->mainheight));
	} else {
		$minnum = 1;
	}

	$mainimagenum = ($minnum>0 ? $minnum : 1);
} else {
	$mainimagenum = ($settings[$destinationtable.'_mainphotonum']!='' ? $settings[$destinationtable.'_mainphotonum'] : 1);
}

// main image functions moved to mainimage.php and mainimage.js - 2019-04-02 by Jeff Kee

// determine number of PDF docs attached.
if($settings[$destinationtable.'_pdfnum']!='') {
	$pdfnum = $settings[$destinationtable.'_pdfnum'];
} else {
	$pdfnum = 1;
}


$count = 0;
while($count<$pdfnum) {
	// when count is 0, the suffix for the ids and classes are blank, so that everything just ends wihtout numbers. We only add the numbers once we get to 1.
	$suffix = ($count==0 ? '' : $count); // first div ID has no suffix, the subsequent ones do!

	$scriptinsert.="
			
	$(document).ready(function(){
		$('#removepdf".$suffix."').click(function(){
			
			var removeresult = remove_s3_file('".$destinationtable."', '".$object->id."', 'pdf', '".$count."');
			if(removeresult == true) {
				$('#".$settings[$destinationtable.'_pdffilename'][$count]."').html('PDF ".$count." removal was successful.');
			} else {
				$('#".$settings[$destinationtable.'_pdffilename'][$count]."').html('PDF ".$count." removal FAILED.');
			}
			
			$('#pdfpreview".$suffix." a').fadeTo(400, 0, function(){ 
				$(this).remove();
			});
		});
		
		$('#pdf_label$suffix').bind('change keyup input', function(){
			$('#update_pdflabel$suffix').removeClass('disabled').addClass('btn-primary');	
		})
		
		$('#update_pdflabel$suffix').click(function(){
			target = $(this).data('input');
			var val = $(target).val();
			var key = $(this).data('key');
			//console.log('logged key =  '+key+' and value = '+val);
			update_pdflabel(val, key);
			$(this).addClass('disabled').removeClass('btn-primary').blur();
		});
		
		


		
		$('#pdfinput".$suffix."').uploadifive({
			'uploadScript' : '/admin/ajax_uploadify.php',
			'auto' : true,
			'buttonClass': 'btn btn-block uploadifiveinput',
			'buttonText': 'Select or Drag and Drop',
			'method': 'post',
			'multi':false,
			'fileObjName': 'Filedata',
			'height': '120',
			'width': 'auto',
			'queueSizeLimit': 1,
			'fileType': ['application/pdf'],
			'removeCompleted': true,
			'queueID': 'pdfqueue".$suffix."',
			'itemTemplate' : '<p class=\"uploadifive-queue-item bg-success\">Currently Uploading <span class=\"filename\"></span> <span class=\"close\"></span>:</p>',
			'formData': {'homeid':'".$_GET['idr']."', 'idr':'".$_GET['idr']."','filename':'".$settings[$destinationtable.'_pdffilename'][$count]."',  'destinationfolder': '".$destinationfolder."'},
			
			'onSelect': function(queue) {
				console.log('onSelect running');
			},
			
			'onAddQueueItem' : function(file) {
				console.log('uploading file check');
				
				$('#pdfprogressbar".$suffix."').css('width', '0%').attr('aria-valuenow', 0);
				var fileName = file.name;
				var ext = fileName.substring(fileName.lastIndexOf(\".\")+1,fileName.length); // Extract EXT
				ext = ext.toLowerCase();
				console.log('checcking ext: '+ext);
				switch (ext) {
					case 'pdf':
						console.log('filetype ok');
					break;
					default:
						$('#pdfinput".$suffix."').uploadifive('cancel', file); // cancel current upload, 
						// $('#pdfinput".$suffix."').uploadifive('clearQueue'); // clear the queue!
						$('#filetype_pdf').modal('show');
					break;
				}
			},
			
						
			'onProgress': function (file, e) {
				console.log('onProgress running');
				var percentage = (e.loaded/e.total)*100;
				
				$('#pdfprogressbar".$suffix."').css('width', percentage+'%').attr('aria-valuenow', percentage);
				
			}, 
			
			'onCancel': function() {
				$('#pdfprogressbar".$suffix."').css('width', '0%').attr('aria-valuenow', 0);
			},
			
			'onError'      : function(errorType) {
				console.log(errorType);
			},
			
			'onUploadComplete': function (file, data) {
				$('#pdfprogressbar".$suffix."').css('width', '100%').attr('aria-valuenow', 100).delay(1000).css('width', '0%').attr('aria-valuenow', 0); 
				
				$('#pdfpreview".$suffix."').html('<a href=\"'+data+'\" target=\"_blank\" class=\"btn btn-default\"><span class=\"glyphicon glyphicon-search\"></span>&nbsp;&nbsp;&nbsp;Preview ".$settings[$destinationtable.'_pdfname'][$count]."</a>');
				
				refreshimage('current_main_image".$suffix."', '".$settings[$destinationtable.'_mainphotofilename'][$count]."','".$suffix."');

			},
		});
		
		$('#uploadifive-pdfinput".$suffix."').bind('dragover', function(){
			console.log('dragover');
			$(this).addClass('dragover');
			
		});
		$('#uploadifive-pdfinput".$suffix."').bind('dragleave', function(){
			console.log('dragleave');
			$(this).removeClass('dragover');
		});
		$('#uploadifive-pdfinput".$suffix."').bind('drop', function(){
			console.log('drop');
			$(this).removeClass('dragover');
		});
		
	});
	";
	$count++;
}


$youtubenum = $settings[$destinationtable.'_youtubenum'];

if($youtubenum>0) {
	// embed format.
	// <iframe width="560" height="315" src="//www.youtube.com/embed/2zV4tgWYx50?rel=0&amp;showinfo=0" frameborder="0" allowfullscreen></iframe>

	$scriptinsert.="

	
	function update_youtube(val, field, idr, suffix) {
		$.post(
			'ajax_modify".$destinationtable.".php',
			{change:'youtube', idr:idr, field:field, value: val},
			function(data){
				$('#youtubepreview'+suffix).html('');
				var videoid = data.message;
				console.log('video updated to '+videoid);
				$('#youtube'+suffix).val(videoid);
				var videohtml = youtube_frame(videoid);
				$('#youtubepreview'+suffix).html('').html(videohtml);
			}, 'json'
		);
	
	}
";

	$count = 0;
	while($count<$youtubenum) {
		$suffix = ($count==0 ? '' : $count); // first div ID has no suffix, the subsequent ones do!

		$scriptinsert .="
	$(document).ready(function(){
		
		$('#updateyoutube".$suffix."').click(function(){update_youtube($('#youtube".$suffix."').val(),'".$settings[$destinationtable.'_youtubefields'][$count]."','".$_REQUEST['idr']."','".$suffix."');});
		$('#removeyoutube".$suffix."').click(function(){update_youtube('','".$settings[$destinationtable.'_youtubefields'][$count]."','".$_REQUEST['idr']."','".$suffix."');});
	";
		if($object->data[$settings[$destinationtable.'_youtubefields'][$count]]!='') {
			// already has video, load the iFrame
			$scriptinsert.="
		$('#youtubepreview".$suffix."').html(youtube_frame('".$object->data[$settings[$destinationtable.'_youtubefields'][$count]]."'));
		";
		}

		$scriptinsert.="});";

		$count++;
	}

}// end of if statement that checks if youtubenum is at least 1




$vimeonum = $settings[$destinationtable.'_vimeonum'];

if($vimeonum>0) {
	$scriptinsert.="

	
	function update_vimeo(val, field, idr, suffix) {
		$.post(
			'ajax_modify".$destinationtable.".php',
			{change:'vimeo', idr:idr, field:field, value: val},
			function(data){
				$('#vimeopreview'+suffix).html('');
				var videoid = data.message;
				$('#vimeo'+suffix).val(videoid);
				var videohtml = vimeo_frame(videoid);
				$('#vimeopreview'+suffix).html('').html(videohtml);
			}, 'json'
		);
	}
";

	$count = 0;
	while($count<$vimeonum) {
		$suffix = ($count==0 ? '' : $count); // first div ID has no suffix, the subsequent ones do!
		$scriptinsert .="
	$(document).ready(function(){
		
	$('#updatevimeo".$suffix."').click(function(){update_vimeo($('#vimeo".$suffix."').val(),'".$settings[$destinationtable.'_vimeofields'][$count]."','".$_REQUEST['idr']."','".$suffix."');});
	$('#removevimeo".$suffix."').click(function(){update_vimeo('','".$settings[$destinationtable.'_vimeofields'][$count]."','".$_REQUEST['idr']."','".$suffix."');});
	
	";

		if($object->data[$settings[$destinationtable.'_vimeofields'][$count]]!='') {
			$scriptinsert.="
		$('#vimeopreview".$suffix."').html(vimeo_frame('".$object->data[$settings[$destinationtable.'_vimeofields'][$count]]."')); 
		";
		}

		$scriptinsert.= "});";
		$count++;
	}

}// end of if statement that checks if vimeo is at least 1



$scriptinsert.='</script>';

$scriptinclude = 'attach.js';

include 'header.php';
?>

	<div class="container">
		<div class="row bottom_40">
			<div class="col-md-12">
				<h1 class="text-center">Manage Attachments for "<?php echo $subject; ?>"</h1>
				<a href="<?=$returnurl?>" class="btn btn-default btn-lg"><span class="glyphicon glyphicon-arrow-left"></span>&nbsp;&nbsp;&nbsp;Back to The List</a>
			</div>
		</div>
		<div class="row">
			<div id="attachment_form_tab" class="col-lg-12 bottom_20">
				<ul class="nav nav-tabs" role="tablist">
					<?php
					if($pdfnum>0) {
						?>
						<li role="presentation"><a href="#pdfstab" role="tab" data-toggle="tab">PDF Files</a></li>
						<?php
					}
					if($youtubenum>0) {
						?>
						<li role="presentation"><a href="#youtubetab" role="tab" data-toggle="tab">Youtube Video</a></li>
						<?php
					}
					if($vimeonum>0) {
						?>
						<li role="presentation"><a href="#vimeotab" role="tab" data-toggle="tab">Vimeo Video</a></li>
						<?php
					}
					?>
				</ul>
			</div>

			<div class="tab-content" id="attachment_form_content">
				<?php
				if($pdfnum>0) {
					if($object->pdf_labels!==false) {
						$labels = $object->pdf_labels;
                    } else {
						$labels = false;
                    }

					?>
					<div role="tabpanel" class="col-lg-12 tab-pane" id="pdfstab">
					<?php
					// Loop through the number of PDF nums allowed.
					$count = 0;
					while($count<$pdfnum) {
						$suffix = ($count==0 ? '' : $count);
						?>
						<div class="row">
							<div class="col-sm-12">
								<h4><?=$settings[$destinationtable.'_pdfname'][$count]?></h4>
							</div>


							<div class="col-sm-6">
								<div class="row">
									<div class="col-xs-8">
										<input class="bottom_10 form-control trim_input" name="pdf_label<?=$suffix?>"  id="pdf_label<?=$suffix?>" placeholder="PDF Label here. E.g. Floorplan Units 400/500" value="<?=(isset($labels[$count]) && is_string($labels[$count]) ? htmlentities($labels[$count]) : '' )?>" />
									</div>
									<div class="col-xs-4">
										<button align="left" type="button" class="btn btn-inline-block update_label disabled" data-input="#pdf_label<?=$suffix?>" data-key="<?=$count?>" id="update_pdflabel<?=$suffix?>" value="Update Label">Update Label</button>
									</div>
								</div>
							</div>


							<div class="clear"></div>

							<div class="col-sm-4 col-xs-12 bottom_20">
								<input type="File" name="pdfinput<?=$suffix?>"  id="pdfinput<?=$suffix?>" />
							</div>

							<div class="col-sm-8 bottom_20">
								<div class="progress">
									<div id="pdfprogressbar<?=$suffix?>" class="progress-bar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" role="progressbar" style="width:0%;"></div>
								</div>
								<div class="row">
									<div class="col-md-12 uploadifivequeue" id="pdfqueue<?=$suffix?>"></div>
                                    <?php if($_COOKIE['username']=='brixwork') {?><a href="#" class="btn btn-warning"onclick="$('#pdfinput<?php echo $suffix;?>').uploadifive('debug');">Debug</a><?php } ?>
								</div>
							</div>
							<div class="clearfix"></div>
							<div class="col-sm-2 col-xs-4 bottom_40">
								<button align="left" type="button" class="btn btn-danger btn-block" name="removepdf<?=$suffix?>" id="removepdf<?=$suffix?>" value="Remove PDF"><span class="glyphicon glyphicon-minus"></span>&nbsp;&nbsp;&nbsp;Remove PDF</button>
							</div>
							<div class="col-sm-10" id="pdfpreview<?php echo $suffix;?>">
                                <?php
								$pdffilelink = $object->pdf_file_link($count, '<span class="glyphicon glyphicon-search"></span>&nbsp;&nbsp;&nbsp;Preview '.$settings[$destinationtable.'_pdfname'][$count], '', '', 'btn btn-default');
								if($pdffilelink) {
									echo $pdffilelink; // this already sorts through S3 then local storage.
								}
								?>
							</div>
						</div>
						<hr class="bottom_40" />
                        <?php
						$count++;
					}
					?>
					</div><?php // end of #pdfstab! ?>
                    <?php
				}
				if($youtubenum>0) {
					?>
					<div role="tabpanel" class="col-lg-12 tab-pane" id="youtubetab">
                    <?php
					$count = 0;
					while($count<$youtubenum) {
						$suffix = ($count==0 ? '' : $count);
						?>
						<div class="row form-group">
							<div class="col-sm-12">
								<h4>Youtube Video<?=($count>0 ? '#'.$count : '')?></h4>
							</div>
							<div class="col-sm-2">
								<label for="youtube<?php echo $suffix;?>" class="control-label" id="label_youtube<?php echo $suffix;?>">
									Enter Youtube URL:
								</label>
							</div>
							<div class="col-sm-6 bottom_20">
								<input type="text" name="youtube<?php echo $suffix;?>" id="youtube<?php echo $suffix;?>" class="form-control input-lg" size="40" value="<?php echo $object->data[$settings[$destinationtable.'_youtubefields'][$count]]; ?>" placeholder="https://youtube.com/v/6h432fyg..." />
							</div>
							<div class="col-sm-2 col-xs-6 bottom_20">
								<input type="button" class="btn btn-primary btn-block" name="updateyoutube<?php echo $suffix;?>" id="updateyoutube<?php echo $suffix;?>" value="Link Youtube Video" />
							</div>
							<div class="col-sm-2 col-xs-6 bottom_20">
								<button class="btn btn-danger btn-block" name="removeyoutube<?php echo $suffix;?>" id="removeyoutube<?php echo $suffix;?>" value="Unlink Youtube Video"><span class="glyphicon glyphicon-minus"></span>&nbsp;&nbsp;&nbsp;Remove Video</button>
							</div>
							<div class="clearfix"></div>
							<div id="youtubepreview<?php echo $suffix; ?>" class="col-sm-10 col-sm-offset-2">

							</div>
						</div>
						<hr class="bottom_40" />
                        <?php
						$count++;
					}
					?>
					</div><?php // end of #youtubetab! ?>
                    <?php
				}
				if($vimeonum>0) {
					?>
					<div role="tabpanel" class="col-lg-12 tab-pane" id="vimeotab">
                    <?php
					$count = 0;
					while($count<$vimeonum) {
						$suffix = ($count==0 ? '' : $count);
						?>
						<div class="row form-group">
							<div class="col-sm-12">
								<h4>Vimeo <?=($count>0 ? '#'.$count : '')?></h4>
							</div>
							<div class="col-sm-2">
								<label for="vimeo<?php echo $suffix;?>" class="control-label" id="label_vimeo<?php echo $suffix;?>">
									Enter Vimeo URL:
								</label>
							</div>
							<div class="col-sm-6 bottom_20">
								<input type="text" name="vimeo<?php echo $suffix;?>" id="vimeo<?php echo $suffix;?>" class="form-control input-lg" size="40" value="<?php echo $object->data[$settings[$destinationtable.'_vimeofields'][$count]]; ?>" placeholder="https://vimeo.com/6h432fyg..." />
							</div>
							<div class="col-sm-2 col-xs-6 bottom_20">
								<input type="button" class="btn btn-primary btn-block" name="updatevimeo<?php echo $suffix;?>" id="updatevimeo<?php echo $suffix;?>" value="Link Vimeo Video" />
							</div>
							<div class="col-sm-2 col-xs-6 bottom_20">
								<button class="btn btn-danger btn-block" name="removevimeo<?php echo $suffix;?>" id="removevimeo<?php echo $suffix;?>" value="Unlink Vimeo Video"><span class="glyphicon glyphicon-minus"></span>&nbsp;&nbsp;&nbsp;Remove Video</button>
							</div>
							<div class="clearfix"></div>
							<div id="vimeopreview<?php echo $suffix; ?>" class="col-sm-10 col-sm-offset-2">

							</div>
						</div>
						<hr class="bottom_40" />
                        <?php
						$count++;
					}
					?>
					</div><?php // end of vimeotab?>
                    <?php
				}
				?>
			</div>
		</div>
	</div>

<?php
modal_html('Filetype Not Accepted!', '<p>Filetype you chose cannot be accepted. Please use a PDF file.</p>', 'filetype_pdf', 'Got it!', false, false);
include 'footer.php';
?>