<?
/*
Filename: gallery.php

Method: Direct
Output: Direct

Description: Matser file for modifying gallery entities on homes/buildings/pages etc., universal. 

Author: Jeff Kee
*/
include 'start.php';
check_login(9);


if($_REQUEST['folder']=='') {
	// if table is not set, default to homes.
	$destinationtable = 'homes';
	$destinationfolder = 'homes';
} else {
	$destinationtable = $_REQUEST['folder'];
	$destinationfolder = $_REQUEST['folder'];
}

if($destinationtable=='pages') {
	$page = new page;
	$page->initialize($_REQUEST['idr']);
	$photo_subject = $page->title;
	$object = $page;
	$returnurl = 'pages.php';
} else if($destinationtable=='resources') {
	$resource = new page;
	$resource->initialize($_REQUEST['idr']);
	$photo_subject = $resource->title;
	$object = $resource;
	$returnurl = 'links.php';
} else if($destinationtable=='agents') {
	$agent = new agent;
	$agent->initialize($_REQUEST['idr']);
	$photo_subject = $agent->displayname;
	$object = $agent;
	$returnurl = 'agents.php';
} else if($destinationtable=='buildings') {
	$building = new building;
	$building->initialize($_REQUEST['idr']);
	$photo_subject = $building->name;
	$object = $building;
	$returnurl = 'buildings.php';
} else if($destinationtable=='homes') {
	$home = new home;
	$home->initialize($_REQUEST['idr']);
	$photo_subject = $home->fulladdress;
	$object = $home;
	$returnurl = 'homes.php';
} else {
	die('invalid object type!');
}



if($_REQUEST['folder']=='' && $_REQUEST['idr']=='') {
	// dead end without proper IDs - redirect to homes
	header("Location:".$settings['sitepath'].'admin/index.php');
}

$scriptinclude = array('aws-sdk-2.40.0.min.js', 'gallery.js?version='.$brixwork_version);

$scriptinsert = '<script type="text/javascript">';

$scriptinsert.="

window.destinationfolder = '".$destinationfolder."';
window.idr = '".$_REQUEST['idr']."';
window.bucket = '".$settings['s3_bucket']."';
window.gifpath = '".$settings['sitepath']."admin/images/ajax-loader.gif';
";

$scriptinsert .= '</script>';

include 'header.php';
?>

<div class="container">
	<div class="row">
		<div class="col-md-12">
			<h1 class="text-center">Photos For <?=$photo_subject?></h1>
			<a href="<?=$returnurl?>" class="btn btn-default btn-lg"><span class="glyphicon glyphicon-arrow-left"></span>&nbsp;&nbsp;&nbsp;Back to The List</a>
		</div>
	</div>
	
	<div class="row">
		<div class="col-md-4 col-md-push-8" id="galleryinput_container">
			<div class="row">
				<div class="col-md-12 bottom_20">
					<input type="file" id="galleryinput" name="galleryinput" />
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="progress">
						<div id="galleryprogressbar" class="progress-bar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" role="progressbar" style="width:0%;"></div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12 uploadifivequeue" id="galleryqueue"></div>
				<?if($_COOKIE['username']=='brixwork') {?><a href="#" class="btn btn-warning" onclick="$('#mainimageinput<? echo $suffix;?>').uploadifive('debug');">Debug</a><? } ?>
			</div>
		</div>
		<div class="col-md-8 col-md-pull-4">
			<div class="row">
				<div class="col-md-2 col-md-offset-8">
					<button class="btn btn-info btn-xs btn-block" id="delete_toggle"><span class="glyphicon glyphicon-th-list"></span>&nbsp;&nbsp;Toggle All</button>
				</div>
				<div class="col-md-2 bottom_10">
					<button class="btn btn-danger btn-xs btn-block" id="deletephotos"><span class="glyphicon glyphicon-minus"></span>&nbsp;&nbsp;Delete</button>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12" id="photolist">
					
				</div>
			</div>
		</div>
		
	</div>
</div>

<?
modal_html('Filetype Not Accepted!', '<p>Filetype you chose cannot be accepted. The non-JPG files will be automatically removed from the list of files to upload.</p>', 'filetype_jpg', 'Got it!', false, false);


$delete_multi_photos = 'delete_multi_photos(window.deletearray)';
modal_html('Delete Photos?', '<p>Are you sure you want to delete the selected photos?</p>', 'delete_confirm', 'Yes, Delete', 'Cancel', $delete_multi_photos);
include 'footer.php';
?>

