<?php
/**
 * Filename: homes.php
 * Description: display "homes" object -
 */
include 'start.php';
global $settings, $login_user;

// TODO: REVERT BACKT TO HOMES.JS
$scriptinclude = 'homes.source.js';

$destinationfolder = 'homes';
$destinationtable = 'homes';

include 'header.php';
// header_html is separated from header.php on purpose.
include 'includes/header_html.php';

$svg_append = 'images/admin_function_icon/';
$plus_sign_svg = get_svg(file_get_contents($svg_append.'plus_sign.svg', true))
?>

<div id="listings_gallery_intro" class="brixwork_admin_container title">
    <h1 id="admin_page__title">Your Listings</h1>

    <div id="listings_filter_row" class="row">
        <h5 class="filter_title">Filter</h5>

        <div id="listings_filter__status" class="col-md-3 py-1 py-lg-0">
            <select class="form-select homes_filter" name="sold" id="homes_filter_sold" aria-label="homes_filter">
                <option value="">All Listings</option>
                <option value="0" <?=($_COOKIE['homes_filter_sold']==0 && isset($_COOKIE['homes_filter_sold']) ? 'selected="selected"': '')?>>Active Listings</option>
                <option value="1" <?=($_COOKIE['homes_filter_sold']==1 && isset($_COOKIE['homes_filter_sold']) ? 'selected="selected"': '')?>>Sold Listings</option>
                <option value="2" <?=($_COOKIE['homes_filter_sold']==2 && isset($_COOKIE['homes_filter_sold']) ? 'selected="selected"': '')?>>Show On Both</option>
            </select>
        </div>

        <div id="listings_filter__city" class="col-md-3 py-1 py-lg-0">
            <select name="city" id="homes_filter_city" class="form-select homes_filter" data-placeholder="Choose a City" autocomplete="off" aria-label="homes city filter">
                <option value="" selected="selected">City</option>
                <?php
                foreach($GLOBALS[BRIX_AREAS_CACHE] as $city) {
                    if($city['publish']==1) {
                        if (strtolower($city['name'] ?: '') == strtolower($params['city'] ?: '')) {
                            $selectedtext = ' selected="selected"';
                        } else {
                            $selectedtext = '';
                        }
                        echo '<option rel="' . $city['id'] . '" value="' . $city['name'] . '" ' . $selectedtext . '>' . $city['name'] . '</option>';
                    }
                } ?>
            </select>
        </div>

        <div id="listings_filter__street" class="col-md-4 py-1 py-lg-0">
            <input type="text" class="form-control homes_filter" id="homes_filter_street" name="street" placeholder="Street Name: i.e. Pier West" size="20" aria-label="homes street filter"/>
        </div>

        <div id="listings_filter__button" class="col-md-2 py-1 py-lg-0">
            <button class="btn btn-admin" id="homes_filter_trigger">Filter</button>
        </div>
    </div>

    <div id="listings_filter_row" class="row">
        <h5 class="filter_title">Listings per Page</h5>
        <div id="listings_filter__perpage" class="col-md-4 col-sm-5">
            <select id="perpage" class="form-select" aria-label="Per Page Filter">
                <option value="25">25 per page</option>
                <option value="50">50 per page</option>
                <option value="100">100 per page</option>
                <option value="250">250 per page</option>
            </select>
        </div>

        <div id="listings_filter__legend" class="col-md-8 col-sm-7 pt-4 pt-md-0">
            <div id="each_legend" class="sold">
                <p data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Listings marked with this color are Sold">
                    <i class="bi bi-square-fill"></i>&nbsp;&nbsp;Sold
                </p>
            </div>

            <div id="each_legend" class="active">
                <p data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Listings marked with this color are currently Active">
                    <i class="bi bi-square-fill"></i>&nbsp;&nbsp;Active
                </p>
            </div>

            <div id="each_legend" class="reciprocity">
                <p data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Listings marked with this color are featured from MLS - not your own">
                    <i class="bi bi-square-fill"></i>&nbsp;&nbsp;Reciprocity
                </p>
            </div>
        </div>
    </div>


    <?php // only available for higher access than content manager OR agents that actually have agents attached!
    if ( login_level_check(USER_LOGIN_CONTENT_MANAGER) || ($login_user->getLevel() == USER_LOGIN_AGENT && $login_user->getAgents()) ) { ?>
        <div id="add_object_wrapper" class="pt-4">
            <button id="add_new_object_btn" type="button" class="btn btn-admin light_blue" data-bs-toggle="modal" data-bs-target="#add_listing_modal">
                <span><?=$plus_sign_svg?></span><span class="title">Add New Listing</span>
            </button>
        </div>
    <?php
    } ?>
</div>

<?php
// DISPLAY WARNING FOR DUPLICATE HOMES
$duplicate_homes_sql = "SELECT COUNT( * ) AS `cnt`, GROUP_CONCAT( CAST( Id AS CHAR ) ) AS `ids`, `mls` FROM `homes` WHERE `mls` !=  '' GROUP BY `mls` HAVING COUNT( * ) >1 ORDER BY `modify_date` DESC LIMIT 0, 20";
$duplicate_homes_res = $mysqli->query($duplicate_homes_sql);

if ($settings['mls_integrated'] == 1 && $duplicate_homes_res->num_rows > 0):
    $duplicate_warning__string = $duplicate_homes_res->num_rows > 1 ? $duplicate_homes_res->num_rows.' Duplicate Homes' : $duplicate_homes_res->num_rows.' Duplicate Home';
    ?>
    <div class="brixwork_admin_container py-2" id="duplicate_warning_js">
        <div class="warning_wrapper duplicate">
            <a class="duplicate_homes_resolve_trigger" rel="<?=$duplicate_homes_res->num_rows?>"><?=$duplicate_warning__string?> Found. Click here to resolve</a>
        </div>
    </div>

    <?php
    // create modals to resolve duplicates
    $counter = 0;
    $duplicate_instances = $duplicate_homes_res->num_rows;

    while ($duplicate_homes = $duplicate_homes_res->fetch_assoc()) {
        $counter++;
        $duplicate_mls = $duplicate_homes['mls'];
        $duplicate_homes_array = explode(',',$duplicate_homes['ids']);

        // for each instance of the duplicate, create modal
        $modal_body = "<p>Duplicate MLS#$duplicate_mls detected. Select the listing to keep. The other listings will be permanently deleted.</p>";

        foreach ($duplicate_homes_array as $index => $duplicate_id) {
            $each_dup_home = new home;
            $each_dup_home->initialize($duplicate_id);
            $main_img = $each_dup_home->get_main_images(0, 275, 200, $settings['sitepath'].'admin/images/noimage.jpg', array('img-full'));

            $checked = $index == 0 ? 'checked' : '';

            $label_address = trim($each_dup_home->address) === "" ? 'No Address' : $each_dup_home->address;
            $label_city = $each_dup_home->areacity ?: 'No City Specified';
            $label_own = intval($each_dup_home->source) === 0 ? 'Own Listing' : 'MLS® Listing';
            $label = "
                <h4 class='address'>$label_address</h4>
                <h6 class='area_city'>$label_city</h6>
                <h6 class='mls_num'>MLS&reg; Number: $duplicate_mls</h6>
                <h6 class='own_listing'>$label_own</h6>";

            // add on to the html.
            $modal_body .= "
                <div class='each_duplicate_bldg'>
                    <div id='brixwork_radio_check' class='form-check'>
                        <input type='radio' class='form-check-input brixwork_radio duplicate_home' value='$each_dup_home->id' name='$duplicate_mls' id='duplicate_home_$each_dup_home->id' $checked>
                        <label class='form-check-label default' for='duplicate_home_$each_dup_home->id'>$label</label>
                    </div>
                    <div class='duplicate_bldg_img'>
                        $main_img
                    </div>
                </div>";
        }

        // modal html
        brixwork_modal_html(array(
            'header_content' => 'Resolve Duplicate Listings ('.$counter.'/'.$duplicate_instances.')',
            'body_content' => $modal_body,
            'footer_content' => "
                <button type='button' class='btn btn-admin resolve_dup_homes' rel='$duplicate_mls' data-bs-dismiss='modal'>Keep Selected</button>",
            'id' => 'resolve_dup_listing_'.$counter
        ));
    }
endif; // end of duplicate listing warning. ?>


<div class="brixwork_admin_container" id="homeslist">
	<?php // AJAX loaded list of homes here. ?>
</div>


<?php
//echo '<div id="anaData"></div>';
//echo '<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>';
include 'footer.php';



// ADD NEW LISTING CONFIRMATION MODAL - USUALLY NOT VISIBLE
/**
 * Need to know what's required for this to function
 * JS? Object data?
 */
$mls_search_html__body = '
    <p>Listings can be added through a MLS® Number or manually added. MLS® Listings can then be set to either be featured or set as your own listing.</p>
    <div class="mls_input_wrapper">
    <form id="mls_number" class="needs-validation" novalidate>
        <label for="mls" class="control-label">MLS&reg; Number</label>
        <input aria-label="mls search" autocomplete="off" type="text" name="mls" id="mls" class="form-control" tabindex="0" value="" placeholder="Enter MLS&reg; #" required/>
        <div class="invalid-feedback">MLS® Number is required for this action!</div>
    </form>
    </div>';
$mls_search_html__footer = '
    <button type="submit" form="mls_number" class="btn btn-admin" id="mls_search_trigger">Scan MLS®</button>
    <a type="button" class="btn btn-admin light_blue" id="add_manually_button" href="homes_mod.php">Add Manually</a>';
$mls_search_modal_options = array(
    'header_content'    => 'Adding New Listing',
    'body_content'      => $mls_search_html__body,
    'footer_content'    => $mls_search_html__footer,
    'id'                => 'add_listing_modal',
    'label'             => 'Adding New Listing'
);
brixwork_modal_html($mls_search_modal_options);


// Delete Modal
$delete_agent_modal__body   = 'Auto Filled';
$delete_agent_modal__footer = '
    <button type="button" class="btn btn-admin" data-bs-dismiss="modal">Keep Listing</button>
    <button type="button" class="btn btn-admin light_blue" id="delete_home_btn">Delete Listing</button>';
$delete_agent_modal__options = array(
    'header_content' => 'Delete Listing',
    'body_content' => $delete_agent_modal__body,
    'footer_content' => $delete_agent_modal__footer,
    'id' => 'delete_home'
);
brixwork_modal_html($delete_agent_modal__options);


// BUILD MODAL FOR SUCCESSFUL MLS SEARCH
$listing_found_html__body = '<p>We found the listing you are looking for. If this is your own listing, or if you have permission to do so from the listing agent, you can show as your own. If you simply want to show it on your site but not claim ownership, you can feature it.</p>';
$listing_found_html__footer = '
    <button type="button" class="btn btn-admin" id="mls_found_convert" data-bs-dismiss="modal">Convert to my Own</button>
    <button type="button" class="btn btn-admin light_blue" id="mls_found_feature" data-bs-dismiss="modal">Feature Only</button>';
$listing_found_modal_option = array(
    'header_content' => 'Listing Found',
    'body_content' => $listing_found_html__body,
    'footer_content' => $listing_found_html__footer,
    'id' => 'mls_found'
);
brixwork_modal_html($listing_found_modal_option);


// BUILD MODAL FOR FAILED SEARCH
$listing_failed_html__body = '<p id="mls_failed__body">The number you entered is not yet found on the system. New listings can take a day or two to be fed into our system from the local real estate board</p><p>If you think that this listing should be available already, please <a href="https://support.brixwork.com/customer/portal/emails/new" target="_blank">contact our support desk</a> with the MLS # and your real estate board information.</p><p class="text-success">We recommend manually entering it however to get better position on Google&trade; search results.</p>';
$listing_failed_html__footer ='<a type="button" class="btn btn-admin light_blue" id="add_manually_button" href="homes_mod.php">Add Manually</a>';
$listing_failed_modal_option = array(
    'header_content' => 'Cannot Find This Listing',
    'body_content' => $listing_failed_html__body,
    'footer_content' => $listing_failed_html__footer,
    'id' => 'mls_failed'
);
brixwork_modal_html($listing_failed_modal_option);