<?php // RENTAL OR LEASE TAB - HOMES DETAILS ?>

<div id="rental_rates_detail" class="each_tab__category brixwork_inner_spacing residential">
    <h3 class="each_tab__category_title">Rental Rates</h3>

    <div class="row">
        <div class="col-lg-4 mb-4 mt-auto">
            <label for="rental_price_month" class="control-label orange">Per Month</label>
            <input type="text" name="rental_price_month" id="rental_price_month" class="form-control" size="10" value="<?=$home->data['rental_price_month']?>" placeholder="i.e. $3000">
        </div>
        <div class="col-lg-4 mb-4 mt-auto">
            <label for="rental_price_week" class="control-label orange">Per Week</label>
            <input type="text" name="rental_price_week" id="rental_price_week" class="form-control" size="10" value="<?=$home->data['rental_price_week']?>" placeholder="i.e. $750" />
        </div>
        <div class="col-lg-4 mb-4 mt-auto">
            <label for="rental_price_day" class="control-label orange">Per Day</label>
            <input type="text" name="rental_price_day" id="rental_price_day" class="form-control" size="10" value="<?=$home->data['rental_price_day']?>" placeholder="i.e. $150" />
        </div>
    </div>
</div>

<div id="rental_dates_detail" class="each_tab__category brixwork_inner_spacing residential">
    <h3 class="each_tab__category_title">Dates & Duration</h3>

    <div class="row">
        <div class="col-lg-6 mb-4 mt-auto">
            <label for="rental_min_term" class="control-label orange">Minimum Rental Term</label>
            <input type="text" name="rental_min_term" id="rental_min_term" class="form-control" value="<?=$home->data['rental_min_term']?>" placeholder="i.e. 6 Months Minimum Lease Term" />
        </div>

        <div class="col-lg-3 mb-4 mt-auto">
            <label for="rental_availability" class="control-label orange">Available from</label>
            <input type="date" name="rental_availability" id="rental_availability" class="form-control" value="<?=($home->data['rental_availability'] != '0000-00-00' ? $home->data['rental_availability'] : '');?>" placeholder="2023-01-23" />
        </div>
    </div>
</div>

<div id="rental_features_detail" class="each_tab__category brixwork_inner_spacing residential">
    <h3 class="each_tab__category_title">Included Features</h3>

    <div class="row">
        <div class="col-lg-4 mb-4 mt-auto">
            <?php $rental_furnished = $home->data['rental_furnished'] == '1' ?>
            <label for="rental_furnished" class="control-label orange">Furnished</label>
            <select id="rental_furnished" name="rental_furnished" class="form-select">
                <option value="0" <?=$rental_furnished ? '' : 'selected'?>>Unfurnished</option>
                <option value="1" <?=$rental_furnished ? 'selected' : ''?>>Furnished</option>
            </select>
        </div>

        <div class="col-lg-4 mb-4 mt-auto">
            <?php $pets_allowed = $home->data['rental_pets'] == '1' ?>
            <label for="rental_pets" class="control-label orange">Pets Allowed</label>
            <select id="rental_pets" name="rental_pets" class="form-select">
                <option value="0" <?=$pets_allowed ? '' : 'selected'?>>No</option>
                <option value="1" <?=$pets_allowed ? 'selected' : ''?>>Yes</option>
            </select>
        </div>

        <div class="col-lg-4 mb-4 mt-auto">
            <label for="rental_washerdryer" class="control-label orange">Washer/ Dryer</label>
            <select id="rental_washerdryer" name="rental_washerdryer" class="form-select">
                <option value="0" <?php if($home->data['rental_washerdryer']=='0'){echo "selected";}?>>N/A</option>
                <option value="1" <?php if($home->data['rental_washerdryer']=='1'){echo "selected";}?>>Common Laundry</option>
                <option value="2" <?php if($home->data['rental_washerdryer']=='2'){echo "selected";}?>>In Suite</option>
            </select>
        </div>

        <div class="col-lg-4 mb-4 mt-auto">
            <?php $dishwasher = $home->data['rental_dishwasher'] == '1' ?>
            <label for="rental_dishwasher" class="control-label orange">Dishwasher</label>
            <select id="rental_dishwasher" name="rental_dishwasher" class="form-select">
                <option value="0" <?=$dishwasher ? '' : 'selected'?>>No</option>
                <option value="1" <?=$dishwasher ? 'selected' : ''?>>Yes</option>
            </select>
        </div>

        <div class="col-lg-4 mb-4 mt-auto">
            <label for="rental_parking" class="control-label orange">Parking</label>
            <select id="rental_parking" name="rental_parking" class="form-select">
                <option value="0" <?php if($home->data['rental_parking']=='0'){echo "selected";}?>>No Parking</option>
                <option value="1" <?php if($home->data['rental_parking']=='1'){echo "selected";}?>>1 Car</option>
                <option value="2" <?php if($home->data['rental_parking']=='2'){echo "selected";}?>>2 Cars</option>
                <option value="3" <?php if($home->data['rental_parking']=='3'){echo "selected";}?>>3 Cars</option>
                <option value="4" <?php if($home->data['rental_parking']=='4'){echo "selected";}?>>4 Cars</option>
                <option value="5" <?php if($home->data['rental_parking']=='5'){echo "selected";}?>>5 Cars</option>
                <option value="6" <?php if($home->data['rental_parking']=='6'){echo "selected";}?>>6 Cars</option>
            </select>
        </div>

        <div class="col-lg-4 mb-4 mt-auto">
            <?php $smoking_allowed = $home->data['rental_smoking'] == '1' ?>
            <label for="rental_smoking" class="control-label orange">Smoking Allowed</label>
            <select id="rental_smoking" name="rental_smoking" class="form-select">
                <option value="0" <?=$smoking_allowed ? '' : 'selected'?>>No</option>
                <option value="1" <?=$smoking_allowed ? 'selected' : ''?>>Yes</option>
            </select>
        </div>
    </div>
</div>

<div id="lease_rates_detail" class="each_tab__category brixwork_inner_spacing commercial">
    <h3 class="each_tab__category_title">Lease Rates</h3>

    <div class="row">
        <div class="col-lg-4 mb-4">
            <label for="comm_price_sqft_y" class="control-label orange">$/SQFT</label>
            <input type="text" name="comm_price_sqft_y" id="comm_price_sqft_y" class="form-control trim_input" size="10" value="<?=$home->data['comm_price_sqft_y']?>" placeholder="i.e. $24" />
        </div>

        <div class="col-lg-4 mb-4">
            <label for="comm_price_addl_y" class="control-label orange">Additional Rent Fee</label>
            <input type="text" name="comm_price_addl_y" id="comm_price_addl_y" class="form-control trim_input" size="10" value="<?=$home->data['comm_price_addl_y']?>" placeholder="i.e. $6" />
        </div>

        <div class="col-lg-4 mb-4 mt-auto">
            <?php // tooltip build
            $net_lease_tooltip = 'data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="To override the automatically calculated value, double-click the input field."'
            ?>
            <label for="comm_rental_rate" class="control-label orange" <?=$net_lease_tooltip?>>Net Monthly</label>
            <input type="text" name="comm_rental_rate" id="comm_rental_rate" class="form-control trim_input" size="10" value="<?=$home->data['comm_rental_rate']?>" placeholder="Auto calculated" readonly>
            <small id="comm_rental_rate_flag" class="text-danger">
                Enter $/sqft and additional fee (monthly).
            </small>
            <input type="hidden" id="comm_rental_rate_override" value="0" />
        </div>
    </div>
</div>

<div id="rental_dates_detail" class="each_tab__category brixwork_inner_spacing commercial">
    <h3 class="each_tab__category_title">Dates & Duration</h3>

    <div class="row">
        <div class="col-lg-3 mb-4 mt-auto">
            <label for="comm_availability" class="control-label orange">Available</label>
            <input type="date" name="comm_availability" id="comm_availability" class="form-control" value="<?= ($home->data['comm_availability'] != '0000-00-00' ? $home->data['comm_availability'] : '');?>" />
        </div>

        <div class="col-lg-3 mb-4 mt-auto">
            <label for="comm_tenant_lease_end" class="control-label orange">Lease End Date</label>
            <input type="date" name="comm_tenant_lease_end" id="comm_tenant_lease_end" class="form-control" value="<?=($home->data['comm_tenant_lease_end'] != '0000-00-00' ? $home->data['comm_tenant_lease_end'] : '');?>" />
        </div>
    </div>
</div>