 <?php
/**
 * THIS _MOD__PHOTOS.PHP IS USED BY ALL BRIXWORK OBJECT TYPES: PAGE, BUILDING, AGENTS ... etc
 * SET $preset_object_type RIGHT BEFORE INCLUDING THIS PHP FILE.
 *
 * object types: pages, resources, agents, buildings, homes;
 *
 * $object_type = formerly used as $destinationtable
 */
$object_type = $preset_object_type;

$mainimagenum = ($settings[$object_type.'_mainphotonum'] != '' ? $settings[$object_type.'_mainphotonum'] : 1);
check_s3_attachments($object_type, $object->id);

// build useful variables to be used by Javascript.
$scriptinsert =
    "<script type=\"text/javascript\">
        window.img_original_height = [];
        window.img_original_width = [];
        window.main_img_num = '".$mainimagenum."'; // this will be looped through to build alt_tags for each images
    </script>";
echo $scriptinsert;
?>

<?php // FIRST ROW -- Lead / Main Images ?>
<h2 class="pb-4">Custom Designed Photos</h2>

<?php // LOOP THROUGH MAIN IMAGES HERE
for ($main_counter = 0; $main_counter < $mainimagenum; $main_counter++):
    $suffix = $main_counter > 0 ? $main_counter : ''; // first suffix is empty, numbered afterwards

    /** @var $page page     If object is PAGE, get title & dimension from different place. */
    // Get dimensions for each main images
    if (is_object($page)):
        // ALLOW PAGE IMAGE DIMENSIONS & TITLE TO BE EDITABLE
        if ($main_counter == 0) {
            // first iteration - if it's not array, then it is a single value, so do not use index
            $main_img_title  = is_array($page->main_img_titles) ? ($page->main_img_titles[$main_counter] ?: $settings[$object_type.'_mainphotoname'][$main_counter]) : ($page->main_img_titles ?: $settings[$object_type.'_mainphotoname'][$main_counter]);
            $main_img_width  = is_array($page->mainwidth)   ? ($page->mainwidth[$main_counter]  ?: $settings[$object_type.'_mainphotowidth'][$main_counter])    : ($page->mainwidth ?: $settings[$object_type.'_mainphotowidth'][$main_counter]);
            $main_img_height = is_array($page->mainheight)  ? ($page->mainheight[$main_counter] ?: $settings[$object_type.'_mainphotoheight'][$main_counter])   : ($page->mainheight ?: $settings[$object_type.'_mainphotoheight'][$main_counter]);
        } else {
            // other iterations - if it's not array, single value filled the first iteration, so rest of iteration can fall back to admin setting.
            $main_img_title  = is_array($page->main_img_titles) ? ($page->main_img_titles[$main_counter] ?: $settings[$object_type.'_mainphotoname'][$main_counter]) : $settings[$object_type.'_mainphotoname'][$main_counter];
            $main_img_width  = is_array($page->mainwidth)   ? ($page->mainwidth[$main_counter] ?: $settings[$object_type.'_mainphotowidth'][$main_counter]) : $settings[$object_type.'_mainphotowidth'][$main_counter];
            $main_img_height = is_array($page->mainheight)  ? ($page->mainheight[$main_counter] ?: $settings[$object_type.'_mainphotoheight'][$main_counter]) : $settings[$object_type.'_mainphotoheight'][$main_counter];
        }
    else:
        $main_img_title     = $settings[$object_type.'_mainphotoname'][$main_counter];
        $main_img_width     = $settings[$object_type.'_mainphotowidth'][$main_counter];
        $main_img_height    = $settings[$object_type.'_mainphotoheight'][$main_counter];
    endif;

    if ($main_img_width == '' && $main_img_height == '') continue; // if both width and height is missing, do not display.

    // useful variables.
    $main_img_dimension_display = $main_img_width.' x '.$main_img_height;
    $filename = ($settings[$object_type.'_mainphotofilename'][$main_counter]!='' ? $settings[$object_type.'_mainphotofilename'][$main_counter] : 'main'.$suffix.'.jpg');
    $ext = get_image_extension($filename); // whether it's jpeg, jpg, it truncates here to 3 letter format.
    $mimetype = get_image_mimetype($ext);
    $main_img_path[$main_counter] = $object ? $object->get_main_images_path($main_counter, false, false) : '';      // object may not exist when adding "new"

    // Get Alt tag labels ... does not exist for "new"
    $labels_sql = 'SELECT alt_tags FROM '.$object_type.' WHERE id = '.$object->id;
    $labels_result = $mysqli->query($labels_sql);
    $alt_tags = null;
    if ($object && $array = $labels_result->fetch_assoc()) {
        $alt_tags = unserialize($array['alt_tags']);
    }
    ?>

    <div id="main_image_section" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title"><?=$main_img_title?> (<?=$main_img_dimension_display?>)</h3>

        <?php // uploadifive library inserted here ?>
        <input type="File"
               name="mainimageinput<?=$suffix?>"
               class="mainimageinput"
               id="mainimageinput<?=$suffix?>"
               data-filename="<?=$filename?>"
               data-width="<?=$main_img_width?>"
               data-height="<?=$main_img_height?>"
               data-ext="<?=$ext?>"
               data-mimetype="<?=$mimetype?>"
               rel="<?=$suffix?>"
               accept="image/*" />

        <div class="progress my-3">
            <div id="mainimageprogressbar<?=$suffix?>" class="progress-bar mainimageprogressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" role="progressbar" style="width:0;"></div>
        </div>

        <div class="row">
            <div class="col-12 uploadifivequeue mainimagequeue" id="mainimagequeue<?=$suffix?>">
                <?php // probably where the img goes ... give full width for editing space. ?>
            </div>

            <div class="jcrop_wrapper col-12 py-3 d-flex justify-content-center">
                <div id="main_img_crop<?=$suffix?>"></div>
            </div>


            <div id="current_main_image<?= $suffix;?>" class="col-lg-6 current_main_image <?=($main_img_path[$main_counter] && $ext=='png' ? 'png_bg' : '')?> d-flex">
                <?php
                $enable_delete_button = false;
                if ($main_img_path[$main_counter]):
                    // MAIN IMAGE EXISTS!
                    $enable_delete_button = true;
                ?>
                    <img src="<?=$main_img_path[$main_counter]?>" class="img-full jcrop-image-preview" alt="lead image <?=$main_counter?> for display"/>
                <?php
                else: // NO MAIN IMAGE.?>
                    <div class="d-flex w-100" style="border: 1px dotted #cecece; align-items: center; justify-content: center">
                        <h4 class="m-0">No Image</h4>
                    </div>
                <?php
                endif; ?>
            </div>

            <div class="col-lg-6 mt-4 d-flex flex-column justify-content-center my-3">
                <label for="alt_tags<?=$suffix?>" class="control-label orange">Image Meta Description</label>
                <input class="form-control alt_tags<?=$suffix?>" name="alt_tags<?=$suffix?>"  id="alt_tags<?=$suffix?>" data-key="<?=$main_counter?>" placeholder="Describe the image here & click Update Tags below." value="<?=htmlentities($alt_tags[$main_counter] ?: '')?>" />
                <div class="pt-2 pb-4">
                    <a type="button" class="update_label disabled alt_tags<?=$suffix?>" data-input="#alt_tags<?=$suffix?>" data-key="<?=$main_counter?>" id="update_alt_tags<?=$suffix?>">Update Tags</a>
                </div>

                <div class="main_img__function_wrapper">
                    <button type="button" class="btn btn-admin maincrop m-0" name="maincrop<?=$suffix?>" id="maincrop<?=$suffix?>" rel="<?=$suffix?>" disabled>Crop</button>
                    <div>
                        <a class="removemainimage <?=$enable_delete_button ? '' : 'd-none'?>" id="removemainimage<?=$suffix?>" rel="<?=$suffix?>">Delete Image</a>
                    </div>

                    <?php if (login_level_check(1)): ?>
                        <div class="my-0">
                            <a class="" onclick="$('#mainimageinput<?=$suffix;?>').uploadifive('debug');">Debug</a>
                        </div>
                    <?php endif; ?>
                </div>
            </div>

            <?php // hidden data keeping input ?>
            <div class="col-12">
                <input type="hidden" size="4" id="main<?=$suffix?>x" />
                <input type="hidden" size="4" id="main<?=$suffix?>y" />
                <input type="hidden" size="4" id="mainx<?=$suffix?>2" />
                <input type="hidden" size="4" id="mainy<?=$suffix?>2" />
                <input type="hidden" size="4" id="main<?=$suffix?>w" />
                <input type="hidden" size="4" id="main<?=$suffix?>h" />
            </div>
        </div>
    </div>
<?php
endfor; ?>



<?php // DISPLAY GALLERY OF PHOTOS ... only for homes & Buildings
if ($object_type === 'homes' || $object_type === 'buildings'):
?>
<h2 class="py-4">Photo Gallery</h2>
<div id="photo_gallery_section" class="each_tab__category brixwork_inner_spacing w-100">
    <?php // uploadify ui goes here ?>
    <input type="file" id="galleryinput" name="galleryinput" />
    <div class="progress my-3">
        <div id="galleryprogressbar" class="progress-bar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" role="progressbar" style="width:0%;"></div>
    </div>
    <div class="col-md-12 uploadifivequeue" id="galleryqueue"></div>

    <div class="gallery_functions_wrapper">
        <?php // SELECT ALL BUTTON & DELETE BUTTON GOES HERE ?>
        <div class="each_function_button">
            <button class="btn btn-admin light_blue" type="button" id="delete_toggle">Select All</button>
        </div>
        <div class="each_function_button">
            <button class="btn btn-admin reddish" type="button" id="deletephotos">Delete</button>
        </div>


        <?php
        if (login_level_check(1)):  // debug ... only visible to brixwork login ?>
            <div class="my-auto">
                <a href="#" class="" onclick="$('#galleryinput').uploadifive('debug');">Debug</a>
            </div>
        <?php
        endif; ?>
    </div>

    <div class="row mt-4">
        <div class="col-lg-7" id="photolist">
            <?php // POPULATE THIS HTML WITH AJAX CREATED GALLERY ?>
        </div>
        <div class="col-lg-4 mt-4 px-4 " id="gallery_tip">
            <?php
            $svg_append = 'images/admin_function_icon/';
            echo get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true));
            ?>
            <p class="my-4">
                Images can be reordered by dragging and dropping on the image thumbnail. <br><br>
                The text fields here correspond to what title is displayed on each image. Not only does this have SEO implications, it creates a better viewing experience for users.
            </p>
        </div>
    </div>
</div>
<?php
endif; ?>


<?php
// BUILD MODAL FOR DELETING GALLERY PHOTO
$delete_gallery_photo__body = '<p>Are you sure you want to delete the selected photos?</p>';
$delete_gallery_photo__footer = '
    <button type="button" class="btn btn-admin" data-bs-dismiss="modal">Keep Photos</button>
    <button type="button" class="btn btn-admin light_blue" data-bs-dismiss="modal" id="delete_gallery_photo">Delete Photos</button>';
$delete_gallery_photo__options = array(
    'header_content' => 'Delete the photos?',
    'body_content' => $delete_gallery_photo__body,
    'footer_content' => $delete_gallery_photo__footer,
    'id' => 'delete_confirm'
);
brixwork_modal_html($delete_gallery_photo__options);
