<?php
/**
 * BUILD USEFUL DATA FOR OBJECT_MOD TABS.
 */
global $settings;
$object_type = $preset_object_type;

// only initialize object for "modify" and if "idr" exists.
if ($_REQUEST['idr'] != '') :
    switch ($object_type):
        case 'page':
        case 'pages':
            $page = new page;
            $page->initialize($_REQUEST['idr']);
            $subject = $page->title;
            $object = $page;
            $returnurl = 'pages.php';
            break;

        case 'agent':
        case 'agents':
            $agent = new agent;
            $agent->initialize($_REQUEST['idr']);
            $subject = $agent->displayname;
            $object = $agent;
            break;

        case 'building':
        case 'buildings':
            $building = new building;
            $building->initialize($_REQUEST['idr']);
            $subject = $building->name;
            $object = $building;
            $returnurl = 'buildings.php';
            break;

        case 'home':
        case 'homes':
            $home = new home;
            $home->initialize($_REQUEST['idr']);
            $subject = $home->fulladdress;
            $object = $home;
            $returnurl = 'homes.php';
            break;

        case 'area':
        case 'areas':
            $area = new area;
            $area->initialize($_REQUEST['idr']);
            $object = $area;
            $returnurl = 'areas.php';
            break;

        case 'subarea':
        case 'subareas':
            $subarea = new subarea;
            $subarea->initialize($_REQUEST['idr']);
            $object = $subarea;
            $returnurl = 'areas.php';
            break;

        case 'resource':
        case 'resources':
            $link = new resource;
            $link->initialize($_REQUEST['idr']);
            $subject = $link->title;
            $object = $link;
            $returnurl = 'links.php';
            break;

        default:
            die('invalid object type!');
    endswitch;
else:
    $object = false;
endif;

// build useful variables to be used by Javascript.
$scriptinsert =
    "<script type=\"text/javascript\">
        window.destinationfolder = '".$object_type."';
        window.idr = '".$_GET['idr']."';
        window.bucket = '".$settings['s3_bucket']."';
    </script>";
echo $scriptinsert;