<?php
// BASIC INFO TAB - LISTING DETAILS
global $settings;
?>

<?php // MAIN DETAILS ?>
<div id="listing_details" class="each_tab__category brixwork_inner_spacing mx-0">
    <h3 class="each_tab__category_title">Main Details</h3>

    <div class="row">
        <div class="col-md-7 mb-4 mb-md-0 mt-auto">
            <label for="title" class="control-label orange">Title of Page</label>
            <input type="text" name="title" id="title" class="form-control" tabindex="0" value="<?=$page->title?>" placeholder="Enter the title of this page" />

            <?php
            if ($settings['description2on']==1) { echo
                "<input type='text' name='title2' id='title2' class='form-control mt-2' tabindex='0' value='$page->title2' placeholder='Enter the title in second language'/>";
            } ?>
        </div>

        <div class="col-md-5 mt-auto">
            <label for="menu_title" class="control-label orange">Menu Label</label>
            <div class="input-group">
                <span class="input-group-text" id="at-addon"><i class="bi bi-list"></i></span>
                <input type="text" name="menu_title" id="menu_title" class="form-control" aria-describedby="at-addon" value="<?=$page->data['menu_title']?>" placeholder="How it shows on menus">
            </div>

            <?php
            if ($settings['description2on']==1) { ?>
                <div class="input-group mt-2">
                    <span class="input-group-text" id="at-addon"><i class="bi bi-list"></i></span>
                    <input aria-label="menu title 2nd" type="text" name="menu_title2" id="menu_title2" class="form-control" aria-describedby="at-addon" value="<?=$page->data['menu_title2']?>" placeholder="How it shows on menus">
                </div>
            <?php
            } ?>
        </div>
    </div>
</div>


<?php // PAGE CONTENT ?>
<div id="listing_details" class="each_tab__category brixwork_inner_spacing mx-0">
    <h3 class="each_tab__category_title">Page Content</h3>

    <div class="row">
        <div class="col-lg-7 mb-4">
            <textarea aria-label="Content Text Editor" name="content" id="content" class="form-control rich_editor" rows="<?=($settings['description2on']==1?'12':'25')?>"><?=cleanupfortextfield($page->data['content']) ?></textarea>
            <?php
            if ($settings['description2on'] == 1) { echo
                "<div class='mt-4'></div><textarea name='content2' id='content2' class='form-control rich_editor' rows='12' placeholder='Page text content in 2nd Language'>".cleanupfortextfield($page->data['content2'])."</textarea>";
            } ?>
        </div>

        <div class="col-lg-5 mb-4" id="content_tip">
            <?php
            $svg_append = 'images/admin_function_icon/';
            echo get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true));
            ?>
            <p class="my-4">
                <span class="content_tip__title">Learn more about managing pages</span>
                Our support centre has <a href="https://support.brixwork.com/support/solutions/folders/8000079249">helpful articles on managing pages & subpages</a> on your Brixwork website.
            </p>
        </div>

        <div class="col-lg-7 mb-4">
            <label for="excerpt" class="control-label orange">Short Description (Excerpt)</label>
            <textarea name="excerpt" id="excerpt" class="form-control" rows="<?=($settings['description2on']==1?'3':'5')?>"><?=cleanupfortextfield($page->data['excerpt']) ?></textarea>

            <?php
            if ($settings['description2on'] == 1) { echo
                "<textarea name='excerpt2' id='excerpt2' class='form-control mt-4' rows='3' placeholder='Page text content in 2nd Language'>".cleanupfortextfield($page->data['excerpt2'])."</textarea>";
            } ?>
        </div>

        <div class="col-lg-5 my-4" id="content_tip">
            <p>
                <span class="content_tip__title">Optional Feature</span>
                Not all pages on your website are configured to show this and requires us to enable this functionality to show properly.
            </p>
        </div>
    </div>
</div>


<?php // Page City Setting ?>
<div id="listing_details" class="each_tab__category brixwork_inner_spacing mx-0">
    <h3 class="each_tab__category_title">City & Area Settings</h3>

    <div class="row">
        <div class="col-lg-7 mb-4">
            <select name="city" id="city" class="form-select" aria-label="City & Area Settings">
                <option value="">Choose a City</option>
                <?php
                $page_city_query['publish'] = 1;
                if($page->data['city']!='') {
                    $page_city_query['id'] = $page->data['city'];
                }
                $cities = get_areas($page_city_query);

                foreach($cities as $city_id) {
                    $city = new area;
                    $city->initialize($city_id);
                    $selected_text = ($page->data['city'] == $city->id) ? 'selected' : '';

                    echo "<option value='$city->id' $selected_text>$city->name</option>";
                }
                ?>
            </select>

            <ul class="mt-3" id="areas_container" data-area="<?=($page->area ? $page->data['area'] : '')?>">
                <?php // AREA CHECKBOX POPULATED VIA JAVASCRIPT ONCE CITY IS SELECTED. ?>
            </ul>
        </div>

        <div class="col-lg-5" id="content_tip">
            <p>
                <span class="content_tip__title">Optional Feature</span>
                Not all pages have any city/area based functions, so changing this may not have any effect.
            </p>
        </div>
    </div>
</div>

<?php //CUSTOM FIELDS ?>
<div id="custom_fields_table" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Custom Fields</h3>
    <?php
    $custom_field_object_type = $page;
    include 'includes/object_custom_field.php';
    ?>
</div>