<?php // General Settings Tab
global $settings;
?>

<div id="settings_main_site" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Main Site Settings</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php // different input functions depending on login
            if (login_level_check(USER_LOGIN_BRIXWORK)) {
                settings_text_2023(array(
                    'name' => 'owner',
                    'value' => $settings['owner'],
                    'label' => 'Owner'));
            } else {
                admin_text_basic(array(
                    'name' => 'owner',
                    'value' => $settings['owner'],
                    'label' => 'Owner'));
            } ?>
        </div>

        <div class="col-lg-6 mb-4">
            <label for="tagline" class="control-label orange">Tagline</label>
            <input class="form-control" id="tagline" name="tagline[]" value="<?=$settings['tagline']?>" placeholder="Your business tagline" />
        </div>

        <div class="col-lg-6 mb-4 mb-lg-0">
            <label for="sitepath" class="control-label orange">URL</label>
            <input class="form-control" id="sitepath" name="sitepath[]" value="<?=$settings['sitepath']?>" <?=login_level_check(1) ? '' : 'disabled'?> placeholder="Website URL. eg: https://www.yoursite.com/" />
        </div>

        <div class="col-lg-6 mb-4 mb-lg-0">
            <label for="title" class="control-label orange">Website Title</label>
            <input class="form-control" id="title" name="title[]" value="<?=$settings['title']?>" placeholder="Title of your website" />
        </div>

        <?php
        // These controls are only available to brixwork login
        if (login_level_check(1)):
        ?>
        <div class="col-12 my-5"><hr/></div>

        <div class="col-lg-4 col-sm-6 mb-4 mb-md-0">
            <h5 class="settings_label">SUSPENSION</h5>
            <?php
            admin_switch(array(
                'name' => 'suspend_website',
                'value' => $settings['suspend_website'],
                'label' => 'Suspend Website'))
            ?>
            <p>Suspension disables the back-end for clients as well. Leave the URL blank to forward to payment page.</p>
        </div>

        <div class="col-lg-4 col-sm-6 mb-4 mb-md-0">
            <h5 class="settings_label">FORWARDING</h5>
            <?php
            admin_switch(array(
                'name' => 'forward_website',
                'value' => $settings['forward_website'],
                'label' => 'Forwarded URL'))
            ?>
            <input class="form-control mb-3" id="forward_destination_url" name="forward_destination_url" value="<?=$settings['forward_destination_url']?>" placeholder="Temporary Forward URL" aria-label="Forwarded URL"/>
            <p>Back-end remains alive for editing. Useful for temporary forwarding or during construction, if client wants something other than our Under construction page.</p>
        </div>

        <div class="col-lg-4 col-sm-6 mb-4 mb-md-0">
            <h5 class="settings_label">CONSTRUCTION</h5>
            <?php
            admin_switch(array(
                'name' => 'under_construction',
                'value' => $settings['under_construction'],
                'label' => 'Enable under construction page'))
            ?>
            <p>Front-end is entirely replaced with default under-construction page, without forwarding.</p>
        </div>

        <?php // END IF FOR if (login_level_check(1)):
        endif; ?>

    </div>
</div>

<?php
if (login_level_check(1)):
?>
<div class="admin_flex_wrapper">
    <div id="settings_mls" class="each_tab__category brixwork_inner_spacing">
        <h3 class="each_tab__category_title">MLS Sync</h3>

        <div class="row">
            <div class="col-sm-6">
                <?php
                admin_switch(array(
                    'name' => 'commercial_enabled',
                    'value' => $settings['commercial_enabled'],
                    'label' => 'Commercial Module',
                    'tooltip' => 'Sync Commercial Listings from MLS'))
                ?>
            </div>

            <div class="col-sm-6">
                <?php
                admin_switch(array(
                    'name' => 'residential_enabled',
                    'value' => $settings['residential_enabled'],
                    'label' => 'Residential Listings'))
                ?>
            </div>

            <div class="col-sm-6">
                <?php
                admin_switch(array(
                    'name' => 'rental_enabled',
                    'value' => $settings['rental_enabled'],
                    'label' => 'Rental Module',
                    'tooltip' => 'Allows listings to be displayed as Rental Unit'))
                ?>
            </div>

            <div class="col-sm-6">
                <?php
                admin_switch(array(
                    'name' => 'autoconvert_agent_listings',
                    'value' => $settings['autoconvert_agent_listings'],
                    'label' => 'Auto Convert',
                    'tooltip' => 'Convert MLS listings to OWN automatically by checking Agent ID'))
                ?>
            </div>

            <div class="col-12">
                <?php
                admin_switch(array(
                    'name' => 'mls_integrated',
                    'value' => $settings['mls_integrated'],
                    'label' => 'RETS Integrated'))
                ?>
                <input class="form-control" id="mls_import_url" name="mls_import_url" value="<?=$settings['mls_import_url']?>" placeholder="Temporary Forward URL" aria-label="RETS import URL"/>
            </div>

            <div class="col-12">
                <div class="brixwork_info_grid pt-4 pb-0">
                    <i class="bi bi-exclamation-circle"></i>
                    <p class="m-0">DO NOT turn MLS on, or Commercial MLS on etc. Verify client's monthly payments first.</p>
                </div>
            </div>
        </div>
    </div>


    <div id="settings_site_module" class="each_tab__category brixwork_inner_spacing">
        <h3 class="each_tab__category_title">Site Module</h3>

        <div class="row">
            <div class="col-sm-6">
                <?php
                admin_switch(array(
                    'name' => 'timthumb',
                    'value' => $settings['timthumb'],
                    'label' => 'Timthumb Enabled'))
                ?>
            </div>

            <div class="col-sm-6">
                <?php
                admin_switch(array(
                    'name' => 'defer_js',
                    'value' => $settings['defer_js'],
                    'label' => 'Defer JavaScript'))
                ?>
            </div>

            <div class="col-12">
                <?php
                admin_switch(array(
                    'name' => 'description2on',
                    'value' => $settings['description2on'],
                    'label' => '2ND Language Desc'))
                ?>
            </div>

            <div class="col-6">
                <?php
                admin_switch(array(
                    'name' => 'multiagents',
                    'value' => $settings['multiagents'],
                    'label' => 'Multi-Agent Module'))
                ?>
                <input class="form-control" id="agents_limit" name="agents_limit" value="<?=$settings['agents_limit']?>" placeholder="Number of Agents to allow" aria-label="Limit of Agent Module"/>
            </div>

            <div class="col-12">
                <div class="brixwork_info_grid pt-4 pb-0">
                    <i class="bi bi-exclamation-circle"></i>
                    <p class="m-0">Before editing number of agents, verify the client’s monthly billing is updated and reflects the new number of agents.</p>
                </div>
            </div>
        </div>
    </div>
</div>

<div id="settings_mls" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">API & Library Settings</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php // FILE PATH
            admin_text_basic(array(
                'name' => 'rootpath',
                'value' => $settings['rootpath'],
                'label' => 'File Root'))
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // S3 FOLDER PATH
            admin_text_basic(array(
                'name' => 's3_folder',
                'value' => $settings['s3_folder'],
                'label' => 'S3 Folder',
                'readonly' => true,
                'tooltip' => 'Generally use full URL eg: www.myname.com'))
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // JQUERY VERSION
            admin_text_basic(array(
                'name' => 'jquery_version',
                'value' => $settings['jquery_version'],
                'label' => 'JQuery Version'));
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // JQUERY UI VERSION
            admin_text_basic(array(
                'name' => 'jqueryui_version',
                'value' => $settings['jqueryui_version'],
                'label' => 'JQuery UI Version'));
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // CAPTCHA PUBLIC KEY
            admin_text_basic(array(
                'name' => 'captcha_public_key',
                'value' => $settings['captcha_public_key'],
                'label' => 'CAPTCHA PUBLIC'));
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // CAPTCHA PRIVATE KEY
            admin_text_basic(array(
                'name' => 'captcha_private_key',
                'value' => $settings['captcha_private_key'],
                'label' => 'CAPTCHA SECRET'));
            ?>
        </div>

        <div class="col-lg-6">
            <?php // GOOGLE MAPS API KEY
            admin_text_basic(array(
                'name' => 'google_maps_api_key',
                'value' => $settings['google_maps_api_key'],
                'label' => 'Google Maps API Key'));
            ?>
        </div>
    </div>
</div>
<?php // END IF if (login_level_check(1)):
endif;