<?php // General Settings Tab
global $settings;
?>
<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">General Listing Settings</h3>

    <div class="row">
        <?php
        // THIS IS A LEGACY FUNCTION ... ONLY SHOW AGENT ID INPUT HERE IF MULTI AGENT MODULE IS DISABLED or BRIXWORK LOGIN.
        // multiple input is possible (i.e. team-mcknight)
        if ($settings['multiagents'] == 0 || login_level_check(USER_LOGIN_BRIXWORK)) {
            echo "<div class='col-lg-6 mb-4'>";
            settings_text_2023(array(
                    'name' => 'agent_id',
                    'value' => $settings['agent_id'],
                    'label' => 'Agent ID',
                    'placeholder' => 'i.e. V12345',
                    'tooltip' => 'Brixwork will use this ID to automatically convert MLS listing to OWN'
                ));
            echo "</div>";
        } ?>

        <div class="col-lg-6 mb-4">
            <?php // OFFICE ID
            admin_text_basic( array(
                'name' => 'firm_id',
                'value' => $settings['firm_id'],
                'label' => 'Office ID',
                'placeholder' => 'i.e. V1234',
                'tooltip' => 'Brixwork will use this ID to automatically convert MLS listing to OWN, if Office Listings page exists'
            )); ?>
        </div>
    </div>

    <div class="row">
        <div class="col-lg-4 mb-4">
            <?php
            admin_dropdown( array(
                'name' => 'street_dir_position_default',
                'value' => $settings['street_dir_position_default'],
                'label' => 'Street Direction Position',
                'value_variants' => array(
                    0 => 'Before Street',
                    1 => 'After Street'
                )
            )); ?>
        </div>

        <div class="col-lg-4 mb-4">
            <?php // TODO: NOT SURE WHAT THIS EXACTLY DOES
            admin_text_basic( array(
                'name' => 'url_trail',
                'value' => $settings['url_trail'],
                'label' => 'URL Trail',
                'placeholder' => 'i.e. vancouver-west-realtor'
            )); ?>
        </div>

        <div class="col-lg-4 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'hideaddressnote',
                'value' => $settings['hideaddressnote'],
                'label' => 'Private Address Label',
                'placeholder' => 'i.e. i.e. Address Upon Request',
                'tooltip' => 'Shown in place of the address for listings you hide the address on - must set to hide address on certain listings first'
            )); ?>
        </div>
    </div>
</div>


<?php
if (login_level_check(USER_LOGIN_BRIXWORK)) {
$brixwork_login = login_level_check(1);
?>
    <div class="row">
        <div class="col-12">
            <div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
                <h3 class="each_tab__category_title">Property Types</h3>

                <div class="row pt-3">
                    <div class="col-lg-6 mb-5 mb-lg-0">
                        <?php
                        settings_text_2023( array(
                            'name' => 'type',
                            'value' => $settings['type'],
                            'disable' => !$brixwork_login, // if not brixwork login, disable input fields.
                            'placeholder' => 'First input left blank intentionally'
                        )); ?>
                    </div>

                    <?php
                    if ($brixwork_login): ?>
                        <div class="col-lg-6">
                            <div class="coder_notes">
                                <h5>Coder Notes</h5>
                                <p>For MLS® integrated Realtor® websites, make sure to set this up to MATCH up with the $settings[‘types’] found in the MLS Source (vancouver., edmonton., toronto etc.). You don’t want Condo to be ID 2 on the RETS server, while the client site has it on ID 3, for example.</p>
                                <p>For non-MLS® sites, or specialty sites such as construction websites, this can be set very liberally (i.e. Upcoming, Under Construction, Past Projects).</p>
                            </div>
                        </div>
                    <?php
                    else: ?>
                        <div class="col-lg-6">
                            <div class="coder_notes">
                                <h5>Note</h5>
                                <p>These property type labels are directly linked to your MLS® board and require a Brixwork staff member to make changes.</p>
                            </div>
                        </div>

                    <?php
                    endif; ?>
                </div>
            </div>
        </div>

        <?php
        if ($settings['commercial_enabled'] == 1): ?>
        <div class="col-12">
            <div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
                <h3 class="each_tab__category_title">Commercial Types</h3>

                <div class="row pt-3">
                    <div class="col-lg-6 mb-5 mb-lg-0">
                        <?php
                        settings_text_2023( array(
                            'name' => 'type_commercial',
                            'value' => $settings['type_commercial'],
                            'disable' => !$brixwork_login, // if not brixwork login, disable input fields.
                            'placeholder' => 'First input left blank intentionally'
                        )); ?>
                    </div>

                    <?php
                    if ($brixwork_login): ?>
                        <div class="col-lg-6">
                            <div class="coder_notes">
                                <h5>Coder Notes</h5>
                                <p>Similar to residential types, if Commercial MLS® reciprocity is enabled, you need to match up the sequence with the MLS source domain.</p>
                            </div>
                        </div>
                    <?php
                    else: ?>
                        <div class="col-lg-6">
                            <div class="coder_notes">
                                <h5>Note</h5>
                                <p>These property type labels are directly linked to your MLS® board and require a Brixwork staff member to make changes.</p>
                            </div>
                        </div>

                    <?php
                    endif; ?>

                </div>
            </div>
        </div>
        <?php
        endif; // end of if ($settings['commercial_enabled'] == 1): ?>
    </div>

    <div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
        <h3 class="each_tab__category_title">Group Same Address Listings to Buildings</h3>

        <div class="row pt-3">
            <div class="col-lg-8">
                <?php
                admin_checkbox( array(
                    'name' => 'building_type',
                    'value' => $settings['building_type'],
                    'value_variants' => $settings['type'],
                )) ?>
            </div>
            <div class="col-lg-4">
                <div class="brixwork_info_grid">
                    <i class="bi bi-exclamation-circle"></i>
                    <p class="m-0">Listings with checked types will be grouped into buildings automatically</p>
                </div>
            </div>
        </div>
    </div>
<?php
} ?>

<div class="row">
    <div class="col-lg-6 match_sibling_height">
        <div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
            <h3 class="each_tab__category_title">Listing Remarks</h3>

            <div class="coder_notes px-0 py-3">
                <?php // different message depending on login.
                if (login_level_check(1)) {
                    echo "<h5>Coder Notes</h5>";
                    echo "<p>Flexible to change, and not dependent on MLS® reciprocity. We can add new custom remarks that are business-case specific, and we can also create listing result pages that filter by remarks ID ($query[‘remarksid’] = 3;).</p>";
                } else {
                    echo "<h5>Notes</h5>";
                    echo "<p>Each Listing is able to choose one of the Remarks listed here. Add / Edit here and select a remark for a listing under Manage Listings page.</p>";
                } ?>
            </div>

            <?php
            settings_text_2023( array(
                'name' => 'remarks',
                'value' => $settings['remarks'],
                'placeholder' => 'i.e. Just Sold, Subject Removed'
            )); ?>
        </div>
    </div>

    <div class="col-lg-6 match_sibling_height">
        <div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
            <h3 class="each_tab__category_title">Building Statuses</h3>

            <div class="coder_notes px-0 py-3">
                <?php // different message depending on login
                if (login_level_check(1)) {
                    echo "<h5>Coder Notes</h5>";
                    echo "<p>The sequence of 0 to 4 cannot be changed, as these phases are FIXED across all sites. You can change the labels however (i.e. “Coming Soon” can become “Future Releases” or “Upcoming” if you like.</p>";
                } else {
                    echo "<h5>Notes</h5>";
                    echo "<p>The sequence cannot be changed, although each label can be edited. Keep the context similar! i.e. \"Coming Soon\" can become \"Future Releases\" or \"Upcoming\".</p>";
                } ?>
            </div>

            <?php
            admin_text_basic(array(
                'name' => 'building_status_display',
                'value' => $settings['building_status_display']
            ));
            ?>
        </div>
    </div>
</div>

<div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Social Share Settings</h3>

    <div class="row align-items-center">
        <div class="col-lg-6">
            <?php
            $value_variants = array(
                '' => 'Show',
                'disabled' => 'Hide'
            );

            // FACEBOOK SHARE
            echo "<div class='mb-4'>";
            admin_dropdown( array(
                'name' => 'facebook_button',
                'value' => $settings['facebook_button'],
                'label' => 'Share on Facebook',
                'value_variants' => $value_variants
            ));
            echo "</div>";

            // TWEETER SHARE
            echo "<div class='mb-4'>";
            admin_dropdown( array(
                'name' => 'twitter_button',
                'value' => $settings['twitter_button'],
                'label' => 'Tweet on Tweeter',
                'value_variants' => $value_variants
            ));
            echo "</div>";

            // LINKEDIN SHARE
            echo "<div class='mb-4'>";
            admin_dropdown( array(
                'name' => 'linkedin_button',
                'value' => $settings['linkedin_button'],
                'label' => 'Post on LinkedIn',
                'value_variants' => $value_variants
            ));
            echo "</div>";

            // PINTEREST SHARE
            echo "<div class='mb-4'>";
            admin_dropdown( array(
                'name' => 'pinterest_button',
                'value' => $settings['pinterest_button'],
                'label' => 'Pin on Pinterest',
                'value_variants' => $value_variants
            ));
            echo "</div>"; ?>
        </div>

        <div class="col-lg-6 px-5" id="gallery_tip">
            <?php
            $svg_append = 'images/admin_function_icon/';
            echo get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true));
            ?>
            <p class="my-4">
                These settings allow your visitors to share your listings and pages on their profiles. It has nothing to do with whether you use these outlets or not. When in doubt, turn them all ON.
            </p>
        </div>
    </div>
</div>

<h2 class="pb-3 pt-4">Contact Form Call-to-actions</h2>
<div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Listings</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php // ACTIVE LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_listings[]',
                'value' => $settings['contact_form_title_listings'][BRIX_LISTING_ACTIVE],
                'label' => 'Active Listings',
                'tooltip' => 'Enabled only on certain custom sites'
            ));
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // SOLD LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_listings[]',
                'value' => $settings['contact_form_title_listings'][BRIX_LISTING_SOLD],
                'label' => 'Sold Listings',
                'tooltip' => 'Enabled only on certain custom sites'
            ));
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // SHOW ON BOTH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_listings[]',
                'value' => $settings['contact_form_title_listings'][BRIX_LISTING_BOTH],
                'label' => 'Show on Both Listings',
                'tooltip' => 'Enabled only on certain custom sites'
            ));
            ?>
        </div>
    </div>
</div>

<div id="settings_listing__properties" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Buildings</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php // ACTIVE BUILDINGS WITH NO LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_ACTIVE.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_ACTIVE][0],
                'label' => 'Active Building (No Listings)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // ACTIVE BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_ACTIVE.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_ACTIVE][1],
                'label' => 'Active Building (Has Listings)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // COMING SOON BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_COMING.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_COMING][0],
                'label' => 'Coming soon (No Listings)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // COMING SOON BUILDINGS WITH NO LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_COMING.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_COMING][1],
                'label' => 'Coming soon (Has Listings)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // VIP PREVIEW BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_VIP.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_VIP][0],
                'label' => 'VIP Presale Building (No Assignments)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // VIP PREVIEW BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_VIP.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_VIP][1],
                'label' => 'VIP Presale Building (Has Assignments)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // Presale BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_PRESALE.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_PRESALE][0],
                'label' => 'Presale Building (No Assignments)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // Presale BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_PRESALE.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_PRESALE][1],
                'label' => 'Presale Building (Has Assignments)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // SOLD OUT BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_SOLDOUT.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_SOLDOUT][0],
                'label' => 'Sold out Building (No Assignments)',
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // SOLD OUT BUILDINGS WITH LISTINGS
            admin_text_basic( array(
                'name' => 'contact_form_title_buildings_'.BRIX_BUILDING_SOLDOUT.'[]',
                'value' => $settings['contact_form_title_buildings_'.BRIX_BUILDING_SOLDOUT][1],
                'label' => 'Sold out Building (Has Assignments)',
            )); ?>
        </div>
    </div>
</div>