<?php // General Settings Tab
global $settings;
?>

<div id="settings_contact" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Gallery Image Setting</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'thumbnailwidth',
                'value' => $settings['thumbnailwidth'],
                'label' => 'Thumbnail Width Limit'
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'thumbnailheight',
                'value' => $settings['thumbnailheight'],
                'label' => 'Thumbnail Height Limit'
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'mobilewidth',
                'value' => $settings['mobilewidth'],
                'label' => 'Mobile Image Width Limit'
            )); ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'mobileheight',
                'value' => $settings['mobileheight'] ?: $settings['mobilewidth'],
                'label' => 'Mobile Image Height Limit'
            )); ?>
        </div>

        <div class="col-lg-6">
            <?php
            admin_text_basic( array(
                'name' => 'imagewidthhorizontal',
                'value' => $settings['imagewidthhorizontal'],
                'label' => 'Web Photo Width Limit'
            )); ?>
        </div>

        <div class="col-lg-6">
            <?php
            admin_text_basic( array(
                'name' => 'imagewidthvertical',
                'value' => $settings['imagewidthvertical'],
                'label' => 'Web Photo Height Limit'
            )); ?>
        </div>
    </div>
</div>


<div id="settings_contact" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Listings</h3>

    <?php // HOMES OBJECT PHOTOS ROW ?>
    <div class="row mb-5 homes_object_photos align-items-center">
        <div class="col-lg-8 mb-4 mb-lg-0">
            <label class="control-label orange">Homes Object Main Photos</label>
            <input class='form-control' type="hidden" id='homes_mainphotonum' name='homes_mainphotonum' value='<?=$settings['homes_mainphotonum']?>' aria-label="Number of photos"/>
            <?php //TODO: enable variable sizing, tooltips
            admin_multi_input(array(
                'row_name'      => 'home_photo',
                'name_array'    => array('homes_mainphotofilename', 'homes_mainphotoname', 'homes_mainphotowidth', 'homes_mainphotoheight'),
                'value_array'   => array($settings['homes_mainphotofilename'], $settings['homes_mainphotoname'], $settings['homes_mainphotowidth'], $settings['homes_mainphotoheight']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the Image on the "Edit" page', 'Width (px)', 'Height (px)'),
                'input_class'   => array('medium', 'large', 'small', 'small'),
                'counter_id'    => 'homes_mainphotonum',
                'counter'       => $settings['homes_mainphotonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Allows specific assignment of photos for custom designed galleries/detail pages only. Make sure NONE of the JPG filenames are the same to avoid overwriting. Verbose JPG filenames are recommended (i.e. mosaic_second_photo.jpg is better than main2.jpg)</p>
            </div>
        </div>
    </div>

    <?php // HOMES OBJECT PDF ROW ?>
    <div class="row mb-5 align-items-center">
        <div class="col-lg-8">
            <label class="control-label orange">Homes Object PDFs</label>
            <input class='form-control' type="hidden" id='homes_pdfnum' name='homes_pdfnum' value='<?=$settings['homes_pdfnum']?>' aria-label="Number of PDFs"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'home_pdf',
                'name_array'    => array('homes_pdffilename', 'homes_pdfname'),
                'value_array'   => array($settings['homes_pdffilename'], $settings['homes_pdfname']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the File on the "Edit" page'),
                'counter_id'    => 'homes_pdfnum',
                'counter'       => $settings['homes_pdfnum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>In most cases, 1 feature sheet & 3 floor plans are enough. Never let PDF filenames to overlap. Adding more PDFs requires customization on the front end with additional budget.</p>
            </div>
        </div>
    </div>


    <?php // HOMES OBJECT YOUTUBE & VIMEO ROW ?>
    <div class="row align-items-center">
        <div class="col-lg-4 mb-4 mb-lg-0">
            <label class="control-label orange">Homes Youtube</label>
            <input class='form-control' type="hidden" id='homes_youtubenum' name='homes_youtubenum' value='<?=$settings['homes_youtubenum']?>' aria-label="Number of Youtube Videos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'home_youtube',
                'name_array'    => array('homes_youtubefields'),
                'value_array'   => array($settings['homes_youtubefields']),
                'counter_id'    => 'homes_youtubenum',
                'counter'       => $settings['homes_youtubenum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <label class="control-label orange">Homes Vimeo</label>
            <input class='form-control' type="hidden" id='homes_vimeonum' name='homes_vimeonum' value='<?=$settings['homes_vimeonum']?>' aria-label="Number of Vimeo"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'home_vimeo',
                'name_array'    => array('homes_vimeofields'),
                'value_array'   => array($settings['homes_vimeofields']),
                'counter_id'    => 'homes_vimeonum',
                'counter'       => $settings['homes_vimeonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Most sites need just one YouTube/Vimeo column, `youtube1` is part of the `homes` table just in case. You cannot add more without manipulating the `homes` table, so do not add unless for very specific cases.</p>
            </div>
        </div>
    </div>
</div>


<div id="settings_contact" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Buildings</h3>

    <?php // BUILDING OBJECT PHOTOS ROW ?>
    <div class="row mb-5 homes_object_photos align-items-center">
        <div class="col-lg-8 mb-4 mb-lg-0">
            <label class="control-label orange">Buildings Object Main Photos</label>
            <input class='form-control' type="hidden" id='buildings_mainphotonum' name='buildings_mainphotonum' value='<?=$settings['buildings_mainphotonum']?>' aria-label="Number of photos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'building_photo',
                'name_array'    => array('buildings_mainphotofilename', 'buildings_mainphotoname', 'buildings_mainphotowidth', 'buildings_mainphotoheight'),
                'value_array'   => array($settings['buildings_mainphotofilename'], $settings['buildings_mainphotoname'], $settings['buildings_mainphotowidth'], $settings['buildings_mainphotoheight']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the Image on the "Edit" page', 'Width (px)', 'Height (px)'),
                'input_class'   => array('medium', 'large', 'small', 'small'),
                'counter_id'    => 'buildings_mainphotonum',
                'counter'       => $settings['buildings_mainphotonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Allows specific assignment of photos for custom designed galleries/detail pages only. Make sure NONE of the JPG file names are the same to avoid overwriting. Verbose JPG names are recommended (i.e. mosaic_second_photo.jpg is better than main2.jpg)</p>
            </div>
        </div>
    </div>

    <?php // BUILDING OBJECT PDF ROW ?>
    <div class="row mb-5 align-items-center">
        <div class="col-lg-8">
            <label class="control-label orange">Buildings Object PDFs</label>
            <input class='form-control' type="hidden" id='buildings_pdfnum' name='buildings_pdfnum' value='<?=$settings['buildings_pdfnum']?>' aria-label="Number of PDFs"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'building_pdf',
                'name_array'    => array('buildings_pdffilename', 'buildings_pdfname'),
                'value_array'   => array($settings['buildings_pdffilename'], $settings['buildings_pdfname']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the File on the "Edit" page'),
                'counter_id'    => 'buildings_pdfnum',
                'counter'       => $settings['buildings_pdfnum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Buildings usually have a lot more PDFs than listings. These PDFs are usually different floor plans for the building.</p>
            </div>
        </div>
    </div>

    <?php // BUILDING OBJECT YOUTUBE & VIMEO ROW ?>
    <div class="row align-items-center">
        <div class="col-lg-4 mb-4 mb-lg-0">
            <label class="control-label orange">Buildings Youtube</label>
            <input class='form-control' type="hidden" id='buildings_youtubenum' name='buildings_youtubenum' value='<?=$settings['buildings_youtubenum']?>' aria-label="Number of Youtube Videos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'building_youtube',
                'name_array'    => array('buildings_youtubefields'),
                'value_array'   => array($settings['buildings_youtubefields']),
                'counter_id'    => 'buildings_youtubenum',
                'counter'       => $settings['buildings_youtubenum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <label class="control-label orange">Buildings Vimeo</label>
            <input class='form-control' type="hidden" id='buildings_vimeonum' name='buildings_vimeonum' value='<?=$settings['buildings_vimeonum']?>' aria-label="Number of Vimeo"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'building_vimeo',
                'name_array'    => array('buildings_vimeofields'),
                'value_array'   => array($settings['buildings_vimeofields']),
                'counter_id'    => 'buildings_vimeonum',
                'counter'       => $settings['buildings_vimeonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Most sites need just one YouTube/Vimeo column, `youtube1` is part of the `homes` table just in case. You cannot add more without manipulating the `homes` table, so do not add unless for very specific cases.</p>
            </div>
        </div>
    </div>
</div>


<div id="settings_contact" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Pages</h3>

    <?php // PAGE OBJECT PHOTOS ROW ?>
    <div class="row mb-5 homes_object_photos align-items-center">
        <div class="col-lg-8 mb-4 mb-lg-0">
            <label class="control-label orange">Pages Object Main Photos</label>
            <input class='form-control' type="hidden" id='pages_mainphotonum' name='pages_mainphotonum' value='<?=$settings['pages_mainphotonum']?>' aria-label="Number of photos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'page_photo',
                'name_array'    => array('pages_mainphotofilename', 'pages_mainphotoname', 'pages_mainphotowidth', 'pages_mainphotoheight'),
                'value_array'   => array($settings['pages_mainphotofilename'], $settings['pages_mainphotoname'], $settings['pages_mainphotowidth'], $settings['pages_mainphotoheight']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the Image on the "Edit" page', 'Width (px)', 'Height (px)'),
                'input_class'   => array('medium', 'large', 'small', 'small'),
                'counter_id'    => 'pages_mainphotonum',
                'counter'       => $settings['pages_mainphotonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Make sure NONE of the JPG filenames are the same to avoid overwriting. Verbose JPG filenames are recommended. Labels can be edited on each page's "EDIT".</p>
            </div>
        </div>
    </div>

    <?php // PAGES OBJECT PDF ROW ?>
    <div class="row mb-5 align-items-center">
        <div class="col-lg-8">
            <label class="control-label orange">Pages Object PDFs</label>
            <input class='form-control' type="hidden" id='pages_pdfnum' name='pages_pdfnum' value='<?=$settings['pages_pdfnum']?>' aria-label="Number of PDFs"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'page_pdf',
                'name_array'    => array('pages_pdffilename', 'pages_pdfname'),
                'value_array'   => array($settings['pages_pdffilename'], $settings['pages_pdfname']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the File on the "Edit" page'),
                'counter_id'    => 'pages_pdfnum',
                'counter'       => $settings['pages_pdfnum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Pages usually do not need PDF attachments, but still exists for special cases.</p>
            </div>
        </div>
    </div>

    <?php // PAGE OBJECT YOUTUBE & VIMEO ROW ?>
    <div class="row align-items-center">
        <div class="col-lg-4 mb-4 mb-lg-0">
            <label class="control-label orange">Pages Youtube</label>
            <input class='form-control' type="hidden" id='pages_youtubenum' name='pages_youtubenum' value='<?=$settings['pages_youtubenum']?>' aria-label="Number of Youtube Videos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'page_youtube',
                'name_array'    => array('pages_youtubefields'),
                'value_array'   => array($settings['pages_youtubefields']),
                'counter_id'    => 'pages_youtubenum',
                'counter'       => $settings['pages_youtubenum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <label class="control-label orange">Pages Vimeo</label>
            <input class='form-control' type="hidden" id='pages_vimeonum' name='pages_vimeonum' value='<?=$settings['pages_vimeonum']?>' aria-label="Number of Vimeo"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'page_vimeo',
                'name_array'    => array('pages_vimeofields'),
                'value_array'   => array($settings['pages_vimeofields']),
                'counter_id'    => 'pages_vimeonum',
                'counter'       => $settings['pages_vimeonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Most sites need just one YouTube/Vimeo.</p>
            </div>
        </div>
    </div>
</div>



<div id="settings_contact" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Agents</h3>

    <?php // AGENTS OBJECT PHOTOS ROW ?>
    <div class="row mb-5 homes_object_photos align-items-center">
        <div class="col-lg-8 mb-4 mb-lg-0">
            <label class="control-label orange">Agents Object Main Photos</label>
            <input class='form-control' type="hidden" id='agents_mainphotonum' name='agents_mainphotonum' value='<?=$settings['agents_mainphotonum']?>' aria-label="Number of photos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'agent_photo',
                'name_array'    => array('agents_mainphotofilename', 'agents_mainphotoname', 'agents_mainphotowidth', 'agents_mainphotoheight'),
                'value_array'   => array($settings['agents_mainphotofilename'], $settings['agents_mainphotoname'], $settings['agents_mainphotowidth'], $settings['agents_mainphotoheight']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the Image on the "Edit" page', 'Width (px)', 'Height (px)'),
                'input_class'   => array('medium', 'large', 'small', 'small'),
                'counter_id'    => 'agents_mainphotonum',
                'counter'       => $settings['agents_mainphotonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Make sure NONE of the JPG filenames are the same to avoid overwriting. Verbose JPG filenames are recommended.</p>
            </div>
        </div>
    </div>

    <?php // AGENTS OBJECT PDF ROW ?>
    <div class="row mb-5 align-items-center">
        <div class="col-lg-8">
            <label class="control-label orange">Agents Object PDFs</label>
            <input class='form-control' type="hidden" id='agents_pdfnum' name='agents_pdfnum' value='<?=$settings['agents_pdfnum']?>' aria-label="Number of PDFs"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'agent_pdf',
                'name_array'    => array('agents_pdffilename', 'agents_pdfname'),
                'value_array'   => array($settings['agents_pdffilename'], $settings['agents_pdfname']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the File on the "Edit" page'),
                'counter_id'    => 'agents_pdfnum',
                'counter'       => $settings['agents_pdfnum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>PDF for each agent. Usually on "About Agent" page.</p>
            </div>
        </div>
    </div>

    <?php // AGENTS OBJECT YOUTUBE & VIMEO ROW ?>
    <div class="row align-items-center">
        <div class="col-lg-4 mb-4 mb-lg-0">
            <label class="control-label orange">Agents Youtube</label>
            <input class='form-control' type="hidden" id='agents_youtubenum' name='agents_youtubenum' value='<?=$settings['agents_youtubenum']?>' aria-label="Number of Youtube Videos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'agent_youtube',
                'name_array'    => array('agents_youtubefields'),
                'value_array'   => array($settings['agents_youtubefields']),
                'counter_id'    => 'agents_youtubenum',
                'counter'       => $settings['agents_youtubenum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <label class="control-label orange">Agents Vimeo</label>
            <input class='form-control' type="hidden" id='agents_vimeonum' name='agents_vimeonum' value='<?=$settings['agents_vimeonum']?>' aria-label="Number of Vimeo"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'agent_vimeo',
                'name_array'    => array('agents_vimeofields'),
                'value_array'   => array($settings['agents_vimeofields']),
                'counter_id'    => 'agents_vimeonum',
                'counter'       => $settings['agents_vimeonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Most agents just need one YouTube/Vimeo.</p>
            </div>
        </div>
    </div>
</div>


<div id="settings_contact" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Resources</h3>

    <?php // RESOURCES OBJECT PHOTOS ROW ?>
    <div class="row mb-5 homes_object_photos align-items-center">
        <div class="col-lg-8 mb-4 mb-lg-0">
            <label class="control-label orange">Resources Object Main Photos</label>
            <input class='form-control' type="hidden" id='resources_mainphotonum' name='resources_mainphotonum' value='<?=$settings['resources_mainphotonum']?>' aria-label="Number of photos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'resource_photo',
                'name_array'    => array('resources_mainphotofilename', 'resources_mainphotoname', 'resources_mainphotowidth', 'resources_mainphotoheight'),
                'value_array'   => array($settings['resources_mainphotofilename'], $settings['resources_mainphotoname'], $settings['resources_mainphotowidth'], $settings['resources_mainphotoheight']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the Image on the "Edit" page', 'Width (px)', 'Height (px)'),
                'input_class'   => array('medium', 'large', 'small', 'small'),
                'counter_id'    => 'resources_mainphotonum',
                'counter'       => $settings['resources_mainphotonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Make sure NONE of the JPG filenames are the same to avoid overwriting. Verbose JPG filenames are recommended.</p>
            </div>
        </div>
    </div>

    <?php // RESOURCES OBJECT PDF ROW ?>
    <div class="row mb-5 align-items-center">
        <div class="col-lg-8">
            <label class="control-label orange">Resources Object PDFs</label>
            <input class='form-control' type="hidden" id='resources_pdfnum' name='resources_pdfnum' value='<?=$settings['resources_pdfnum']?>' aria-label="Number of PDFs"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'resource_pdf',
                'name_array'    => array('resources_pdffilename', 'resources_pdfname'),
                'value_array'   => array($settings['resources_pdffilename'], $settings['resources_pdfname']),
                'tooltip'       => array('File name. No duplicate!', 'Label for the File on the "Edit" page'),
                'counter_id'    => 'resources_pdfnum',
                'counter'       => $settings['resources_pdfnum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>PDF for each agent. Usually on "About Agent" page.</p>
            </div>
        </div>
    </div>

    <?php // RESOURCES OBJECT YOUTUBE & VIMEO ROW ?>
    <div class="row align-items-center">
        <div class="col-lg-4 mb-4 mb-lg-0">
            <label class="control-label orange">Resources Youtube</label>
            <input class='form-control' type="hidden" id='resources_youtubenum' name='resources_youtubenum' value='<?=$settings['resources_youtubenum']?>' aria-label="Number of Youtube Videos"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'resource_youtube',
                'name_array'    => array('resources_youtubefields'),
                'value_array'   => array($settings['resources_youtubefields']),
                'counter_id'    => 'resources_youtubenum',
                'counter'       => $settings['resources_youtubenum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <label class="control-label orange">Resources Vimeo</label>
            <input class='form-control' type="hidden" id='resources_vimeonum' name='resources_vimeonum' value='<?=$settings['resources_vimeonum']?>' aria-label="Number of Vimeo"/>
            <?php
            admin_multi_input(array(
                'row_name'      => 'resource_vimeo',
                'name_array'    => array('resources_vimeofields'),
                'value_array'   => array($settings['resources_vimeofields']),
                'counter_id'    => 'resources_vimeonum',
                'counter'       => $settings['resources_vimeonum']
            )); ?>
        </div>

        <div class="col-lg-4">
            <div class="coder_notes px-4">
                <h5>Coder Notes</h5>
                <p>Most resource links just need one YouTube/Vimeo.</p>
            </div>
        </div>
    </div>
</div>