<?php // General Settings Tab
global $settings;
?>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Map Search Settings</h3>

    <div class="row">
        <div class="col-lg-6">
            <h6 class="mls_map_subtitle">This setting may not be applicable to you if you do not have the MLS® map search function enabled on your site.</h6>
        </div>
    </div>

    <div class="row">
        <?php // MLS SEARCH DEFAULT MAP
        if ($settings['office_lat'] && $settings['office_long']) {
            $map_search_lat  = $settings['mapsearch_lat'];
            $map_search_long = $settings['mapsearch_long'];
        }
        else {
            $default_lat_long = explode(',', $settings['baselatlong']);
            $map_search_lat   = $default_lat_long[0];
            $map_search_long  = $default_lat_long[1];
        }
        ?>
        <div class="col-lg-6 mb-4 mb-lg-0">
            <div id="map_search_container" class="listingmapcontainer box-shadow" data-lat="<?=$map_search_lat?>" data-long="<?=$map_search_long?>">
                <div id="map_search" class="listingmap"></div>
            </div>
        </div>

        <div class="col-lg-6">
            <label class="control-label orange">Default Map Center</label>
            <p>Drag the map to the appropriate centre where you want your MLS® Map Search to default from. This is a good way to define your niche area.</p>

            <div class="mls_map_input_wrapper">
                <input aria-label="Default MLS Latitude" type="text" name="mapsearch_lat" id="mapsearch_lat" class="form-control" value="<?=$settings['mapsearch_lat']?>"/>
                <input aria-label="Default MLS Longitude" type="text" name="mapsearch_long" id="mapsearch_long" class="form-control" value="<?=$settings['mapsearch_long']?>"/>
            </div>

            <a class="btn btn-admin light_blue mls_search_map_reset">Reset Map</a>

            <?php // this toggle is only availalbe for brixwork login
            if (login_level_check(USER_LOGIN_BRIXWORK)) { ?>
                <div class="upgraded_search_toggle">
                    <?php // TODO: NOT REALLY SURE WHAT THIS ONE DOES
                    admin_switch(array(
                        'name' => 'brixwork_search_enabled',
                        'value' => $settings['brixwork_search_enabled'],
                        'label' => 'New Map and List Search'
                    )); ?>
                </div>
            <?php
            } ?>
        </div>
    </div>
</div>


<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Price Slider Settings (For Sale)</h3>

    <p class="each_tab__category_subtitle">
        This applies to the newer price sliders, as well as the interactive map & list search module (Fairview and Yaletown Templates).
    </p>

    <div class="row">
        <div class="col-lg-4 col-sm-6 mb-4 mb-lg-0">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_search_min_price',
                'value' => $settings['brixwork_search_min_price'],
                'label' => 'Minimum Price',
                'tooltip' => 'Generally set to 0. Numbers only!'
            )); ?>
        </div>

        <div class="col-lg-4 col-sm-6 mb-4 mb-lg-0">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_search_max_price',
                'value' => $settings['brixwork_search_max_price'],
                'label' => 'Maximum Price',
                'tooltip' => 'Users can still search above the Max Price by dragging the slide bar all the way.'
            )); ?>
        </div>

        <div class="col-lg-4 col-sm-6">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_search_price_increments',
                'value' => $settings['brixwork_search_price_increments'],
                'label' => 'Slide Increment',
                'tooltip' => 'Generally set to 10,000 or 50,000. Depends on Maximum Price'
            )); ?>
        </div>
    </div>
</div>


<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Price Slider Settings (Rentals)</h3>

    <p class="each_tab__category_subtitle">
        This applies to the rental price sliders. If your site is not equipped with the rentals add-on, these settings are irrelevant.
    </p>

    <div class="row">
        <div class="col-lg-4 col-sm-6 mb-4 mb-lg-0">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_rental_search_min_price',
                'value' => $settings['brixwork_rental_search_min_price'],
                'label' => 'Minimum Price',
                'tooltip' => 'Generally set to 0. Numbers only!'
            )); ?>
        </div>

        <div class="col-lg-4 col-sm-6 mb-4 mb-lg-0">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_rental_search_max_price',
                'value' => $settings['brixwork_rental_search_max_price'],
                'label' => 'Maximum Price',
                'tooltip' => 'Users can still search above the Max Price by dragging the slide bar all the way.'
            )); ?>
        </div>

        <div class="col-lg-4 col-sm-6">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_rental_search_price_increments',
                'value' => $settings['brixwork_rental_search_price_increments'],
                'label' => 'Slide Increment',
                'tooltip' => 'Generally set to 1,000 or 5,000. Depends on Maximum Price'
            )); ?>
        </div>
    </div>
</div>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Sqft Slider Settings</h3>

    <p class="each_tab__category_subtitle">
        This applies to the newer sqft sliders, as well as the interactive map & list search module (Fairview & Yaletown Templates).
    </p>

    <div class="row">
        <div class="col-lg-4 col-sm-6 mb-4 mb-lg-0">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_search_min_sqft',
                'value' => $settings['brixwork_search_min_sqft'],
                'label' => 'Minimum SQFT',
                'tooltip' => 'Generally set to 0. Numbers only!'
            )); ?>
        </div>

        <div class="col-lg-4 col-sm-6 mb-4 mb-lg-0">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_search_max_sqft',
                'value' => $settings['brixwork_search_max_sqft'],
                'label' => 'Maximum SQFT',
                'tooltip' => 'Users can still search above the Max Price by dragging the slide bar all the way.'
            )); ?>
        </div>

        <div class="col-lg-4 col-sm-6">
            <?php
            admin_text_basic( array(
                'name' => 'brixwork_search_sqft_increments',
                'value' => $settings['brixwork_search_sqft_increments'],
                'label' => 'Slide Increment',
            )); ?>
        </div>
    </div>
</div>


<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Property Types to Search</h3>

    <p class="each_tab__category_subtitle">
        Which property types would you like to allow on your search?
    </p>

    <div class="row">
        <div class="col-12">
            <?php
            admin_checkbox( array(
                'name' => 'brixwork_search_type',
                'value' => $settings['brixwork_search_type'],
                'value_variants' => $settings['type'],
                'label_class' => 'style="text-transform: none"'
            )); ?>
        </div>
    </div>
</div>