<?
/*
Filename: settings_tracking.php
Location: /admin/includes

Method: Include
Output: HTML

Description: Settings form for tracking tags info screen

Author: Jeff Kee
*/
// settings_text($name, $value, $label, $placeholder, $firstdivclass, $seconddivclass, $allowmultiple = false, $readonly = false, $tooltip='')
// settings_select($name, $value, $options, $label, $selecttext='Select', $firstdivclass, $seconddivclass, $allowmultiple = false, $readonly = false, $tooltip='')
// settings_checkbox($name, $value, $options, $label, $firstdivclass, $seconddivclass, $allowmultiple = true, $readonly = false, $tooltip='')
// settings_textarea($name, $value, $label, $firstdivclass, $seconddivclass, $readonly = false, $rows = 10, $tooltip='')
?>
<div class="row">
	<div class="col-md-12">
		<h4>Google Analytics &amp; Adword Trackers</h4>
	</div>
</div>


<div class="row form-group">
	<? echo settings_text('google_analytics', $settings['google_analytics'], 'Google Analytics', 'G-XXXXXXX',  'col-md-2', 'col-md-3', false, false, false, 'Enter the Tracking ID (G-XXX or UA-XXX) only, NOT the entire code!'); ?>
	<? echo settings_text('google_webmaster_tools', $settings['google_webmaster_tools'], 'Search Console', '88ljRtBTGlpSlHS7Jmic5BKElvYiORQyDl4SFsy70BU',  'col-md-2', 'col-md-5', false, false, false, 'Enter the HTML meta tag provided under Alternative Methods'); ?>

</div>

<div class="row form-group">
    <? echo settings_text('google_adwords_tracking', $settings['google_adwords_tracking'], 'Google Adwords Tag', 'AW-XXXXXXX',  'col-md-2', 'col-md-3', false, false, false, 'Enter the AW-XXXX tag only, NOT the entire code!'); ?>

</div>

<div class="row">
    <div class="col-md-12">
        <h4>Or, Enter your Google Tag Manager ID</h4>
    </div>
</div>

<div class="row form-group">
	<? echo settings_text('google_tag_manager', $settings['google_tag_manager'], 'Google Tag Manager', 'GTM-XXXXXXX',  'col-md-2', 'col-md-3', false, false, false, 'Enter the ID (GTM-XXX) only, NOT the entire code!'); ?>
	<div class="col-md-12">
		<hr />
	</div>
</div>

<div class="row form-group">
	<div class="col-md-6 col-md-offset-3">
		<div class="alert alert-danger" role="alert">
			<p><strong>Only include javascript in the sections below!</strong>. Entering wrong tracking code or activation code can break your entire site. After adding snippets, please test your website's front-end. If it's broken, remove the added code and save again, and contact our support centre. </p>
			<a href="mailto:support@brixwork.com" class="btn btn-default">Email Support</a>
		</div>
	</div>
</div>


<div class="row form-group">
	<div class="col-md-5">
		<h6>Head Tracking Javascript</h6>

		<div class="well">
			<p>Do not repeat Google Analytics, Google Tag Manager snippet or Google Search Console tags here - look above. Other tracking code such as Facebook tracking code, or any other javascript snippet to place before the &lt;/head&gt; can be placed here. </p>
		</div>

	</div>
	<div class="col-md-7">
		<?
		// because we used google_tag_manager as field name, might as well keep calling it that.
		echo settings_textarea('header_js', $settings['header_js'], 'Head tag Javascript', 'hidden', 'col-md-12', false, 8, 'Enter javascript tracking code.'); ?>
	</div>
	<div class="col-md-12">
		<hr />
	</div>
</div>



<div class="row form-group">
	<div class="col-md-5">
		<h6>Body Top Tracking Javascript</h6>

		<div class="well">
			<p>Do not repeat Google Analytics, Google Tag Manager snippet or Google Search Console tags here - look above. Initialization tags that need to be right after &lt;body&gt; should be placed here.</p>
		</div>

	</div>
	<div class="col-md-7">
		<?
		// because we used google_tag_manager as field name, might as well keep calling it that.
		echo settings_textarea('body_top_js', $settings['body_top_js'], 'Body Top Javascript', 'hidden', 'col-md-12', false, 8, 'Enter javascript tracking code or pixels.'); ?>
	</div>
	<div class="col-md-12">
		<hr />
	</div>
</div>


<div class="row form-group">
	<div class="col-md-5">
		<h6>Footer Javascript Includes</h6>

		<div class="well">
			<p>Facebook Messenger Chat Widgets and other similar widgets can be entered here.</p>
			<p><a href="http://support.brixwork.com/support/solutions/articles/8000074517-add-facebook-chat-widget-to-your-website" target="_blank" class="btn btn-default">FB Chat Widget</a></p>
		</div>

	</div>
	<div class="col-md-7">
		<?
		// because we used google_tag_manager as field name, might as well keep calling it that.
		echo settings_textarea('footer_js', $settings['footer_js'], 'Footer JS', 'hidden', 'col-md-12', false, 8, 'Enter javascript tracking code.'); ?>
	</div>
	<div class="col-md-12">
		<hr />
	</div>
</div>

