<?php
/**
 * Filename: index.php
 * Description: Dashboard of the 2023 V5 backend.
 *
 */
include 'start.php';
global $settings, $login_user;

// TODO: COMPILE SOURCE.JS TO INDEX.JS AND REPLACE
// must be included in the footer for the double slider and the dropdown in the mls search form
$scriptinclude_footer = 'index.source.js';

/**
 * Attempt at getting notice/advertising data from demo.
 */
$masterurl  = 'https://demo.brixwork.com/master/admin/notice.php';
$jsonfeed   = curl_get_file_contents($masterurl, 'GET');
$statusjson = json_decode($jsonfeed, TRUE);

if($statusjson['date']!=$_COOKIE['brixwork_notice_date']) {
	if($statusjson==false) {
		$statusjson['active'] =0;
		$statusjson['allow'] = 1;
	}
	if($statusjson['active'] == 1) {
		setcookie('brixwork_notice_date', $statusjson['date'], time()+(3600*72)); // set cookie so this one does not pop up again on reload. 
		$scriptinsert = "
		<script type=\"text/javascript\">
			$(document).ready(function(){
				$('#statusjson').modal('show');
			});
		</script>
		";
	} else {
		setcookie('brixwork_notice_date', '', -1); // set cookie so this one does not pop up again on reload. 
	}
}
			
include 'header.php';
// header_html is separated from header.php on purpose.
include 'includes/header_html.php';

if($statusjson['active']!=1 || ($statusjson['allow']==1 && $statusjson['active']==1)) {
    $userquery = "SELECT `user` FROM `login` WHERE `hash`='".$mysqli->real_escape_string($_COOKIE['hash'])."'";
    $userdump = $mysqli->query($userquery);
    $user = $userdump->fetch_assoc();

    /**
     * Query Listing/Building data.
     * 1. These numbers are different depending on login - only query for associated listings!
     * 2. Only add agent to the query if the login user is Agent Level.
     */
    $index_active_listings_query    = array('ownlisting' => 1, 'sold' => 0);
    $index_sold_listings_query      = array('ownlisting' => 1, 'sold' => 1);
    $index_buildings_query          = array('feature' => 1);

    if (!login_level_check(USER_LOGIN_MANAGER)) {
        // only add agent query if user login is below MANAGER level.
        $index_active_listings_query['agent'] = $index_sold_listings_query['agent'] = $index_buildings_query['agent'] = $login_user->getAgents();
    }

    // GET PROPERTY COUNTS.
    $index_active_listings_count    = get_properties('', $index_active_listings_query, array('ord'), array('ASC'), 100000, 1, true);
    $index_sold_listings_count      = get_properties('', $index_sold_listings_query,'', '', 100000, 1, true);
    $index_buildings_count          = get_buildings($index_buildings_query, array('ord'), array('ASC'), 100000, 1, true);


    /**
     * BRIXWORK SERVICE ADVERTISING BANNER
     * 1. Update the variables below to change the advertising banner
     */
    // TODO: image calling with master_url doesnt work for newly added image - ask jeff why.
    //$admin_banner__img          = $settings['master_url'].'admin/images/admin_banner__listing_presentation.jpg';
    $index_banner_img           = $settings['sitepath'].'admin/images/admin_banner__listing_presentation.jpg';
    $index_banner_small_header  = "Custom Designed Listing Presentation";
    $index_banner_big_header    = "Show what makes you a cut above the rest";
    $index_banner_link_href     = "/";
    $index_banner_link_label    = "Learn More";
    ?>
    <section id="admin_intro" class="brixwork_admin_container">
        <h1 id="admin_page__title">Welcome to the dashboard</h1>
        <h5>You are managing <?=$settings['title']?> (<a href="<?=$settings['sitepath']?>" target="_blank"><?=$settings['sitepath']?></a>), logged in as <u><?= $_COOKIE['username'];?></u>.</h5>

        <div class="admin_intro__dashboard brix_row">
            <div class="admin_intro__banner">
                <div class="inner_wrapper">
                    <img class="img-full" src="<?=$index_banner_img?>" alt="<?=$index_banner_big_header?>">
                    <div class="overlay dark"></div>
                    <div class="text_over_img">
                        <div class="title">
                            <h5><?=$index_banner_small_header?></h5>
                            <h2><?=$index_banner_big_header?></h2>
                        </div>

                        <div class="useful_link">
                            <a class="brix_link" href="<?=$index_banner_link_href?>"><?=$index_banner_link_label?></a><span>></span>
                        </div>
                    </div>
                </div>
            </div>
            <div class="admin_intro__blocks">
                <div id="active_listing" class="admin_intro__each_data">
                    <div class="content_wrapper">
                        <h2><?=$index_active_listings_count?></h2>
                        <h4>Active Listings</h4>
                    </div>
                </div>
                <div id="sold_listing" class="admin_intro__each_data">
                    <div class="content_wrapper">
                        <h2><?=$index_sold_listings_count?></h2>
                        <h4>Sold Listings</h4>
                    </div>
                </div>
                <div id="buildings" class="admin_intro__each_data">
                    <div class="content_wrapper">
                        <h2><?=$index_buildings_count?></h2>
                        <h4>Featured Buildings</h4>
                    </div>
                </div>
            </div>
        </div>
    </section>



    <?php
    $sitepath_append = $settings['sitepath'].'admin/';

    // Brixwork Admin Functions
    if (login_level_check(USER_LOGIN_BRIXWORK)) { ?>
        <section id="admin_function_grid" class="brixwork_admin_container">
            <h2 class="title">Brixwork Functions</h2>

            <div class="function_grid">
                <a id="" href="<?=$sitepath_append?>pageurls.php" class="each_function">
                    <i class="bi bi-book"></i>
                    <h5>Mass Page Edits</h5>
                </a>
            </div>
        </section>
    <?php
    }


    // GRID OF QUICK LINKS TO OTHER ADMIN PAGES
    $svg_append = 'images/admin_function_icon/';

    // TODO: how to hide icons depending on user permission?
    /**
     * Build array of links - "function name" => array("link to page/section" , "link SVG", permission level)
     * - Permission Levels -
     * 1. if not specified, available to everyone
     * 2. if single value, that show the block for that access level & above. i.e. USER_LOGIN_MANAGER = only available for manager & admin.
     * 3. if it's array, exclude the access level specified in the array
     *
     * Listings          - All levels have access: within the page, only the valid listings will appear.
     * Page Content      - Agent Level will not have access, but Content Manager has access.
     * Cities            - Agent Level will not have access, Content Manager will have partial access within the page.
     * Buildings         - All levels have access, same as listings.
     * Contact Info      - Only Admin has access to the settings page.
     * Agents            - All levels have access, same as listings.
     * Links & Resources - Agent Level will not have access.
     * Social Media      - Only Admin has access to the settings page.
     */
    $links_array = array(
        "Manage Listings"           => array($sitepath_append.'homes.php', get_svg(file_get_contents($svg_append.'listings.svg', true))),
        "Edit Page Content"         => array($sitepath_append.'pages.php', get_svg(file_get_contents($svg_append.'pages.svg', true)), array(USER_LOGIN_AGENT)),
        "Manage Cities"             => array($sitepath_append.'areas.php', get_svg(file_get_contents($svg_append.'areas.svg', true)), array(USER_LOGIN_AGENT)),
        "Manage Buildings"          => array($sitepath_append.'buildings.php', get_svg(file_get_contents($svg_append.'buildings.svg', true))),
        "Change Contact Info"       => array($sitepath_append.'setup.php?section=contact-tab', get_svg(file_get_contents($svg_append.'contact_info.svg', true)), USER_LOGIN_ADMIN),
        "Edit Agents"               => array($sitepath_append.'agents.php', get_svg(file_get_contents($svg_append.'agents.svg', true))),
        "Edit Links & Resources"    => array($sitepath_append.'links.php', get_svg(file_get_contents($svg_append.'links.svg', true)), array(USER_LOGIN_AGENT)),
        "Edit Social Media"         => array($sitepath_append.'setup.php?section=social-tab', get_svg(file_get_contents($svg_append.'social_media.svg', true)), USER_LOGIN_ADMIN),
    );
    ?>
    <section id="admin_function_grid" class="brixwork_admin_container">
        <h2 class="title">What would you like to accomplish?</h2>

        <div class="function_grid">
            <?php
            foreach ($links_array as $function_title=>$each_link) {
                $each_id = implode("-", explode(" ", strtolower($function_title)));
                /**
                 * Skip condition
                 * 1. Continue to next iteration if permission check fails
                 */
                // Podium specific
                if (str_contains($settings['sitepath'], "https://podium.properties") && (!login_level_check(USER_LOGIN_MANAGER)) && (str_contains($function_title, "Manage Listings"))) {
                    continue;
                }
                if (isset($each_link[2]) && (
                        (is_array($each_link[2]) && in_array($login_user->getLevel(), $each_link[2])) ||
                        (!is_array($each_link[2]) && !login_level_check($each_link[2]))
                    )) {
                    continue;
                } ?>
                <a id="<?=$each_id?>" href="<?=$each_link[0]?>" class="each_function">
                    <?=$each_link[1]?>
                    <h5><?=$function_title?></h5>
                </a>
            <?php
            } ?>
        </div>
    </section>


    <?php // MLS QUICK SEARCH FORM
    if (login_level_check(USER_LOGIN_MANAGER)) { ?>
        <section id="brixwork_mls_search" class="brixwork_admin_container">
            <h2 class="title">MLS® Quick Search</h2>
            <form id="admin_listing_search_form" class="brixwork_inner_spacing" action="ajax_listhomeslist.php" enctype="multipart/form-data" method="post">
                <div class="form_function_desc">
                    <h3 class="form_title">With this, you can:</h3>
                    <div class="form_function_desc__list">
                        <ul class="form_function_ul">
                            <li>Quickly search and share listing pages with your clients!</li>
                            <li>Share listings to social media in a snap.</li>
                        </ul>
                        <ul class="form_function_ul">
                            <li>Get an overview of the number of listings in a specific region that matches your criteria.</li>
                        </ul>
                    </div>
                </div>
                <div class="row bottom_10">
                    <div class="col-lg-2 col-xs-12">
                        <input autocomplete="off" type="text" class="form-control input-lg" name="mls" id="mls" placeholder="MLS #" size="40" aria-label="MLS #"/>
                    </div>
                    <div class="col-lg-1 text-center py-2"><label for="city">- OR -</label></div>
                    <div class="col-lg-9">
                        <?php // CITIES, AREA AND TYPE SELECT ?>
                        <div class="row pb-2">
                            <div class="col-lg-4 py-1 py-lg-0">
                                <?php // CITIES - BOOTSTRAP 5 SELECT  ?>
                                <select name="cityid" id="city" class="form-select" aria-label="Select a City">
                                    <option value="" selected>Select a city</option>
                                    <?php
                                    $sql = "SELECT id, name FROM areas WHERE `publish`=1 ORDER BY feature DESC, name ASC";
                                    $result = $mysqli->query($sql);
                                    while($cities = $result->fetch_assoc()) {
                                        echo '<option value="'.$cities['id'].'">'.$cities['name'].'</option>';
                                    }
                                    ?>
                                </select>
                            </div>

                            <div class="col-lg-5 py-1 py-lg-0">
                                <?php // CITIES - BOOTSTRAP 5 SELECT ?>
                                <select name="areaid" id="area" class="form-select" aria-label="All Subareas">
                                    <option value="">All Subareas</option>
                                </select>
                            </div>

                            <div class="col-lg-3 py-1 py-lg-0">
                                <select name="typeid" size="1" id="type" class="form-select" aria-label="Choose Type">
                                    <?php
                                    foreach ($settings['type'] as $key=>$type):
                                        if ($key < 50):
                                            if ($type == "") continue;
                                            $residential_rel = (is_array($settings['building_type']) ? (in_array($key, $settings['building_type']) ? 'rel="building"' : 'rel="detached"') : ($key == $settings['building_type'])) ? 'rel="building"' : 'rel="detached"';
                                            $label = $type ?: 'All Types';
                                            echo "<option value='$key' $residential_rel>$label</option>";
                                        endif;
                                    endforeach;

                                    // only enable commercial selection if commercial is enabled.
                                    if ($settings['commercial_enabled'] == 1) {
                                        echo '<optgroup label="----------------"></optgroup>';

                                        foreach($settings['type_commercial'] as $key=>$type):
                                            if ($key > 50): // skip empty string
                                                $commercial_rel = (is_array($settings['building_type']) ? (in_array($key, $settings['building_type']) ? 'rel="building"' : 'rel="detached"') : ($key == $settings['building_type'])) ? 'rel="building"' : 'rel="detached"';
                                                $label = $type ?: 'Error';
                                                echo "<option value='$key' class='type_commercial' $commercial_rel>$label</option>";
                                            endif;
                                        endforeach;
                                    }
                                    ?>
                                </select>
                            </div>
                        </div>

                        <?php // STREET NAMES, BEDS & BATHS INPUT FIELD ?>
                        <div class="row">
                            <div class="col-lg-4 col-xs-12 py-1 py-sm-0">
                                <input autocomplete="new-password" type="text" class="form-control" name="street" id="street" placeholder="Street Name" size="5" aria-label="Street Name"/>
                            </div>
                            <div class="col-lg-2 col-6 py-1 py-lg-0">
                                <input type="text" class="form-control" name="bedroom" id="bedroom" placeholder="Beds" aria-label="Beds" size="5" />
                            </div>
                            <div class="col-lg-2 col-6 py-1 py-lg-0">
                                <input type="text" class="form-control" name="bathroom" id="bathroom" placeholder="Baths" aria-label="Baths" size="5" />
                            </div>
                            <div class="col-lg-2 col-6 py-1 py-lg-0">
                                <input type="text" class="form-control" name="min_sqft" id="min_sqft" placeholder="Sqft" aria-label="Sqft" size="5" />
                            </div>
                            <div class="col-lg-2 col-6 py-1 py-lg-0">
                                <input type="text" class="form-control" name="min_lot" id="min_lot" placeholder="Lot Size" aria-label="Lot Size" size="5" />
                            </div>
                        </div>

                        <?php // DOUBLE SLIDER SECTION ?>
                        <div class="row">
                            <div class="col-md-12" id="price_range_section">
                                <?php // RENTAL SEARCH IS DISABLED. ?>
                                <label for="amount">Price range:</label>
                                <div class="sixteen columns slider_display_value_container">
                                    <h6>From <span id="range1">$0</span> to <span id="range2">Unlimited</span></h6>
                                </div>

                                <?php
                                $price_param = array();
                                $price_param['min'] = $settings['brixwork_search_min_price'] ?: 0;
                                $price_param['max'] = $settings['brixwork_search_max_price'] ?: 5000000;
                                $price_param['increment'] = $settings['brixwork_search_price_increments'] ?: 250000;
                                ?>

                                <?php // HIDDEN INPUT FOR DATA TO BE USED IN JAVASCRIPT ?>
                                <input type="hidden" name="min_price" id="listing_search_min_price" value="<?=$price_param['min']?>" />
                                <input type="hidden" name="max_price" id="listing_search_max_price" value="<?=$price_param['max']?>" />
                                <input type="hidden" id="search_min_price" value="0" />


                                <?php // DOUBLE SLIDER HTML ?>
                                <div class="range-container">
                                    <div class="slider-track" data-tracker-color="#637c91" data-background="#dadae5"></div>
                                    <input
                                            aria-label="slider one"
                                            type="range"
                                            min="0"
                                            max="<?=$price_param['max']?>"
                                            value="<?=$price_param['min']?>"
                                            step="<?=$price_param['increment']?>"
                                            id="slider-1"
                                            oninput="slideOne()"
                                    >
                                    <input
                                            aria-label="slider two"
                                            type="range"
                                            min="0"
                                            max="<?=$price_param['max']?>"
                                            value="<?=$price_param['max']?>"
                                            step="<?=$price_param['increment']?>"
                                            id="slider-2"
                                            oninput="slideTwo()"
                                    >
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="listing_search_order_options row">
                    <div class="col-lg-4 col-xs-12">
                        <?php /** Original Dropdown - for reference
                        <select name="listing_order_by" id="listing_order_by" class="form-control">
                        <option value="">Order By</option>
                        <option value="create_date"<?php if($params['order_by']=='create_date') { echo ' selected="selected"';}?>>Date Listing Came On Market</option>
                        <option value="price"<?php if($params['order_by']=='price') { echo ' selected="selected"';}?>>Current Listed Price</option>
                        <option value="sqft"<?php if($params['order_by']=='sqft') { echo ' selected="selected"';}?>>Size of Home (sqft)</option>
                        <option value="bedroom"<?php if($params['order_by']=='bedroom') { echo ' selected="selected"';}?>>Number of Bedrooms</option>
                        <option value="bathroom"<?php if($params['order_by']=='bathroom') { echo ' selected="selected"';}?>>Number of Bathrooms</option>
                        </select> */

                        // Bootstrap 5 DROPDOWN - the hidden input field is the one that will be fed to data ?>
                        <div class="dropdown">
                            <button id="listing_order_dropdown" class="btn btn-brixwork dropdown-toggle" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                Order By
                            </button>
                            <input type="hidden" name="listing_order_by" id="listing_order_by" value="">
                            <ul class="dropdown-menu">
                                <li class="dropdown-header"><h6 class="m-0">Order By</h6></li>
                                <li id="listing_order_category_li" data-val="date" class="dropdown-item" value="create_date"<?php if($params['order_by']=='create_date') { echo ' selected="selected"';}?>>Date Listing Came On Market</li>
                                <li id="listing_order_category_li" data-val="price" class="dropdown-item" value="price"<?php if($params['order_by']=='price') { echo ' selected="selected"';}?>>Current Listed Price</li>
                                <li id="listing_order_category_li" data-val="sqft" class="dropdown-item" value="sqft"<?php if($params['order_by']=='sqft') { echo ' selected="selected"';}?>>Size of Home (sqft)</li>
                                <li id="listing_order_category_li" data-val="numBeds" class="dropdown-item" value="bedroom"<?php if($params['order_by']=='bedroom') { echo ' selected="selected"';}?>>Number of Bedrooms</li>
                                <li id="listing_order_category_li" data-val="numBaths" class="dropdown-item" value="bathroom"<?php if($params['order_by']=='bathroom') { echo ' selected="selected"';}?>>Number of Bathrooms</li>
                            </ul>
                        </div>
                    </div>
                    <div class="col-lg-4 col-xs-12">
                        <?php /** ORIGINAL DROPDOWN - FOR REFERENCE
                        <select name="listing_order_direction" id="listing_order_direction" class="form-control">
                        <option value="DESC">Choose Option</option>
                        <option value="ASC"<?php if($params['order_direction']=='ASC') { echo ' selected="selected"';}?>>Choose Option</option>
                        </select>
                         */
                        // BOOTSTRAP DROPDOWN - the hidden input field is the one that will be fed to data ?>
                        <div class="dropdown">
                            <button id="listing_order_direction_dropdown" class="btn btn-brixwork dropdown-toggle disabled" type="button" data-bs-toggle="dropdown" aria-expanded="false">
                                Choose Order By First
                            </button>
                            <input type="hidden" name="listing_order_direction" id="listing_order_direction_input" value="">
                            <ul class="dropdown-menu">
                                <li id="listing_order_direction_dir" class="dropdown-item" value="DESC"></li>
                                <li id="listing_order_direction_dir" class="dropdown-item" value="ASC"<?php if($params['order_direction']=='ASC') { echo ' selected="selected"';}?>></li>
                            </ul>
                        </div>
                    </div>
                    <div class="col-sm-4 col-xs-12">
                        <button type="submit" class="btn btn-admin btn-lg btn-block" id="admin_listing_search_submit">Search</button>
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-12" id="listing_search_list">
                        <?php // THIS GETS POPULATED WITH SEARCH RESULTS FROM INDEX.JS?>
                    </div>
                    <div class="pagination_wrapper pt-3" aria-label="Listings Search Pagination">
                        <ul class="pagination"></ul>
                    </div>
                </div>

                <?php
                /*
                 * Control modules for the quick MLS search thing on the admin screen.
                 * Whether the DEBUG button shows, or whether the Re-fetch RETS is shown etc.
                 * are dependent on whether it's a BRIXWORK user or not, as well as whether
                 * it's on an MLS subsite or not, etc.
                 * */
                ?>
                <input type="hidden" id="brixwork_user" value="<?=($_COOKIE['username'] == 'brixwork' ? 1 : 0)?>" />
                <input type="hidden" id="mlssite" value="<?=($settings['mlssite'] == true ? 1 : 0)?>" />
                <?php
                if($settings['mlssite'] == true) {

                    ?>
                    <input type="hidden" id="rets_trigger_php_file" value="<?=$settings['rets_trigger_php_file']?>" />

                    <?php
                }
                ?>
            </form>
        </section>
    <?php
    } ?>


    <div class="grid_8" style="display:none;">
        <h2>Keep Up With Us!</h2>
        <div class="grid_8 alpha omega bottom_20">
            <?php
            // require_once('simplepie.inc');
            require_once('simplepie/autoloader.php');
            // We'll process this feed with all of the default options.
            $feed = new SimplePie();
            // Set the feed to process.
            $feed->set_feed_url('http://www.brixwork.com/realtors/blog/feed/');
            // Run SimplePie.
            $feed->init();
            // This makes sure that the content is sent to the browser as text/html and the UTF-8 character set (since we didn't change it).
            $feed->handle_content_type();
            ?>
            <h4>The Brixwork Blog</h4>

            <p><a href="<?php echo $feed->get_permalink(); ?>" target="_blank">The Brixwork Blog</a> contains very useful updates &amp; new feature guides that you should be aware of. You can also subscribe to the <a href="http://www.brixwork.com/realtors/blog/feed/" target="_blank">RSS feed here</a>.</p>

            <div id="blogfeed">
                <?php

            foreach ($feed->get_items(0,3) as $item):
            $author = $item->get_author();
            ?>
                <h3><a href="#"><?php echo $item->get_title(); ?></a></h3>
                <div>
                    <p><?php echo $item->get_description(); ?> [<a href="<?php echo $item->get_permalink(); ?>" target="_blank">read full article]</a></p>
                    <p><small>Writte on <?php echo $item->get_date($mysql_time['shortdisplay']); ?> by <?php echo $author->get_name(); ?></small></p>
                </div>

            <?php endforeach; ?>
            </div>
        </div>

        <div class="grid_8 alpha omega bottom_20">
            <div class="fb-like-box" data-href="https://www.facebook.com/brixwork" data-width="460" data-height="300" data-show-faces="true" data-stream="true" data-header="false"></div>
        </div>


        <a href="logoff.php" class="ui-state-highlight ui-corner-all contains_icon"><span class="ui-icon ui-icon-locked"></span>Log Off</a>

    </div>
<?php
}



// IE warning, link to chrome site!
$get_chrome = js_redirect($url='https://www.google.com/chrome/', $ms = 10, true);
modal_html('Browser Not Supported', 'It appears you are using Internet Explorer, which does not meet industry standards for usability. Some functions may not work so smoothly. Please consider upgrading to Chrome, a Google-provisioned browser with better functionality.', 'get_chrome', 'Upgrade', 'I\'m OK With Some Issues', $get_chrome);

$logout = js_redirect($url='logoff.php', $ms = 10, true);
modal_html($statusjson['title'], $statusjson['desc'], 'statusjson', ($statusjson['allow']==1 && $statusjson['active']==1 ? 'Got it' : 'Exit'), false, ($statusjson['allow']==1 && $statusjson['active']==1 ? false : $logout), ($statusjson['allow']==1 && $statusjson['active']==1 ? false : $logout));


brixwork_modal_html(array(
    'header_content' => 'Convert MLS® listing to your own.',
    'body_content' => "<p>If this is your own listing, or if you have permission to do so from the listing agent, you can convert the listing as your own and start editing content. If you simply want to display the listing on your site but not claim ownership, you can feature it instead.</p>",
    'footer_content' => "
        <button type='button' class='btn btn-admin' data-bs-dismiss='modal'>Cancel</button>
        <button type='button' class='btn btn-admin light_blue convert_to_own_btn px-4' data-bs-dismiss='modal'>Convert Listing</button>",
    'id' => 'convert_to_own',
));


$footer_position = "left";
include 'footer.php';