$(document).ready(function(){
	window.page = 1;
	listagents(window.page);
	$('#perpage').change(function(){
		window.page = 1; // new filter, back to page 1
		listagents(window.page);
	});

	$('#agents_filter_trigger').click(function(){
		window.page = 1;// new filter, start with page 1!
		listagents(window.page);
	});

	$('#agents_filter_clear').click(function(){
		$('.agents_filter').each(function(){
			$(this).val('');
		});
		window.page = 1;// new filter, start with page 1!
		listagents(window.page);
	});

	// $('.agentslist_legend').tooltip();

	// delete agent function in a modal
	let agent_delete_btn = document.querySelectorAll('#delete_agent_btn');
	agent_delete_btn.forEach(e => e.addEventListener('click', function () {
		modifyagent('delete', e.dataset.agentId, 1)
	}))
});



function listagents(page) {
	let randomnumber = Math.floor(Math.random()*101);
	let perpage = $('#perpage').val();
	window.page = page;
	$('#agentslist').html(window.ajax_loader);
	console.log('Loading '+perpage+' agents, page number '+page);

	/*
	* #agents_filter_fname = returns 0 through 5, or blank for unset.
	* #buildings_filter_name = string
	* #buildings_filter_street = string
	* Can loop through al using .agents_filter class.
	* */
	let filters = {}; // start array
	let filtersset = false;
	$('.agents_filter').each(function(){
		if($(this).val() !== '') {
			filtersset = true;
			filters[$(this).attr('name')] = $(this).val();
		}
	});

	$.post("ajax_listagents.php", { page:page, perpage:perpage, filters:filters, rand:randomnumber },
		function(data){
			$('#agentslist').html(data);

			activate_agents_toggles();
			if(filtersset === false) {
				$("#agentstable").sortable({
					items: ".each_admin_listing",
					handle: ".orderhandle",
					cursor: 'move',
					update: function (event, ui) {
						let agentordervars = $("#agentstable").sortable('serialize');
						$.get("ajax_modifyagents.php", agentordervars + '&change=order&perpage=' + perpage + '&page=' + window.page,
							function (data) {
								console.log(data);
								if (data.code === 0) {
									console.log(data.message);
									$("#agentstable").sortable('cancel');
								} else {
									console.log(data.message);
								}
							},
							'json'
						);
					}
				});

				$('#agentstable .agent_row').each(function () {
					$(this).find('.orderhandle').disableSelection(); // so that you cannot accidentally SELECT the iamge instead of using it to DRAG.
				});

				$('.orderhandle').each(function () {
					$(this).click(function () {
						return false;
					});
				})
			}

			$('.agents_pagelink').each(function(){
				$(this).click(function(){
					listagents($(this).attr('rel'));
					return false;
				});
			});


		});
}

function modifyagent(change,idr,value){
	var randomnumber=Math.floor(Math.random()*101)

	$.post("ajax_modifyagents.php", { idr: idr, value: value, change: change, rand: randomnumber },
		function(data){
			if(data.code==0) {
				console.log(data.message);
			} else {
				var classtoremove = '';
				var classtoadd = '';
				switch(change) {
					case 'publishstatus':

						if(value==1) {
							classtoremove = '';
							classtoadd = 'agent_publish';
						} else {
							classtoremove = 'agent_publish';
							classtoadd = '';
						}

						break;

					case 'delete':
						$('#agent_'+idr).slideUp(300, function(){
							$(this).remove();
						}); // deleted, get rid of this row!
						break;

				}

				$('#agent_'+idr).removeClass(classtoremove).addClass(classtoadd);
			}
		},'json');
}


function activate_agents_toggles() {
	$('.agent_publish_toggle').each(function(){
		$(this).change(function(){
			console.log('publish status change on '+$(this).attr('rel'));
			modifyagent('publishstatus',$(this).attr('rel'),$(this).val());
		});
	});

	$('.agent_delete').each(function(){
		$(this).click(function(){
			let agentid = $(this).attr('rel');
			let agentname = $('#agent_'+agentid+' .full_name').html();
			window.agent_delete_id = agentid;
			let delete_modal = $('#delete_agent');
			delete_modal.find('.modal-body').html('<p>Are you sure you want to delete <strong>'+agentname+'</strong>?</p>');
			$('#delete_agent_btn').attr('data-agent-id', agentid);
			delete_modal.modal('show');
			return false;
		});
	});
}