window.ajax_loader =
	'<div class="d-flex justify-content-center">' +
	'  <div class="spinner-border" role="status">' +
	'    <span class="visually-hidden">Loading...</span>' +
	'  </div>' +
	'</div>';

function alert_display(content, cssclass) {
	if(typeof(cssclass)==='undefined') cssclass = 'danger';
	
	// Javascript equivalent of the ALERT Display for the new bootstrap style. 
	// used inline mostly, different from the modal pop-up. 
	var html = '<div class="alert alert-'+cssclass+'" role="alert">'+content+'</div>';
	return html;
}

function redirect(url, ms) {
	if(typeof(url)==='undefined') url = 'index.php';
	if(typeof(ms)==='undefined') ms = 1000;
	// genreates a simple redirect javascript snippet to be inserted any where in HTML
	window.leaveflag=1;
	setTimeout("window.location = \""+url+"\";", ms);
}

/**
 * SHOW OR HIDE BOOTSTRAP PROCESSING MODAL
 * @param show	visibility status - boolean true or false
 */
function modal_processing(show = false) {
	let loading_modal = document.getElementById('modal_processing')
	if(show !== false) {
		// CREATE A NEW INSTANCE OF MODAL
		let bootstrap_modal = new bootstrap.Modal(loading_modal, {
			keyboard: false,
			backdrop: 'static',
		})
		bootstrap_modal.show();
		console.log('processing...')
	} else {
		// Two different closing conditions -
		let existing_bootstrap_modal = bootstrap.Modal.getInstance(loading_modal);

		// one for operation that's too fast ... wait for "shown" event,
		loading_modal.addEventListener('shown.bs.modal', function () {
			// console.log('processing finished while modal is loading')
			if (existing_bootstrap_modal) {
				existing_bootstrap_modal.hide();
			}
			return 0;
		})
		// one for slow operation ... just close the modal
		// console.log('processing finished')
		if (existing_bootstrap_modal) {
			existing_bootstrap_modal.hide();
		}
	}
}

function update_price_from_slider(min_price, max_price) {
	let search_min_price = (min_price!==undefined ? min_price : $( "#slider_price" ).slider( "values", 0));
	let search_max_price = (max_price!==undefined ? max_price : $( "#slider_price" ).slider( "values", 1));
	let max_display

	if(search_max_price === $('#search_max_price').val()) {
		// maximum value
		max_display = 'Unlimited';
		search_max_price = 0;
	} else {
		max_display = "$"+$.number(search_max_price, 0);
	}
	
	$( "#amount" ).html( "From $" + $.number(search_min_price, 0) +  " to " +  max_display);
	
	$('#listing_search_min_price').val( search_min_price ); //sets the default value of hidden input to the default value of the styled form
	$('#listing_search_max_price').val( search_max_price ); //sets the default value of hidden input to the default value of the styled form
}

function error_display(message, title, icon, functionyes) { 
	// dead function!
	return false;
}

function confirmation_display(message, title, icon, functionyes, functionno) { 
	// confirm yes or no on certain actions. run functionyes or functionno depending on the client's response on the pop-up. 
	// THIS IS BEING DEPRECATED SOON! DO NOT USE ANYMORE.
	var yesorno = '';
	$('#error_console').html('<span class="ui-icon ui-icon-'+icon+' picon"></span><p>'+message+'</p>');
	// add and remove the classes depending on type of warning. 
	// set title. 
	$('#error_console').attr('title',title);
	$("#error_console").dialog({
			bgiframe: true,
			modal: true,
			buttons: {
				Yes: function() {
					$(this).dialog('close');
					eval(functionyes);
					$(this).dialog('destroy');
				},
				No: function() {
					$(this).dialog('close');
					eval(functionno);
					$(this).dialog('destroy');
				}
			}
		});
	
	$("#error_console").dialog('open');
	return yesorno;
}

function error_disappear() {
	// THIS IS BEING DEPRECATED SOON! DO NOT USE ANYMORE.
	$("#error_console").dialog('destroy');
}

function trim_input_value(inputid) {
	// removes blank spaces before and after on certain input fields such as emails, usernames, headings etc. where there shouldn't be dead space!p
	
	// see if item passed is jQuery object of an <input> already? 
	if((inputid instanceof jQuery)===true) {
		//console.log('its already object, use as is');
		var targetinput = inputid;
	} else if(typeof inputid==='string') {
		//console.log('raw string, so letes do #'+inputid);
		var targetinput = $('#'+inputid);
	}
	
	if(targetinput.length) {
		var inputvalue = targetinput.val();
		inputvalue = inputvalue.trim();
		targetinput.val(inputvalue);
	}
	
}



/* DELAY FUNCTION to run AJAX after keyup action has paused for a while! */
var delay = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  };
})();

function activate_reactiverows() {
	var reactiverows = $(".reactiverow").hover(
		function(){
		$(this).css('background-color', '#fcdfc8');
    	},
		
		function(){
      	$(this).css('background-color', '#fafafa');
    	}
		);
}

function deactivate_reactiverows() {
	var reactiverows = $(".reactiverow").hover(
		function(){
		$(this).css('background-color', '#fafafa');
    	},
		
		function(){
      	$(this).css('background-color', '#fafafa');
		}
		);
}

function activate_ui_hover() {
	$('.ui-icon').hover(
		function() { $(this).addClass('ui-state-hover'); }, 
		function() { $(this).removeClass('ui-state-hover'); }
	);

}

function loadingbar_toggle(onoff) { // toggles the loading bar ont he top of page for long ajax calls. 
	// removing, do NOTHING
	// we keep this here ot prevent any shitty errors or breakages.
	return false;
}


function removefile(filename,folder,targetdiv) { // universal AJAX file removal function. folder MUST include '/' at the beginning for calls. 
	$.post('ajax_removefile.php', {folder:folder, filename:filename },
		function(data){
			if(data=='1') {
				$('#'+targetdiv).html(filename+' has been successfully removed.');
			}
			else if(data=='0') {
				$('#'+targetdiv).html(filename+' is already removed - nothing more to remove.');
			}
		}
	);
}

/**
 *
 * @param type
 * @param idr
 * @param attachment
 * @param count
 */
function remove_s3_file(type, idr, attachment, count) {
	// new function that removes S3 files. Still calls same PHP file which also needs to be updated accordingly. This will remove the local file as well as remote files (part of S3 upgrades in 2016-12. 
	console.log('Removal script initiated');
	console.log('Type: '+type);
	console.log('ID: '+idr);
	console.log('Attachment: '+attachment);
	console.log('Count: '+count);
	$.post('ajax_removefile.php', {type:type, idr:idr, attachment:attachment, count:count, s3:true});
}

function getrandomnumber() {
	var randomnumbera=Math.floor(Math.random()*101);
	var randomnumberb=Math.floor(Math.random()*101);
	var randomnumberc=Math.floor(Math.random()*101);
	var randomnumberd=Math.floor(Math.random()*101);
	var randomnumbere=Math.floor(Math.random()*101);
	
	return randomnumbera+randomnumberb+randomnumberc+randomnumberd+randomnumbere;
}


function activatefield(thisfield, activecolour, inactivecolour) {
	
	if(activecolour=='' || activecolour==undefined || activecolour==false) {
		var activecolour = '#333';
	}
	if(inactivecolour=='' || inactivecolour==undefined || inactivecolour==false) {
		var inactivecolour = '#999';
	}
	
	thisfield.css('color',inactivecolour);
	thisfield.attr('rel',thisfield.val());
	
	thisfield.focus(function(){
		// action for focus!
		if(thisfield.attr('rel')!=thisfield.val() && thisfield.val()!='') {
			// field has already been modified. set the colour to active, do NOT modify content
			thisfield.css('color',activecolour);
		} else if(thisfield.attr('rel')==thisfield.val()) {
			// field still has not been touched. remove content, set to active colour
			thisfield.val('').css('color',activecolour);
		}
	
		return true;
	});
	
	thisfield.blur(function(){
		// action for blur!
		if(thisfield.attr('rel')!=thisfield.val() && thisfield.val()!='') {
			// field has already been modified. set the colour to active, do NOT modify content
			thisfield.css('color',activecolour);
		} else if(thisfield.attr('rel')==thisfield.val() || thisfield.val()=='') {
			// the user did NOT change anything on the field, or left a blank - reset to original.
			thisfield.val(thisfield.attr('rel')).css('color',inactivecolour);
		}
	
		return true;
	});
}

function calculate_length(fieldobj, displaydiv, max) {
	var length = fieldobj.val().length;
	var popen = '<p class="my-0"><small>';
	var pclose = '</small></p>';
	var addclass = 'alert-success'; // default add success. 
	var removeclass = 'alert-danger'; // default, remove danger. 
	var message = '';
	if(length<=max) {
		message = 'Character Count: '+length+'/'+max+'.'
	} else {
		addclass = 'alert-danger';
		removeclass = 'alert-success';
		message = 'Character Count '+length+'/'+max+' - over the recommended length!';
	}
	
	$('#'+displaydiv).addClass(addclass).removeClass(removeclass).html(popen+message+pclose);
}

function append_http(field, ssl) {
	if(typeof(ssl)==='undefined') ssl = true; // default to ssl true!

	var content = field.val();
	if(content!='') {
		// no point in appending empty field.

		var httppattern = new RegExp(/^(http|https):\/\//i);
		var slashspattern = new RegExp(/^\/\//i);
		// regex check for http(s) or just // (browser will figure it out)
		if(!httppattern.test(content) && !slashspattern.test(content)) {
			// if http is not there, append it.
			if(ssl===false) {
				field.val('http://'+content);
			} else {
				field.val('https://'+content);
			}

		}
	}
}

function isUrl(s) {
	var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
	return regexp.test(s);
}


function isEmail(email) {
	var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	return regex.test(email);
}

function isNumber(number) {
	var regex = /^-?\d+(\.\d+)?$/;
	return regex.test(number);
}

function url_format(input) {
	// converts spaces to dashes, and removes all non-alphanumeric items.
	var output = input.replace(/ /g,'-');
	output = output.replace(/[^a-zA-Z0-9-_]/, '');
	return output;
}

function number_only(input) {
	// Useful for raw number calculatoin.
	// To generate display-friendly numbers, look at the numbers plugin we alreayd have
	// admin/js/jquery.numbers.js
	// https://github.com/customd/jquery-number for user guide.

	// if not a number, remove those strings!
	// Also allows decimals and negatives.
	var output = input.replace(/[^0-9.\-]/g, '');
	output = parseFloat(output);
	return output;
}

function integer_only(input) {
	// Strip all but integers, also negative.
	// Unlike number_only(), this also kills dots.
	var output = input.replace(/[^0-9\-]/g, '');
	output = parseInt(output, 10);
	return output;
}

function remain_logged_in() {
	$.post('ajax_keeplogin.php', {},
		function(data){
			console.log('Extended login - '+data);
		}
	);
}

/**
 * Cuts off String to preset length and add ...
 * @deprecated this action can be done better using CSS { overflow: hidden; white-space: nowrap; text-overflow: ellipsis }
 * @param string
 * @param max_length
 * @param hellip
 * @return {string|*}
 */
function shorten_display(string, max_length, hellip) {
	if(typeof(hellip)==='undefined') hellip = true;
	return (string.length>max_length ? string.substr(0, (hellip ? max_length-3 : max_length))+(hellip ? '&hellip;' : '') : string);
}

/**
 * Update the Google Preview as user is typing.
 *
 * @param element
 */
function googlepreview_update(element) {
	let fieldname = element.attr('id'); // get the ID
	let objecttype = $('#objecttype').val();
	let value = element.val();
	let target = '';
	// let max_length = parseInt(element.attr('rel')); // get max length of this specific field type.
	// console.log('Google Preview - Processing ID '+fieldname+' on object type '+objecttype+'with max length limit of '+max_length);

	if( element.attr('name') === 'metadescription' ) {
		target = $('#googlepreview span');
		if( value === '' ) {
			value = $('#'+fieldname+'_default').val(); // override to original value if the entry is blank! 
		}
	}
	else if( element.attr('name') === 'metatitle' ) {
		target = $('#googlepreview h3');
		if(value === '') {
			value = $('#'+fieldname+'_default').val(); // override to original value if the entry is blank! 
		}
	}
	else if( element.attr('name') === 'slug' ) {
		target = $('#googlepreview cite');
		value = url_format(value);
		element.val(value);
		if(value === '') {
			value = $('#'+fieldname+'_default').val(); // override to original value if the entry is blank!
		}
		if(objecttype === 'page') {
			// for page objects, the page ID has to be part of the slug!
			let slugpageid = ($('#idr').val() !== '' ?  $('#idr').val() : '[id]')+'/';
			value = slugpageid+value;
		}
		value = $('#url_root').val()+value; // prepend the value with the URL root, which is most likely the $settings['sitepath']
	}

	target.html(value);
}


function is_ie() {
	// detect if it's internet explorer.
	var ua = window.navigator.userAgent;
	//alert(ua);
	var msie = ua.indexOf("MSIE ");
	if (msie > 0) {
		return true;
	}
	else {
		return false;
	}
}


/**
 * TOGGLE STREET DIRECTION POSITION (EITHER BEFORE STREET NAME OR AFTER STREET NAME)
 * @param toggle_data		true = toggle data, false = do not toggle data
 * @param prefix    		for listing, building, or showroom?
 */
function street_dir_position_toggle(toggle_data = false, prefix = '') {
	console.log('street_dir_position_toggle clicked with prefix: '+prefix)

	let street_dir_position_html = $("#"+prefix+"_street_dir_position")
	let street_dir_position = parseInt(street_dir_position_html.val()); // get current value.

	if (toggle_data) {
		street_dir_position = (street_dir_position === 1 ? 0 : 1);	// toggle!
		$(street_dir_position_html).val(street_dir_position);		// update the var.
	}

	let dir_container = $("#"+prefix+"_street_dir_container")
	let street_name_container = $("#"+prefix+"_street_name_container")

	if (street_dir_position === 0) {
		dir_container.css('order', '1')
		street_name_container.css('order', '2')
	}
	else {
		dir_container.css('order', '2')
		street_name_container.css('order', '1')
	}
}

/**
 * Update Subarea Dropdown content depending on the City Selected
 * @param selected
 * @param cityselect
 * @param subareaselect
 */
function updatesubarea(selected, cityselect, subareaselect) {
	// universal function to laod city/subarea on all parts thorughout site..
	selected = typeof selected !== 'undefined' ? selected : false;
	cityselect = typeof cityselect !== 'undefined' ? cityselect : '#city';
	subareaselect = typeof subareaselect !== 'undefined' ? subareaselect : '#area';

	console.log('cityselect: '+cityselect+', subareaselect: '+subareaselect);
	let areadropdown = $(cityselect);
	let subareadropdown = $(subareaselect);
	let cityid = areadropdown.val();
	console.log(cityid+' was ID we found from DIV '+cityselect);
	subareadropdown.empty().append($("<option></option>").val("").text("... Loading Subareas ...")); // create teh SELECT AREA option first. 
	// make JSON call
	$.post(window.sitepath+'ajax/ajax_subareas.php', {areaid: cityid},
		function(data){
			if(parseInt(data.code) === 1) {
				subareadropdown.empty().append($("<option></option>").val("").text("Select Area")); // create teh SELECT AREA option first. 
				$.each(data.subareas, function(key, value){
					subareadropdown.append($("<option></option>").val(value.id).text(value.name));
				});
				
				$(subareadropdown).focus(); // finally focus on the subarea dropdown! 
				if(selected!==false) {
					subareadropdown.val(selected);
				}
			} else {
				// fail!
				console.log(data.message);
			}
		}, 'json'
	);	
}

function refreshimage(targetdiv, image, numadd) {
	let img = new Image();

	img.src = image;
	img.onload = function() {
		window.img_original_height[numadd] = this.height;
		window.img_original_width[numadd] = this.width;
		console.log('Refreshing new image, height: '+window.img_original_height[numadd]);
		console.log('Refreshing new image, width: '+window.img_original_width[numadd]);
	}

	$('#'+targetdiv).delay(200).html('<img src="'+image+'?mod='+Date.now()+'" id="mainimagecrop'+numadd+'" class="img-full jcrop-image-preview" />');

}

function addDoneTypingFunction() {
	// @author - Brad Christie
	// $('#element').donetyping(callback[, timeout=1000])
	// Fires callback when a user has finished typing. This is determined by the time elapsed
	// since the last keystroke and timeout parameter or the blur event--whichever comes first.
	//   @callback: function to be called when even triggers
	//   @timeout:  (default=1000) timeout, in ms, to to wait before triggering event if not
	//              caused by blur.
	// Requires jQuery 1.7+
	//
	;(function($){
	    $.fn.extend({
	        donetyping: function(callback,timeout){
	            timeout = timeout || 1e3; // 1 second default timeout
	            var timeoutReference,
	                doneTyping = function(el){
	                    if (!timeoutReference) return;
	                    timeoutReference = null;
	                    callback.call(el);
	                };
	            return this.each(function(i,el){
	                var $el = $(el);
	                // Chrome Fix (Use keyup over keypress to detect backspace)
	                // thank you @palerdot
	                $el.is(':input') && $el.on('keyup keypress paste',function(e){
	                    // This catches the backspace button in chrome, but also prevents
	                    // the event from triggering too preemptively. Without this line,
	                    // using tab/shift+tab will make the focused element fire the callback.
	                    if (e.type=='keyup' && e.keyCode!=8) return;
	                    
	                    // Check if timeout has been set. If it has, "reset" the clock and
	                    // start over again.
	                    if (timeoutReference) clearTimeout(timeoutReference);
	                    timeoutReference = setTimeout(function(){
	                        // if we made it here, our timeout has elapsed. Fire the
	                        // callback
	                        doneTyping(el);
	                    }, timeout);
	                }).on('blur',function(){
	                    // If we can, fire the event since we're leaving the field
	                    doneTyping(el);
	                });
	            });
	        }
	    });
	})(jQuery);
}

/**
 * Custom field functions are shared by Home, Building, Agent, and Pages
 * prerequisites: include proper php file - "includes/object_custom_field.php
 */
function enable_custom_fields() {
	if (window.innerWidth > 768) {
		// only allow draggable for bigger screen.
		$('#custom_fields_sortable').sortable({
			cursor: "move",
		});
	}

	$('#custom_field_new_add').click(function() {
		// get the key & value first
		let key_div = document.getElementById('custom_field_new_name');
		let value_div = document.getElementById('custom_field_new_value');
		let desc_div = document.getElementById('custom_field_new_desc')

		let key = key_div.value;
		let value = value_div.value;
		let desc = desc_div.value;

		$('#custom_field_new_add').removeClass('btn-danger');

		// empty all 3 fields.
		// key_div.value = ''; // Key doesnt need to be reset.
		value_div.value = '';
		desc_div.value = '';

		console.log('key: '+key)
		console.log('vale: '+value)
		console.log('desc: '+desc)

		if(key !== '') {
			// make sure it's not blank. the key. value can be blank, as a blank value is a valid argument to pass on.
			add_custom_field_row(key, value, desc);
		} else {
			$('#custom_field_key_blank').modal('show');
		}
		return false;
	});

	$('#custom_fields_table').on('click', '.remove_custom_field', function(){
		let x = $(this).attr('rel')
		console.log('#custom_field_row_'+x);
		$('#custom_field_row_'+x).remove();
	});

	$('#custom_field_new_value, #custom_field_new_name, #custom_key_name_select').change(function(){
		$('#custom_field_new_add').addClass('btn-danger');
	});

	$('#add_new_custom_field_name').click(function(){
		$(this).blur();
		return toggle_custom_field_new();
	});

	$('#custom_key_name_select').change(function(){
		let value = $(this).val();
		let desc = $(this).find(":selected").attr('rel');
		$('#custom_field_new_name').val(value);
		$('#custom_field_new_desc').val(desc);
	});
}


/**
 * TOGGLE BETWEEN "ENTER NEW KEY" AND "SELECT FROM EXISTING"
 * @return {boolean}
 */
function toggle_custom_field_new() {
	if (parseInt(window.customfieldnewmode) === 0) {
		// toggle to mode 1, meaning add new one!
		window.customfieldnewmode = 1;
		$('#cancelnew, #custom_field_new_name').show();
		$('#enternew, .bootstrap-select.custom_select').hide();
	} else {
		window.customfieldnewmode = 0;
		$('#custom_field_new_name').val('');
		$('#enternew, .bootstrap-select.custom_select').show();
		$('#cancelnew, #custom_field_new_name').hide();
	}
	return false;
}

/**
 * PREVIEW THE CUSTOM FIELDS TO BE ADDED ... USER MUST CLICK "SAVE" AT THE BOTTOM TO ACTUALLY UPDATE THE DATABASE.
 * @param name
 * @param value
 * @param desc
 */
function add_custom_field_row(name, value, desc) {
	if (!window.customnewcount) {
		console.log('CUSTOM NEW COUNT VARIABLE DOES NOT EXIST ... ADD TO THE WINDOW!')
		return
	}

	let counter = parseInt(window.customnewcount);
	console.log('Adding new custom field! window.customnewcount value: '+counter);

	let new_field_html =
		'<div class="custom_field_row row align-items-center bg-success py-3" id="custom_field_row_'+counter+'" style="--bs-bg-opacity: .6;">' +
		'	<div class="col-lg-3">' + // FIELD NAME
		'		<h6 class="fw-bold m-0">'+name+'</h6>' +
		'		<input type="hidden" name="custom_field['+counter+'][name]" value="'+name+'" />' +
		'	</div>' +
		'	<div class="col-lg-3">' + // FIELD DESCRIPTION
		'   	<textarea aria-label="Custom Field Description" class="form-control" rows="1" name="custom_field['+counter+'][desc]">'+desc+'</textarea>' +
		'   </div>' +
		'	<div class="col-lg-5">' + // FIELD VALUE
		'        <textarea aria-label="Custom Field Value" class="form-control" rows="1" name="custom_field['+counter+'][value]">'+value+'</textarea>' +
		'   </div>' +
		'	<div class="col-lg-1">' + // FIELD DELETE BUTTON
		'		<button type="button" rel="'+counter+'" class="btn btn-danger remove_custom_field"><i class="bi bi-trash-fill"></i></button>' +
		'	</div>' +
		'</div>'

	console.log('Appending to html to #custom_fields_sortable');
	$('#custom_fields_sortable').append(new_field_html);

	$(new_field_html).sortable({
		connectWith: "#custom_fields_sortable"
	}).disableSelection();

	window.customnewcount++;
}

/**
 * DELETE CUSTOM FIELD ROW
 * @param x		id assigned to the row.
 */
function remove_custom_field_row(x) {
	('#custom_field_row_' + x).remove();
}


/**
 * COLLAPSE CONTROL BUTTON FOR BOOTSTRAP COLLAPSIBLE
 * USED IN PAGES, RESOURCES, & CITIES
 */
function activate_collapse_control() {
	let collapse_control = document.querySelectorAll('.collapse_control')

	collapse_control.forEach(each_control => each_control.addEventListener('click', function () {
		// if "disable", do not allow click event to change anything.
		if (each_control.classList.contains('disable')) return

		// while collapse animation is happening, disable button
		each_control.classList.add('disable')
		let icon = this.querySelector('i')
		icon.classList.toggle('bi-plus-circle-fill')
		icon.classList.toggle('bi-dash-circle-fill')

		let collapse_events = ['hidden.bs.collapse', 'shown.bs.collapse']
		let collapse_body = document.getElementById(this.getAttribute('aria-controls'))

		collapse_events.forEach(function (collapse_event) {
			collapse_body.addEventListener(collapse_event, function () {
				// collapse event finished, enable button again.
				each_control.classList.remove('disable')
			})
		})
	}))
}


/**
 * NEW OBJECT FEATURE HTML
 * @param data			Data retrieved by modify ajax
 * @param new_feature	Name of the new feature
 * @return {string}		HTML build
 */
function add_new_feature(data, new_feature) {
	return  '<div class="each_listing_feature col-xl-4 col-sm-6 py-2 form-check checkbox" id="bfeature_' + data.id + '" data-id="' + data.id + '">' +
			'	<input class="form-check-input" type="checkbox" name="features[]" value="' + data.id + '" rel="' + data.id + '" id="feature_' + data.id + '">' +
			'   <label class="form-check-label orderhandle" for="feature_' + data.id + '" style="text-transform: none">' +
			new_feature +
			'   </label>' +
			'   <a class="remove_feature" onclick="remove_new_feature(' + data.id + ')" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="Delete this feature - this feature will be removed from ALL listings" data-id="' + data.id + '" rel="' + data.id + '"><i class="bi bi-trash-fill"></i></a>\n' +
			'</div>'
}

/**
 * Show Modal that has buttons to delete feature.
 * @param selected	Clicked Feature that will be deleted
 */
function remove_object_feature(selected) {
	$(selected).click(function(){
		window.feature_id = $(selected).attr('rel');

		let delete_modal = new bootstrap.Modal(document.getElementById('delete_feature'))
		delete_modal.show()
		return false;
	});
}

/**
 * Prompt Modal that removes newly created Feature
 * @param id
 * @return {boolean}
 */
function remove_new_feature(id){
	//any new feature a client adds to the page will use this function if they remove it.
	window.feature_id = id;

	let delete_modal = new bootstrap.Modal(document.getElementById('delete_feature'))
	delete_modal.show()
	return false;
}


$(document).ready(function(){
	window.windowh = $(window).height();
	window.windoww = $('body').innerWidth(); // this gets body width AFTER scroll bar has been accounted for!
	remain_logged_in(); // this will initially set cookies, which will be periodically refreshed by below function
	// $('[data-toggle="tooltip"]').tooltip(); // boostrap tooltip
	
	$('.trim_input').each(function(){ // all items with .trim_input needs value trimming. 
		trim_input_value($(this));  // apply on load. 
		$(this).change(function(){
			trim_input_value($(this)); // then attach function on each change as well to keep it that way. 
		});
	});


	// UPDATES THE GOOGLE PREVIEW ON KEY INPUT
	$('.googlepreview_field').each(function(){
		$(this).keyup(function(){
			googlepreview_update($(this));
		});
		$(this).change(function(){
			// fallback ONCHANGE encase auto complete is used by user and no keyup event triggered.
			googlepreview_update($(this));
		});
	});


	$('.calculate_length').each(function(){
		console.log($(this).attr('id')+' being checked for length');
		var fieldname = $(this).attr('id'); // get the ID
		var max_length = $(this).attr('rel')*1; // get max length of this specific field type.

		$(this).keyup(function(){
			calculate_length($(this), fieldname+'_length',max_length);
		});
		calculate_length($(this), fieldname+'_length',max_length);
	});


	$('.numberonly_field').each(function(){
		$(this).keyup(function(){
			var input = $(this).val();
			$(this).val(number_only(input));
		});
		
		$(this).change(function(){ // back up for ONCHANGE incase auto complete is used by user and no keyup event triggered.
			var input = $(this).val();
			$(this).val(number_only(input));
		});
	});
	

	activate_reactiverows();
	activate_ui_hover();
	addDoneTypingFunction();

	let login_interval = (window.cookie_duration > 0 ? (window.cookie_duration*1000) - 10000 : 1800000-10000); // window.cookie_duration is by seconds.. JS runs on miliseconds, so *1000
	console.log(login_interval+' is the login interval');
	let int = self.setInterval("remain_logged_in()",login_interval); // periodic re-login, 120,000 miliseconds is 120 seconds, or 2 minutes.


	// NAV HAMBURGER MENU BEHAVIOR - 2023 upgrade
	let brixwork_nav = document.getElementById('brixwork_nav');
	let brixwork_nav_overlay = document.querySelector('.brixwork_nav__overlay')

	let brixwork_nav_html = document.getElementById('brixwork_nav_hamburger')
	if (brixwork_nav_html) {
		brixwork_nav_html.addEventListener("click", brixwork_nav_behaviour);
	}
	document.addEventListener('keydown', onkeydown);
	if (brixwork_nav_overlay) {
		brixwork_nav_overlay.addEventListener('click', brixwork_nav_behaviour)
	}

	function brixwork_nav_behaviour() {
		// this.classList.toggle('opened');
		brixwork_nav.classList.toggle('opened')
		brixwork_nav_overlay.classList.toggle('opened')
		document.querySelector("body").classList.toggle('opened')
	}

	function onkeydown(e) {
		if (e.keyCode === 27) {
			brixwork_nav.classList.remove('opened')
			brixwork_nav_overlay.classList.remove('opened')
			document.querySelector("body").classList.remove('opened')
		}
	}

	// toggle bootstrap 5 switch to change value
	let bootstrap_checkboxes = document.querySelectorAll('input.admin_switch[type="checkbox"][role="switch"]');
	bootstrap_checkboxes.forEach(function (each_checkbox) {
		each_checkbox.addEventListener('click', function () {
			each_checkbox.value = parseInt(each_checkbox.value) === 0 ? 1 : 0
		})
	})

	/**
	 * RICH TEXT EDITOR CONFIG
	 */
	tinymce.init({
		selector: 'textarea.rich_editor',
		plugins: 'anchor autolink charmap emoticons lists table visualblocks wordcount code',
		toolbar: '| blocks | bold italic underline strikethrough | link image media table mergetags | spellcheckdialog a11ycheck typography | align lineheight | checklist numlist bullist indent outdent | emoticons charmap | removeformat | code',
		menubar: false,
	});

	/**
	 * TODO: enable again
	 * you must initialize tooltips before they can be used.
	 * One way to initialize all tooltips on a page would be to select them by their data-bs-toggle attribute, like so:
	 */
	const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
	const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl))
});