$(document).ready(function(){
	window.page = 1;
	listbuildings(window.page);

	$('#perpage').change(function(){
		window.page = 1; // new filter, back to page 1
		listbuildings(window.page);
	});

	$('#buildings_filter_trigger').click(function(){
		window.page = 1; // new filter, back to page 1
		listbuildings(window.page);
	});

	$('#buildings_filter_clear').click(function(){
		$('.buildings_filter').each(function(){
			$(this).val('');
		});
		window.page = 1;// new filter, start with page 1!
		listbuildings(window.page);
	});

	$('.homeslist_legend').tooltip();


	// INITIATE SEARCH
	$('#name, #number, #street').keyup(function() {
		delay(function(){
			search_buildings();
		}, 200 );
	});
	$('#city').change(function(){
		search_buildings();
	});

	// WHEN SEARCH MODAL IS CLOSED, RESET ALL INPUT FIELDS
	let bldg_search_modal = document.getElementById('bldg_search_modal')
	bldg_search_modal.addEventListener('hide.bs.modal', reset_search_form)


	$(window).keydown(function(event){
		if(event.keyCode === 13) {
			event.preventDefault();
			return false;
		}
	});
});

function listbuildings(page) {
	$('#buildings_list').html(window.ajax_loader);
	let perpage = $('#perpage').val();
	window.page = page;
	console.log('Loading '+perpage+' buildings, page number '+page);

	/*
	* #buildings_filter_status = returns 0 through 5, or blank for unset.
	* #buildings_filter_name = string
	* #buildings_filter_street = string
	* Can loop through al using .buildings_filter class.
	* */
	let filters = {}; // start array
	let filtersset = false;
	$('.buildings_filter').each(function(){
		if($(this).val()!='') {
			filtersset = true;
			filters[$(this).attr('name')] = $(this).val();
		}
	});

	$.post("ajax_listbuildings.php", {page:window.page, perpage:perpage, filters:filters, debug:0},
		function(data){
			$('#buildings_list').html(data);
			$('[data-toggle="tooltip"]').tooltip(); // tooltip need re-enabling for freshly loaded DOM.

			$('.building_publish_toggle').each(function(){
				$(this).change(function(){
					console.log('publish status change on '+$(this).attr('rel'));
					modifybuilding('publishstatus',$(this).attr('rel'),$(this).val());
				});
			});

			$('.building_status_toggle').each(function(){
				$(this).change(function(){
					console.log('sold status change on '+$(this).attr('rel'));
					modifybuilding('salestatus',$(this).attr('rel'),$(this).val());
				});
			});

			$('.bldg_remove_check').each( function () {
				// show modal warning about un-featuring
				$(this).click( function () {
					$('#bldg_remove_modal').modal('show')

					// add functions to the un-feature button
					let bldg_remove_btn = $('#bldg_remove_modal #bldg_remove_btn')
					bldg_remove_btn.attr('rel', $(this).attr('id'))

					// call modify function
					bldg_remove_btn.click(function () {
						$('#bldg_remove_modal').modal('hide')
						console.log('Changing feature status on '+ $(this).attr('rel'))
						modifybuilding('featurestatus', $(this).attr('rel'), 0)
					})
				})
			})

			if(filtersset==false) {
				$("#buildingstable").sortable({
					items: ".row",
					handle: ".orderhandle",
					cursor: 'move',
					update: function (event, ui) {
						var buildingordervars = $("#buildingstable").sortable('serialize');
						console.log(buildingordervars + ' is vars');
						$.post("ajax_modifybuildings.php", buildingordervars + '&change=order&perpage=' + perpage + '&page=' + window.page,
							function (data) {
								console.log(data);
								if (data.code == 0) {
									console.log('Error ' + data.code + ': ' + data.message);
									$("#buildingstable").sortable('cancel');
								}
							},
							'json'
						);
					}
				});
			}

			$('#buildingstable .home_row').each(function() {
				$(this).find('img.orderhandle').disableSelection(); // so that you cannot accidentally SELECT the iamge instead of using it to DRAG.
			});

			$('.orderhandle').each(function(){
				$(this).click(function(){
					return false;
				});
			});


			// rebuild modal popup
			$('.dupbuilding_resolve').each(function() {
				$(this).click(function () {
					let parent_bldg = $(this).attr('rel')
					let b_count = 0
					let modal_html = "<p>Please choose the building you wish to consolidate into. This is typically the building that has content entered.</p>"
					$('.dupbuilding_'+parent_bldg).each(function () {
						let dup_address  = $(this).data('address')
						let dup_main_img = $(this).data('mainimage')
						let dup_name	 = $(this).data('name') ? $(this).data('name') : 'No Building Name Entered'
						let dup_desc	 = $(this).data('description')
						let dup_val 	 = $(this).val();
						let dup_label	 = '<h6 class="dup_name">' + dup_name + '</h6>'
											+ '<p class="dup_address">'+dup_address+'</p>'
											+ '<p class="dup_desc">'+dup_desc+'</p>'

						modal_html += "" +
							"<div class='each_duplicate_bldg'>" +
							"	<div id='brixwork_radio_check' class='form-check'>" +
							"		<input type='radio' class='form-check-input dupbuilding_consolidate brixwork_radio' name='dupbuilding_consolidate' id='dupbuilding_consolidate_"+dup_val+"' value='"+dup_val+"' "+(b_count === 0 ? "checked" : "")+">" +
							"		<label class='form-check-label default' for='dupbuilding_consolidate_"+$(this).val()+"'>"+dup_label+"</label>" +
							"	</div>" +
							"	<div class='duplicate_bldg_img'>" +
							"		<img src='"+dup_main_img+"' alt='"+dup_address+" Main Image' class='img-full'>" +
							"	</div>" +
							"</div>"

						b_count++
					})

					let resolve_duplicate_modal = $('#bldg_duplicates_modal')
					resolve_duplicate_modal.find('.modal-body').html(modal_html)
					resolve_duplicate_modal.modal('show');
				})
			});
			$('.buildings_pagelink').each(function(){
				$(this).click(function(){
					window.page = $(this).attr('rel');
					listbuildings(window.page);
					return false;
				});
			});
		}
	);

	$('#bldg_duplicate_resolve').each(function () {
		$(this).on('click', function () {
			dupbuilding_resolve()
		})
	})
}


function modifybuilding(change,idr,value){
	// $('#homeslist').html(window.ajax_loader);
	let randomnumber=Math.floor(Math.random()*101);

	$.post("ajax_modifybuildings.php", { idr: idr, value: value, change: change, rand: randomnumber },
		function(data){
			if(data.code === 0) {
				console.log('Error '+data.code+': '+data.message);
			} else {
				// now process classes etc. depending on what was done!
				let classtoremove = '';
				let classtoadd = '';
				switch(change) {

					case 'publishstatus':
						if(parseInt(value) === 1) {
							classtoremove = '';
							classtoadd = 'home_publish';
						} else {
							classtoremove = 'home_publish';
							classtoadd = '';
						}
						break;

					case 'featurestatus':
						if(parseInt(value) === 1) {
							// building became featured, reload the list.
							// this only happens from the autocompelte search thing on top!
							listbuildings(1);
							// also empty all search forms!
							$('#building_search_list').html('');
							$('#name, #street, #number').val('');
						} else {
							// When building is no longer featurd, it's just gone from list.
							$('#building_'+idr).slideUp(300, function(){
								$(this).remove();
							}); // deleted, get rid of this row!

						}
						break;

					case 'salestatus':
						// "Coming Soon" & "VIP Preview" will be marked red.
						if(parseInt(value) === 1 || parseInt(value) === 2) {
							classtoremove = '';
							classtoadd = 'home_sold';
						} else {
							classtoremove = 'home_sold';
							classtoadd = '';
						}
						break;

					case 'delete':
						$('#building_'+idr).slideUp(300, function(){
							$(this).remove();
						}); // deleted, get rid of this row!
						break;

				}

				$('#building_'+idr).removeClass(classtoremove).addClass(classtoadd);
				// listhomes(window.page, idr);
			}
		},'json'
	);
}


function search_buildings() {
	let number = $('#number').val();
	let street = $('#street').val();
	let street_dir = $('#street_dir').val();
	let city = ($('#city').val()!=='' ? $('#city option:selected').text() : '');
	let name = $('#name').val();

	console.log('Searching for: ' + `${name} (${number} ${street_dir} ${street} ${city})`)

	// mark empty input with "invalid"
	validate_bldg_search('#city', (number !== '' || street !== '') && city === '')
	validate_bldg_search('#street', (number !== '' || city !== '') && street === '')
	validate_bldg_search('#number', (street !== '' || city !== '') && number === '')

	if ((number !== '' && street !== '' && city !== '') || (name !== '' && name.length>2)) {  // only run if this is a new page, OR if building is not set yet. If editing existing item with set buildling, no need to run again.
		let lastbuildingsearch = '';

		if(window.buildingsearchstring !== '') {
			lastbuildingsearch = window.buildingsearchstring;
		}

		window.buildingsearchstring = (name !== '' ? name : number+' '+(street_dir !== '' ? street_dir+' ': '')+street+' '+city); // if name is searched, take precedence.

		console.log('fetching building list for ' + window.buildingsearchstring);
		if(lastbuildingsearch !== window.buildingsearchstring) {
			$('#building_search_list').html(window.ajax_loader);

			// only run if there was a change to avoid unncessary flickers.
			$.post("ajax_listbuildinglist.php", { name: name, number: number, street: street, street_dir: street_dir, city:city, debug:0},
				function(data) {
					if(data.count === 0) {
						$('#building_search_list').html(
							'<div class="error_container d-flex">' +
							'   <i class="bi bi-exclamation-circle"></i>' +
							'   <div class="error_content_wrapper">' +
							'       <h6 class="error_content_title">Nothing Found When Searching For</h6>' +
							'       <p>'+ `${name} ${number} ${street_dir} ${street} ${city}` +'</p>' +
							'   </div>' +
							'	<a href="buildings_mod.php?mode=new" class="btn btn-admin">Create New Building</a>' +
							'</div>')
					}
					else {
						$('#building_search_list').html('<table class="table table-hover"></table>');
						for (let key in data.buildings) {
							if (data.buildings[key].subids === false && data.buildings[key].mainid === false) {
								let each_search = data.buildings[key]
								let featured = each_search.feature === "1"
								let bldg_to_edit = each_search.mainid !== false ? each_search.mainid : each_search.value

								// initial search result row with building name + address
								$("#building_search_list table").append(
									'<tr id="building_search_'+ each_search.id +'">' +
									'   <td class="building_search_display">' + each_search.display + '</td>' +
									'</tr>'
								)

								let featured_append = $(`#building_search_${each_search.id} td.building_search_display`);
								if (featured) {
									// building is already featured ... add "Modify" button
									featured_append.after(
										'<td>' +
										'	<a href="buildings_mod.php?idr='+(bldg_to_edit)+'&mode=modify" class="btn btn-admin light_blue">Edit</a>' +
										'	<a class="btn btn-admin disabled">Featured</a>' +
										'</td>'
									)
								}
								else {
									// building is not featured ... enable btn for featuring
									featured_append.after(
										'<td>' +
										'	<a class="btn btn-admin building_feature_button" rel="'+each_search.value+'">Feature on my site</a>' +
										'</td>'
									)
								}
							}
						}

						// FEATURE THE SEARCH RESULT BUILDING
						$('.building_feature_button').each(function() {
							$(this).click(function(){
								$("#bldg_search_modal").modal('hide')
								modifybuilding('featurestatus',$(this).attr('rel'),1);
							});
						});
					}
				}, 'json'
			);
		}
	}
}


function dupbuilding_resolve() {
	let dupids = [];
	let bid = 0;

	$('.dupbuilding_consolidate').each(function(){
		// loop through to figure out which one is selected or not.
		console.log('checking '+$(this).attr('id'));
		if($(this).is(':checked')) {
			bid = $(this).val();
		} else {
			dupids.push($(this).val());
		}
	});

	console.log('triggering actual consolidation for building id '+bid+'');
	for(let i = 0; i < dupids.length; i++) {
		console.log(dupids[i]);
	}
	$.post("ajax_mergebuildings.php", { bid: bid, dupids: dupids},
		function(data) {
			if(data.code === 1) {
				// redirect to edit data.id
				let bmodurl = '/admin/buildings_mod.php?idr='+data.id+'&mode=modify';
				redirect(bmodurl, 300);
			} else {
				// display error from data.message
				let message ="<p>" + data.message + "</p>"
				let error_duplicate_modal = $('#bldg_duplicates_error_modal')
				error_duplicate_modal.find('.modal-body').html(message)
				error_duplicate_modal.modal('show');
			}
		}, 'json'
	);
}


/**
 * SIMPLE VALIDATION FOR BUILDING SEARCH
 * @param elementId		element to make changes on
 * @param condition
 */
function validate_bldg_search(elementId, condition) {
	let validated = 'is-invalid'
	let element = document.querySelector(elementId);

	if (condition) {
		element.classList.add(validated);
	} else {
		element.classList.remove(validated);
	}
}


/**
 * FIRED ON BUILDING SEARCH MODAL CLOSE - EMPTY ALL INPUT FIELDS
 */
function reset_search_form() {
	// empty input fields
	$('#name, #city, #number, #street_dir, #street').val("")

	// remove validation
	let validated_divs = $('#city, #number, #street_dir, #street');
	if ($(validated_divs).hasClass('is-invalid')) {
		$(validated_divs).removeClass('is-invalid')
	}

	// empty search results
	$('#building_search_list').html("")
}