let building_map, building_marker, showroom_map, showroom_marker

$(document).ready(function() {
    let lat_lng_origin_building = building_map.center
    let lat_lng_origin_showroom = showroom_map.center

    $(window).keydown(function(event) {
        if (event.keyCode === 13 && !$(event.target).is('textarea')) {
            event.preventDefault();
            return false;
        }
    });
    if (window.getvar["mode"] == "new" && $("#building_city").val() != "") {
        updatesubarea(false);
    } else {
        fetch_subbuildings();
    }

    $("#building_city").change(function() {
        updatesubarea(false, '#building_city', '#building_area');
    });

    $("#showroom_city").change(function() {
        updatesubarea(false, '#showroom_city', '#showroom_area');
    });


    // BUILDING MAP FUNCTIONS
    $(".reset_map").each(function() {
        $(this).click(function() {
            let target_map = $(this).data('maptype');
            let map_obj, marker_obj, lat_lng_origin
            if (target_map === 'building') {
                map_obj = building_map
                marker_obj = building_marker
                lat_lng_origin = lat_lng_origin_building
            }
            else {
                map_obj = showroom_map
                marker_obj = showroom_marker
                lat_lng_origin = lat_lng_origin_showroom
            }
            console.log('resetting ' + target_map)
            marker_obj.setPosition(lat_lng_origin)
            map_obj.setCenter(lat_lng_origin)
        });
    });
    $(".find_address_on_map").each(function(){
        $(this).click(function() {
            let target_map = $(this).data('maptype');
            find_address_on_map(target_map).then(r => console.log(target_map + ' located: ' + r))
        });
    });


    street_dir_position_toggle(false, 'building')   // this sets position of DIRECTION according to current value of "position toggle"
    street_dir_position_toggle(false, 'showroom')
    $(".street_dir_position_toggle").each(function(){
        $(this).click(function() {
            let target_map = $(this).data('maptype');
            console.log("street_dir_position_toggle clicked on "+target_map);
            street_dir_position_toggle(true, target_map);
            return false;
        });
    });



    $("#buildings_mod_form").submit(function() {
        window.leaveflag = 1;
        $(this).find("#pagesubmit").attr("disabled", "disabled").attr("value", "processing...");
        return true;
    });


    /**
     * FUNCTIONS RELATED TO LISTING FEATURES!
     */
    $("#buildingfeatures").sortable({
        items: ".each_listing_feature",
        handle: ".orderhandle",
        cursor: "move",
        update: function(event, ui) {
            let featureordervars = $(this).sortable("serialize");
            console.log(featureordervars + " is vars")
        }
    });
    $("#buildingfeatures .row").each(function() {
        $(this).find(".orderhandle").disableSelection();
    });
    $("#add_new_feature").click(function() {
        return add_new_building_feature()
    });
    $('.remove_feature').each(function() {
        remove_object_feature(this);
    });




    $('.agent_dropdown').each(function(){
        $(this).change(function(){
            console.log($(this).attr('id')+' was changed to '+$(this).find(':selected').val());
            add_agent_email_to_lead_email($(this));
        });

    });

    $("#search_submit").click(function() {
        fetch_building_list();
        return false;
    });

    window.customnewcount = $('#new_fields_key').attr('rel');
    enable_custom_fields()

    // INIT DELETE OTHER FEATURES ON MODAL
    let remove_feature_button = document.getElementById('remove_listing_feature')
    remove_feature_button.addEventListener('click', remove_feature);

    // INIT DETACH SUB-BUILDING FUNCTION ON MODAL
    const detachBtn = document.getElementById('detach_building_btn')
    detachBtn.addEventListener('click', detach_building)

    // INIT DETACH SUB-BUILDING FUNCTION ON MODAL
    const make_primary_btn = document.getElementById('make_primary_btn')
    make_primary_btn.addEventListener('click', make_primary_building)
});


/**
 * INIT MAP FUNCTION THAT RUNS IN THE HEADER BY THE SCRIPT PROVIDED BY GOOGLE MAPS API
 */
function initMap() {
    let building_map_data = document.getElementById('buildingmapcontainer')
    let building_lat    = parseFloat(building_map_data.dataset.lat)
    let building_long   = parseFloat(building_map_data.dataset.long)

    let showroom_map_data = document.getElementById('showroommapcontainer')
    let showroom_lat    = parseFloat(showroom_map_data.dataset.lat)
    let showroom_long   = parseFloat(showroom_map_data.dataset.long)

    building_map = new google.maps.Map(document.getElementById("buildingmap"), {
        center: {lat: building_lat, lng: building_long},
        zoom: 16,
    })
    building_marker = new google.maps.Marker({
        position: { lat: building_lat, lng: building_long },
        map: building_map,
    });

    showroom_map = new google.maps.Map(document.getElementById('showroommap'), {
        center: {lat: showroom_lat, lng: showroom_long},
        zoom: 16,
    })
    showroom_marker = new google.maps.Marker({
        position: { lat: showroom_lat, lng: showroom_long },
        map: showroom_map,
    })
}

function add_new_building_feature() {
    let new_feature_input = document.getElementById('new_feature');

    if (new_feature_input.value === "") {
        new_feature_input.setAttribute('placeholder', 'You must type here first!')
    } else {
        modal_processing(true);

        let new_feature = new_feature_input.value;
        $.post("ajax_modifybuildingfeatures.php", {
            change: "add",
            value: new_feature
        }, function(data) {
            if (data.id !== "" && data.id !== undefined) {
                let appendhtml = add_new_feature(data, new_feature)
                $("#buildingfeatures").append(appendhtml);

                // initialize newly generated tooltip
                const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
                const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl))
            }
            modal_processing(false)
        }, "json")
    }
    // return false
    new_feature_input.value = ''
}



/**
 * Remove Building Feature
 */
function remove_feature(){
    modal_processing(true);
    $.post("ajax_modifybuildingfeatures.php", {
        change: "delete",
        idr: window.feature_id,
    }, function(data) {
        if (data.feature_id !== "" && data.feature_id !== undefined) {
            console.log('Deleting Feature #' + data.feature_id);
            //un-select before removing feature
            $(`#feature_${data.feature_id}`).removeAttr('checked')
            $(`#bfeature_${data.feature_id}`).remove();
        }
        modal_processing(false)
    }, "json")
}



function fetch_subbuildings() {
    let mainid = parseInt($("#idr").val());
    if (mainid !== 0 && mainid > 0) {
        console.log("Trigger subbuildings list for ID: " + mainid);
        $("#subbuildings").html("<tr><td>"+window.ajax_loader+"</td></tr>");

        $.post("ajax_listbuildinglist.php", {
            mainid: mainid
        }, function(data) {
            // console.log('return data length: ' + data.length)
            if (parseInt(data.count) === 0) {
                $("#subbuildings").html("");
                $("#subbuildings").append("<tr><td>No Sub-Buildings. Search to add: </td></tr>")
            }
            else {
                $("#subbuildings").html("");
                for (let key in data.buildings) {
                    $("#subbuildings").append(
                        '<div class="each_sub_building">' +
                        '   <div class="each_sub_building__title">' + data.buildings[key].display + '</div>' +
                        '   <div>' +
                        '       <a href="#" class="btn btn-admin light_blue building_make_primary" rel="' + data.buildings[key].id + '">Make Main Building</a>' +
                        '       <a href="#" class="btn btn-admin reddish building_detach" rel="' + data.buildings[key].id + '">Detach</a>' +
                        '  </div>' +
                        '</div>'
                    )
                }
            }

            $(".building_make_primary").each(function() {
                $(this).click(function() {
                    window.mainbuildingid = $(this).attr("rel");
                    $("#make_primary_building").modal("show");
                    return false
                })
            });
            $(".building_detach").each(function() {
                $(this).click(function() {
                    window.detachid = $(this).attr("rel");
                    $("#detach_building").modal("show");
                    return false
                })
            })

        }, "json")
    } else {
        console.log("Main ID is not valid, not fetching sub builings.")
    }
    return false
}

/**
 * RUNS on click of "search_submit"
 */
function fetch_building_list() {
    let html_bldg_number = $("#search_number");
    let html_bldg_street = $("#search_street");

    let number = html_bldg_number.val();
    let street = html_bldg_street.val();
    let street_dir = $("#search_street_dir").val();
    let city = $("#building_city option:selected").text();
    let excludeid = parseInt($("#idr").val());
    console.log("Trigger building list search with City: "+city+", address: "+number+" "+street);

    if (number === "") {
        html_bldg_number.addClass("is-invalid")
        html_bldg_street.removeClass("is_invalid")
    }
    else if (street === "") {
        html_bldg_number.removeClass("is-invalid");
        html_bldg_street.addClass("is-invalid")
    }
    else {
        // sufficient data ... search!
        modal_processing(true);
        html_bldg_number.removeClass("is-invalid");
        html_bldg_street.removeClass("is-invalid");

        $.post("ajax_listbuildinglist.php", {
            number: number,
            street: street,
            street_dir: street_dir,
            city: city
        }, function(data) {
            if (data.count === 0) {
                $('#building_search_list').html(
                    '<div class="error_container d-flex">' +
                    '   <i class="bi bi-exclamation-circle"></i>' +
                    '   <div class="error_content_wrapper">' +
                    '       <h6 class="error_content_title">Nothing Found When Searching For</h6>' +
                    '       <p>'+ `${number} ${street_dir} ${street} ${city}` +'</p>' +
                    '   </div>' +
                    '</div>'
                );

                $("#add_new_subbuilding").click(function() {
                    return add_new_building()
                });
                modal_processing(false)
            }
            else {
                $("#building_search_list").html('<table class="table table-hover"></table>');
                for (let key in data.buildings) {
                    if (data.buildings[key].subids === false && data.buildings[key].mainid === false) {
                        $("#building_search_list table").append(
                            '<tr id="building_search_' + data.buildings[key].id + '">' +
                            '   <td>' + data.buildings[key].display + '</td>' +
                            '   <td>' + (data.buildings[key].id !== excludeid ? '<a class="btn btn-admin building_attach_button" rel="' + data.buildings[key].id + '">Attach</a>' : "(Cannot link itself)") + "</td>" +
                            "</tr>")
                    }
                }

                $(".building_attach_button").each(function() {
                    $(this).click(function() {
                        window.building_attach_id = $(this).attr("rel");
                        return attach_to_building($(this).attr("rel"))
                    })
                });
                modal_processing(false)
            }
        }, "json")
    }
}


function make_primary_building() {
    modal_processing(true);
    let randomnumber = Math.floor(Math.random() * 101);
    $.post("ajax_modifybuildings.php", {
        idr: window.mainbuildingid,
        change: "primary_building",
        rand: randomnumber
    }, function(data) {
        if (data.code === 0) {

        }
        else {
            let targeturl = "buildings_mod.php?idr=" + window.mainbuildingid + "&mode=modify";
            redirect(targeturl, 1e3)
        }
    }, "json")
}


function add_new_building() {
    modal_processing(true);
    $.post("ajax_modifybuildings.php", {
        change: "add",
        number: $("#search_number").val(),
        street: $("#search_street").val(),
        street_dir: $("#search_street_dir").val(),
        city: $("#building_city").val(),
        area: $("#building_area").val(),
        mainid: $("#idr").val(),
        building_name: $("#name").val()
    }, function(data) {
        if (data.code == 1) {
            $("#mainid").val($("#idr").val());
            $("#building_search_list").html("");
            $("#search_number").select();
            fetch_subbuildings();
            modal_processing(false)
        } else {
            modal_processing(false);
            alert("error! " + data.message)
        }
    }, "json");
    return false
}


function attach_to_building(idr) {
    modal_processing(true);
    var mainid = $("#idr").val();
    $('#mainid').val(mainid);
    console.log("Setting Main ID of this buildling to be "+mainid);
    var randomnumber = Math.floor(Math.random() * 101);
    console.log("Attaching " + idr + " to " + mainid);
    $.post("ajax_modifybuildings.php", {
        idr: idr, // child buildling, loaded via AJAX.
        mainid: mainid, // mother building (current building under buildings_mod.php)
        change: "attach_building",
        rand: randomnumber
    }, function(data) {
        if (data.code === 0) {
            alert(data.message);
            modal_processing(false)
        } else {
            $("#building_search_list").html("");
            $("#search_number").select();
            fetch_subbuildings();
            modal_processing(false)
        }
    }, "json");
    return false
}

/**
 * DETACH SUB-BUILDING FROM THE CURRENT BUILDING
 */
function detach_building() {
    modal_processing(true);
    let randomnumber = Math.floor(Math.random() * 101);
    if (window.detachid !== "" && window.detachid > 0) {
        $.get("ajax_modifybuildings.php", {
            idr: window.detachid,
            change: "detach_building",
            rand: randomnumber
        }, function(data) {
            if (data.code === 1) {
                fetch_subbuildings();
                modal_processing(false)
            } else {
                alert("error! " + data.message);
                modal_processing(false)
            }
        }, "json")
    }
}


/**
 * DISPLAY ADDRESS ON MAP
 * @param target_map    either building map or showroom map
 */
async function find_address_on_map(target_map = 'building') {
    let number = $("#"+target_map+"_number").val();
    let street_dir = $("#"+target_map+"_street_dir").val();
    let street = $("#"+target_map+"_street").val();
    if (street_dir !== "") {
        street = street_dir + " " + street
    }
    let city = $("#"+target_map+"_city option:selected").text();
    let location = $("#location").val();

    let latitude, longitude

    if (number && street) {
        let geocoder = new google.maps.Geocoder();
        await geocoder.geocode({ 'address': number+' '+street+', '+city+', '+location }, function(results, status) {
            if (status === google.maps.GeocoderStatus.OK) {
                // Successful geocoding
                latitude = results[0].geometry.location.lat();
                longitude = results[0].geometry.location.lng();
                console.log(number+' '+street+', '+city+', '+location)
                console.log("Latitude: " + latitude + "\nLongitude: " + longitude);
            } else {
                // Geocoding failed
                console.log("Geocode was not successful for the following reason: " + status);
            }
        });
    } else {
        $("#map_address_notfound").modal("show")
    }

    // UPDATE DATA
    $("#"+target_map+"_lat").val(latitude)
    $("#"+target_map+"_long").val(longitude)

    // UPDATE MAP AND MARKER
    let map_obj = (target_map === 'building') ? building_map : showroom_map
    let marker_obj = (target_map === 'building') ? building_marker : showroom_marker
    let newLatLng = new google.maps.LatLng(latitude, longitude)

    marker_obj.setPosition(newLatLng)
    map_obj.setCenter(newLatLng)
}


function reset_map(target_map = 'building') {

}

function add_agent_email_to_lead_email(select) {
    var email = select.find(":selected").data('email');
    console.log(typeof(email));

    if(typeof(email)!="undefined" && email!='') {
        var currentemail = $('#email').val();
        console.log('Curren email is '+currentemail+', and string match came to '+currentemail.includes(email));
        if(currentemail.includes(email)==false || currentemail.includes(email)==-1) {
            // thils email is not found in the current email string, so add.
            if(currentemail.length>5) {
                currentemail = currentemail+','+email;
            } else {
                currentemail = email;
            }
            $('#email').val(currentemail);// append.
        }
    }
}