window.leaveflag=0;
window.customfieldnewmode = 0; // default to selecting existing one!
let home_map, marker	// home_map variable is created by initMap() called by googleapis.

$(document).ready(function(){
	window.customnewcount = $('#new_fields_key').attr('rel');

	console.log('BYPASS enable_full_form() because now we need full form all the time on this page')

	let lat_origin = home_map.center.lat()
	let lng_origin = home_map.center.lng()

	// enable_chosen_dropdowns(); 		// All the dropdowns ... TODO: we don't use chosen dropdown anymore - remove the library as well?
	listing_type_and_sale_change(); 	// changed form appearance depending on "for sale" or "Rent/Lease"
	enable_custom_features(); 			// custom fields, sortable on features, etc.
	enable_address_map_triggers();		// address search on map, building selection drpodown, street dir toggle etc.
	//enable_datepicker_plugins();		// deprecated - replaced with bootstrap 5 datepicker
	enable_custom_fields()				// CUSTOM FIELDS ENABLED - shared by Home, Building, Agent, and Pages class

	$('#city').change(function(){
		updatesubarea(false);
	});

	fetch_building_list()
	validate_new_building()


	// disable accidental ENTER.
	$(window).keydown(function (event) {
		if (parseInt(event.keyCode) === 13 && !$(event.target).is("textarea")) {
			event.preventDefault();
			return false;
		}
	});

	$('#homes_mod_form').submit(function () {
		window.leaveflag = 1;
		$(this).find('#pagesubmit').attr('disabled', 'disabled').attr('value', 'processing...');
		return true;
	});

	// LISTING MAP FUNCTIONS!
	$('#reset_map').click(function () {
		display_map_origin(lat_origin, lng_origin)
	})
	$('#find_address_on_map').click(display_address_on_map)


	// Check Custom Name ( also check if 2nd language option is used )
	// When changing option of "Hide Address", update the Custom Name Display label and placeholder
	let hide_address_option = document.getElementById('showaddress');

	let name_label = document.getElementById('custom_display_name__label');
	let name_textbox = document.getElementById('custom_display_name');
	let name_custom_value = name_textbox.value;

	let name2_label = document.getElementById('custom_display_name__label2'); // verify the id exists ( doesnt exist if second language if off )
	let name2_textbox = document.getElementById('custom_display_name2');
	let name2_custom_value = name2_textbox ? name2_textbox.value : '';

	let keep_text = false;
	name_textbox.oninput = () => {
		keep_text = true;
	}

	// shared data
	let name_default_value = $('#custom_display_name').attr('data-hide-address-note');
	let custom_name_tooltip = 'Custom Display Name that will replace the address, Should not be blank'

	hide_address_option.onchange = (event) => {
		let option_value = parseInt(event.target.value);

		if (option_value === 1) {
			// Option changed to "No" - Display address as is.

			// Disable the text input
			name_textbox.setAttribute('disabled', '');
			if (name2_textbox) name2_textbox.setAttribute('disabled', '');

			// Empty the text input - should just display the address
			name_textbox.value = '';
			if (name2_label) name2_textbox.value = '';
		}
		if (option_value === 0) {
			// Option changed to "Yes" - Hide Address and replace with nickname

			// Enable the text input
			name_textbox.removeAttribute('disabled');
			if (name2_textbox) name2_textbox.removeAttribute('disabled');

			if (!keep_text) {
				// only attempt to change the text if nothing is typed in
				name_textbox.value =  name_custom_value ? name_custom_value : name_default_value;
				if(name2_textbox) name2_textbox.value = name2_custom_value ? name2_custom_value : '';
			}
		}
	}

	// DELETE OTHER FEATURES
	let remove_feature_button = document.getElementById('remove_listing_feature');
	remove_feature_button.addEventListener('click', remove_feature);

	// verify agent value and enable/disable submit.
	// submit_button_control();
	// const agent_divs = document.querySelectorAll('#agent_1, #agent_2, #agent_3');
	// agent_divs.forEach((div) => {
	// 	// Do something with each div
	// 	div.addEventListener('change', submit_button_control)
	// });
})

/**
 * GOOGLE MAPS API CALLBACK FUNCTION.
 */
function initMap() {
	let home_map_data = document.getElementById('listingmapcontainer')
	let home_lat    = parseFloat(home_map_data.dataset.lat)
	let home_long   = parseFloat(home_map_data.dataset.long)

	home_map = new google.maps.Map(document.getElementById("listingmap"), {
		center: {lat: home_lat, lng: home_long},
		zoom: 16,
	})
	marker = new google.maps.Marker({
		position: { lat: home_lat, lng: home_long },
		map: home_map,
	});

	// make marker move with the map
	google.maps.event.addListener(home_map, 'bounds_changed', function() {
		marker.setPosition(home_map.getCenter());
	});
	// update hidden lat long data fields
	google.maps.event.addListener(home_map, 'idle', function () {
		let new_position = marker.getPosition()
		// UPDATE VALUE
		document.getElementById('lat').value = new_position.lat()
		document.getElementById('long').value = new_position.lng()
	})

	console.log('Initialized Google Map Objects')
}

function enable_custom_features() {
	console.log('enabling sortables on home feature, custom field/add removal triggers, calculators, etc.');

	// Causes Error for mod=new
	// $('#metadescription').keyup(function(){
	// 	calculate_length($(this), 'metadescription_length',156);
	// });
	// calculate_length($('#metadescription'), 'metadescription_length',156);


	$('#push_firmid').click(function(){
		push_firmid();
	});

	$('#virtualtour').change(function(){
		append_http($(this));
	});

	$('#comm_price_sqft_y').change(function(){
		commercial_lease_calculate();
	});
	$('#comm_price_addl_y').change(function(){
		commercial_lease_calculate();
	});
	$('#comm_rental_rate').dblclick(function(){
		// trigger warning to allow users to manually override,
		// instead of letting commercial_lease_calculate(); take over the rate calculation.
		console.log('comm rental rate double clicked')
		const commercial_lease_modal = new bootstrap.Modal('#commercial_lease_override')
		commercial_lease_modal.show();
	});


	/**
	 * FUNCTIONS RELATED TO LISTING FEATURES!
	 */
	$("#homefeatures").sortable({
		items: ".each_listing_feature",
		handle: ".orderhandle",
		cursor: "move",
		update: function(event, ui) {
			let featureordervars = $(this).sortable("serialize");
			console.log(featureordervars + " is vars")
		}
	});
	$("#homefeatures .row").each(function() {
		$(this).find(".orderhandle").disableSelection();
	});
	$("#add_new_feature").click(function() {
		return add_new_home_feature()
	});
	$('.remove_feature').each(function(){
		remove_object_feature(this);
	});


	// enable dimension empty button.
	let empty_dimension_btn = document.querySelectorAll('.empty_dimension_js')
	empty_dimension_btn.forEach(function (each) {
		each.addEventListener('click', empty_dimension)
	})

	empty_dimension_btn.forEach(each => {each.addEventListener('click', empty_dimension)})
}

function enable_address_map_triggers() {
	if ($('#building').val()==='') {
		// unless building is already set while editing existing listing, DISABLE THE BUILDING container
		$('#building_container').slideUp(20);
	}

	// SET DEFAULT POSITION - DO NOT TOGGLE.
	street_dir_position_toggle(false, 'listing')

	// TOGGLE STREET DIRECTION INPUT ORDER
	$('#street_dir_position_toggle').click(function(){
		street_dir_position_toggle(true, 'listing');
	});

	$('#unit, #number, #street, #city,  #area, #type').change(function(){
		fetch_building_list();
		return false;
	});
}

/**
 * @deprecated replaced with bootstrap 5 datepicker
 */
function enable_datepicker_plugins() {
	console.log('this datepicker function is deprecated! Use bootstrap 5 datepicker instead')
	$( "#rental_availability" ).datepicker({
		//dateFormat: 'yy-mm-dd'
		format: 'yyyy-mm-dd',
		orientation: 'top'
	});

	$( "#comm_availability" ).datepicker({
		//dateFormat: 'yy-mm-dd'
		format: 'yyyy-mm-dd',
		orientation: 'top'
	});

	$( "#comm_tenant_lease_end" ).datepicker({
		//dateFormat: 'yy-mm-dd'
		format: 'yyyy-mm-dd',
		orientation: 'top'
	});
}



function listing_type_and_sale_change() {
	// function to run to determine what form looks like depending on whether we are talking rental or sales.
	// This function also takes into account whether the listing is commercial or not (don't let the title mislead you)
	// if commercial, enable the comm field,
	// and also show the commercial lease fields under rental
	// while disabling the residential stuff.
	let rental_select = document.getElementById('for_rent');
	let commercial_select = document.getElementById('is_comm');

	// Run function once when window loads, Run AGAIN when selection has changed.
	// passes 1 as val if rental enabled, 0 if not. It's not boolean - it's from the dropdown values.
	listing_type_rental(rental_select.value);
	rental_select.addEventListener('change', function () {
		listing_type_rental(rental_select.value);
	})

	// passes 1 as val if commercial enabled, 0 if not. It's not boolean - it's from the dropdown values.
	listing_type_commercial(commercial_select.value);
	commercial_select.addEventListener('change', function (e) {
		listing_type_commercial(commercial_select.value, e);
	})
}

/**
 * Change Form Appearance depending on Commercial or Residential
 * @param val		chose "commercial" or "residential".
 * @param event		differentiate between initial load vs. user chose other option.
 */
function listing_type_commercial(val, event) {
	let tab_commercial = document.getElementById('commercial-controls');
	let tab_rental = document.getElementById('rental-controls');
	let residential_blocks = document.querySelectorAll('.brixwork_inner_spacing.residential');
	let commercial_blocks = document.querySelectorAll('.brixwork_inner_spacing.commercial');

	if(parseInt(val) === 1) {
		console.log('Commercial type enabled.')
		tab_commercial.classList.remove('disabled')	// enabled commercial tab
		tab_rental.innerHTML = 'Lease'

		residential_blocks.forEach(each_block => {
			each_block.style.display = 'none'	// hide residential related info on rental tab
		})
		commercial_blocks.forEach(each_block => {
			each_block.style.display = 'block'	// show commercial related info on lease tab
		})

		$('#type option').each(function(){
			if($(this).attr('selected') && event) {
				$(this).removeAttr('selected')		// changing from residential -> commercial should automatically choose first commercial type.
			}
			$(this).attr('disabled', true);	// disable all listing types.
		});
		$('#type option.type_commercial').each(function(i, el){
			if(i === 1 && event) {
				$(this).attr('selected', true)	// changing from residential -> commercial should automatically choose first commercial type.
				$('#type').focus()
			}
			$(this).removeAttr('disabled');			// enable commercial types.
		});

	} else {
		console.log('Residential type enabled')
		tab_commercial.classList.add('disabled')	// enabled commercial tab
		tab_rental.innerHTML = 'Rental'

		residential_blocks.forEach(each_block => {
			each_block.style.display = 'block'	// hide residential related info on rental tab
		})
		commercial_blocks.forEach(each_block => {
			each_block.style.display = 'none'	// show commercial related info on lease tab
		})

		$('#type option').each(function(i, e){
			if($(this).attr('selected') && event) {
				$(this).removeAttr('selected')		// changing from commercial -> residential should automatically choose first commercial type.
			}
			if(i === 1 && event) {
				$(this).attr('selected', true)	// changing from commercial -> residential should automatically choose first commercial type.
				$('#type').focus()
			}
			$(this).removeAttr('disabled');			// enable all types
		});
		$('#type option.type_commercial').each(function(){
			$(this).attr('disabled', true);	// disable all commercial types
		});
	}
}

/**
 * Change Form Appearance depending on SALE or RENT/LEASE
 * @param val	selected option id ( 0 or 1 )
 */
function listing_type_rental(val) {
	let tab_rental = document.getElementById('rental-controls');
	let price_input = document.getElementById('price')

	if(parseInt(val)===1) {
		console.log('Rental type enabled.');
		tab_rental.classList.remove('disabled')					// enabled rental tab
		price_input.setAttribute('disabled', '')		// disabled SALE price input
	} else {
		console.log('Rental type disabled.');
		tab_rental.classList.add('disabled')					// disable rental tab
		price_input.removeAttribute('disabled')	// enable SALE price input
	}
}


function commercial_lease_calculate(userinput) {
	userinput = (typeof userinput === 'undefined') ? false : userinput;

	let base_rent_div = $('#comm_price_sqft_y')
	let additional_rend_div = $('#comm_price_addl_y')
	let sqft_div = $('#sqft');

	// calculates the monthly rent from the lease rates.
	// commercial leases are weird. base rent + additional rent nets to total $/sqft, annually.
	// (comm_price_sqft_y + comm_price_addl_y) * sqft / 12 = monthly net rent.
	let base_rent = (base_rent_div.val() !== '' ? number_only(base_rent_div.val()) : ''); // default to bank so it doesn't run.
	let addl_rent = (additional_rend_div.val() !== '' ? number_only(additional_rend_div.val()) : 0); // can defaul to 0. so it still runs.
	let sqft = (sqft_div.val() !== '' ? number_only(sqft_div.val()) : '');

	let monthly_rate = ''; // start with blank.
	let rate_message; // default message.

	console.log("base_rent: " + base_rent + ' type: ' + typeof base_rent);
	console.log("addl_rent: " + addl_rent + ' type: ' + typeof addl_rent);
	console.log("sqft: " + sqft + ' type: ' + typeof sqft);
	console.log("user input status: " + userinput)

	const num_to_dollar = new Intl.NumberFormat('en-US', {
		style: 'currency',
		currency: 'USD',
		// These options are needed to round to whole numbers if that's what you want.
		//minimumFractionDigits: 0, // (this suffices for whole numbers, but will print 2500.10 as $2,500.1)
		//maximumFractionDigits: 0, // (causes 2500.99 to be printed as $2,501)
	});

	if (userinput) {
		// user manually input
		$('#comm_rental_rate_override').val(1);
		$('#comm_rental_rate').attr("readonly", false).focus();
		base_rent_div.val('')
		additional_rend_div.val('')
		rate_message = 'Manually enter monthly rent.';
	} else {
		// calculate value
		rate_message = 'Enter $/sqft and additional rent.';

		if (base_rent && sqft) {
			console.log('calculate rent with: ' + base_rent + 'rent and ' + sqft + 'sqft')
			let annual_rate = base_rent + addl_rent;
			let monthly_rate_raw = annual_rate * sqft / 12;
			monthly_rate =  num_to_dollar.format(monthly_rate_raw)
			rate_message = 'Calculated from ' + num_to_dollar.format(annual_rate) + '/sqft on ' + sqft + 'sqft.';

			console.log("annual_rate: " + annual_rate + ' type: ' + typeof annual_rate);
			console.log("monthly_rate_raw: " + monthly_rate_raw + ' type: ' + typeof monthly_rate_raw);
		}
		else {
			$('#comm_rental_rate').val(0)
		}
	}
	if(monthly_rate) {
		$('#comm_rental_rate').val(monthly_rate).attr("readonly", true);
		$('#comm_rental_rate_override').val(0); // set to non-overridden so that a value change in rent or sqft triggers further changes.
	}
	$('#comm_rental_rate_flag').html(rate_message); // enter whatever rate message we have - all scenarios are covered by now.
}



// function push_firmid() {
// 	console.log('pushign firm IDs');
// 	// settings_firmid_0, 1 & 2 to be pushed.
// 	let firmidcount = 3;
// 	let firmidnum = 1; // start at 1.
// 	while(firmidnum<=firmidcount) {
// 		if($('#settings_firmid_'+firmidnum).val()!='' && $('#settings_firmid_'+firmidnum).length==1) { // if element exists, and not blank.
// 			$('#firm_'+firmidnum+'_id').val($('#settings_firmid_'+firmidnum).val());
// 		}
// 		firmidnum++;
// 	}
// }


/**
 * DISPLAY INPUT ADDRESS ON THE MAP.
 * @return {Promise<void>}
 */
async function display_address_on_map() {
	let number 		= document.getElementById('number').value
	let street 		= document.getElementById('street').value
	let city		= document.getElementById('city').options[document.getElementById('city').selectedIndex].text
	let location	= document.getElementById('location').value

	let latitude, longitude;
	if (number !== "" && street !== "") {
		let geocoder = new google.maps.Geocoder();
		await geocoder.geocode({ 'address': number+' '+street+', '+city+', '+location }, function(results, status) {
			if (status === google.maps.GeocoderStatus.OK) {
				// Successful geocoding
				latitude = results[0].geometry.location.lat();
				longitude = results[0].geometry.location.lng();
				console.log("Latitude: " + latitude + "\nLongitude: " + longitude);
			} else {
				// Geocoding failed
				console.log("Geocode was not successful for the following reason: " + status);
			}
		});

		// UPDATE VALUE
		document.getElementById('lat').value = latitude
		document.getElementById('long').value = longitude

		// UPDATE MAP AND MARKER
		let newLatLng = new google.maps.LatLng(latitude, longitude)
		marker.setPosition(newLatLng)
		home_map.setCenter(newLatLng)
	}
	else {
		$('#map_address_notfound').modal('show')
	}
}

/**
 * ORIGINAL MAP POSITION USING INITIAL LAT LONG VALUE
 */
function display_map_origin(lat_origin, lng_origin) {
	let lat_lng_origin = new google.maps.LatLng(lat_origin, lng_origin);
	home_map.setCenter(lat_lng_origin)
}


function fetch_building_list(select_id) {
	let number = $('#number').val();
	let unit = $('#unit').val();
	let street_dir = $('#street_dir').val();
	let street = $('#street').val();
	let city_index = $('#city').prop('selectedIndex');
	let city = $('#city option:selected').text();
	let building_id = $('#building').val();
	let type = $('#type').val();
	let buildingtype = ($('#type option:selected').attr('rel') === 'building'); // see if a property type that denotes a building was selected or not. 

	// only run if this is a new page, OR if building is not set yet. If editing existing item with set buildling, no need to run again.
	// only run if the street name, or number etc. has changed. do not run on unit # change, so as to avoid duplicate queries.
	if( (number!=='' && street!==''  && city!=='' && city_index>1 && buildingtype===true && window.getvar['mode']==='new' && building_id==='') || (window.getvar['mode']==='modify' && building_id==='' && buildingtype===true)) {

		let last_building_search = '';
		if(window.buildingsearchstring !== '') {
			last_building_search = window.buildingsearchstring;
		}

		window.buildingsearchstring = number+(street_dir!=='' ? street_dir+' ' : ' ')+street+' '+city+' '+type;

		console.log('Compare ' + last_building_search + ' with fetching building list with '+window.buildingsearchstring);

		if(last_building_search !== window.buildingsearchstring) {
			$.post("ajax_listbuildinglist.php", { number: number, street: street, street_dir: street_dir, city: city, buildingid: building_id},
				function(data) {
					console.log(data.count)
					if(parseInt(data.count) === 0) {
						// if this was triggered with a unit number in, then force it to take action. Or if buildingtype is positive, meaning the property type selected indicates it should be a unit. 
						if(unit!=='' || buildingtype===true) {
							$('#building_notfound').modal('show');
						} else {
							// do nothing, just a passive buildings check to see if it exists, but no unit number given, so could be a duplex, house, anything else. 
							console.log('nothing running, passive check, as unit was blank and property type does not indicate building ');
						}
					} else {
						$('#building_container').slideDown(600);
						$('#building').html('').append('<option value="">Select a Building</option>'); //blank it out, then put the default select on there. 
						for(let key in data.buildings) {
							$('#building').append('<option value="'+data.buildings[key].value+'"'+(data.buildings[key].selected===true ? ' selected="selected"' : '')+'>'+data.buildings[key].display+'</option>');
						}
						if(select_id !== undefined) {
							$('#building').html(data.dropdown).val(select_id);
						}
					}
				}, 'json'
			);
		} else {
			console.log('no significant changes in building search query from last one: '+last_building_search);
		}
	}
}


function create_new_building() {
	let building_name = $('#building_name').val();
	let number = $('#number').val();
	let street = $('#street').val();
	let street_dir = $('#street_dir').val();
	let city = $('#city ').val();
	let area = $('#area').val();
	let lat = $('#lat').val();
	let lng = $('#long').val();

	let create_button = $('#building_notfound').find('.create_new_building')
	create_button.on('click', function () {

	})

	$.post("ajax_modifybuildings.php", { change:'add', number: number, street: street, street_dir: street_dir, city:city, area:area, lat:lat, lng:lng, building_name:building_name},
		function(data) {
			if(parseInt(data.code) === 1) {
				window.buildingsearchstring = ''; // blank this to force new search regardless of last search.
				fetch_building_list(data.id);
			} else {
				alert('error! '+data.message);
			}
		}, 'json'
	);
	return false;
}


// MLS data related functions
function convertlisting(change) {
	if(change=='source') {
		var fieldvalue = 0;
	} else if(change=='feature') {
		var fieldvalue = 1;
	}
	let mlsnum = $('#mls').val();
	console.log('changing '+change+' to '+fieldvalue+' now.');
	// function to either convert to FEATURED or OWN depending on feed. 
	modal_processing(true);
	
	$.post("ajax_modifyhomes.php", { mls: mlsnum, value: fieldvalue, change:change},
		function(data) {
			if(data.code==0) {
				$('#mls_failed').find('.modal-body').html('<p>An error occurred - please contact the Brixwork Support Team and include the following error message:</p><p><strong>'+data.message+'</strong>.</p>');
				$('#mls_failed').modal('show');
			} else if(data.code==1) {
				// MLS # was successfully converted! 
				window.leaveflag=1;
				if(change=='source') {
					// converted to OWN listing, take to homes screen.
					window.location = 'homes_mod.php?idr='+data.id+'&mode=modify'; 
				} else {
					// just featured MLS listing, go back to homes list. 
					window.location = 'homes.php'; 
				}
			}
			modal_processing(false);
		}, 'json');
}

function resetmls() {
	// if NO is answered when asked to convert MLS listing to own listing. 
	$('#mls').val('');
	$('#submit').attr('disabled','');
}


function add_new_home_feature() {
	let new_feature_input = document.getElementById('new_feature');

	if (new_feature_input.value === "") {
		new_feature_input.setAttribute('placeholder', 'You must type here first!')
	} else {
		modal_processing(true);

		let new_feature = new_feature_input.value;
		$.post("ajax_modifyhomefeatures.php", {
			change: "add",
			value: new_feature
		}, function(data) {
			if (data.id !== "" && data.id !== undefined) {
				let appendhtml = add_new_feature(data, new_feature)
				$("#homefeatures").append(appendhtml);

				// initialize newly generated tooltip
				const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
				const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl))
			}
			modal_processing(false)
		}, "json")
	}
	// return false
	new_feature_input.value = ''
}

function remove_feature() {
	modal_processing(true);
	$.post("ajax_modifyhomefeatures.php", {
		change: "delete",
		idr: window.feature_id,
	}, function(data) {
		console.log(data);
		if (data.feature_id != "" && data.feature_id !== undefined) {
			console.log(data.feature_id);
			$(`#bfeature_${data.feature_id}`).remove();

		}
		modal_processing(false)
	}, "json")
}


/**
 * Replace current (emptied) spec row with the next one, and keep going. Pushing up all spec row by one.
 * @param event		"Empty" button clicked
 */
function empty_dimension(event) {
	let curr_count = Number(event.target.getAttribute('rel'))
	console.log('Currently emptying row #:'+ curr_count)

	let total_num_dimensions = document.querySelectorAll('.empty_dimension_js').length;
	for (let count = curr_count; count < total_num_dimensions; count++) {
		let next_elem = count + 1;
		let current_dim_name = document.getElementById('specname_'+count)
		let current_dim_spec = document.getElementById('specvalue_'+count)
		let next_dim_name = document.getElementById('specname_'+next_elem)
		let next_dim_spec = document.getElementById('specvalue_'+next_elem)

		if (next_elem === total_num_dimensions) {
			return // for last element, do not look for next element.
		}
		current_dim_name.value = next_dim_name.value;
		current_dim_spec.value = next_dim_spec.value;
	}
}


function edit_building(buildingid) {
	// after listings is entered, and the attached building is blank, it forces user to go to the buildings screen on that building to edit that home.
	window.leaveflag = 1;
	window.setTimeout("window.location.href = 'buildings_mod.php?idr="+buildingid+"&mode=modify'", 500);
}

function back_to_list() {
	// simply forwards user back to the homes list screen after done editing. 
	window.leaveflag = 1;
	window.setTimeout("window.location.href = 'homes'", 500);
}


/**
 * For the building name popup, validated the input field before creating the building
 * building name is required for this action!
 */
function validate_new_building() {
	$('.create_new_building').click(function () {
		let form = document.getElementById('new_building__name')

		form.addEventListener('submit', event => {
			event.preventDefault() // PREVENT THE SUBMIT BUTTON TO REFRESH BROWSER
			if (!form.checkValidity()) {
				// failed validation
				event.stopPropagation()
			}
			else {
				// success
				$('#building_notfound').modal('hide')
				modal_processing(true)
				create_new_building()
				modal_processing(false)
			}

			form.classList.add('was-validated')
		}, false)
	})
}


/**
 * Each listing must have at least one agent, whether it's agent_1, agent_2, or agent_3 does not matter
 * Sometime through MLS Sync, the agent on the website is listed second, after some other agent not on the website.
 * In this case, it is allowed to have empty agent_1, because agent_2 will be filled with the valid agent.
 *
 * This verification should run on open & whenever the select form is changed.
 */
function verify_agent_on_listing() {
	let agent_1 = document.getElementById('agent_1');
	let agent_2 = document.getElementById('agent_2');
	let agent_3 = document.getElementById('agent_3');
	// agent_1.value returns the internal agent ID (e.g. 13), not Realtor ID (e.g. V12345)
	return !(agent_1.value === '' && agent_2.value === '' && agent_3.value === '');
}

function submit_button_control() {
	let submit_button = document.getElementById('pagesubmit')
	let agent_warning = document.querySelector('.agent_error_div')
	let verification = verify_agent_on_listing();

	submit_button.disabled = !verification;
	agent_warning.style.display= (!verification ? 'flex' : 'none')
}



window.onbeforeunload = function() {
	if(window.leaveflag !== 1) {
    	return 'Are you sure you want to leave this page? There may be unsaved changes on this page content.';
    }
}