window.leaveflag=0;
window.customfieldnewmode = 0; // default to selecting existing one!

// default vars for global access.
var map;
var geocoder = new google.maps.Geocoder();
var defaultlatlng = '';
$(document).ready(function(){

	window.customnewcount = $('#new_fields_key').attr('rel');

	// first determine whether form should be visible or not.

	if(window.getvar['mode']==='new') {
		// this is a NEW listing being added.
		$('#city').change(function(){
			updatesubarea(false);
		});
		if($('#mls_integrated').val()=='1') {
			// this site has MLS integration. Do NOT show the form yet.
			$('#no_mls_entry').popover();
			$('#mls_search_trigger').fadeIn(600);
		} else {
			// no MLS integration, so no need to intercept for MLS import. activate full form eright away.
			enable_full_form();
		}
	} else if(window.getvar['status']!='post') {
		console.log('updating existing listing')
		enable_full_form();
		$('#city').change(function(){
			var selectedsubarea = $('#area option:selected').val();
			console.log('updating subarea with existing selected val: '+selectedsubarea);
			updatesubarea(selectedsubarea); // load what was set?
			// do we need to do this?
		});
		fetch_building_list(); // why not run it on load and see if building is not set yet.
	}




	if (window.getvar['status'] != 'post') {

		// responsive stuff.. if under 768px pixels, do not use tabs!
		if (window.windoww < 300) {
			console.log('small window (' + window.windoww + '), kill all tabs!');
			$('#listing_form_tab').remove();
			$('#listing_form_tab_content').removeClass('tab-content');
			$('.tab-pane').removeClass('tab-pane');
		} else {
			// keep tabs. Enable the rental tab to return nothing if disabled.
			$('#no_mls_entry').click(function () {
				enable_full_form();
			});
		}

		// disable accidental ENTER.
		$(window).keydown(function (event) {
			if (event.keyCode == 13 && !$(event.target).is("textarea")) {
				event.preventDefault();
				return false;
			}
		});


		// enable mls search by AJAX for converting MLS listing in.
		$('#mls_search_trigger').click(function () {
			var addListingModalEl = document.getElementById('add_listing_modal');
			var add_listing_modal = bootstrap.Modal.getInstance(addListingModalEl)

			var mlsnum = $('#mls').val();
			if (mlsnum.length > 0) {
				$.post("ajax_countrows.php", {
						'filterfields[]': ['mls', 'source'],
						'filtervalues[]': [mlsnum, '1'],
						table: "homes"
					},
					function (data) {
						if (data.code == 2) {
							add_listing_modal.hide();
							$('#mls_failed').find('.modal-body').html('<p>An error occurred - please contact the Brixwork Support Team and include the following error message:</p><p><strong>' + data.message + '</strong>.</p>');
							$('#mls_failed').modal('show');
						} else if (data.code == 1) {
							add_listing_modal.hide();
							$('#mls_found').modal('show');
						} else if (data.code == 0) {
							add_listing_modal.hide();
							$('#mls_notfound').modal('show');
						}
						return false;
					}, 'json');
			} else {
				// mls # not entered properly
				$('#mls_blank').modal('show');
			}
		});

		$('#homes_mod_form').submit(function () {
			window.leaveflag = 1;
			$(this).find('#pagesubmit').attr('disabled', 'disabled').attr('value', 'processing...');
			return true;
		});

		// Check Custom Name ( also check if 2nd language option is used )
		// When changing option of "Hide Address", update the Custom Name Display label and placeholder
		let hide_address_option = document.getElementById('showaddress');

		let name_label = document.getElementById('custom_display_name__label');
		let name_textbox = document.getElementById('custom_display_name');
		let name_custom_value = name_textbox.value;

		let name2_label = document.getElementById('custom_display_name__label2'); // verify the id exists ( doesnt exist if second language if off )
		let name2_textbox = document.getElementById('custom_display_name2');
		let name2_custom_value = name2_textbox ? name2_textbox.value : '';

		let keep_text = false;
		name_textbox.oninput = () => {
			keep_text = true;
		}

		// shared data
		let name_default_value = $('#custom_display_name').attr('data-hide-address-note');
		let custom_name_tooltip = 'Custom Display Name that will replace the address, Should not be blank'

		hide_address_option.onchange = (event) => {
			let option_value = parseInt(event.target.value);

			if (option_value === 1) {
				// Option changed to "No" - Display address as is.

				// Disable the text input
				name_textbox.setAttribute('disabled', '');
				name2_textbox.setAttribute('disabled', '');

				// Empty the text input - should just display the address
				name_textbox.value = '';
				if (name2_label) name2_textbox.value = '';
			}
			if (option_value === 0) {
				// Option changed to "Yes" - Hide Address and replace with nickname

				// Enable the text input
				name_textbox.removeAttribute('disabled');
				name2_textbox.removeAttribute('disabled');

				if (!keep_text) {
					// only attempt to change the text if nothing is typed in
					name_textbox.value =  name_custom_value ? name_custom_value : name_default_value;
					if(name2_textbox) name2_textbox.value = name2_custom_value ? name2_custom_value : '';
				}
			}
		}
	} else {
		console.log('post stuff only');
	}
	
});


function enable_full_form() {
	console.log('enable_full_form() running');

	$('#listing_form').show(0, '',function(){
		console.log('Full listing form showed!');

		$('#pagesubmit, #for_rent_container, #price_container, #sold_container').show(0); // show the goodies!

		console.log(window.windoww+' is width, move onto tabs?');
		if(window.windoww>300) {
			$('#listing_form_tab').tabs({
				active: 0,
				create: function(event,ui) {
					console.log("tabs activated ,moving onto chosen dropdowns, maps, and rental/comm toggles");

					enable_chosen_dropdowns(); // All the dropdowns.

					listing_type_and_sale_change(); // check rental fields on load as well.

					enable_custom_fields_features(); // custom fields, sortable on features, etc.

					enable_address_map_triggers(); // address search on map, building selection drpodown, street dir toggle etc.

					enable_datepicker_plugins();

					load_google_map();
				},
				activate: function( event, ui ) {
					var opentab = $(ui).parent().index();
					console.log('Opening tab seq '+opentab);
					if(opentab==0) {
						console.log('tab ID 0 for address, activate map!');

					}
				}
			});
		}
		$('#mls_search_trigger').fadeOut(300);
		$('#no_mls_entry').fadeOut(300);
	});
}



function enable_chosen_dropdowns() {
	console.log('Enabling chosen dropdowns on rent, comm, city/subarea, agents, remarks etc.');
	$('#for_rent').change(function(){
		listing_type_and_sale_change();
	});

	$('#is_comm').change(function(){
		listing_type_and_sale_change();
	});

	var chosen_options = { allow_single_deselect: true };

	if($('#agent_1').length) {
		$('#agent_1').chosen(chosen_options);
		$('#agent_2').chosen(chosen_options);
		$('#agent_3').chosen(chosen_options);
	}

	$('#remarks').chosen(chosen_options);
}


function enable_custom_fields_features() {
	console.log('enabling sortables on home feature, custom field/add removal triggers, calculators, etc.');

	$('#metadescription').keyup(function(){
		calculate_length($(this), 'metadescription_length',156);
	});

	calculate_length($('#metadescription'), 'metadescription_length',156);

	$('#description, #description2, #description3').tinymce({
		script_url : 'js/tiny_mce/tinymce.min.js',
		theme : 'modern',
		plugins: 'paste,link,image,autolink,code',
		menubar: "edit format code",
		toolbar : ["bold,italic,underline,strikethrough,|,formatselect,removeformat,|,bullist,numlist,|,link,unlink,|,code"],
		paste_auto_cleanup_on_paste : true,
		paste_strip_class_attributes:'all',
		paste_retain_style_properties:'none',
		paste_remove_styles:true,
		paste_remove_spans:true,
		relative_urls: false,
		remove_script_host: true
	});

	$('#push_firmid').click(function(){
		push_firmid();
	});

	$('#virtualtour').change(function(){
		append_http($(this));
	});

	$('#comm_price_sqft_y').change(function(){
		commercial_lease_calculate();
	});

	$('#comm_price_addl_y').change(function(){
		commercial_lease_calculate();
	});

	$('#comm_rental_rate').dblclick(function(){
		// trigger warning to allow users to manually override,
		// instead of letting commercial_lease_calculate(); take over the rate calculation.
		$('#commercial_lease_override').modal('show');
	});

	// drag-and-drop of features enabled here to allow clients' own ordering.
	$("#homefeatures").sortable({
		items: ".row",
		handle: ".orderhandle",
		cursor: "move",
		update: function(event, ui) {
			var featureordervars = $("#homefeatures").sortable("serialize");
			console.log(featureordervars + " is vars")
		}
	});

	$("#homefeatures .row").each(function() {
		$(this).find(".orderhandle").disableSelection();
	});

	$("#add_new_feature").click(function() {
		return add_new_feature()
	});
	$('.remove_feature').each(function(){
		$(this).click(function(){
			var featureid = $(this).attr('rel');
			window.feature_id = featureid;
			$('#delete_feature').find('.modal-body').html('<p>Are you sure you want to delete this feature? This will remove this feature from ALL your buildings, not just this one.</p>');
			$('#delete_feature').modal('show');
			return false;
		});
	});

	$('#custom_fields_sortable').sortable({
		cursor: "move",
	});

	$('#custom_field_new_add').click(function(){
		// get the key & valu efirst
		var key = $('#custom_field_new_name').val();
		var value = $('#custom_field_new_value').val();
		var desc = $('#custom_field_new_desc').val();

		$('#custom_field_new_add').removeClass('btn-danger');

		// empty all 3 fields.
		$('#custom_field_new_name').val('');
		$('#custom_field_new_value').val('');
		$('#custom_field_new_desc').val('');

		if(key!='') {
			// make sure it's not blank.. the key. value can be blank, as a blank value is a valid argument to pass on.
			add_custom_field_row(key, value, desc);
		} else {
			$('#custom_field_key_blank').modal('show');
		}

		return false;
	});

	$('#custom_fields_table').on('click', '.remove_custom_field', function(){
		var x = $(this).attr('rel')
		console.log('#custom_field_row_'+x);
		$('#custom_field_row_'+x).remove();
	});


	$('#custom_field_new_value, #custom_field_new_name, #custom_key_name_select').change(function(){
		$('#custom_field_new_add').addClass('btn-danger');
	});


	$('#add_new_custom_field_name').click(function(){
		$(this).blur();
		return toggle_custom_field_new();
	});

	$('#custom_key_name_select').change(function(){
		var value = $(this).val();
		var desc = $(this).find(":selected").attr('rel');
		$('#custom_field_new_name').val(value);
		$('#custom_field_new_desc').val(desc);
		// existing customm field selected.
	});

	// enable dimension empty button.
	$('.empty_dimension').each(function(){
		$(this).click(function(){
			empty_dimension($(this).attr('rel'));
		});
	});
}

function enable_address_map_triggers() {
	console.log('enabling the street and address, as well as map triggers');

	if($('#building').val()=='') {
		// unless building is already set while editing existing listing, DISABLE THE BUILDING container
		$('#building_container').slideUp(20);
	}

	street_dir_position_toggle(true);

	$('#street_dir_position_toggle').click(function(){
		console.log('street_dir_position_toggle clicked');
		street_dir_position_toggle(false);
		return false;
	});

	$('#unit, #number, #street, #city,  #area, #type').change(function(){
		fetch_building_list();
		return false;
	});

	$('#resetmap').click(function(){
		reset_map();
		return false;
	});

	$('#findaddress').click(function(){
		find_address_on_map();
		return false;
	});
}

function enable_datepicker_plugins() {
	$( "#rental_availability" ).datepicker({
		//dateFormat: 'yy-mm-dd'
		format: 'yyyy-mm-dd',
		orientation: 'top'
	});

	$( "#comm_availability" ).datepicker({
		//dateFormat: 'yy-mm-dd'
		format: 'yyyy-mm-dd',
		orientation: 'top'
	});

	$( "#comm_tenant_lease_end" ).datepicker({
		//dateFormat: 'yy-mm-dd'
		format: 'yyyy-mm-dd',
		orientation: 'top'
	});
}

function toggle_custom_field_new() {
	if(window.customfieldnewmode==0) {
		// toggle to mode 1, meaning add new one!
		window.customfieldnewmode = 1;
		$('#cancelnew, #custom_field_new_name').show();
		$('#enternew, #custom_key_name_select').hide();
	} else {
		window.customfieldnewmode = 0;
		$('#custom_field_new_name').val('');
		$('#enternew, #custom_key_name_select').show();
		$('#cancelnew, #custom_field_new_name').hide();
	}
	return false;
}

function add_custom_field_row(name, value, desc) {
	var appendhtml = '<div class="row form-group bottom_20 custom_field_row" id="custom_field_row_'+window.customnewcount+'">';
	
	appendhtml = appendhtml+'<div class="col-md-2 col-sm-2 col-xs-12"><strong>'+name+'</strong><input type="hidden" name="custom_field['+window.customnewcount+'][name]" value="'+name+'"></div>';
	appendhtml = appendhtml+'<div class="col-md-4 col-sm-4 col-xs-12"><textarea class="form-control" name="custom_field['+window.customnewcount+'][desc]">'+desc+'</textarea></div>';
	appendhtml = appendhtml+'<div class="col-md-5 col-sm-5 col-xs-9"><textarea class="form-control" name="custom_field['+window.customnewcount+'][value]">'+value+'</textarea></div>';
	appendhtml = appendhtml+'<div class="col-md-1 col-sm-1 col-xs-1"><button type="button" rel="'+window.customnewcount+'" class="btn btn-danger remove_custom_field"><span class="glyphicon glyphicon-minus"></span></button></div>';
	appendhtml = appendhtml+'</div>';
									
	$('#custom_fields_sortable').append(appendhtml);
	
	$(appendhtml).sortable({
		connectWith: "#custom_fields_sortable"
	}).disableSelection();
	
	window.customnewcount++;
}

function remove_custom_field_row(x) {
	('#custom_field_row_' + x).remove();
}

function listing_type_and_sale_change() {
	// function to run to determine what form looks like depending on whether we are talking rental or sales.
	// This function also takes into account whether the listing is commercial or not (don't let the title mislead you)
	// if commercial, enable the comm field,
	// and also show the commercial lease fields under rental
	// while disabling the residential stuff.
	var rentaldropdown = $('#for_rent');
	var commdropdown = $('#is_comm');

	listing_type_rental(rentaldropdown.val());
	// passes 1 as val if rental enabled, 0 if not. It's not boolean - it's from the dropdown values.

	listing_type_commercial(commdropdown.val());
	// passes 1 as val if commercial enabled, 0 if not. It's not boolean - it's from the dropdown values.

}

function listing_type_commercial(val) {
	if(val==1) {
		console.log('Commercial type enabled.');
		// $('#commtab_button').prop( "disabled", false ).removeClass('disabled'); // enable button.
		// $('#listing_form_tab li:eq(4)').removeClass('disabled disabledTab'); //
		$( "#listing_form_tab" ).tabs( "enable", 4 );
		$('#listing_form_tab li:eq(3) a').html('Lease'); // change "Rental" label to "Lease" - regardless of its lease or not.
		//enables or disables bed bath or commercial type
		$('#comm_sub_type_row').slideDown();
		$('#residential_rental_container').slideUp();
		$('#commercial_lease_container').slideDown();

		$('#type option').each(function(){
			// disable all lsiing types.
			$(this).attr('disabled', true);
		});

		$('#type option.type_commercial').each(function(){
			// enable commercial types.
			$(this).removeAttr('disabled');
		});

	} else {
		console.log('Residential type enabled');
		// $('#commtab_button').prop( "disabled", true ).addClass('disabled');
		// $('#listing_form_tab li:eq(4)').addClass('disabled disabledTab');
		$( "#listing_form_tab" ).tabs( "disable", 4 );
		$('#listing_form_tab li:eq(3) a').html('Rental');
		//enables or disables bed bath or commercial type
		$('#comm_sub_type_row').slideUp();
		$('#residential_rental_container').slideDown();
		$('#commercial_lease_container').slideUp();

		$('#type option').each(function(){
			$(this).removeAttr('disabled');
		});

		$('#type option.type_commercial').each(function(){
			$(this).attr('disabled', true);
		});
	}
}

function listing_type_rental(val) {
	if(val==1) {
		console.log('Rental type enabled.');
		// $('#rentalstab_button').prop( "disabled", false ).removeClass('disabled');
		// $('#listing_form_tab li:eq(3)').removeClass('disabled disabledTab');
		$( "#listing_form_tab" ).tabs( "enable", 3 );
		$('#price').prop('readonly','readonly').prop('placeholder','N/A');
	} else {
		console.log('Rental type disabled.');
		// $('#rentalstab_button').prop( "disabled", true ).addClass('disabled');
		// $('#listing_form_tab li:eq(3)').addClass('disabled disabledTab');

		$( "#listing_form_tab" ).tabs( "disable", 3 );
		$('#price').prop('readonly','').prop('placeholder','$123,456');
	}
}


function commercial_lease_calculate(userinput) {

	var userinput = (typeof userinput === 'undefined') ? false : userinput;

	if(userinput!==false) {
		$('#comm_rental_rate_override').val(1);
		$('#comm_rental_rate').attr("readonly", false).focus();
	}
	// calculates the monthly rent from the lease rates.
	// commercial leases are weird. base rent + additional rent nets to total $/sqft, annually.
	// (comm_price_sqft_y + comm_price_addl_y) * sqft / 12 = monthly net rent.
	var base_rent = ($('#comm_price_sqft_y').val()!='' ? number_only($('#comm_price_sqft_y').val()) : ''); // default to bank so it doesn't run.
	console.log("base_rent: "+base_rent);
	console.log('type of base_rent '+typeof base_rent);
	var addl_rent = ($('#comm_price_addl_y').val()!='' ? number_only($('#comm_price_addl_y').val()) : 0); // can defaul to 0. so it still runs.
	console.log("addl_rent: "+addl_rent);
	console.log('type of addl_rent '+typeof addl_rent);
	var sqft = ($('#sqft').val()!='' ? number_only($('#sqft').val()) : '');
	console.log("sqft: "+sqft);
	console.log('type of sqft '+typeof sqft);

	var monthly_rate = ''; // start with blank.
	var rate_message = 'Enter sqft, then the annual rate.'; // default message.

	if(userinput!==false) {
		// user override flag was set through an alert/modal box warning.
		rate_message = 'Manually enter monthly rent (include $).';
	} else if(base_rent!='' && sqft!='') {
		// check if basic fields are filled,
		// also check the user didnt override it already for manual field.
		var annual_rate = base_rent+addl_rent;
		console.log('type of annual_rate '+typeof annual_rate);
		console.log("annual_rate: "+annual_rate);
		var monthly_rate_raw = annual_rate*sqft/12; // raw number only.
		console.log('type of monthly_rate_raw '+typeof monthly_rate_raw);
		console.log("monthly_rate_raw: "+monthly_rate_raw);
		monthly_rate =  '$'+$.number(monthly_rate_raw, 2, '.', ','); // add commas and dollar sign.
		console.log("monthly_rate: "+monthly_rate);
		rate_message = 'Calculated from $'+$.number(annual_rate, 2, '.', ',')+'/sqft per annum.';
		// calculate the rate from sqft etc.
	} else {
		rate_message = 'Enter sqft, then the annual rate.';
	}

	$('#comm_rental_rate_flag').html(rate_message); // enter whatever rate message we have - all scenarios are covered by now.

	if(monthly_rate!='') {
		$('#comm_rental_rate').val(monthly_rate).attr("readonly", true);
		$('#comm_rental_rate_override').val(0); // set to non-overridden so that a value change in rent or sqft triggers further changes.
	}
}



function push_firmid() {
	console.log('pushign firm IDs');
	// settings_firmid_0, 1 & 2 to be pushed. 
	var firmidcount = 3;
	var firmidnum = 1; // start at 1. 
	while(firmidnum<=firmidcount) {
		if($('#settings_firmid_'+firmidnum).val()!='' && $('#settings_firmid_'+firmidnum).length==1) { // if element exists, and not blank. 
			$('#firm_'+firmidnum+'_id').val($('#settings_firmid_'+firmidnum).val());
		}
		firmidnum++;
	}
}

function load_google_map() {
	if(typeof map === 'object') {
		console.log('already loaded');
	} else {
		var latlng = '';
		if($('#lat').val() !='' && $('#long').val()!='') {
			// already has lat/lng from existing home data. use that.
			console.log("using existing lat/lng: "+$('#lat').val()+', '+$('#long').val());
			latlng = new google.maps.LatLng($('#lat').val(), $('#long').val()); // it prefers a whole string like "xx.xxxxx, xx.xxxx", not two separate vars.
			var zoomlevel = 16;
		} else {
			console.log("using defdault lat/lng: "+$('#defaultlat').val()+', '+$('#defaultlng').val());
			var latlng = new google.maps.LatLng($("#defaultlat").val(), $("#defaultlng").val());
			var zoomlevel = 12;
		}

		var myOptions = {
			zoom: zoomlevel,
			center: latlng,
			scrollwheel: false,
			mapTypeId: google.maps.MapTypeId.ROADMAP,
			streetViewControl:true
		};
		var mapdivid = 'listingmap';
		map = new google.maps.Map(document.getElementById(mapdivid), myOptions);
		google.maps.event.addListener(map, 'dragend', function() {
			get_coordinates();
		});
	}
}

function find_address_on_map() { 
	var number = $('#number').val();
	var street_dir = $('#street_dir').val();
	var street = $('#street').val();
	if(street_dir!='') {
		street = street_dir+' '+street;
	}
	var city = $('#city option:selected').text();
	var location = $('#location').val();
	if(number!='' && street!='') {
    	geocoder.geocode( { 'address': number+' '+street+' ,'+city+','+location}, function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
				map.setCenter(results[0].geometry.location);
				map.setZoom(16);
				get_coordinates();
			} else {
				$('#map_address_notfound').modal('show');
			}
		});
	} else {
		$('#map_address_notfound').modal('show');
	}
}
	  
function reset_map() {
	if($('#lat').val() !='' && $('#long').val()!='') {
		// already has lat/lng from existing home data. use that.
		console.log("using existing lat/lng: "+$('#lat').val()+', '+$('#long').val());
		var latlng = new google.maps.LatLng($('#lat').val(), $('#long').val());
		var zoomlevel = 12;
	} else {
		console.log("using defdault lat/lng: "+$('#defaultlat').val()+', '+$('#defaultlng').val());
		var latlng = new google.maps.LatLng($("#defaultlat").val(), $("#defaultlng").val());
		var zoomlevel = 16;
	}
	map.setCenter(latlng);
	map.setZoom(zoomlevel);
	get_coordinates();
}

function get_coordinates() {
	var currentlocation = map.getCenter();
	$('#lat').val(currentlocation.lat());
	$('#long').val(currentlocation.lng());
}

function fetch_building_list(selectid) {
	var number = $('#number').val();
	var unit = $('#unit').val();
	var street_dir = $('#street_dir').val();
	var street = $('#street').val();
	var cityindex = $('#city').prop('selectedIndex');
	var city = $('#city option:selected').text();
	var buildingid = $('#building').val();
	var type = $('#type').val();
	var buildingtype = ($('#type option:selected').attr('rel')=='building' ? true : false ); // see if a property type that denotes a building was selected or not. 
	if(
		(number!='' && street!=''  && city!='' && cityindex>1 && buildingtype==true && window.getvar['mode']=='new' && buildingid=='')  // only run if this is a new page, OR if building is not set yet. If editing existing item with set buildling, no need to run again. 
		||
		(window.getvar['mode']=='modify' && buildingid=='' && buildingtype==true)
	) {
		if(window.buildingsearchstring!='') {
			var lastbuildingsearch = window.buildingsearchstring;
		}
		window.buildingsearchstring = number+(street_dir!='' ? street_dir+' ' : ' ')+street+' '+city+' '+type;
		console.log('fetching builing list with '+window.buildingsearchstring);
		if(lastbuildingsearch!=window.buildingsearchstring) {
			// only run if the street name, or number etc. has changed. do not run on unit # change, so as to avoid duplicate queries. 
			$.post("ajax_listbuildinglist.php", { number: number, street: street, street_dir: street_dir, city:city, buildingid:buildingid},
				function(data) {
					if(data.count==0) {
						// if this was triggered with a unit number in, then force it to take action. Or if buildingtype is positive, meaning the property type selected indicates it should be a unit. 
						if(unit!='' || buildingtype===true) {
							$('#building_notfound').modal({
								backdrop: 'static',
								keyboard: false
								}, 'show'
							);
						} else {
							// do nothing, just a passive buildings check to see if it exists, but no unit number given, so could be a duplex, house, anything else. 
							console.log('nothing running, passive check, as unit was blank and property type does not indicate building ');
						}
					} else {
						$('#building_container').slideDown(600);
						$('#building').html('').append('<option value="">Select a Building</option>'); //blank it out, then put the default select on there. 
						for(var key in data.buildings) {
							// $dropdown.= '<option value="'.$thisbuilding->id.'"'.$selectedtext.'>'.$displayname.'</option>';
							$('#building').append('<option value="'+data.buildings[key].value+'"'+(data.buildings[key].selected==true ? ' selected="selected"' : '')+'>'+data.buildings[key].display+'</option>');
						}
						if(selectid!=undefined) {
							$('#building').html(data.dropdown).val(selectid);
						}
					}
				}, 'json'
			);
		} else {
			console.log('no significant changes in building search query from last one: '+lastbuildingsearch);
		}
	}
}

function create_new_building() {
	var building_name = $('#building_name').val();
	var number = $('#number').val();
	var street = $('#street').val();
	var street_dir = $('#street_dir').val();
	var city = $('#city ').val();
	var area = $('#area').val();
	var lat = $('#lat').val();
	var lng = $('#long').val();
	$.post("ajax_modifybuildings.php", { change:'add', number: number, street: street, street_dir: street_dir, city:city, area:area, lat:lat, lng:lng, building_name:building_name},
		function(data) {
			if(data.code==1) {
				window.buildingsearchstring = ''; // blank this so as to force new search regardless of last search. 
				fetch_building_list(data.id);
			} else {
				alert('error! '+data.message);
			}
		}, 'json'
	);
	return false;
}

// MLS data related functions
function convertlisting(change) {
	if(change=='source') {
		var fieldvalue = 0;
	} else if(change=='feature') {
		var fieldvalue = 1;
	}
	var mlsnum = $('#mls').val();
	console.log('changing '+change+' to '+fieldvalue+' now.');
	// function to either convert to FEATURED or OWN depending on feed. 
	modal_processing(true);
	
	$.post("ajax_modifyhomes.php", { mls: mlsnum, value: fieldvalue, change:change},
		function(data) {
			if(data.code==0) {
				modal_processing(false);
				$('#mls_failed').find('.modal-body').html('<p>An error occurred - please contact the Brixwork Support Team and include the following error message:</p><p><strong>'+data.message+'</strong>.</p>');
				$('#mls_failed').modal('show');
			} else if(data.code==1) {
				// MLS # was successfully converted! 
				window.leaveflag=1;
				if(change=='source') {
					// converted to OWN listing, take to homes screen.
					window.location = 'homes_mod.php?idr='+data.id+'&mode=modify'; 
				} else {
					// just featured MLS listing, go back to homes list. 
					window.location = 'homes.php'; 
				}
			}
		},
	'json');
}

function resetmls() {
	// if NO is answered when asked to convert MLS listing to own listing. 
	$('#mls').val('');
	$('#submit').attr('disabled','');
}

function remove_new_feature(id){
	//any new feature a client adds to the page will use this function if they remove it.
	var featureid = id;
	window.feature_id = featureid;
	$('#delete_feature').find('.modal-body').html('<p>Are you sure you want to delete this feature? This will remove this feature from ALL your homes, not just this one.</p>');
	$('#delete_feature').modal('show');
	return false;
}
function add_new_feature() {
	if ($("#new_feature").val() == "") {
		console.log('Add New Feature function - failed')

		$("#new_feature_group").addClass("has-error")
	} else {
		console.log('Add New Feature function - success');

		modal_processing(true);
		$("#new_feature_group").removeClass("has-error");
		var new_feature = $("#new_feature").val();
		$.post("ajax_modifyhomefeatures.php", {
			change: "add",
			value: new_feature
		}, function(data) {
			if (data.id != "" && data.id !== undefined) {
				var appendhtml = '<div class="row bottom_10" id="bfeature_' + data.id + '"><div class="col-sm-11 col-sm-offset-1 col-xs-10 col-xs-offset-2"><div class="checkbox"><input type="checkbox" name="features[]" value="' + data.id + '" id="feature_' + data.id + '" checked="checked" /><label class="orderhandle" for="feature_' + data.id + '">' + new_feature + '</label></div><div class="remove"><a href="#" class="remove_feature" data-id="'+data.id+'" rel="'+data.id+'" onclick="remove_new_feature('+data.id+')">Delete</a></divclass></div></div>';
				$("#homefeatures").append(appendhtml);
				$("#new_feature").val("")
			}
			modal_processing(false)
		}, "json")
	}
	return false
}
function remove_feature(){


	modal_processing(true);
	$.post("ajax_modifyhomefeatures.php", {
		change: "delete",
		idr: window.feature_id,
	}, function(data) {
		console.log(data);
		if (data.feature_id != "" && data.feature_id !== undefined) {
			console.log(data.feature_id);
			$(`#bfeature_${data.feature_id}`).remove();

		}
		modal_processing(false)
	}, "json")
}
// function add_new_feature() {
// 	if ($("#new_feature").val() == "") {
// 		$("#new_feature_group").addClass("has-error")
// 	} else {
// 		modal_processing(true);
// 		$("#new_feature_group").removeClass("has-error");
// 		var new_feature = $("#new_feature").val();
// 		$.post("ajax_modifyhomefeatures.php", {
// 			change: "add",
// 			value: new_feature
// 		}, function(data) {
// 			if (data.id != "" && data.id !== undefined) {
// 				var appendhtml = '<div class="row bottom_10" id="hfeature_' + data.id + '"><div class="col-sm-11 col-sm-offset-1 col-xs-10 col-xs-offset-2"><div class="checkbox"><input type="checkbox" name="features[]" value="' + data.id + '" id="feature_' + data.id + '" checked="checked" /><label class="orderhandle" for="feature_' + data.id + '">' + new_feature + "</label></div></div></div>";
// 				$("#homefeatures").append(appendhtml);
// 				$("#new_feature").val("")
// 			}
// 			modal_processing(false)
// 		}, "json")
// 	}
// 	return false
// }



function empty_dimension(num) {
	console.log('woriking on '+num);
	$('#specname_'+num).val('');
	$('#specvalue_'+num).val('');
	
	var specstotal = $('.empty_dimension').length;
	var currentcount = Array();

	var count = num; // start at the one that was just emptied, so as to pull the rest of the dimension fields UP one step. 
	while(count<specstotal) {
		var nextone = (count*1)+1;
		$('#specname_'+count).val($('#specname_'+nextone).val());
		$('#specvalue_'+count).val($('#specvalue_'+nextone).val());
		
		// clean out the value we just shifted up
		$('#specname_'+nextone).val('');
		$('#specvalue_'+nextone).val('');
		count++;
	}
}


function edit_building(buildingid) {
	// after listings is entered, and the attached building is blank, it forces user to go to the buildings screen on that building to edit that home.
	window.leaveflag=1;
	window.setTimeout("window.location.href = 'buildings_mod.php?idr="+buildingid+"&mode=modify'", 500);
}

function back_to_list() {
	// simply forwards user back to the homes list screen after done editing. 
	window.leaveflag=1;
	window.setTimeout("window.location.href = 'homes'", 500);
}


window.onbeforeunload = function() {
	if(window.leaveflag!=1) {
    	return 'Are you sure you want to leave this page? There may be unsaved changes on this page content.';
    }
}


/**
 * RICH TEXT EDITOR CONFIG
 */
tinymce.init({
	selector: 'textarea',
	skin: 'bootstrap',
	plugins: 'anchor autolink charmap emoticons lists table visualblocks wordcount',
	toolbar: '| blocks | bold italic underline strikethrough | link image media table mergetags | spellcheckdialog a11ycheck typography | align lineheight | checklist numlist bullist indent outdent | emoticons charmap | removeformat',
	menubar: false,
});