$(document).ready(function() {
	if(is_ie()) {
		// Do people still use IE? Seriously?
		$('#get_chrome').modal('show');
	}
	
	$('#admin_listing_search_submit').click(function(){
		load_mls_listings();
		return false;
	});
	
	$('#city').change(function(){
		updatesubarea(false);
	});

});



// DOUBLE SLIDER ON HOMEPAGE LISTINGS SEARCH JAVASCRIPT
let sliderOne = document.getElementById("slider-1");
let sliderTwo = document.getElementById("slider-2");
let displayValOne = document.getElementById("range1");
let displayValTwo = document.getElementById("range2");
let minGap = 0;
let sliderTrack = document.querySelector(".slider-track");
let sliderMaxValue = sliderOne ? sliderOne.max : '';

let searchFormMin = document.getElementById('listing_search_min_price');
let searchFormMax = document.getElementById('listing_search_max_price');
let default_max_price = searchFormMax ? searchFormMax.value : false;

function slideOne() {
	if(parseInt(sliderTwo.value) - parseInt(sliderOne.value) <= minGap){
		sliderOne.value = parseInt(sliderTwo.value) - minGap;
	}
	displayValOne.textContent = '$' + sliderOne.value;
	searchFormMin.setAttribute('value', sliderOne.value);
	fillColor();
}
function slideTwo() {
	if(parseInt(sliderTwo.value) - parseInt(sliderOne.value) <= minGap){
		sliderTwo.value = parseInt(sliderOne.value) + minGap;
	}

	displayValTwo.textContent = '$' + sliderTwo.value;

	// console.log(default_max_price)
	if (default_max_price === sliderTwo.value) {
		// if default and current sliderTwo is the same, it means we want to search unlimited.
		searchFormMax.setAttribute('value', '0');
	}
	else {
		// if different, respect the slider value.
		searchFormMax.setAttribute('value', sliderTwo.value);
	}
	fillColor();
}
function fillColor(){
	let percent1 = (sliderOne.value / sliderMaxValue) * 100;
	let percent2 = (sliderTwo.value / sliderMaxValue) * 100;
	let trackerColor = sliderTrack.getAttribute('data-tracker-color');
	let trackerBackground = sliderTrack.getAttribute('data-background');
	sliderTrack.style.background = `linear-gradient(to right, ${trackerBackground} ${percent1}% , ${trackerColor} ${percent1}% , ${trackerColor} ${percent2}%, ${trackerBackground} ${percent2}%)`;
}

//DOUBLE SLIDER JAVASCRIPT
if (sliderOne && sliderTwo) {
	slideOne();
	slideTwo();
}


// LISTINGS SEARCH CATEGORY DROPDOWN ON THE HOMEPAGE
let listing_order_dropdown = document.getElementById('listing_order_dropdown'); 			// the dropdown itself
let listing_direction_dropdown = document.getElementById('listing_order_direction_dropdown');	//dropdown itself

let listing_order_input = document.getElementById('listing_order_by');					// hidden input field
let listing_direction_input = document.getElementById('listing_order_direction_input');	// hidden input field

let listing_order_category_li = document.querySelectorAll('#listing_order_category_li')	// first dropdown li
let listing_order_direction = document.querySelectorAll('#listing_order_direction_dir');	// second dropdown

// first order category
listing_order_category_li.forEach(each_li => each_li.addEventListener("click", dropdown_action))
listing_order_direction.forEach(each_li => each_li.addEventListener('click', function (e) {
	// replace the dropdown text with selected option text
	listing_direction_dropdown.innerHTML = e.target.innerHTML;
	listing_direction_input.setAttribute('value', e.target.getAttribute('value'));
}))

function dropdown_action(e) {
	let selected = e.target.getAttribute('data-val');
	let dropdown_desc = listing_order_direction[0];
	let dropdown_asc = listing_order_direction[1];

	listing_direction_dropdown.classList.remove('disabled');			// enable button

	switch (selected) {
		case 'date':
			reset_dropdown();
			dropdown_desc.innerHTML = 'Newest To Oldest';
			dropdown_asc.innerHTML = 'Oldest to Newest';
			break;
		case 'price':
			reset_dropdown();
			dropdown_desc.innerHTML = 'Highest to Lowest';
			dropdown_asc.innerHTML = 'Lowest to Highest';
			break;
		case 'sqft':
			reset_dropdown();
			dropdown_desc.innerHTML = 'Largest to Smallest';
			dropdown_asc.innerHTML = 'Smallest to Largest';
			break;
		case 'numBeds':
			reset_dropdown();
			dropdown_desc.innerHTML = 'More To Less';
			dropdown_asc.innerHTML = 'Less To More';
			break;
		case 'numBaths':
			reset_dropdown();
			dropdown_desc.innerHTML = 'More To Less';
			dropdown_asc.innerHTML = 'Less To More';
			break;
		case null:
			listing_direction_dropdown.innerHTML = 'Choose Order By First';
			listing_direction_dropdown.classList.add('disabled');
			break;
		default:
			dropdown_desc.innerHTML = 'Choose Order By First';
	}

	// updates main dropdown text with selected option
	listing_order_dropdown.innerHTML = e.target.innerHTML;
	listing_order_input.setAttribute('value', e.target.getAttribute('value'));
}

function reset_dropdown() {
	listing_direction_dropdown.innerHTML = 'Choose Direction' 				// reset dropdown text
	listing_direction_input.setAttribute('value', '');	// reset hidden input
}


/**
 * LISTS MLS SEARCH RESULTS - THIS ONE HAS COOL PAGINATION WHERE IT ONLY SHOWS 3 PAGES BUT UPON CLICKED 3RD PAGE LINK IT WILL DISPLAY 4TH PAGE, IF IT EXISTS.
 */
function load_mls_listings(page) {
	$('#listing_search_list').html(window.ajax_loader);
	
	if(page === '' || page === undefined || page === false) {
		page = 1;
	}
	
	let postvars = $('#admin_listing_search_form').serialize();
	postvars = postvars+'&page='+page;

	// console.log('Post Vars: '+postvars);
	// console.log('Get Action of the form:'+ document.getElementById('admin_listing_search_form').getAttribute('action'))
	
	$.post($('#admin_listing_search_form').attr('action'), postvars,
		function(data){
			// console.log('Printing Data within "function": '+data);
			$('.pagination').empty()
			if( data.count === 0 ) {
				$('#listing_search_list').html(data.message);
			} else {
				const homesArray = data.homes;
				const numberOfItems = data.homes.length;
				const numberPerPage = 5
				const currentPage = 1
				const numberOfPages = (numberOfItems/numberPerPage) % 0 ? (numberOfItems/numberPerPage) : Math.ceil(numberOfItems/numberPerPage);

				// console.log('Printing Data within "else": '+data);

				// HELPER FUNCTIONS
				function buildPagination(clickedPage) {
					$('.pagination').empty()
					const currPageNum = accomodatePage(clickedPage)

					if (numberOfPages >= 5) {
						for (let i=-2; i<3; i++) {
							let active = ((currPageNum+i) === clickedPage) ? 'active' : ''

							if (currPageNum + i > 0 && currPageNum + i <= numberOfPages) {
								$('.pagination').append(`<li class="page-item ${active}"><button class="page-link" value="${currPageNum+i}">${currPageNum+i}</button></li>`)
							}
						}
					} else {
						for (let i=0; i<numberOfPages; i++) {
							// $('.paginator').append(`<button class="btn btn-primary" value="${i+1}">${i+1}</button>`)
							let active = (i+1 === clickedPage) ? 'active' : ''
							$('.pagination').append(`<li class="page-item ${active}"><button class="page-link" value="${i+1}">${i+1}</button></li>`)
						}
					}
				}

				function accomodatePage(clickedPage) {
					if (clickedPage <= 1) { return clickedPage + 1}
					if (clickedPage >= numberOfPages) { return clickedPage -1}
					return clickedPage
				}

				// activate the feature toggle selects.
				function activate_listing_feature_status() {
					$('.listing_feature_toggle').each(function(){
						let mlsnum = $(this).attr('rel');

						$(this).change(function(){
							let changedir = $(this).val();
							$.get("ajax_modifyhomes.php", { mls: mlsnum, value: $(this).val(), change: 'feature'},
								function(data){
									if(parseInt(data.code) === 1) {
										if($('#mls').val() !== '') {
											// it was a straight up MLS search so let's re-load the search in case it was a remote listing.
											load_mls_listings(1);
										} else {
											if(parseInt(changedir) === 1) {
												console.log('adding home_feature class to admin_listing_search_'+data.id);
												$('#admin_listing_search_'+data.id).addClass('home_feature');
											} else {
												$('#admin_listing_search_'+data.id).removeClass('home_feature');
											}
										}
									} else {
										// error_display(data.message,'Failed!','check',"$('#listing_feature_"+data.id+"').val(0);");
									}
								},'json'
							);
						});
					});
				}
				// activate the feature toggle selects.
				function activate_covert_to_own() {
					$('.listing_convert_own').each(function(){
						let mls_id = $(this).attr('rel');

						$(this).click(function() {
							let convert_to_own_btn = $('.convert_to_own_btn')
							convert_to_own_btn.click(function () {
								convert_listing(mls_id)
							})
							$('#convert_to_own').modal('show');
						});
					});
				}

				// DISPLAY STYLED LIST FUNCTION
				function displayHomes(trimmedHomesArray) {
					let html = '<div id="admin_listing_search_wrapper">';

					trimmedHomesArray.forEach(each_listing => {
						// DATA PREP
						let notfeaturedselected = "";
						let featuredselected = "";
						switch (each_listing.feature*1) {
							case 0:
								notfeaturedselected = " selected";
								featuredselected = "";
								break;

							case 1:
								notfeaturedselected = "";
								featuredselected = " selected";
								break;
						}
						let mark_as_own_div = (parseInt(each_listing.source) === 1 && parseInt($('#mlssite').val()) === 0) ?
											'<div class="mark_as_own">' +
												'<input type="button" class="btn btn-admin listing_convert_own" value="Mark As Own" rel="'+each_listing.mls+'"/>' +
											'</div>'
											:
											'<div class="mark_as_own">' +
												'<a class="btn btn-admin grey_teal" href="'+each_listing.url+'" role="button" target="_blank">View on website</a>' +
											'</div>';
						let debug_button_div = (parseInt($('#brixwork_user').val()) === 1) ?
											'<div class="debug_button">' +
												'<a href="home_debug.php?idr='+each_listing.value+'" class="btn btn-info btn-sm" target="_blank">Debug</a>' +
											'</div>'
											: '';

						// DISPLAY EACH SEARCH RESULT!
						let residential_type = each_listing.mls.charAt(0) === "R"
						html +=
							'<div id="admin_listing_search_'+each_listing.value+'" class="each_search_listing row '+(parseInt(each_listing.feature) === 1 ? 'home_feature' : '')+'">' +
							// LISTING IMAGE WRAPPER
							'	<div class="each_search_listing__img">' +
							'		<img src="'+each_listing.image+'" title="'+each_listing.fulladdress+'" alt="'+each_listing.fulladdress+'" class="img-full" />' +
							'	</div>' +
							// SUMMARY: MLS# , ADDRESS, PRICE, TYPE
							'	<div class="each_search_listing__summary">' +
							'		<h6 class="mls_num">MLS #'+ each_listing.mls +'</h6>' +
							'		<h4 class="full_address">'+ each_listing.address +'<br/>'+ each_listing.areacity +'</h4>' +
							'		<div class="price_and_type">' +
							'			<h6 class="price">'+ each_listing.price +'</h6>' +
							'			<h6 class="type">'+ each_listing.type +'</h6>' +
							'		</div>' +
							'		<h6 class="provided_by">Listed by '+ each_listing.providedby +'</h6>' +
							'	</div>' +
							// MORE DETAILS + FUNCTIONS: FEATURE ON SITE, MARK AS OWN, NUM BEDS & BATHS ... ETC
							'	<div class="each_search_listing__details">' +
							'		<div class="feature_functions_wrapper">' +
							'			<div class="feature_status">' +
							'				<h6>Feature on my site</h6>' +
							'				<select class="form-select input-sm listing_feature_toggle" rel="'+each_listing.mls+'" >' +
							'					<option value="0"'+notfeaturedselected+'>Not Featured</option>' +
							'					<option value="1"'+featuredselected+'>Featured</option>' +
							'				</select>' +
							'			</div>' +
										mark_as_own_div +
							'		</div>';

						if (residential_type) {
							html +=
								'<table class="beds_baths_etc table table-hover table-borderless">' +
								'	<tbody>' +
								'		<tr>' +
								'			<th>Beds</th><td>'+each_listing.bedroom+'</td>' +
								'			<th>Living Area</th><td>'+each_listing.sqft+'</td>' +
								'		</tr>' +
								'		<tr>' +
								'			<th>Baths</th><td>'+each_listing.bathroom+'</td>' +
								'			<th>Days on MLS</th><td>'+each_listing.dom+'</td>' +
								'		</tr>' +
								'		<tr>' +
								'			<th>Built in</th><td>'+each_listing.year+'</td>' +
								'		</tr>' +
								'	</tbody>' +
								'</table>';
						}
						else {
							html +=
								'<table class="beds_baths_etc table table-hover table-borderless">' +
								'	<tbody>' +
								'		<tr>' +
								'			<th>SQFT</th><td>'+each_listing.sqft+'</td>' +
								'			<th>Days on MLS</th><td>'+each_listing.dom+'</td>' +
								'		</tr>' +
								'	</tbody>' +
								'</table>';
						}

						// closing tags for each listing
						html += '</div></div>';
					})
					html += '</div>'
					return html;
				}

				// BUILD PAGE BY SLICING HOMES ARRAY
				function buildPage(currPage) {
					const trimStart = (currPage-1)*numberPerPage
					const trimEnd = trimStart + numberPerPage

					// APPEND TO HTML TO DISPLAY ON THE FRONTEND.
					let homesToDisplay = homesArray.slice(trimStart, trimEnd);
					$('#listing_search_list').empty().append(displayHomes(homesToDisplay));
				}


				// ACTUALLY BUILD THE HOME HTML
				buildPage(1)
				buildPagination(currentPage)
				activate_listing_feature_status()
				activate_covert_to_own()

				$('.pagination').on('click', 'button', function() {
					let clickedPage = parseInt($(this).val())
					buildPagination(clickedPage)
					console.log(`Page clicked on ${clickedPage}`)
					buildPage(clickedPage)
					activate_listing_feature_status()
					activate_covert_to_own()
				});


				// $('#listing_search_list').html(html);
				// facebook stuff
				// FB.XFBML.parse(document.getElementById('listing_search_list'));
				
				// once HTML is set, activate other functions such as getting page links working. 
				$('.homes_pagelink').each(function(){
					$(this).click(function(){
						let targetpage = $(this).attr('rel');
						load_mls_listings(targetpage);
						return false;
					});
				});
			}
	}
	,'json');
}


function set_listing_order() {
	var order_column_pairs = [];
	order_column_pairs['create_date'] = ['Newest To Oldest','Oldest to Newest'];
	order_column_pairs['modify_date'] = ['Newest To Oldest','Oldest to Newest'];
	order_column_pairs['sqft'] = ['Largest to Smallest','Smallest to Largest'];
	order_column_pairs['price'] = ['Highest to Lowest','Lowest to Highest'];
	order_column_pairs['bedroom'] = ['More To Less','Less To More'];
	order_column_pairs['bathroom'] = ['More To Less','Less To More'];
	
	var order_column = $('#listing_order_by').val();
	if(order_column!='' && order_column!=undefined) {
		$('#listing_order_direction').fadeTo(300,1);
		$('#listing_order_direction option:eq(0)').html(order_column_pairs[order_column][0]);
		$('#listing_order_direction option:eq(1)').html(order_column_pairs[order_column][1]);
	} else {
		$('#listing_order_direction').fadeTo(300,0);
	}
}



function convert_listing(mls_num) {
	modal_processing(true);
	$.get("ajax_modifyhomes.php", { mls: mls_num, value: 0, change: 'source'},
		function(data){
			if(parseInt(data.code) === 1) {
				console.log(data.code+' was code, ID was '+data.id);
				window.location = 'homes_mod.php?idr='+data.id+'&mode=modify';
	 		} else {

	 		}
		},'json'
	);
	modal_processing(false)
}