$(document).ready(function(){
	list_links()
	init_add_category()
});

function list_links() {
	$('#linkslist').html(window.ajax_loader);
	let random_number = Math.floor(Math.random()*101);

	$.post("ajax_listlinks.php", { rand : random_number }, function(data) {

		$('#linkslist').html(data);
		// trigger re-order options with drag & drop sortables.
		activate_category_reorders()
		activate_collapse_control()

		// resource publish on or off AJAX
		$('.resource_publish_toggle').each(function() {
			$(this).change(function(){
				console.log('publish status change on '+ $(this).attr('rel')+ ' to ' + $(this).val());
				modify_resource('publishstatus', $(this).attr('rel'), $(this).val());
			});
		});

		// set up category modify AJAX functions
		$('.category_mod').each(function(){
			$(this).click(function(){
				let category_name = $(this).attr('data-name')
				let category_id = $(this).attr('data-id')
				let save_btn = $('.mod_category__save');

				$('#mod_category_name').val(category_name);
				save_btn.attr('data-id', category_id)
				save_btn.attr('data-name', category_name)
				$('#mod_category').modal('show');
			});
		});


		// save edited name function
		$('.mod_category__save').each(function () {
			$(this).on('click', function () {
				console.log('saving new name...')
				let new_name = $('#mod_category_name').val()

				// only run modify if the value is edited.
				if ($(this).attr('data-name') !== new_name)
					modify_category('title', $(this).attr('data-id'), new_name)
			})
		})


		// set up resource deletion links
		$('.resource_delete').each(function(){
			$(this).click(function(){
				let resource_id = $(this).attr('rel');
				let category_id = $(this).attr('data-parent')
 				let resource_title = $('#resource_'+resource_id+' .each_list__title').text();
				let resource_delete_modal = $('#delete_resource')

				console.log(resource_title+ ' ID '+resource_id+' delete triggered');

				resource_delete_modal.find('.modal-body').html("<p class='my-3'>Are you sure you want to delete <strong>"+resource_title+"</strong>? It is recommended to 'Hide' instead</p>")
				resource_delete_modal.find('.mod_resource__delete').on('click', function () {
					modify_resource('delete', resource_id, category_id)
				})

				resource_delete_modal.modal('show')
			});
		});


		// set up category deletion links
		$('.category_delete').each(function(){
			$(this).click(function(){
				let category_id = $(this).attr('rel')
				let category_title = $('#category_'+ category_id +' .each_list__title').text()
				let category_delete_modal = $('#delete_category')

				console.log(category_title+' ID '+ category_id +' delete triggered')

				category_delete_modal.find('.modal-body').html("<p class='my-3'>Are you sure you want to delete <strong>"+category_title+"</strong>? This category will not appear if there are no resources under it.</p>")
				category_delete_modal.find('.mod_category__delete').on('click', function () {
					modify_category('delete', category_id)
					list_links()
				})

				// show modal
				category_delete_modal.modal('show')
			});
		});
	});
}


/**
 * ADD EVENT LISTENER TO BUTTONS
 */
function init_add_category() {
	// on click event to show modal
	$('#add_new_category_button').on('click', function () {
		let add_category_modal = $('#add_category')
		let add_category_modal__btn = add_category_modal.find('.mod_category__add')

		add_category_modal__btn.on('click', function () {
			add_category()
		})
		add_category_modal.modal('show')
	})
}

/**
 * CREATE NEW CATEGORY
 */
function add_category() {
	let category_name = $('#category_name').val();
	$.post("ajax_modifyresourcecategories.php", { change:'add', category_name:category_name},
		function(data) {
			if(data.code === 1) {
				list_links()
			} else {
				alert('error! '+data.message);
			}
		}, 'json'
	);
}


/**
 * ACTIVATE JQUERY UI SORTABLE
 */
function activate_category_reorders() {
	// first, destroy all sortables so we start fresh. Otherwise, we'll have duplicate triggers!
	$('.category_wrapper').each(function(){
		if($(this).sortable('instance')!==undefined) {
			$(this).sortable('destroy');
		}
		$(this).sortable({
			items: ".brixwork_list_wrapper", // or .each_page
			handle: ".each_list__title",
			cursor: 'move',
			update: function(event, ui) {
				let category_order_vars = $(this).sortable('serialize');

				$.get("ajax_modifyresourcecategories.php", category_order_vars+'&change=order',
					function(data){
						console.log(data);
					},
					'json'
				);
			}
		});
	});
	
	activate_resources_reorders();
}



function activate_resources_reorders() {
	$('.resource_wrapper').each(function(){
		if($(this).sortable('instance')!==undefined) {
			$(this).sortable('destroy');
		}
		let category_id = $(this).attr('rel')

		$(this).sortable({
			items: "> div", // or .each_page
			handle: ".each_list__title",
			cursor: 'move',
			update: function(event, ui) {
				let resource_order_vars = $(this).sortable('serialize');

				$.get("ajax_modifyresources.php", resource_order_vars+'&change=order&category='+category_id,
					function(data) {
						// add remove last_elem class from other rows.
						toggle_last_elem_class(category_id)
					},
					'json'
				);
			}
		});
	});
}

function toggle_last_elem_class(category_id) {
	$('.resource_wrapper[rel='+category_id+']').find('.each_list').each(function (index) {
		$(this).removeClass('last_elem')
		const length = $('.resource_wrapper[rel=' + category_id + ']').find('.each_list').length - 1
		if (parseInt(index) === length)
			$(this).addClass('last_elem')
	})
}

function modify_resource(change,idr,value){
	let random_number = Math.floor(Math.random()*101)
	
	$.post("ajax_modifyresources.php", { idr: idr, value: value, change: change, rand: random_number },
		function(data){
  		
  		if(data.code === 0) {
			console.log(data.message);
		} else {

			switch (change) {
				// now process classes etc. depending on what was done!
				 case 'publishstatus':
					 $('#resource_' + idr).toggleClass('hidden_list')
				break;
			}
		}
	}, 'json');
}



function modify_category(change,idr,value) {
	let random_number = Math.floor(Math.random()*101)

	$.post("ajax_modifyresourcecategories.php", { idr: idr, value: value, change: change, rand: random_number }, '' +
		function(data) {
			if(data.code === 0) {
				console.log('Error '+data.code+': '+data.message);
			}
			else {
				switch (change) {
					// now process classes etc. depending on what was done!
					case 'delete':
						$('#category_' + idr).slideUp(300, function(){
							$(this).remove();
						}); // deleted, get rid of this row!
					break;

					case 'title':
						list_links(); // title changed ... refresh list.
					break;
				}
			}
		}, 'json'
	)
}