$(document).ready(function(){
	// initially hide ... show if needed
	$('#mailchimp_merge_fields_container').hide();

	if($('#settings_mailchimp_api_key_container input').val() !== '' ) {
		console.log("Mailchimp API key is already pre-filled, trigger Audience list retrieval.");
		getMailchimpList($('#settings_mailchimp_api_key_container input[type=text]').val(), getMailchimpMergeFields);
	}

	$('#settings_mailchimp_api_key_container input').on('change', function() {
		getMailchimpList($('#settings_mailchimp_api_key_container input[type=text]').val(), getMailchimpMergeFields);
	});

	$('#settings_mailchimp_api_list_container select').on('change', function(){
		if($(this).val() !='') {
			console.log('Audience list selected, loading the merge fields.');
			getMailchimpMergeFields($(this).val());
		}
	});
});


// simply puts cursor back on the API key field in case the entry was invalid etc.
function focus_on_api_key() {
	$('#settings_mailchimp_api_key_container input[type=text]').focus();
}


function getMailchimpList(api_key, callback) {
	// Get and show the contact lists of client's Mailchimp account based on API key.
	// Note this function will run on page load, if the API Key is already selected.
	// If there's already a selected list, it will put a selected tag by the <option> tag too.
	$('#mailchimp_merge_fields_container').hide();
	$.post("ajax_mailchimp.php", { api_key: api_key, request_type: 'list'}, null, 'json')
		.done(function(data){
			if(data.code!=0) {
				// figureout what that api = false is

				//$("#settings_mailchimp_api_list_container").html('afterend', data.options);
				var mailchimp_list = $("#settings_mailchimp_api_list_container select");
				mailchimp_list.empty(); // remove old options
				var numoptions = data.options.length;
				$.each(data.options, function(key,array) {
					mailchimp_list.append($("<option></option>")
					.attr({value: array.listid, selected: (array.selected==1 ? true : false)}).text(array.label));

					if(array.selected==1) {
						callback(array.listid); // call the callback function and pass the listid as an argument
					}
				});

				console.log('Updated audience list with '+numoptions+' new options.');
				$('#mailchimp_merge_fields_container').show(); // show the first/last name div.

			} else {
				alert("API Key error - "+data.message);
				var mailchimp_list = $("#settings_mailchimp_api_list_container select");
				mailchimp_list.empty(); // remove old options
				focus_on_api_key();
				$('#mailchimp_merge_fields_container').hide(); // hide the first/last name div.
			}

			// $.when(listenToSelect()).done(function(){

			// });
		})
		.fail(function(error) {
			console.log('error: ', error.error());
			alert("API Fetch error - "+data.message);
			var mailchimp_list = $("#settings_mailchimp_api_list_container select");
			mailchimp_list.empty(); // remove old options
			focus_on_api_key();
			$('#mailchimp_merge_fields_container').hide(); // show the first/last name div.
		});
}

function getMailchimpMergeFields(listid) {

	// if this function runs, we assume the API key was valid and we have a proper list of audiences to work with.
	var api_key = $('#settings_mailchimp_api_key_container input[type=text]').val();

	$.post("ajax_mailchimp.php", {api_key : api_key, request_type: 'fields', listid}, null, 'json')
		.done(function(data){
			if(data.code!=0) {
				console.log(data.options);
				// go through all the dropdowns and replace.
				$('#mailchimp_merge_fields_container select').each(function(){
					var mailchimp_merge_field_name = $(this).attr('name');
					var mailchimp_select = $(this);
					mailchimp_select.empty(); // remove old options
					var numoptions = data.options.length;
					$.each(data.options, function(key,array) {
						mailchimp_select.append($("<option></option>")
							.attr({value: array.fieldid, selected: (array.selected==mailchimp_merge_field_name ? true : false)}).text(array.label));
					});
					console.log('Updated '+mailchimp_merge_field_name+' with '+numoptions+' fields.');
				});
			} else {
				alert("Merge fields fetch error - "+data.message);
			}
		})
		.fail(function(error) {
			console.log('error: ', error.error());
			alert("Merge fields fetch error - "+error.error());
		})
}
