$(document).ready(function(){

	$('.mainimageinput').each(function(){
		var ajaxdest = 'ajax_uploadify.php';

		var sequence = $(this).attr('rel');
		var filename = $(this).data('filename');

		var width = $(this).data('width');
		var height = $(this).data('height');

		var ext = $(this).data('ext'); // jpg or png generally.
		var mimetype = $(this).data('mimetype'); // jpg or png generally. Webp?


		if(filename!='') {
			$(this).uploadifive({
				'uploadScript' : ajaxdest,
				'auto' : true,
				'buttonClass': 'btn btn-block uploadifiveinput',
				'buttonText': 'Select or Drag and Drop',
				'method': 'post',
				'multi':false,
				'fileObjName': 'Filedata', // for the $_POST var name.
				'height': '120', // not image height. Height of the drop area?
				'width': 'auto',
				'queueSizeLimit': 1,
				'fileType': [mimetype],
				'removeCompleted': true,
				'queueID': 'mainimagequeue'+sequence,
				'itemTemplate' : '<p class="uploadifive-queue-item bg-success">Currently Uploading <span class="filename"></span> <span class="close"></span>:</p>',
				'formData': {'homeid':window.idr, 'idr':window.idr, 'filename': filename, 'minwidth':width, 'minheight':height, 'destinationfolder': window.destinationfolder},

				'onSelect': function(queue) {

				},

				'onAddQueueItem' : function(file) {
					console.log('uploading file check');

					$('#mainimageprogressbar'+sequence).css('width', '0%').attr('aria-valuenow', 0);
					var file_name = file.name;
					var file_ext = file_name.substring(file_name.lastIndexOf('.')+1,file_name.length); // Extract EXT main_detail.jpg rejects .jpeg
					file_ext = file_ext.toLowerCase();
					console.log('checking ext: '+file_ext);
					if(file_ext=='jpg' || file_ext=='jpeg' || file_ext=='png'  || file_ext=='gif') {
						console.log('Valid file extension.');
					} else {
						$('#mainimageinput'+sequence).uploadifive('cancel', file); // cancel current upload,
						// $('#mainimageinput".$suffix."').uploadifive('clearQueue'); // clear the queue!
						$('#filetype_'+ext).modal('show'); // we have filetype_jpg, filetype_png etc. set up..
					}
				},

				'onProgress': function (file, e) {
					var percentage = (e.loaded/e.total)*100;

					$('#mainimageprogressbar'+sequence).css('width', percentage+'%').attr('aria-valuenow', percentage);

				},

				'onCancel': function() {
					$('#mainimageprogressbar'+sequence).css('width', '0%').attr('aria-valuenow', 0);
				},

				'onError'      : function(errorType) {
					console.log(errorType);
				},

				'onUploadComplete': function (file, data) {
					console.log(data);
					$('#mainimageprogressbar'+sequence).css('width', '100%').attr('aria-valuenow', 100).delay(1000).css('width', '0%').attr('aria-valuenow', 0);
					refreshimage('current_main_image'+sequence, data, sequence);

					$('#mainimagecrop'+sequence).Jcrop({
						onSelect: function(c) { showCoords(c, sequence)},
						minSize: [width*0.2,height*0.2],
						aspectRatio: width/height,
						setSelect: [0,0,width,height],
						bgColor: 'transparent',
						bgFade: true,

					});

					$('#maincrop'+sequence).prop('disabled', false);
				},
			});
		}

		// the sequences found on each .mainimageinput has other supplementary DIVs that come along.
		// no need to invoke another set of $('.[class]').each(function(){}); to initiate..

		$('#uploadifive-mainimageinput'+sequence).bind('dragover', function(){
			$(this).addClass('dragover');
		});
		$('#uploadifive-mainimageinput'+sequence).bind('dragleave', function(){
			$(this).removeClass('dragover');
		});
		$('#uploadifive-mainimageinput'+sequence).bind('drop', function(){
			$(this).removeClass('dragover');
		});


		$('#maincrop'+sequence).click(function () {
			// process the width/height based on dimensions!

			$(this).prop('disabled', true);
			$(this).html('Cropping...');

			console.log('O Width: '+ window.img_original_width[sequence]); // refreshimage() in basics.js sets this var after upload.
			console.log('O Height: '+ window.img_original_height[sequence]);

			var img_visible_width = $('#current_main_image'+sequence+' img').width();
			var img_visible_height = $('#current_main_image'+sequence+' img').height();

			console.log('Vis Width: '+img_visible_width);
			console.log('Vis Width: '+img_visible_height);

			var shrink = window.img_original_width[sequence]/img_visible_width;
			if(shrink<1) shrink = 1;

			var xpoint = Math.floor($('#main'+sequence+'x').val()*shrink); // round down so we don't lose pixels.
			var ypoint = Math.floor($('#main'+sequence+'y').val()*shrink); // round down so we don't lose pixels.

			// container width of visible width/height of images.. col-12 caps out, so larger images will have shrunk.
			var cwidth = Math.floor($('#main'+sequence+'w').val()*shrink);
			var cheight = Math.floor($('#main'+sequence+'h').val()*shrink);

			console.log('shrink ratio is '+shrink);

			console.log('x point went from '+$('#main'+sequence+'x').val()+' to '+xpoint);
			console.log('y point went from '+$('#main'+sequence+'y').val()+' to '+ypoint);
			console.log('width went from '+$('#main'+sequence+'w').val()+' to '+cwidth);
			console.log('height went from '+$('#main'+sequence+'h').val()+' to '+cheight);

			$.post('ajax_cropimage.php', { x: xpoint, y: ypoint, w:cwidth, h:cheight, object:window.destinationfolder, idr:window.idr, type:window.destinationfolder, folder:'../'+window.destinationfolder+'/'+window.idr, twidth:width, theight:height,filename:filename },
				function(data){
					$('#maincrop'+sequence).html('Crop To Selection');
					refreshimage('current_main_image'+sequence, data, sequence);
				}
			);

		});
	});


	$('.removemainimage').each(function() {
		$(this).click(function(){
			// straight forward.. removes the currently attached main image from S3, then empties the HTML preview.
			var sequence = $(this).attr('rel');
			var removeresult = remove_s3_file(window.destinationfolder, window.idr, 'mainphoto', sequence);

			if(removeresult == true) {
				$('#mainimagemessage'+sequence).html('Main Image '+sequence+' removal was successful.');
			} else {
				$('#mainimagemessage'+sequence).html('Main Image \'+sequence+\' removal FAILED.');
			}

			$('#current_main_image'+sequence+' img').slideUp(400, function(){
				$(this).remove();

				$('#current_main_image'+sequence).html(''); // empty HTML anyway, in case there's jCrop stuff left over!
			});

			$('#maincrop'+sequence).prop('disabled', true);
		});

	});

	$('.maincrop').each(function(){
		// disable crop by default. Only enable crop on new uploads!
		var sequence = $(this).attr('rel');
		$('#maincrop'+sequence).prop('disabled', true);
	});

});
function update_alt_tags(val, key) {
	$.post(
		'ajax_modify'+window.destinationfolder+'.php',
		{change:'alt_tags', value: val, key: key, idr: window.idr},
		function(data){
			// blink to show success!
			if(data.code=='1') {
				$('#update_alt_tags'+key).removeClass('btn-primary');
				console.log('success');
			} else {
				error_display(data.message, 'Alt Tag update error!');
			}
		}, 'json'
	);
}

function showCoords(c, sequence) {
	console.log(c);
	console.log(sequence);
	$('#main'+sequence+'x').val(c.x);
	$('#main'+sequence+'y').val(c.y);
	$('#main'+sequence+'x2').val(c.x2);
	$('#main'+sequence+'y2').val(c.y2);
	$('#main'+sequence+'w').val(c.w);
	$('#main'+sequence+'h').val(c.h);
}
