$(document).ready(function(){
	$('.change_page_attr').each(function() {
		$(this).change(function(){ // #1 attach function to an event - such as changing field.
			modifypage($(this).data('change'), $(this).attr('rel'), $(this).val() ); // #2 run the element in question that ran. 
		});
	});



	$('.switch_widths').click(function(){
		var cycle = $(this).data('cycle');
		
		switch(cycle) {
			case 1:
				$('.col_left').removeClass('col-sm-6').addClass('col-sm-9');
				$('.col_right').removeClass('col-sm-6').addClass('col-sm-3');
				$(this).data('cycle', 2);
			break;
			
			case 2:
				$('.col_left').removeClass('col-sm-9').addClass('col-sm-3');
				$('.col_right').removeClass('col-sm-3').addClass('col-sm-9');
				$(this).data('cycle', 3);
			break;
			
			case 3:
				$('.col_left').removeClass('col-sm-3').addClass('col-sm-6');
				$('.col_right').removeClass('col-sm-9').addClass('col-sm-6');
				$(this).data('cycle', 1);
			break;
			
			default:
			break;
		}
	});



	$("textarea[name='metatitle']").each(function() {
		var char_num = $(this).parent().find('.metatitle_count');
		var max = $(this).parent().find('.metatitle_count').data("maxchar");
		$(char_num).html($(this).val().length + '/' + max );
		
		if ($(this).val().length > max) {
			$(this).css('background-color', '#FFEAEA');
		} else {
			$(this).css('background-color', 'none');
		}
	})
	$("textarea[name='metatitle']").focus(function(){
		$('.metatitle_count').css('opacity', '0.7');
		var char_num = $(this).parent().find('.metatitle_count');
		var max = $(this).parent().find('.metatitle_count').data("maxchar");
		
		$(char_num).css('opacity', '1');
		$(char_num).html($(this).val().length + '/' + max );
		$(this).on('keyup', function() {
			$(char_num).html($(this).val().length + '/' + max );
			if ($(this).val().length > max) {
				$(this).css('background-color', '#FFEAEA');
			} else {
				$(this).css('background-color', 'none');
			}			
		})
	})

	$("textarea[name='description']").each(function() {
		var char_num = $(this).parent().find('.metadesc_count');
		var max = $(this).parent().find('.metadesc_count').data("maxchar");
		$(char_num).html($(this).val().length + '/' + max );
		
		if ($(this).val().length > max) {
			$(this).css('background-color', '#FFEAEA');
		} else {
			$(this).css('background-color', 'none');
		}
	})
	$("textarea[name='description']").focus(function(){
		$('.metadesc_count').css('opacity', '0.7');
		var char_num = $(this).parent().find('.metadesc_count');
		var max = $(this).parent().find('.metadesc_count').data("maxchar");
		
		$(char_num).css('opacity', '1');
		$(char_num).html($(this).val().length + '/' + max );
		$(this).on('keyup', function() {
			$(char_num).html($(this).val().length + '/' + max );
			if ($(this).val().length > max) {
				$(this).css('background-color', '#FFEAEA');
			} else {
				$(this).css('background-color', 'none');
			}			
		})
	})

});

/*

#1 - attach triggers. so when a field is edited, on blur activity, it should hit the server somehow. Therefore javascript needs to attach a function accordingly. 
#2 - define the function that runs - how it gatehrs data from the field of question, and how to aggregate the necessary data. 
#3 - finally, HIT the .PHP in back-end,
#4 - return confirmation to ensure it worked, otherewise trigger an error so we know what's up. 

Things to note: 
Keep functions simple so that more of the work is done by the HTML markup, and less by javascript. The javascript should be more universal, whereas the HTML DOM structure defines the parameters better. 

*/


function modifypage(change,idr,value){
		var randomnumber=Math.floor(Math.random()*101)
		
		//alert('change type: '+change+', ID of row: '+idr+', value: '+value); // test it first. 
		
		if(change!='' && idr!='' && idr>0) {
			
			$.post("ajax_modifypages.php", { idr: idr, value: value, change: change, rand: randomnumber }, // #3 - in the ajax php page $_REQUEST['idr'] // this will be same as whats in idr

	  		function(data){
		  		
		  		// #4
		  		if(data.code==0) {
					console.log('Error '+data.code+': '+data.message);
					return false;
				} else {
					return true;
				}
	 
			}, 'json');
		}
}
