/*
Filename: setup_search.js
Location: admin/js

Method: JS
Output: JS

Description: JS file specific for the new interactive map/list search module!

Author: Jeff Kee
*/
$(document).ready(function(){
	// load up the office location map for centering!
	
	loadmap();
	
	$('#resetmap').click(function(){
		reset_map();
		return false;
	});
	
	$('input[name^="brixwork_search_price_increments"]').keyup(function(){
		window.setTimeout($(this).val(number_only($(this).val())), 500);
	});	
	
	$('input[name^="brixwork_search_min_price"]').keyup(function(){
		window.setTimeout($(this).val(number_only($(this).val())), 500);
	});	
	
	$('input[name^="brixwork_search_max_price"]').keyup(function(){
		window.setTimeout($(this).val(number_only($(this).val())), 500);
	});
	
	$('input[name^="brixwork_search_prices"]').keyup(function(){
		window.setTimeout($(this).val(number_only($(this).val())), 500);
	});
});

var latlng;
var geocoder;
var map;

function loadmap() {
	geocoder = new google.maps.Geocoder();
	
	var office_lat = $('#office_lat').val()*1;
	var office_long = $('#office_long').val()*1;
	
	var mapsearch_lat = $('input[name^="mapsearch_lat"]').val()*1;
	var mapsearch_long = $('input[name^="mapsearch_long"]').val()*1;
	
	if(mapsearch_lat!='' && mapsearch_long!='') {
		latlng = new google.maps.LatLng(mapsearch_lat, mapsearch_long);
	} else if(office_lat!='' && office_long!='') {
		latlng = new google.maps.LatLng(office_lat, office_long);
	} else {
		latlng = new google.maps.LatLng(49.2986563,-123.0815964);
	}
	var myOptions = {
		zoom: 12,
		center: latlng,
		scrollwheel: false,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		streetViewControl:true
	};
	map = new google.maps.Map(document.getElementById('listingmap'), myOptions);
	google.maps.event.addListener(map, 'dragend', function() {get_coordinates(); } );
	google.maps.event.addListener(map, 'zoom_changed', function() {get_coordinates(); } );
}


	  
function reset_map() {
	map.setCenter(latlng);
	map.setZoom(12);
	get_coordinates();
}

function get_coordinates() {
	var currentlocation = map.getCenter();
	console.log(currentlocation.lat()+', '+currentlocation.lng());
	$('input[name^="mapsearch_lat"]').val(currentlocation.lat());
	$('input[name^="mapsearch_long"]').val(currentlocation.lng());
}
