<?php
/**
 * Filename: links.php
 * Description: Lists all resource categories & links via AJAX.
 *
 * Accessibility: Manager, Admin and Content Manager has access.
 */
include 'start.php';
redirect_invalid_user(USER_LOGIN_AGENT, true); // Agent users do not have access to this page.

$scriptinclude = 'links.js';
$destinationfolder = 'resources'; // although the primary query is through the resourcecategories table, the resources is the money table anyway.
$destinationtable = 'resources';

include 'header.php';
// header_html is separated from header.php on purpose.
include 'includes/header_html.php';
?>
<div id="listings_gallery_intro" class="brixwork_admin_container title">
    <h1 id="admin_page__title">Manage Links & Resources</h1>

    <div class="col-md-12 mt-5" id="linkslist">
        <?php // POPULATE AREA VIA AJAX ?>
    </div>

    <div class="mt-4">
        <a class="btn btn-admin" id="add_new_category_button">Add new category</a>
    </div>
</div>

<?php
include 'footer.php';


// EDIT EXISTING CATEGORY NAME MODAL
brixwork_modal_html(array(
    'header_content' => 'Edit Category',
    'body_content' => "
        <label class='control-label orange'>Enter new name for category</label>
        <input type='text' class='form-control mb-4' id='mod_category_name' name='mod_category_name' value='' />",
    'footer_content' => "
        <button type='button' class='btn btn-admin px-4' data-bs-dismiss='modal'>Cancel</button>
        <button type='button' class='btn btn-admin light_blue px-4 mod_category__save' data-bs-dismiss='modal'>Save</button>",
    'id' => 'mod_category',
));


// ADD NEW CATEGORY MODAL
brixwork_modal_html(array(
    'header_content' => 'Add New Category',
    'body_content' => "
        <label class='control-label orange'>Enter name for the new category</label>
        <input type='text' class='form-control mb-4' id='category_name' name='category_name' value='' /> ",
    'footer_content' => "
        <button type='button' class='btn btn-admin px-4' data-bs-dismiss='modal'>Cancel</button>
        <button type='button' class='btn btn-admin light_blue px-4 mod_category__add' data-bs-dismiss='modal'>Add</button>",
    'id' => 'add_category',
));


// DELETE CATEGORY MODAL
brixwork_modal_html(array(
    'header_content' => 'Delete Category',
    'body_content' => "<p>Auto Generated through JS</p>",
    'footer_content' => "
        <button type='button' class='btn btn-admin px-4' data-bs-dismiss='modal'>Cancel</button>
        <button type='button' class='btn btn-admin light_blue px-4 mod_category__delete' data-bs-dismiss='modal'>Delete</button>",
    'id' => 'delete_category',
));


// DELETE RESOURCE MODAL
brixwork_modal_html(array(
    'header_content' => 'Delete Resource',
    'body_content' => "<p>Auto Generated through JS</p>",
    'footer_content' => "
        <button type='button' class='btn btn-admin px-4' data-bs-dismiss='modal'>Cancel</button>
        <button type='button' class='btn btn-admin light_blue px-4 mod_resource__delete' data-bs-dismiss='modal'>Delete</button>",
    'id' => 'delete_resource',
));