<?
/*
Filename: loadhomes.php
Location: /admin

Method: Direct
Output: Direct

Description: Allow mass-adding of homes all in one go. 

Author: Jeff Kee
*/
include_once 'start.php';

ob_start();

$scriptinclude = 'resizephotos.js';

$destinationfolder = $_REQUEST['folder'];
$destinationtable = $_REQUEST['folder'];

// if either of the above are blank, it means we have not been given anything to execute.
// user must first choose which objects to re-size.

include 'header.php';

// this part validates whether the user is logged in as a administrator or not
?>
<div class="container">
	<div class="row">
		<div class="col-md-12">
			<h2>Mass Resize Gallery Photos</h2>
		</div>
	</div>
</div>

<?
if($destinationfolder!='') {
	// process the entries.
	?>
	<div class="container">
		<div class="row">
			<div class="col-sm-12">
				<h4>Re-Sizing All Photos for <?=$destinationfolder?></h4>
				<input type="hidden" id="folder" value="<?=$destinationfolder?>" />
			</div>
		</div>
		<?
		switch ($_REQUEST['folder']) {
			case 'homes':
				$query = array(
					'source'=>0
				);
				$objects = get_properties('', $query, 'ord', 'asc', 10000, '', false, false);
				break;

			case 'buildings':
				$query = array(
					'feature'=>0
				);
				$objects = get_buildings( $query, 'ord', 'asc', 10000, '', false, false);
				break;

			case 'pages':
				// this is the only case we dont' use the brixwork_get_pages function etc.,
				// just do a SQL for this, no big deal.
				$sql = "SELECT id, title FROM `pages`";
				$result = $mysqli->query($sql);
				while($array = $result->fetch_assoc()) {
					$objects[] = $array['id'];
				}

				break;

			case 'agents':
				$objects = list_agents($query, '', '', 10000, '', false, false);
				break;
		}


		foreach($objects as $objectcount => $object) {
			echo '<input type="hidden" name="objectid" class="objectids" value="'.$object.'">';

		}
		?>

		<div class="row">
			<div class="col-sm-12 well" id="resize_output">
				<?
				echo count($objects)." ".$destinationfolder." returned, intitializing resize: <br />\r\n";
				?>
			</div>
		</div>

	</div>
	<?
} else {
?>
<form method="post" role="form" id="resizephotos_form" class="form-inline" enctype="multipart/form-data" action="<?=$_SERVER['PHP_SELF'];?>">
	<div class="container">
		<div class="row">
			<div class="col-sm-6 form-group">
				<lable for="folder">Object to Re-size</lable>:<br />
				<?
				$objecttypes = array(
					'homes'=>'Homes/Listings',
					'buildings'=>'Buildings/Presales',
					'pages'=>'Pages/Content',
					'agents'=>'Agents/Realtors'
				);

				foreach ($objecttypes as $objectkey => $objectdisplay) {
					?>
					<div class="radio-inline">
						<label><input type="radio" name="folder" class="resize_type_radio" autocomplete="off" value="<?=$objectkey?>" data-displaytext="<?=$objectdisplay?>"><?=$objectdisplay?></label>
					</div>
					<?
				}
				?>
			</div>

			<div class="col-sm-4 form-group" id="confirm_container">
				<lable for="confirm">Re-Type To Confirm</lable>:<br />
				<input type="text" value="Re-type the value" name="confirm" class="form-control" id="confirm" autocomplete="off">
			</div>

			<div class="col-sm-2 form-group">
				<input type="submit" name="submit" value="Resize Now!" class="btn btn-lg btn-success" />
			</div>
		</div>
		<div class="row">
			<div class="col-sm-6">
				<div class="alert alert-warning">
					<strong>Careful!</strong> Depending on how many gallery photos the website has, this can take a while, and is only necessary for upgrading templates (one-time) or re-setting for speed/load issues.
				</div>
			</div>
		</div>
	</div>
</form>
<?
} // end of if-else that checks for form submission.


include 'footer.php';
?>