<?php
/**
 * Filename: resources_mod.php
 * Description: Edit each resource data.
 *
 * Accessibility: Manager, Admin and Content Manager has access.
 */
include 'start.php';
redirect_invalid_user(USER_LOGIN_AGENT, true); // Agent users do not have access to this page.

$destinationtable = 'resources';
$destinationfolder = 'resources';

// pretty much the "parent id"
$category_id = $_GET['category'];
$category_title = gettablefield('resourcecategories', 'title', $category_id);

// TODO: Add ?version='.$brixwork_version to js. AND minify!
//$scriptinclude = array('resources_mod.js', 'aws-sdk-2.40.0.min.js', 'brixwork_images.source.js', 'brixwork_attach.source.js');
$scriptinclude = array('resources_mod.js');


include "header.php";

$preset_object_type = "resources";                          // essential variable
include "includes/object_mod_tabs/object_mod__prep.php";    // essential file inclusion


$error = '';
// SUBMIT BEHAVIOR
if($_POST) {
    $current_mode   = $_POST['mode'];           // either `new` or `modify`.
    $idr            = $_POST['idr'] ?: false;   // could be empty if `new`.
    $allow_submit   = true;                     // verify $_POST data and if not good, turn this variable to false and print error.


    if ($allow_submit) {
        $update_id = form_to_table($destinationtable, $_POST, $_POST['idr']);

        if (is_numeric($update_id)) {

            $post_title         = $_POST['title'] ?: $_POST['contact'];
            $link_id_display    = login_level_check(1) ? '(ID: '.$update_id.')' : '';
            $status             = ($current_mode == 'new' && $idr === false) ? 'added' : 'modified';
            $_SESSION['success-message'] = "<p><b>Success!</b> The resource data has been $status for <span style='text-decoration: underline'>$post_title $link_id_display</span>.</p>";

            // redirect to modify form, which will recreate the object.
            header('Location:'.$settings['sitepath'].ltrim($_SERVER['PHP_SELF'], '/').'?idr='.$update_id);
            exit();

        } else {
            // updated failed ... create error message. stay on the same page
            $error = '<b>Error</b> There was an error while attempting to '.($_GET['mode']=='modify' ? 'update' : 'create').' new resource. Error: <i>'.$update_id.'</i>. Please contact our support desk with this message.';
        }
    } else {
        $error = "<p><b>Warning!</b> Invalid value passed. Please verify your input or contact Brixwork Support.</p>";
    }
// end of if-else that checks if data $_POST has been submitted already.
}

// header_html is separated from header.php on purpose.
include 'includes/header_html.php';
?>
<form method="post" role="form" id="resources_mod_form" class="brixwork_admin_container mod_form" enctype="multipart/form-data" action="<?=$_SERVER['PHP_SELF']?>?mode=modify">
    <h1 id="admin_mod__title">
        <?php if($_GET['mode']=='new') {echo 'Adding A New Resource Under '.$category_title; } else {echo 'Editing '.$link->title;} ?>
    </h1>

    <?php
    // SUCCESS OR ERROR MESSAGE ON FORM SUBMIT.
    session_alert_display('success-message');

    if ($error)
        echo brixwork_alert($error, 'error');

    // BOOTSTRAP 5 TABS - Command + F to find HTML content for each tab
    // $nav_tab_array = is_object($link) ? array('Basic Info', 'Attachments', 'Lead Images') : array('Basic Info');
    $nav_tab_array = array('Basic Info');
    brixwork_object_tabs('resource', $nav_tab_array);
    ?>

    <?php // ALL CORRESPONDING TAB CONTENTS ?>
    <div class="manage_object_tab_content tab-content">
        <?php // BASIC INFO CONTENT ?>
        <div class="manage_listing_each_tab tab-pane fade show active" id="basic-info-tab" role="tabpanel" aria-labelledby="Basic-Info" tabindex="0">
            <?php include "includes/object_mod_tabs/resources_mod__basic_info.php"; ?>
        </div>

        <?php // ATTACHMENTS TAB CONTENT ... images and attachments need "modified_date" column in the database... resources don't use attachemnts/images anyway so let's just disable it now.
//        if (is_object($link)) { ?>
<!--            <div class="manage_listing_each_tab tab-pane fade" id="attachments-tab" role="tabpanel" aria-labelledby="Attachments" tabindex="0">-->
<!--                --><?php //include "includes/object_mod_tabs/object_mod__attach.php"; ?>
<!--            </div>-->
<!---->
<!--            --><?php //// PHOTOS TAB CONTENT ?>
<!--            <div class="manage_listing_each_tab tab-pane fade" id="lead-images-tab" role="tabpanel" aria-labelledby="Lead-Images" tabindex="0">-->
<!--                --><?php //include "includes/object_mod_tabs/object_mod__photos.php"; ?>
<!--            </div>-->
<!--        --><?php
//        } ?>
    </div>

    <div id="submit_button_group" class="">
        <?php // HIDDEN INPUT TO BE USED IN $_POST
        if (is_object($link)) {
            $idr_val = $link->id;
            $mode_val = 'modify';
        } else {
            $idr_val = "";
            $mode_val = 'new';
        }
        echo "<input type='hidden' name='idr' id='idr' value='$idr_val' />";
        echo "<input type='hidden' name='mode' value='$mode_val' />";
        ?>
        <input type="submit" name="submit" id="pagesubmit" class="btn btn-admin" value="Save" />
        <a class="btn btn-admin light_blue" href="links.php">Back</a>
    </div>
</form>

<?php
include 'footer.php';