<?php
/*
Filename: settings.php
Location: /Volumes/Macintosh HD/Users/jeffkee/Documents/Work Docs/Brixwork/Brixwork-for-Realtors/dev/admin

Method: Include
Output: Include

Description: Loads up the settings table and converts to $settings variable for usage thorughout the site.	

Author: Jeff Kee
*/
// settings retrieval package
$start_time = time();

if(isset($wpdb) && is_object($wpdb) && !is_object($mysqli)) {
	include $_SERVER['DOCUMENT_ROOT'].'/includes/common.php';
	// if this is called into Wordpress, the $mysqli var is NOT set, so we want to redeclare. $wpdb object only contains wordpress tables...
}

$sql = "SELECT `name`, `value` FROM settings";
$result = $mysqli->query($sql);
while($array = $result->fetch_assoc()) {

	if(unserialize($array['value'])) {
		$settings[$array['name']] = unserialize($array['value']);
	} else {
		$settings[$array['name']] = $array['value'];
	}
}

$encoding = (array_key_exists('encoding', $settings) && $settings['encoding']!='' ? $settings['encoding']: 'utf-8');
$timezone = (array_key_exists('timezone', $settings) && $settings['timezone']!='' ? $settings['timezone'] : 'America/Los_Angeles');
date_default_timezone_set($timezone); // default timezone is US LA.

if(!array_key_exists('rootpath', $settings) || (array_key_exists('rootpath', $settings) && $settings['rootpath']=='')) {
	$settings['rootpath'] = '/'; // regular site, starting at public_html/[webroot]
}

if(!array_key_exists('cache_duration', $settings) || $settings['cache_duration']=='') {
	if($settings['mls_integrated'] == 1){
		$seconds_to_cache = 1800; // 30min.. so listings auto populate.
	}else{
		$seconds_to_cache = (3600 * 4); // 4 hr.. so listings auto populate.
	}
}


$sql = "SELECT `name`, `value` FROM `custom_settings`";
if ($result = $mysqli->query($sql)) {
	$settings['custom_settings'] = array();
	while($array = $result->fetch_assoc()) {
		if(unserialize($array['value'])) {
			$settings['custom_settings'][$array['name']] = unserialize($array['value']);
		} else {
			$settings['custom_settings'][$array['name']] = $array['value'];
		}
	}
}


// JUST in case basics.php wasn't called in yet.
if(!isset($local)) {
	// easy indicator to see if basics.php was called in or not yet.
	require_once $_SERVER['DOCUMENT_ROOT'].$settings['rootpath'].'admin/basics.php';
}


if($settings['use_template']==1) {
	if(array_key_exists('template', $_REQUEST) && $_REQUEST['template']!='') {
		$settings['templatefolder'] = '/'.$_REQUEST['template'];
	} else {
		$settings['templatefolder'] = '/main';
	}
	
	if(!is_dir($_SERVER['DOCUMENT_ROOT'].'/templates'.$settings['templatefolder'])) {
		die("Invalid template folder - ".$_SERVER['DOCUMENT_ROOT'].'/templates'.$settings['templatefolder']);
		// folder not found
	}
	$settings['includepath'] = $_SERVER['DOCUMENT_ROOT'].'/templates'.$settings['templatefolder'].'/';
	$settings['templatepath'] = $settings['sitepath'].'templates'.$settings['templatefolder'].'/';
}

if($settings['mls_import_url']=='' || !isset($settings['mls_import_url']) || $settings['mls_import_url']=='https://demo.brixwork.com/master/') {
	$settings['mls_import_url'] = 'https://vancouver.brixwork.com/';
	// default to Vancouver.
	// if MLS import is set to OFF, this won't run anyway, so doesn't really matter.
}

if(function_exists("get_host")) {
	// on WP calls often settings.php was called before functions.php so this wont work.
	// but we never need this on WP side so whatever as this is noly useful for MLS photo imports.
	// The image URLs etc. are all cloudfronted anyway, so even if we laoded listings in the Wordpress blog.. don't need the import URL.
	$settings['mls_import_url_host'] = get_host($settings['mls_import_url']);
}
// filter out just vancouver.brixwork.com without the http or https for other functions.

// default building status display settings
if(!array_key_exists('building_status_display', $settings)) {
	$settings['building_status_display'] = array(
		'Active',
		'Coming Soon',
		'VIP Preview',
		'Now Selling',
		'Sold Out'
	);
}

// DEFAULT BUILDING STATUS DISPLAY SETTINGS
if(!array_key_exists('building_land_title_display', $settings)) {
    $settings['building_land_title_display'] = array (
        false,
        'Freehold',
        'Leasehold'
    );
}

// default building types to distinguish which type IDs are buildings (condo, townhome, penthouse, loft etc.)
if(!array_key_exists('building_type', $settings)) {
	$settings['building_type'] = array(
		2, 
		3,
		6,
		11
	); // these are REBGV defaults.
}

$settings['condo_subtypes'] = array(
	'vancouver.brixwork.com'=>array(
		2=>array(6,11) // 2 is condo, 6 & 11 are penthouse & loft respectively.
	)
);

// default commercial property types. These are defaults from the REBGV. Each site, if not like REBGV should have the array set through the setup.php tab. 
if(!array_key_exists('type_commercial', $settings)) {
	// here, we start at ID 50.. commercial is all ID 50 and above. 
	$settings['type_commercial'] = array(
		50 => 'Commercial',
		51 => 'Business',
		52 => 'Business with Property',
		53 => 'Office',
		54 => 'Retail',
		55 => 'Industrial',
		56 => 'Land Commercial',
		57 => 'Multi-Family Commercial ',
		58 => 'Agri-Business '
	);
} else {
	// if set in databsae, it will be starting at 0. So let's up-convert. 
	foreach($settings['type_commercial'] as $i=>$v) {
		$settings['type_commercial'][$i+50] = $v; // convert to 50, 51 etc. 
		unset($settings['type_commercial'][$i]); // unset the 0, 1, 2 etc. 
	}
}

// this is really LOCATION FEATURES... shit name.
// Do not confuse with custom features on `homefeatures` table from the 2020-12 upgrade.
if(!array_key_exists('home_features', $settings)) {
	$settings['home_features'] = array(
		'Waterfront' => 'waterfront',
		'Ski Hill' => 'skihill',
		'On or Near Golf Course' => 'golfcourse',
		'Near Marina' => 'marina',
		'Gated Community' => 'gatedcomm',
		// 'Has Pool' => 'pool',
		'Retirement Community' => 'retirementcomm'
	); // on the search form, these are passed as true/false flag (1 or 0) then get_properties() will decipher.
}

// edmonton, remove marina and retirement.. no such thing there.
if(strpos($settings['mls_import_url'], 'edmonton')!==false ) {
	unset($settings['home_features']['Near Marina']);
	unset($settings['home_features']['Retirement Community']);
}

if(strpos($settings['mls_import_url'], 'toronto')!==false ) {
	unset($settings['home_features']['Gated Community']);
	unset($settings['home_features']['Retirement Community']);
}

//if($settings['commercial_enabled']==1) {
//	// commercial type enabled. let's add these two together!
///*
//	foreach($settings['type_commercial'] as $i=>$v) {
//		$settings['type'][$i] = $v; // push in the type_commercial thorugh to the type arraay to preserve IDs.
//	}
//*/
//	$settings['type_residential'] = $settings['type']; // preserve just residential types for usage in settings tab etc.
//	$settings['type'] = $settings['type']+$settings['type_commercial'];
//}


/**
 * Originally had $settings['residential_disabled'] == 1 to disable residential
 * This caused confusion so created $settings['residential_enabled'] column to align data structure with rest of the settings
 *
 * The function below just takes care of the backward compatibility
 */
if (isset($settings['residential_enabled'])) {
    // the field exists .... meaning that currently on 2023 upgrade
    $settings['residential_disabled'] = ($settings['residential_enabled'] == 0 ? 1 : 0);
}

/*
 * System wide defaults and street type vars etc.
 * */
$GLOBALS[BRIX_FORWARD_DESTINATION_URL] = ($settings['forward_destination_url']!='' ? $settings['forward_destination_url'] : 'https://www.brixwork.com/realtors/');

$settings['metatitle_max_length'] = 55;
$settings['metadescription_max_length'] = 157;
$settings['url_max_length'] = 64;
if(isset($settings['office_city']) && $settings['office_city']!='' && $settings['address2']=='' && strpos(strtolower($settings['address2']), strtolower($settings['office_city']))===false && strpos($_SERVER["SCRIPT_FILENAME"], 'setup.php')===false) {
	// override address2 if the office_city is filled, and also address 2 does not repeat the city... this means the new variables as of version 4.0 have kicked in. 
	$settings['address2'] = $settings['office_city'].', '.$settings['province'];
}

$settings['baselatlong'] = ($settings['baselatlong']!='' ? $settings['baselatlong'] : '49.2832693,-123.1087835');
// default base lat lng at Brixwokr office so none of the maps choke. We always need some lat/lng to load.

$settings['streettypes'] = array (
	'Acres' => array (
		0 => 'ac',
		1 => 'acres',
		2 => 'acrs'
	),
	'Alley' => array (
		0 => 'al',
		1 => 'alley',
		2 => 'aly'
	),
	'Avenue' => array (
		0 => 'ave',
		1 => 'avenue',
		2 => 'av'
	),
	'Bay' => array (
		0 => 'bay',
		1 => 'by'
	),
	'Beach' => array (
		0 => 'be',
		1 => 'beach',
		2 => 'bch'
	),
	'Bend' => array (
		0 => 'bn',
		1 => 'bend',
		2 => 'bnd'
	),
	'Boulevard' => array (
		0 => 'boulevard',
		1 => 'blvd',
		2 => 'bvd'
	),
	'Bypass' => array (
		0 => 'bp',
		1 => 'bypass',
		2 => 'byps'
	),
	'Cape' => array (
		0 => 'ca',
		1 => 'cape',
		2 => 'cpe'
	),
	'Centre' => array (
		0 => 'centre',
		1 => 'cntr',
		2 => 'ctr',
		3 => 'ce',
		4 => 'cent'
	),
	'Circle' => array (
		0 => 'cl',
		2 => 'circle'
	),
	'Close' => array (
		0 => 'close',
		1 => 'cs',
	),
	'Creek' => array (
		0 => 'creek',
		1 => 'ck',
	),
	'Common' => array (
		0 => 'cm',
		1 => 'common',
		2 => 'comm'
	),
	'Corners' => array (
		0 => 'corners',
		1 => 'crnrs'
	),
	'Court' => array (
		0 => 'court',
		1 => 'ct',
		2 => 'crt',
	),
	'Cove' => array (
		0 => 'cv',
		1 => 'cove',
		2 => 'cov'
	),
	'Crossing' => array (
		0 => 'cg',
		1 => 'crossing',
		2 => 'cross'
	),
	'Crescent' => array (
		0 => 'crescent',
		1 => 'cres',
		2 => 'cr'
	),
	'Detour' => array (
		0 => 'detour',
		1 => 'dtr'
	),
	'Diversion' => array (
		0 => 'diversion',
		1 => 'di'
	),
	'Dyne' => array (
		0 => 'dyne',
		1 => 'dn'
	),
	'Esplanade' => array (
		0 => 'esplanade',
		1 => 'espl',
		2 => 'ep'
	),
	'Estates' => array (
		0 => 'estates',
		1 => 'estate'
	),
	'Freeway' => array (
		0 => 'freeway',
		1 => 'fwy',
		2 => 'fw',
	),
	'Gate' => array (
		0 => 'gate',
		1 => 'gt'
	),
	'Garden' => array (
		0 => 'garden',
		1 => 'gdn',
		2 => 'gn',
	),
	'Glen' => array (
		0 => 'glen',
		1 => 'gl',
		2 => 'gln',
	),
	'Grove' => array (
		0 => 'grove',
		1 => 'gr',
		2 => 'grv',
	),
	'Drive' => array (
		0 => 'drive',
		1 => 'drv',
		2 => 'dr',
	),
	
	'Harbour' => array (
		0 => 'harbour',
		1 => 'harbr',
	),
	'Haven' => array (
		0 => 'haven',
		1 => 'ha',
		2 => 'hvn',
	),
	'Heights' => array (
		0 => 'heights',
		1 => 'hts',
		2 => 'ht'
	),
	'Highlands' => array (
		0 => 'highlands',
		1 => 'hghlds',
	),
	'Highway' => array (
		0 => 'highway',
		1 => 'hwy',
		2 => 'highwy',
		3 => 'hy'
	),
	'Hill' => array (
		0 => 'hill',
		1 => 'hl',
		2 => 'hll',
	),
	'Hollow' => array (
		0 => 'hollow',
		1 => 'ho',
		2 => 'hlw'
	),
	'Heath' => array (
		0 => 'heath',
		1 => 'he',
		2 => 'hth'
	),
	'Island' => array (
		0 => 'island',
		1 => 'is',
		2 => 'isl'
	),
	'Impasse' => array (
		0 => 'impasse',
		1 => 'imp',
	),
	'Knoll' => array (
		0 => 'knoll',
		1 => 'kn',
		2 => 'knl'
	),
	'Lake' => array (
		0 => 'lake',
		1 => 'lk',
		2 => 'knl'
	),
	'Landing' => array (
		0 => 'landing',
		1 => 'la'
	),
	'Lane' => array (
		0 => 'lane',
		1 => 'lne',
		2 => 'ln',
	),
	'Link' => array (
		0 => 'link',
		1 => 'li',
		2 => 'lnk',
	),
	'Lookout' => array (
		0 => 'lookout',
		1 => 'lkout',
		2 => 'lo'
	),
	'Loop' => array (
		0 => 'loop',
		1 => 'lp',
	),
	'Mall' => array (
		0 => 'mall',
		1 => 'ma',
		1 => 'mll',
	),
	'Manor' => array (
		0 => 'manor',
		1 => 'mr',
		1 => 'mnr',
	),
	'Meadows' => array (
		0 => 'meadows',
		1 => 'md',
		1 => 'mdws',
	),
	'Mews' => array (
		0 => 'mews',
		1 => 'me'
	),
	'Mount' => array (
		0 => 'mount',
		1 => 'mt'
	),
	'Parade' => array (
		0 => 'parade',
		1 => 'pde',
		2 => 'pa',
	),
	'Park' => array (
		0 => 'park',
		1 => 'prk',
		2 => 'pk',
	),
	'Parkway' => array (
		0 => 'parkway',
		1 => 'pkwy',
		2 => 'pw',
	),
	'Pass' => array (
		0 => 'pass',
		1 => 'ps',
		2 => 'pss',
	),
	'Passage' => array (
		0 => 'passage',
		1 => 'pg',
		2 => 'psg',
	),
	'Path' => array (
		0 => 'path',
		1 => 'ph'
	),
	'Peak' => array (
		0 => 'peak',
		1 => 'pe'
	),
	'Place' => array (
		0 => 'place',
		1 => 'pl',
		2 => 'plc'
	),
	'Plaza' => array (
		0 => 'plaza',
		1 => 'pz',
		2 => 'plz'
	),
	'Point' => array (
		0 => 'point',
		1 => 'pt',
		2 => 'pnt'
	),
	'Porter' => array(
		'porter',
		'ptr',
		'prtr'
	),
	'Pond' => array (
		0 => 'pond',
		1 => 'pd',
		2 => 'pnd'
	),
	'Promenade' => array (
		0 => 'promenade',
		1 => 'pr'
	),
	'Quarry' => array (
		0 => 'quarry',
		1 => 'qa',
	),
	'Quay' => array (
		0 => 'quay',
		1 => 'qy',
	),
	'Ranch' => array (
		0 => 'ranch',
		1 => 'ra',
	),
	'Range' => array (
		0 => 'range',
		1 => 'rng',
	),
	'Ridge' => array (
		0 => 'ridge',
		1 => 'rg',
	),
	'River' => array (
		0 => 'river',
		1 => 'rv',
	),
	'Road' => array (
		0 => 'road',
		1 => 'rd',
	),
	'Row' => array (
		0 => 'row',
		1 => 'rw',
	),	
	'Rise' => array (
		0 => 'rise',
		1 => 'rs',
	),	
	'Shores' => array (
		0 => 'shores',
		1 => 'sh'
	),
	'Sideroad' => array(
		0 => 'sideroad',
	),
	'Square' => array (
		0 => 'square',
		1 => 'sq',
	),
	'Street' => array (
		0 => 'street',
		1 => 'str',
		2 => 'st'
	),
	'Summit' => array (
		0 => 'summit',
		1 => 'su',
		2 => 'smt'
	),
	'Terrace' => array (
		0 => 'terrace',
		1 => 'terr',
	),
	'Terrasse' => array (
		0 => 'terrasse',
		1 => 'tsse'
	),
	'Trail' => array (
		0 => 'trail',
		1 => 'tr'
	),
	'Vila' => array (
		0 => 'vila',
		1 => 'va'
	),
	'Villa' => array (
		0 => 'villa',
		1 => 'vl'
	),
	'View' => array (
		0 => 'view',
		1 => 'vw'
	),
	'Village' => array (
		0 => 'village',
		1 => 'vg'
	),
	'Vista' => array (
		0 => 'vista',
		1 => 'vs'
	),
	'Walk' => array (
		0 => 'walk',
		1 => 'wlk',
	),
	'Way' => array (
		0 => 'way',
		1 => 'wy',
	),
	'Wood' => array (
		0 => 'wood',
		1 => 'wd',
	),
	'Wynd' => array (
		0 => 'wynd',
		1 => 'wnd',
	),
);

$street_dir_pairs = array( // just to check if any of the arrays match street type
	'n'=>'north',
	's'=>'south',
	'e'=>'east',
	'w'=>'west',
	'ne'=>'northeast',
	'nw'=>'northwest',
	'se'=>'southeast',
	'sw'=>'southwest',
);

if(!array_key_exists('roomsizetotal', $settings) || $settings['roomsizetotal']=='') {
	$settings['roomsizetotal'] = 20;
}


if($settings['cookie_search_history_max']=='') {
	$settings['cookie_search_history_max'] = 50;
}

if($settings['cookie_listing_history_max']=='') {
	$settings['cookie_listing_history_max'] = 50;
}


// amazon URL default starts with https://s3.ca-central-1.amazonaws.com/
// amazon bucket name default is 'brixwork'
if(!array_key_exists('s3_url', $settings) || $settings['s3_url']=='') {
	$settings['s3_url'] = 'https://s3.ca-central-1.amazonaws.com/';
}

if(!array_key_exists('s3_bucket', $settings) || $settings['s3_bucket']=='') {
	// highly recommended that a bucket name is set, so that a URL change doesn't mean having to change the bucket name theorugh s3. it takes forever!
	$settings['s3_bucket'] = 'brixwork';
}

// putting the bucket as a sub-domain is how amazon returns their results, so have this as a fallback to switch URLs etc. easily. 
// major use, for example, is when the `home` table mls_photo field is set to MLS photo #1 - we replace the return URL that contains the S3 path, adn replace with the Cloudfront URL below. 
$settings['s3_return_url'] = $settings['s3_url'].$settings['s3_bucket'].'/';
// https://s3.ca-central-1.amazonaws.com/brixwork-test/dev.brixwork.com/pages/2/main.jpg?mod=1614459463627 is a pretty common return URL.
$settings['s3_return_url_legacy'] = 'https://'.$settings['s3_bucket'].'.'.parse_url($settings['s3_url'], PHP_URL_HOST).'/';
// https://brixwork-test.s3.ca-central-1.amazonaws.com/dev.brixwork.com/pages/2/main.jpg?mod=1614459463627 also works (when bucket name goes ahead as subdomain)

// does NOT include the distro for demo.brixwork.com, which is stored in master_url for most part.
// these are ONLY the S3 storage routing. Does not include any demo.brixwork.com, or vancouver.brixwork.com style sudomains for MLS sync.
$cloudfront_distros = array(
	// these are S3 buckets for direct retrieval of gallery photos, PDFs for the most part.
	// retsimport works with this too.
	'brixwork-vancouver'=>'d2c1z9m2a98rxn', // even though this says brixwork-vancouver, this holds Edmonton, VIVA and other RETS feed photos.
	'brixwork'=>'dyhx7is8pu014',
	'brixwork-test'=>'d2wi4375u0d0xi',
	'brixwork-crea'=>'d2s5fz8xd3giol'
);

// generate the CF distro URL for all other items such as .jpg galleries, .pdf attachments... all. 
if($cloudfront_distros[$settings['s3_bucket']]!='') {
	$settings['cloudfront_url'] = 'https://'.$cloudfront_distros[$settings['s3_bucket']].'.cloudfront.net/';
} else {
	$settings['cloudfront_url'] = $settings['s3_url'].$settings['s3_bucket'].'/';
}

$settings['google_code_api_url'] = 'https://ajax.googleapis.com/ajax/libs/';

/* map the MLS import URLs to the subdomains - this is NOT for photos feed as they comem from
the RETS main buckets, or often from the CREA or VIVA server directly, but just the /cache/[homeid].txt
 as well as retsexport to quickly get the JSON feed of listings & photo URLs from our S3 => Cloudfront for rapid
MLS updates.

note that VIVA has their own distribution - https://dvvjkgh94f2v6.cloudfront.net/
If you don't find dvvjkgh94f2v6 cloudfront subdomain on our AWS panel, you know why.

*/
$mls_import_cloudfront_distros = array(
	'http://vancouver.brixwork.com/'=>'https://djsq99o3cm7ux.cloudfront.net/',
	'https://vancouver.brixwork.com/'=>'https://djsq99o3cm7ux.cloudfront.net/',

	'http://vancouver2.brixwork.com/'=>'https://di82aruk6oqyg.cloudfront.net/',
	'https://vancouver2.brixwork.com/'=>'https://di82aruk6oqyg.cloudfront.net/',

	'http://toronto.brixwork.com/'=>'https://d1grsy2zvmdfrw.cloudfront.net/',
	'https://toronto.brixwork.com/'=>'https://d1grsy2zvmdfrw.cloudfront.net/',

//	'http://victoria.brixwork.com/'=>'https://d1lsren6625iqu.cloudfront.net/',
//	'https://victoria.brixwork.com/'=>'https://d1lsren6625iqu.cloudfront.net/',
//
//	'http://visland.brixwork.com/'=>'https://d15y4evqsconvk.cloudfront.net/',
//	'https://visland.brixwork.com/'=>'https://d15y4evqsconvk.cloudfront.net/',

	'http://viva.brixwork.com/'=>'https://d3ar1sze35lvh9.cloudfront.net/',
	'https://viva.brixwork.com/'=>'https://d3ar1sze35lvh9.cloudfront.net/',

	'http://edmonton.brixwork.com/'=>'https://dlxyxu369bwf5.cloudfront.net/',
	'https://edmonton.brixwork.com/'=>'https://dlxyxu369bwf5.cloudfront.net/',

	'http://kelowna.brixwork.com/'=>'https://d3bmy3uj8rrb6l.cloudfront.net/',
	'https://kelowna.brixwork.com/'=>'https://d3bmy3uj8rrb6l.cloudfront.net/',

	'http://kamloopsbc.brixwork.com/'=>'https://d2g26ya8qjwia.cloudfront.net/',
	'https://kamloopsbc.brixwork.com/'=>'https://d2g26ya8qjwia.cloudfront.net/',
//   OMREB and SOREB merged to AIR (Kelowna.brixwork.com)
//	'http://penticton.brixwork.com/'=>'https://d2wp14de25lky5.cloudfront.net/',
//	'https://penticton.brixwork.com/'=>'https://d2wp14de25lky5.cloudfront.net/',

	'http://ottawa.brixwork.com/'=>'https://d3gia9z1ki5gsu.cloudfront.net/',
	'https://ottawa.brixwork.com/'=>'https://d3gia9z1ki5gsu.cloudfront.net/',

	'http://tillsonburg.brixwork.com/'=>'https://d3mc63bxfsdg91.cloudfront.net/',
	'https://tillsonburg.brixwork.com/'=>'https://d3mc63bxfsdg91.cloudfront.net/',

	'http://halifax.brixwork.com/'=>'https://dnbe3lfe95f93.cloudfront.net/',
	'https://halifax.brixwork.com/'=>'https://dnbe3lfe95f93.cloudfront.net/'
);

if(!array_key_exists('brixwork_api_url', $settings) || $settings['brixwork_api_url']=='') {
	$settings['brixwork_api_url'] = 'https://clients.brixwork.com/api/';
}

// verify if this current site is one of the MLS hosts!
$settings['mlssite'] = false; // by default, it's not!
if(array_key_exists($settings['sitepath'], $mls_import_cloudfront_distros)) {
	// it meaans this is oneo f those vancouver.brixwork.com, etc. MLS sub sites.
	// https://docs.google.com/presentation/d/1YHtYwWIcT5gZImdmN4UM23jvBSnCmHWUtw9UvAo7GLU/ has details on how this works.
	$settings['mlssite'] = true;
	$settings['mls_import_url'] = false; // disable the potential of running an MLS Sync on a site tha tshould be the source.


	/*
	 * To avoid potential errors, all RETS calls that go out to Reciprocity providers
	 * use fully unique file names such as cron_vancouver.php et.c
	 * They don't always match the subdomain - best to manually map them out to avoid all odds of errors,
	 *
	 * */
	$rets_trigger_php_files = array(
		'http://vancouver.brixwork.com/'=>'cron_vancouver.php',
		'https://vancouver.brixwork.com/'=>'cron_vancouver.php',

		'http://vancouver2.brixwork.com/'=>'cron_vancouver.php',
		'https://vancouver2.brixwork.com/'=>'cron_vancouver.php',

		'http://toronto.brixwork.com/'=>'cron_toronto.php',
		'https://toronto.brixwork.com/'=>'cron_toronto.php',
//
//	'http://victoria.brixwork.com/'=>'https://d1lsren6625iqu.cloudfront.net/',
//	'https://victoria.brixwork.com/'=>'https://d1lsren6625iqu.cloudfront.net/',
//
//	'http://visland.brixwork.com/'=>'https://d15y4evqsconvk.cloudfront.net/',
//	'https://visland.brixwork.com/'=>'https://d15y4evqsconvk.cloudfront.net/',

		'http://viva.brixwork.com/'=>'cron_viva.php',
		'https://viva.brixwork.com/'=>'cron_viva.php',

		'http://edmonton.brixwork.com/'=>'cron_edmonton.php',
		'https://edmonton.brixwork.com/'=>'cron_edmonton.php',

		'http://kelowna.brixwork.com/'=>'cron_kelowna.php',
		'https://kelowna.brixwork.com/'=>'cron_kelowna.php',

		'http://kamloopsbc.brixwork.com/'=>'cron_kamloops.php',
		'https://kamloopsbc.brixwork.com/'=>'cron_kamloops.php',

//   Penticton feed was merged to Kelowna feed as the two MLS boards merged.
//	'http://penticton.brixwork.com/'=>'https://d2wp14de25lky5.cloudfront.net/',
//	'https://penticton.brixwork.com/'=>'https://d2wp14de25lky5.cloudfront.net/',

		'http://ottawa.brixwork.com/'=>'cron_ottawa.php',
		'https://ottawa.brixwork.com/'=>'cron_ottawa.php',

		'http://tillsonburg.brixwork.com/'=>'cron_tillsonburg.php',
		'https://tillsonburg.brixwork.com/'=>'cron_tillsonburg.php',

		'http://halifax.brixwork.com/'=>'cron_halifax.php',
		'https://halifax.brixwork.com/'=>'cron_halifax.php'
	);


	$settings['rets_trigger_php_file'] = $rets_trigger_php_files[$settings['sitepath']]; // map it!
// Mainly used for JSON cache of photo URLs that are stored in vancouver.brixwork/com/admin/api/cache/ etc.

}


if(array_key_exists('debug', $_REQUEST) && $_REQUEST['debug']==1) {
	// instead of running the whole $_REQUEST['debug'] var comparison, just use this universal $debug global going forward.
	define('DEBUG', true);
} else {
	define('DEBUG', false);
}


if(DEBUG===true) {
	echo "MLS Site : ".($settings['mlssite'] ? "Yes" : "No");
	echo "<br />".PHP_EOL;
}

//echo "start debug </br>";

$settings['mls_import_url_cloudfront'] = (isset($settings['mls_import_url']) && $settings['mls_import_url']!='' && $mls_import_cloudfront_distros[$settings['mls_import_url']]!='' ? $mls_import_cloudfront_distros[$settings['mls_import_url']] : (isset($settings['mls_import_url']) && $settings['mls_import_url']!='' ? $settings['mls_import_url'] : '')) ; // map it!
// Mainly used for JSON cache of photo URLs that are stored in vancouver.brixwork/com/admin/api/cache/ etc.

$settings['s3_photodrop_bucket'] = (isset($settings['s3_photodrop_bucket']) && $settings['s3_photodrop_bucket']!='' ? $settings['s3_photodrop_bucket'] : 'brixwork-photodrop');

//check to see if we fail to access cloudfront; if so, default to demo and the s3 bucket.
// at this point, the master_url will already be a cloudfront URL!
$default_masterurl = 'https://demo.brixwork.com/master/';
// if distro fails for the dependency CSS/JS files, this is the origin at brixwork.com

// temporarily override to demo.brixwork.com since cloudfront is DOWN - 2017-11-21
if(array_key_exists('cf_bypass', $_REQUEST)  && $_REQUEST['cf_bypass']==1 && $settings['master_url'] != $default_masterurl) {
	$settings['master_url'] = $default_masterurl;
}

/* GOOGLE ANALYTICS API RELATED */
/*
 * (none): 8 visits
organic: 1 visits
referral: 211 visits
*/

$settings['views_traffic_source'] = array(
	'(none)', // basically means direct? This is the string that Analytics feeds, so let's keep it pure & matched.
	// on our UI display, we can replace ID 0 with "Direct" instead. It's more true to data structures.
	'organic',
	'referral', // use this if the social media source is undefined in the rest of the arrays below.
	'Facebook',
	'YouTube',
	'Instagram',
	'Twitter',
	'Pinterest',
	'TikTok',
	'Quora',
	'Reddit'
);

/* MAILCHIMP RELATED */

// Brixwork list API key we need to enable adding active users to our own list - this is CONSTANT.
$settings['mailchimp_brixwork_api'] = 'cef73cc689d44629279140710fb5f25c-us4'; // NEVER LET API KEYS LEAK!!!
$settings['mailchimp_brixwork_active_clients_list'] = 'c3120ac935';

// Related to the Mailchimp API re-work,https://app.asana.com/0/283822686917686/1204541838853455
// Added new columns to users table: https://app.asana.com/0/283822686917686/1204573119998862
$settings['mailchimp_subscriber_status'] = array(
	0 => false, // unknown, or never subscribed to MC list.
	1 => "subscribed",
	2 => "unsubscribed",
	3 => "cleaned",
	4 => "pending",
	5 => "transactional"
);

// the individual account user's Mailchimp API KEY will be added by the user manually by settings UI.

// New for 2021 - API method is better than SMTP.
// lno6MI3fSlqSiDW52KGwVg is the name of key - and the actual key below.
if(!array_key_exists('sendgrid_api_key', $settings) || $settings['sendgrid_api_key']!='') {
	$settings['sendgrid_api_key'] = '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';
}
// NEVER LET API KEYS LEAK!!!
// additinal settings can be added via the mysql table, or here:
// $settings['valuename'] = 'value';
// $settings['arrayname'] = array('value1', 'value2', 'value3');


/* INSTAGRAM RELATED */
// do we even need this outside of clients.brixwork.com? The API Auth through the FB app is done from clients.brixwork.com, not individual sites.
if(!array_key_exists('instagram_app_client_id', $settings) || $settings['instagram_app_client_id']!='') {
	$settings['instagram_app_client_id'] = '232192128210411';
}

if(!array_key_exists('instagram_app_client_id_secret', $settings) || $settings['instagram_app_client_id_secret']!='') {
	$settings['instagram_app_client_id_secret'] = '1509560fa07620370d74d04bc6d132c3';
}


/* MODAL CONTACT SETTINGS */
/*
 * modal_contact_divid: a:6:{i:0;s:20:"listing_detail_modal";i:1;s:0:"";i:2;s:0:"";i:3;s:0:"";i:4;s:0:"";i:5;s:0:"";}
modal_contact_min_pagetype: a:6:{i:0;s:4:"home";i:1;s:1:"0";i:2;s:1:"0";i:3;s:1:"0";i:4;s:1:"0";i:5;s:1:"0";}
modal_contact_min_pageview: a:6:{i:0;s:1:"3";i:1;s:0:"";i:2;s:0:"";i:3;s:0:"";i:4;s:0:"";i:5;s:0:"";}
modal_contact_min_seconds: a:6:{i:0;s:2:"10";i:1;s:0:"";i:2;s:0:"";i:3;s:0:"";i:4;s:0:"";i:5;s:0:"";}
modal_contact_mobile_trigger: a:6:{i:0;s:1:"0";i:1;s:1:"1";i:2;s:1:"1";i:3;s:1:"1";i:4;s:1:"1";i:5;s:1:"1";}

	we also want an array that looks like:

	$settings['modal_contact_settings'] = array(
		0 => array(
		   modal_contact_divid=>'html_div_id',
				modal_contact_min_pagetype => 'home',
	)
	)

 * */


if(array_key_exists('modal_contact_divid', $settings)) {
	$settings['modal_contact_settings']  = array();
	foreach($settings['modal_contact_divid'] as $modal_contact_count => $divid_value) {
		if($divid_value!='') {
			// each set has a series of settings for a specific modal display and its behaviours, hence multi levels.
			$modal_contact_settings_row = array(
				'modal_contact_divid'=>$divid_value,
				'modal_contact_min_pagetype' => $settings['modal_contact_min_pagetype'][$modal_contact_count],
				'modal_contact_min_pageview' => $settings['modal_contact_min_pageview'][$modal_contact_count],
				'modal_contact_min_seconds' => $settings['modal_contact_min_seconds'][$modal_contact_count],
				'modal_contact_mobile_trigger'=> $settings['modal_contact_mobile_trigger'][$modal_contact_count],
			); // blank array first,

			$settings['modal_contact_settings'][] = $modal_contact_settings_row;
		}
	}
}


/*  Agents and Agent classes related!
(2022-11 by Jeff Kee)

Initially I thought maybe w can run a JOIN query for agents & agent_classes in one, to create a cache
But caching all agents on a site like team 3000 would be a disaster.
Given the agnet info isn't fetched too often on most sites, we'll just run separate queries.
*/

$agents_classes_sql = "SELECT * FROM `agent_classes`";
$agents_classes_result = $mysqli->query($agents_classes_sql);
if($agents_classes_result != false && $agents_classes_result->num_rows>0) {
	// `agent_classes` table is active & being used on this site!
	$settings['agent_classes'] = array();
	while($classes_array = $agents_classes_result->fetch_assoc()) {
		$agent_class = array(); // fresh array each time,
		$agent_class['id'] = $classes_array['id'];
		$agent_class['name'] = $classes_array['name'];
		$agent_class['name2'] = $classes_array['name2'];
		$agent_class['billable'] = $classes_array['billable']== '1';
		$agent_class['publish'] = $classes_array['publish']== '1';
		$settings['agent_classes'][] = $agent_class; // push to compile array.
	}
} else {
	$settings['agent_classes'] = false;
}


/*
 * PAGE DATA CACHE LOAD UPGRADE (2018-04)
 *
 * */


$pages_sql = "SELECT 
	pages.*, 
	hierarchy.parent as `parentid`,
	custom_fields.id AS `custom_field_id`,
	custom_fields.name AS `custom_field_name`,
	custom_fields.value AS `custom_field_value`,
	custom_fields.desc AS `custom_field_desc`
	 FROM `pages` 
	 LEFT JOIN `hierarchy` on pages.id = hierarchy.page
	 LEFT JOIN `custom_fields` ON pages.id = custom_fields.page
	 ORDER BY pages.ord ASC
	 ";

$pages_result = $mysqli->query($pages_sql); // no need to clean up etc... internal query without any vars entered!
$GLOBALS[BRIX_PAGES_QUERY] = 1; // by default, 1 query always!
$brixwork_pages_cache = []; // declare blank arary first so we don't tack on new. This should run a fresh batch of pages.

while($parray = $pages_result->fetch_assoc()) {
	if(!array_key_exists($parray['id'], $brixwork_pages_cache)) {
		// create new page key, only if it isn't set yet.
		$brixwork_pages_cache[$parray['id']] = $parray; // fresh key for this page!
		$brixwork_pages_cache[$parray['id']]['custom_fields'] = array();
	}

	// now append any custom fields.
	// since it attaches to $parray['id'] key, it will automatically append WITHIN the top page as a sub-array for custom fields.
	if($parray['custom_field_id'] != '') {
		$brixwork_pages_cache[$parray['id']]['custom_fields'][] =  array(
			'custom_field_id' => $parray['custom_field_id'],
			'custom_field_name' => $parray['custom_field_name'],
			'custom_field_value' => $parray['custom_field_value'],
			'custom_field_desc' => $parray['custom_field_desc'],
		); // push to last?
	}


	// the following should be cascaded down to SUBARRAY under 'custom_fields' array, so kill them here!

	unset($brixwork_pages_cache[$parray['id']]['custom_field_id']);
	unset($brixwork_pages_cache[$parray['id']]['custom_field_name']);
	unset($brixwork_pages_cache[$parray['id']]['custom_field_value']);
	unset($brixwork_pages_cache[$parray['id']]['custom_field_desc']);
}

$GLOBALS[BRIX_PAGES_CACHE] = $brixwork_pages_cache;

/* CITY/SUBAREAS preload - 2018-05 upgrades */
$brixwork_areas_cache = array();
$areassql = "SELECT * FROM `areas` ORDER BY `name` ASC";
$areasresult = $mysqli->query($areassql);
if($areasresult->num_rows>0) {
	while($area = $areasresult->fetch_assoc()) {
		$brixwork_areas_cache[$area['id']] = $area;
	}
}
// if areas are not set yet it will just have an empty array, not a false or undeclared, to avoid the "not an array" warning in future.


$GLOBALS[BRIX_AREAS_CACHE] = $brixwork_areas_cache;

$brixwork_areas_hierarchy_cache = array();
$brixwork_subareas_cache = array();

$subareassql = "SELECT s.*, a.name AS city FROM `subareas` s LEFT JOIN `areas` a on s.area=a.id ORDER BY `name` ASC";
$subareasresult = $mysqli->query($subareassql);
if($subareasresult->num_rows>0) {
	while($subarea = $subareasresult->fetch_assoc()) {
		$brixwork_subareas_cache[$subarea['id']] = $subarea; // contains the whole array, including 'city' with the name of city.
	}
}

$GLOBALS[BRIX_SUBAREAS_CACHE] = $brixwork_subareas_cache;

// cache building feature ID & labels.
$buildingfeaturessql = "SELECT `id`, `name` FROM `buildingfeatures` ORDER BY `id`";
$buildingfeaturesresult = $mysqli->query($buildingfeaturessql);
if($buildingfeaturesresult!==false) {
	$brixwork_buildingfeatures_cache = array();
	while($feature = $buildingfeaturesresult->fetch_assoc()) {
		$brixwork_buildingfeatures_cache[$feature['id']] = $feature['name']; // contains the whole array, including 'city' with the name of city.
	}
} else {
	$brixwork_buildingfeatures_cache = false;
}
$GLOBALS[BRIX_BUILDINGFEATURES_CACHE] = $brixwork_buildingfeatures_cache;

$brixwork_homefeatures_cache = array();
// cache home feature ID & labels.
$homefeaturessql = "SELECT `id`, `name` FROM `homefeatures` ORDER BY `id`";
$homefeaturesresult = $mysqli->query($homefeaturessql);
if($homefeaturesresult!==false) {
	$brixwork_homefeatures_cache = array();
	while($feature = $homefeaturesresult->fetch_assoc()) {
		$brixwork_homefeatures_cache[$feature['id']] = $feature['name']; // contains the whole array, including 'city' with the name of city.
	}
} else {
	$brixwork_homefeatures_cache = false;
}

$GLOBALS[BRIX_HOMEFEATURES_CACHE] = $brixwork_homefeatures_cache;

$GLOBALS[BRIX_COOKIE_FOLDER] = $_SERVER['DOCUMENT_ROOT'].'/cookies/';
$GLOBALS[BRIX_TEMP_FOLDER] = $_SERVER['DOCUMENT_ROOT'].'/tmp/';

$document_root = explode('/',$_SERVER['DOCUMENT_ROOT']);
$settings['cpanel_username'] =  $document_root[2];

/**
 * LABEL FOR EACH BRIXWORK LOGIN LEVELS, EDIT HERE
 */
$settings['user_level_label'] = array (
    USER_LOGIN_BRIXWORK => 'Brixwork Login',
    USER_LOGIN_ADMIN => 'Admin',
    USER_LOGIN_MANAGER => 'Manager',
    USER_LOGIN_AGENT => 'Agent',
    USER_LOGIN_CONTENT_MANAGER => 'Content Manager'
);

//var_dump(DEBUG);