<?php
session_start();
$versiontxt = file_get_contents($_SERVER['DOCUMENT_ROOT'].'/brixwork_version.txt');
$versions = explode(':', $versiontxt);
$brixwork_version = $versions[0];
$brixwork_update_date = $versions[1];

require_once '../includes/common.php'; // DB connect.
require_once 'basics.php'; // GLobal vars & basics (without need for settings yet)
require_once 'settings.php'; // some settings require the global constants set in basics.php
// 2023 - moved the settings.php to load before functions.php - there were some lines at top of functions.php that relied on $settings vars.
require_once 'functions.php';
require_once 'classes.php';
require_once 'svg_icons.php';
require_once 'admin_functions.php';
//include '../includes/dropdown.inc';


// force forward to https:// for SSL enabled sites!
if( (empty($_SERVER['HTTPS']) || $_SERVER['HTTPS'] == "off") && strpos($settings['sitepath'], 'https')!==false){
    $redirect = 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    header('Location: ' . $redirect, true, 301);
    exit();
}

// This was a quick patch for that botched update in 2018-04 when all sites forwarded to https by mistake and we had to
// reverse the effects.. don't think we need it?
//if( (!empty($_SERVER['HTTPS']) || $_SERVER['HTTPS'] == "on") && strpos($settings['sitepath'], 'https')===false){
//    $redirect = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
//    header('Location: ' . $redirect, true, 301);
//    exit();
//}

// for now we keep the utf-8 encoding. BING maps preferrs UTF-8 for AJAX queries.
header('Content-Type: text/html; charset='.$encoding);

// caching prevention PHP script for admin section.
header("Expires: Mon, 26 Jul 1990 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

header("Access-Control-Allow-Origin: http://demo.brixwork.com", false);
header("Access-Control-Allow-Origin: https://demo.brixwork.com", false);

header("Access-Control-Allow-Origin: https://brixwork.com", false);
header("Access-Control-Allow-Origin: https://cloudfront.net", false);
header("Access-Control-Allow-Origin: ".$settings['cloudfront_url']);


// verify user login ...
$login_status = validate_login();

// redirect no-login user to homepage except for certain pages.
$redirect_exception_bool = (bool)preg_match('/(login|lost_password|lost_password_reset)\.php$/', $_SERVER['PHP_SELF']);

if (!$redirect_exception_bool && !$login_status) {
    if (isset($_COOKIE['hash']) && $_COOKIE['hash']!='') logoff(); // remove all cookies before redirect to login page.

    header('Location: '.$settings['sitepath'].'admin/login.php'.($_SERVER['REQUEST_URI']!='' ? '?req='.urlencode($_SERVER['REQUEST_URI']) : ''));
    exit();
}

global $mysqli;
// redirect did not happen = valid user, so let's initialize global user.
$login_user = new user(array('id' => $_COOKIE['userid']), $mysqli, $settings);