<?php

// https://github.com/troydavisson/PHRETS/issues/99

if(strpos($query_ranges[$chunk_number], '|')!==false) {
	// multiple ranges...
	$query_range_blocks = explode('|', $query_ranges[$chunk_number]);
	$ranges = $query_range_blocks[0].'T00:00:00-'.$query_range_blocks[1].'T23:59:59';
	$ranges_dmql = $ranges; // already includes times.
	echo "Ranges: ".$ranges."<br />";
} else {
	// single date range.
	//$ranges = $query_ranges[$chunk_number].'T00:00:00-'.$query_ranges[$chunk_number].'T23:59:59';
	// ottawa doesn't like ranges.. it's FROM that date.

	$ranges = $query_ranges[$chunk_number];
	$ranges_timestamp = strtotime($ranges.' 23:59:59 GMT') + (3600 * 8); // get a raw timestamp .. but give it some leniency of 8 hrs for GMT/EST issues.
	$ranges_dmql = $ranges.'T00:00:00Z';
	echo "Range: ".$ranges."<br />";
}
if($chunk_number==0) {
	write_log("Skipping old log at chunk number=".$chunk_number.", because it's CREA and no need to go that far back. \r\n");
	retsrunning_close();
	die('Abort before wasting a query!');
}
$rets_query = "(LastUpdated=".$ranges_dmql.")";

// This part of query is to just CHECK if there are listings to update since the date.
$rets_options_default = array("Limit" => 1, "Format" => "STANDARD-XML", "Count" =>1);
if(isset($rets_options_custom) && is_array($rets_options_custom)) {
	$rets_options = array_merge($rets_options_default, $rets_options_custom);
} else {
	$rets_options = $rets_options_default;
}

echo 'Querying '.$ranges.', query: '.$rets_query.', type '.$type.'<br />';
write_log("Querying ".$ranges.", query: ".$rets_query.", type ".$type.PHP_EOL);

$summary = array();

for ($attempts = 0; $attempts <= 3; $attempts++) {
	$result = $rets->Search(
		"Property",
		$type,
		$rets_query,
		$rets_options
	);
	$summary[$type_name] = array();
	$summary[$type_name][$ranges] = 0; // start the count of valid listings at 0 here.
	$listings_xml = $result->getIterator();
	if(is_object($listings_xml) && isset($listings_xml[0])) {
		$listings =  json_decode(json_encode($listings_xml[0]), true); ;
		$numlistings = count($listings_xml); // 1 if theres at least one listing.
	} else {
		$listings = false;
		$numlistings = 0;
	}

	$error_info = $result->getError();
	if(!is_null($error_info)) {
		echo "Error (if any): <br />".PHP_EOL;
		var_dump($error_info);
		echo "<br />".PHP_EOL;
	}

	if($error_info!=NULL && $error_info['type'] != "" && $error_info['code']!='20201' && $error_info['code']!='202010') {
		// error, keep tryihng again.
		echo $listings." rows found. RETS error (code {$error_info['code']}): {$error_info['text']} on attempt ".$attempts." with query ".$rets_query." on type ".$type_code.".<br />";
		write_log( $listings." rows found. RETS error (code {$error_info['code']}): {$error_info['text']} on attempt {$attempts} with query ".$rets_query." on type ".$type_code.".\r\n");
		if($attempts==3) {
			write_log( "Giving up after 3 rounds. Query was ".$rets_query." on type ".$type_code.".\r\n");
			$mysqli->query("DELETE FROM `cronlog` WHERE id='".$cronlog_id."'"); // delete latest cronlog entry so that it will run again!
			retsrunning_close();
			die('3 tries and nothing');
		}
	} else if(isset($error_info['code']) && ($error_info['code']=='202010' || $error_info['code']=='20201')) {
		write_log( "Too many queries, shutt`ing her down. (code {$error_info['code']}): {$error_info['text']} on attempt {$attempts} with query ".$rets_query." on type ".$type_code.".\r\n");
		$mysqli->query("DELETE FROM `cronlog` WHERE id='".$cronlog_id."'"); // delete latest cronlog entry so that it will run again!
		retsrunning_close();
		die('Too many queries, shutting her down!');
	} else {
		echo "Successful query at ".$attempts.", found at least ".$numlistings." CREA DDF result for this date range.<br />";
		break;
	}
}

$boardskip = 0;
$outofdaterange = false;// because CREA DDF returns everything SINCE a date, without a max, we use this method.