<?php
/*
 *
 * This file can be inserted at the top of any CREA DDF feed (kelowna, halifax etc.) to initialize the date ranges (or, single MLS#)
 * Then it will proceed to create a stnadardized login.
 *
 * This is being tested on ottawa.brixwork.com as of 2023-02-19 but will be moved to the core, then re-distributed across all CREA installations.
 *
 * */

$class_array = array('Property' => 'Property'); // CREA DDF doesn't separate this much, unlike Vancouver etc. where it separates Res attached, detached, land, comm etc.

$single_listing = false;
// getRetsRunning();
echo "Starting CREA DDF query at IP ".$_SERVER [ 'SERVER_ADDR' ]." on ".$_SERVER['HTTP_HOST']."<br />Timezone: ".date_default_timezone_get()."<br />".PHP_EOL;
require_once 'cron_chunk.php'; // include the chunk determinator block, log file generator, MySQL settings, override to set timeout to 0 etc.


// connect to RETS server!
$config = new \PHRETS\Configuration;
$config->setLoginUrl($rets_login_url);
$config->setUsername($rets_username);
$config->setPassword($rets_password);
$config->setRetsVersion('1.7.2');

$config->setOption('compression_enabled', true);
$config->setOption('Accept', '/');
$config->setOption('debug_mode', true);
if(class_exists('CreaStrategy')) {
	// for STANDARD-XML fetches we need this (for getting listings) but to get raw results, not quite.
	$config->setStrategy(new CreaStrategy());
}
// connect to RETS server
$rets = new \PHRETS\Session($config);

$connect = $rets->Login();


if (!$connect) {
	echo "Connection error:<br />".PHP_EOL;
	print_r($rets->Error());

	write_log(print_r($rets->Error(), true));
	print_r($rets->Error());
	retsrunning_close();
	exit;
} else {
	echo "RETS connect success!<br />".PHP_EOL;
}

retsrunning_close();
$RETS_LimitPerQuery = 100; // soon to be 100 once we launch

list($cities, $subareas) = load_cities(); // load all cities & subareas into this thing!


$summary = array();
$mls_numbers = array();
$listingcount = 0;
?>