<?
/*
Filename: cron_functions.php
Description:
These functions encombass functions that are used for RETS data imports. 
*/

ignore_user_abort(true); // this has to finish regardless!!
set_time_limit(0); // no limit
@ini_set('zlib.output_compression', 0);
@ini_set('implicit_flush', 1);
ob_start();
header("Content-Encoding: none");

function getRetsRunning($exptime = 3600) {
	global $local;
	if(file_exists('retsrunning.txt')) {
		$statuslines = file('retsrunning.txt');
		$retsrunningstatus = $statuslines[0];
	} else {
		$retsrunningstatus = 0;
	}
	// $statuslines[0] contains 0 or 1,
	// $statuslines[1] contains the script htaat did this. $_SERVER['SCRIPT_NAME']

	if($retsrunningstatus!=0) {
		// running active!!
		$fileage = time() - filemtime ('retsrunning.txt');
		// $retsrunning = fopen("retsrunning.txt", "w"); // have to at least open it to overwrite the 0 at end on retsrunning_close();.
		if($fileage>$exptime) {
			echo 'old age file, reset for next run!';
			retsrunning_close();// if its been locked for more than 20 mins, soething's wrong.. let's run it again!
		} else {
			// $txt = "1\n".$_SERVER['SCRIPT_NAME'];
			// fwrite($retsrunning, $txt);
			die('Kill it:, '.$statuslines[1].' is already running. '.$retsrunningstatus);
		}
	} else {
		// false or 0 or whatever.. if its not 1... that means we are clear to RUN this file!
		echo 'Set to 1 and run! Last file was '.$statuslines[1].'<br />'.PHP_EOL;
		$retsrunning = fopen("retsrunning.txt", "w");
		$txt = "1\n".$_SERVER['SCRIPT_NAME'];
		fwrite($retsrunning, $txt);
	}

	return $retsrunning;
}

function retsrunning_close() {
	global $log_file;
	$retsrunning = fopen("retsrunning.txt", "w");
	if( !isset($retsrunning) ) {
		die("Error: retsrunning us undefined");
	}
	// empty out the file.
	fwrite($retsrunning, "0\n".$_SERVER['SCRIPT_NAME']);
	fclose($retsrunning);
}

function consolidate_city_name($string, $comparray) {
	$original = $string; // in case we spit back original out cause there's nothing to do.
	$string = strtolower(trim($string)); // clean and lowercase.

	$return = false; // return is false by default.
	foreach($comparray as $cityname => $comp) {
		foreach($comp as $compstring) {
			if($compstring!='' && strpos($string, $compstring)!==false && $return===false) {
				// make sure $compstring is not empty,
				// also make sure we didn't already find a string that matches, in which case skip rest.
				// the $comparray is set by priority.
				// For example, Penticton (Apex) should go to Apex, and not override to Penticton later.
				$return = $cityname;
			}
		}
	}

	if($return===false) {
		// no match found, so pass whatever we got as it is.
		$return = $original;
	}

	return $return;
}

function load_cities($published = false) {
	global $settings;
	global $mysqli;
	// load all cities & subareas in array, preload.
	// difference between this and get_areas? This returns a better organized set of subareas with area->subarea tree structure.
	$cities = array();
	foreach($GLOBALS[BRIX_AREAS_CACHE] as $city_array) {
		if($published===false || ($published===true && $city_array['publish']==1)) {
			$cities[$city_array['id']] = strtolower($city_array['name']);
		}
	}

	$subareas = array();
	// rarely, we have no subareas.. such as Collingwood ON DDF.
	if(is_array($GLOBALS[BRIX_SUBAREAS_CACHE]) && count($GLOBALS[BRIX_SUBAREAS_CACHE])>0) {
		foreach($GLOBALS[BRIX_SUBAREAS_CACHE] as $subarea_array) {
			$subareas[$subarea_array['area']][$subarea_array['id']] = strtolower($subarea_array['name']);
		}
	}

	return array($cities, $subareas); // returns both arrays in combined array. 
}


function match_cities($value_data, &$cityarray, &$subareaarray) {
	// used mostly by retsimport.php, to match up city/subarea. 
	// matches up city / subarea, and if it doesnt exist, creates new one. Make sure that $cityarray and $subareaarray is fed in by the laod_cities function, direclty, so that new area/subareas become created and put into the array as it goes along to avoid duplicate entries. 
	global $mysqli;
	global $settings;
	global $handle; // error log handle. we really need a betetr name for this once the error log stuff is settled.

	$subarea_id = false; // default 0
	$city_id = false; // default 0

	$city_id = array_search(strtolower($value_data['city']), $cityarray);
	// echo $city_id.' fetched from old cities search for '.$value_data['city'].'.<br />';
	if (!$city_id) {
		// city_it returned false as it does not exist yet. 
		$mysqli->query("INSERT INTO `areas` (`name`) VALUES ('".$mysqli->real_escape_string($value_data['city'])."')");
		$city_id = $mysqli->insert_id;
		// echo $city_id.' NEW CITY INSERT for '.$value_data['city'].'<br />';
		write_log("Inserted new area called ".$value_data['city'].", ID ".$city_id." (for home : ".$value_data['mls']."):".PHP_EOL);
		$cityarray[$city_id] = strtolower($value_data['city']); // add to the $cityarray array so that future instances do not create yet another city with the same name. 
	}

	if(isset($subareaarray[$city_id]) && is_array($subareaarray[$city_id])) {
		$subarea_id = array_search(strtolower($value_data['area']), $subareaarray[$city_id]);
	}

	// echo $subarea_id.' fetched from old subareas search for '.$value_data['area'].'.<br />';
	if ($subarea_id==false && $value_data['area']!='') {
		// city_it returned false as it does not exist yet. 
		$mysqli->query("INSERT INTO `subareas` (`name`, `area`) VALUES ('".$mysqli->real_escape_string($value_data['area'])."', '".$city_id."')");
		$subarea_id = $mysqli->insert_id;
		// echo $subarea_id.' NEW SUBAREA INSERT for '.$value_data['area'].'<br />';
		write_log("Inserted new subarea called ".$value_data['area']." with city ".$value_data['city']."(".$city_id."), ID ".$subarea_id." (for home : ".$value_data['mls']."):".PHP_EOL);
		$subareaarray[$city_id][$subarea_id] = strtolower($value_data['area']); // add to the $subareas array so that future instances do not create yet another city with the same name. 
	} else if ($value_data['area']=='') {
		$subarea_id = '';
		// echo 'blank returned from '.$value_data['area'].' and city '.$value_data['city'].'?';
	}

	return array($subarea_id, $city_id);
}

function google_geocode($data, $value_data) {
	// uses raw $data from MLS before it was conveted to $value_data, as $value_data['city'] will contain ID, not a string of the city name... 
	// connect to Google for lat/long
	global $cities;
	global $mysqli;
	global $cities;
	global $subareas;
	global $settings;

	$address = urlencode($value_data['number']." ".($value_data['street_dir']!='' ? $value_data['street_dir'].' ' : '').(isset($value_data['street_name']) && $value_data['street_name'] !='' ? $value_data['street_name']." " : '').$value_data['street_type'].", ".$cities[$value_data['city']].", ".$settings['province']." ".$settings['country']);
	$url = "https://maps.googleapis.com/maps/api/geocode/json?address=$address&sensor=false&key=".$settings['google_maps_api_key'];
	// $opts = array('http' => array('method' => "GET"));
	// $context = stream_context_create($opts);
	$content = curl_get_file_contents($url,'get');
	write_log("Geocode request for ".$value_data['mls']." (".$url.")\n");
	$position = json_decode($content, true);

	if ($position['status'] == 'OK') {
		$lat = $position['results'][0]['geometry']['location']['lat'];
		$long = $position['results'][0]['geometry']['location']['lng'];
		echo "Google returned ".$lat.", ".$long."<br />\n";
	} else if($position['status'] == '620') {
		write_log("Giving Google a break on ".$value_data['mls']." using string ".$url.", google status: ".$position['status']."\r\n");
		unsleep(2000); // if google blocks us for to many requests, take a 2 second break. 
		$lat = '';
		$long = '';
	} else {
		$lat = '';
		$long = '';
		echo "Google says: ".$position['status']."<br />";
		write_log("Failed Geocode request for ".$value_data['mls']." using string ".$url.", google status: ".$position['status']."\r\n");
		write_log("Google Message: ".$position['error_message']."\r\n");
	}

	return array($lat, $long);

}


function write_log ($msg) {
	global $handle;
	if (!empty($handle)) {
		fwrite($handle, $msg, strlen($msg));
	}
}


function write_listing_json ($array, $mlsnum, $date='') {
	if($mlsnum!='') {
		if($date!='' && !file_exists('mls/'.$date)) {
			mkdir('mls/'.$date, 0755);
		}
		// Log all MLS listings!
		$mls_file = 'mls/'.($date!='' ? $date.'/' : ''). $mlsnum .'.txt';
		if (is_writable(dirname($mls_file))) {
			$fh = fopen($mls_file, 'w+');
		} else {
			$fh = null;
			echo "cannot generate log file. Proceeding anyway.<br />";
		}

		if (!empty($fh)) {
			$fcontent = json_encode($array);
			fwrite($fh, $fcontent, strlen($fcontent));
		}
	} else {
		echo "Blank MLS Number, skipping log .txt gen.<br />";
	}
}


function write_photo_json($homeid, $photosarray) {
	$photosjsonpath = $_SERVER['DOCUMENT_ROOT'].'/admin/api/cache/';
	$photosjsonfile = $photosjsonpath.$homeid.'.txt';
	$jsonfileobject = fopen($photosjsonfile,'w');
	// open file to prepare writing. W will overrite from beginning or create new file.

	/*
		$photosarray should contain:
		home = should always equal $homeid. 
		filename
		s3
		title
		timestamp
		ord
		
		FROM photos WHERE `home`='".$idr."'
	*/

	if(is_countable($photosarray) && count($photosarray)>0 && $photosarray[0]['home']==$homeid) {
		$code = 1;
		$message = 'Listing found successfully.';
		$photos = $photosarray; // contains either array or false for nothing.
	}  else {
		$photos = false;
		$code = 0 ;
		$message = 'No photos for '.$home->mls.', masterid '.$id.'.';
	}

	// based on out put above, generate JSON
	$return = array('code'=>$code, 'message'=>$message, 'photos'=>$photos);
	$file_content = json_encode($return);

	// now create cache file
	fwrite($jsonfileobject,$file_content);
	fclose($jsonfileobject);

	return $return;
}

function flush_photo_json($homeid) {
	$photosjsonpath = $_SERVER['DOCUMENT_ROOT'].'/admin/api/cache/';
	$photosjsonfile = $photosjsonpath.$homeid.'.txt';
	if(file_exists($photosjsonfile)) {
		$result = unlink($photosjsonfile); // remove, to force reset. 
	} else {
		$result = false;
	}

	return $result;
}

// flatten multi-dimensional array of DDF to single level only!
function flatten_array_map($listing, $columns_map) {
	$array = array();
	// first get initial mapping based on arrays.
	foreach($columns_map as $key=>$val) {
		// dissect through!
		if(is_array($val)) {
			// loop thorugh again at this level:
			if(array_key_exists($key, $listing)) {
				$subarray = flatten_array_map($listing[$key], $val);
				$array = array_merge($array, $subarray);
			}
		} else {
			$array[$val] = (array_key_exists($key, $listing) ? $listing[$key] : '');
		}
	}
	return $array;
}

function crea_photos_to_rets_format($photos_array, $params) {
	/*
	*
	* each $photo from RETS
	[SequenceId] => 1 => to Object-ID i thikn?
	[LastUpdated] => 31/05/2020 07:40:50 PM // dont need.
	[PhotoLastUpdated] => Mon, 01 Jun 2020 00:40:50 GMT // dont need.
	[ThumbnailURL] => https://ddfcdn.realtor.ca/listings/TS637265508507000000/reb24/lowres/6/244686_1.jpg
	[PhotoURL] => https://ddfcdn.realtor.ca/listings/TS637265508507000000/reb24/medres/6/244686_1.jpg
	[LargePhotoURL] => https://ddfcdn.realtor.ca/listings/TS637265508507000000/reb24/highres/6/244686_1.jpg // to URL?

	 * rets_get_photos() for a regular RETS instance would return an array that looksl ike this:

	$array['Success'] = true;
	$array['Content-ID'] = $photo->getContentId();
	$array['Content-Desc'] = $photo->getContentDescription();
	$array['Object-ID'] = $photo->getObjectId(); // 0, 1, 2 numbers.
	$array['URL'] = $photo->getLocation();
		OR
	$array['Data'] = $photo->getContent();
	}
	 *
	 *
	 * $params['addresss'] = used to form some sort of a description for the sake of it.
	 *
	 * */


	$result = array(); // new format
	if(is_array($photos_array) && count($photos_array)>0) {
		foreach($photos_array as $photo_array) {
			$newarray = array();
			$newarray['Success'] = true; // by default.
			$newarray['Object-ID'] = $photo_array['SequenceId']; // 1, 2, 3 etc.
			$newarray['Content-Desc'] = $params['address'];
			$newarray['URL'] = $photo_array['LargePhotoURL'];
			$result[] = $newarray;
		}
	}
	return $result;
}


function modify_rets_timezone($input, $retstz = 'UTC', $localtz='') {
	global $settings;
	global $mysql_time;

	if(!isset($localtz) || $localtz=='') {
		$localtz = date('T'); // default to local timestamp. 
	}

	// initialize timezones for comparison's sake. 
	$retstimezone = new DateTimeZone($retstz);
	$localtimezone = new DateTimeZone($localtz);

	// to compare offsets, we need at least one TIMESTAMP from each timezone. 
	$retstime = new DateTime("now", $retstimezone);
	$localtime = new DateTime("now", $localtimezone);

	// finally get offset between two zones using the getOffset() function of the Timezone object.
	$offset = $retstimezone->getOffset($retstime) - $localtimezone->getOffset($localtime);
	// UTC to PST, for exapmle, returns 28800 for 8 hours. 

	// truncate given string 
	// It looksl ike this: 
	// 2017-05-20T00:00:00-2017-05-20T23:59:59 
	$start = substr($input, 0, 19);
	$end = substr($input, 20);

	$start =str_replace(' ', 'T', date($mysql_time['full'], strtotime(str_ireplace('T', ' ', $start))+$offset));
	$end = str_replace(' ', 'T', date($mysql_time['full'], strtotime(str_ireplace('T', ' ', $end))+$offset));

	return $start.'-'.$end;
}



$table = 'homes';

// Get table metadata
$table_data = array();
$res = $mysqli->query("SHOW COLUMNS FROM `$table`");
while ($row = $res->fetch_assoc()) {
	if (strpos($row['Type'], 'int') === 0 || strpos($row['Type'], 'decimal') === 0) {
		$table_data[] = $row['Field'];
	}
}


// prepare agent IDs & FIRM IDs
if(isset($settings['agent_id']) && is_array($settings['agent_id'])) {
	foreach($settings['agent_id'] as $akey=>$aid) {
		$settings['agent_id'][$akey] = strtolower($aid);// lowercase it all first!
	}
} else if(isset($settings['agent_id']) && $settings['agent_id']!='') {
	$settings['agent_id'] = strtolower($settings['agent_id']); // lowercase the single agent ID
} else {
	$settings['agent_id'] = false;
}

if(isset($settings['firm_id']) && is_array($settings['firm_id'])) {
	foreach($settings['firm_id'] as $akey=>$aid) {
		$settings['firm_id'][$akey] = strtolower($aid);// lowercase it all first!
	}
} else if(isset($settings['firm_id']) && $settings['firm_id']!='') {
	$settings['firm_id'] = strtolower($settings['firm_id']); // lowercase the single agent ID
} else {
	$settings['firm_id'] = false; // set it to false for RETS import purposes ponly. 
}


?>