<?php
/*
Filename: retsimport.php

Method: CRON or DIRECT
Output: RAW TEXT & WRITE LOG

Description: Fetches listnigs from MLS main servers in JSON, then enters it into child websites. 

*/


if($_GET['hash']=='58300774') {
	
require_once '../start.php'; 

// Log
$log_file = 'logs/s3_' . $now . '.log';
if (is_writable(dirname($log_file))) {
	$handle = fopen($log_file, 'a+');
} else {
	$handle = null;
}

ob_implicit_flush(true);
require_once 'cron_functions.php'; 

getRetsRunning();

require_once $_SERVER['DOCUMENT_ROOT'].'/includes/swift/swift_required.php';
			
$transport = Swift_SmtpTransport::newInstance('smtp.sendgrid.net', 25) // was 587, 'tls'
->setUsername('brixwork')
->setPassword('puFj7ez9');

$mailer = Swift_Mailer::newInstance($transport);

$message = Swift_Message::newInstance('S3 Migration Issues '.$settings['sitepath']) // set subject with URL. 
->setReplyTo($_REQUEST["email"])
->setFrom('server@brixwork.com')
->setTo('support@brixwork.com');

$emailbody = false;
		
$type = $message->getHeaders()->get('Content-Type');
$type->setValue('text/html');
$type->setParameter('charset', 'iso-8859-1');
$type->setParameter('MIME-Version', '1.0');

$start_time = time();

set_time_limit(0); // no limit
ignore_user_abort(true);

// off all modes
$mysqli->query ( "SET SESSION sql_mode=''" );


$repeatscript = false; // repeat of this script is set to false by default. 

$homesperrun = ($_REQUEST['perrun']!='' ? $_REQUEST['perrun'] : 50); // # of homes to process per run. can now be set by get var. 

/*
LOGIC:
Homes,
Buildings,
Pages,
Resources,

Type of files:
Main attachments (main.jpg, pdfs, etc.) 
Photo Galleries (recurse through photo folder)


*/

// set table types to recurse through: 
$objects = array(
'homes',
'buildings',
'pages',
'agents',
'resources'	
);

// preliminary checks for safety

// s3_folder - does it contain BRIXWORK? Send email and abort! All the MLS stuff is moved over already os no need to run from xxx.brixwork.com anymore. 
if(preg_match('/brixwork/', $settings['s3_folder']) || $settings['s3_folder']=='' || $settings['s3_folder']===false || strlen($settings['s3_folder'])<5 || strpos($settings['s3_folder'], '/')!==false ) {
	$emailbody = "S3 Folder problem: ".$settings['s3_folder']." so aborting! Sort this out first or manually disable for a MLS site run.";
} else {
	$logmsg = "Safety checks passed for S3 run! Bucket folder: ".$settings['s3_folder'];
	write_log($logmsg."\r\n");
	echo $logmsg."<br />\r\n";ob_end_flush();
	
	$logsurl = $settings['sitepath'].'cron/logs/';
	echo 'Check logs at <a href="'.$logsurl.'" target="_blank">'.$logsurl.'</a><br />';ob_end_flush();
	
// all safety checks passed!	
foreach($objects as $table) {
	// query the objects and all of its entities. 
	// if HOMES, select masterid = 0 or masterid='' only! 
	//If it has masterid it wil refer to vancouver.brixwork.com any way, no point in processing any attachments. 
	$masteridresult = $mysqli->query("SHOW COLUMNS FROM `".$table."` LIKE 'masterid'");
	$maseridexists = ($masteridresult->num_rows) ? TRUE : FALSE;
	
	$tablesingular = substr($table, 0, strlen($table)-1);
	
	/*
	Homes table, so stagger the run so that we know which files are needed. 
	Files needed: 
	/cron/logs/homescount.txt - gets total count of homes. 
	/cron/logs/homesmoved.txt - array of homes processed so far.  (;)
	
	The rest of tables, just keep log of what we did so we can skip it altogether! 
	*/
	
	$objectscountfilename = 'logs/'.$table.'count.txt'; // homescount.txt. pagescount.txt, etc. etc. 
	$objectsmovedfilename = 'logs/'.$table.'moved.txt'; //homesmoved.txt. etc.
	if(!is_writable(dirname($objectscountfilename))) {
		write_log("Cannot log ".$objectscountfilename." - aborting.\r\n");
		ob_end_flush();
		retsrunning_close();
		die('Cannot log '.$objectscountfilename.' - aborting.<br />');
	} else {
		$objectscount = (file_exists($objectscountfilename) ? file_get_contents($objectscountfilename)*1 : false); // get count of previous total. 
		
		$objectsmovedcontent = (file_exists($objectsmovedfilename) ? file_get_contents($objectsmovedfilename) : ""); // get what's moved so far. 
		if(strpos($objectsmovedcontent, ';')!==false) {
			$objectsmoved = explode(';', $objectsmovedcontent); // array of what's been moved so far!
		} else if($objectsmovedcontent!='') {
			// single line? 
			$objectsmoved = array($objectsmovedcontent);
		} else {
			$objectsmoved = array(); // start from blank!
		}
	}
	
	
	
	if($table=='homes' && $maseridexists===false) {
		// matser ID non exist means this is one of the MLS stuff, HIGH VOLUME!
		$sql = "SELECT home as id, s3 FROM `photos` where `s3`=0 AND `home`!='' GROUP BY home ORDER BY home ASC LIMIT 0, ".$homesperrun;
	} else {
		// build exclude query for object IDs already migrated. 
		$excludeids = ""; // start with blank query. 
		if(is_array($objectsmoved) && count($objectsmoved)>0) {
			foreach($objectsmoved as $excludeid) {
				if($excludeid!='') {
				$excludeids .= " AND id!=".$excludeid;
				}
			}
		} else {
			$excludeids = "";
		}
		
		$sql = "SELECT id FROM `".$table."`".
			($table=='homes' ? 
				" WHERE ".($maseridexists ? "`source`=0 " : " `id`!='' " ).$excludeids." LIMIT 0, ".$homesperrun 
				:
				($table=='buildings' ?
					" WHERE (`feature`=1 OR `mainid`!='') ".$excludeids
					:
					" WHERE id!='' ".$excludeids
				)
			); // effectively filters out source=1 listings. Or appends feature=1 or mainid!='' for buildings.
	}
	
	if($_REQUEST['idr']!='') {
		// override to IDR reuqest in URL!
		$sql = "SELECT id FROM `homes` WHERE `id`='".$_REQUEST['idr']."'";
	}

	if(count($objectsmoved)==$objectscount && $objectscount!==false && 
		( // some sites, the count of agents, resouces, buildings can be blank. Only ones NOT blank is pages & homes. 
			($objectscount>0 && ($table=='homes' || $table=='pages')) // for pages and homes count must be at least 1. 
			||
			($table=='buildings' || $table=='resources' || $table=='agents') // these can be 0 if they like. 
		)
	) {
		if(!file_exists($objectscountfilename)) {
			// if file doesn't exist, and yet the count matched up, its probably all 0 - meaning no agents, or no resourcdes, etc., so just write in a 0 file for objectscount file. 
			$objectscountfile = fopen($objectscountfilename, 'w+');
			fwrite($objectscountfile, $objectscount.'', strlen($objectscount.''));
		}
		$logmsg = $table." already migrated (".count($objectsmoved)."/".$objectscount.")."; // DO NOT CHANGE THE VERBIAGE OF THIS - the mass run module uses this to determine whether it's safe to abort or not. 
		echo $logmsg.'<br />';
		write_log($logmsg."\r\n");
		// fwrite($objectscountfile, $objectscount.'', strlen($objectscount.''));
		continue;
	} else {
		
		// get new object count in case this doesn't match up the old ones (perhaps a new home added?)
		$result = $mysqli->query($sql); // process the query. 

		if($table=='homes') {
			
			// for homes, we need separate query since the main query has LIMIT 0,$homesperrun etc. 
			$homescountsql = "SELECT COUNT(*) AS `cnt` FROM `homes`".($maseridexists ? " WHERE `source`=0" : "");
			$homescountresult  = $mysqli->query($homescountsql);
			$homescountarray = $homescountresult->fetch_assoc();
			$objectscount = $homescountarray['cnt'];
			
		} else {
			// all other object types, we can get count from the $sql on $result.  
			$objectscount = $result->num_rows; // get the total count. 
			
		}
	
		// need to migrate. So let's set up the count file & moved file. 
		$objectscountfile = fopen($objectscountfilename, 'w+');
		if($objectscount) {
			// positive result, write the object count. 
			fwrite($objectscountfile, $objectscount.'', strlen($objectscount.''));
		} else {
			// wrong count - delete file so we don't end up with false 0 count!
			unlink($objectscountfilename);
		}
		
		// write total count of objects denoted here. 
	}
	
	$processedids = array(); // reset the array for all IDs processed. 
	// log how many sub-objects were found (homes, pages etc) 
	$logmsg = $table." Objects Counted: ".$result->num_rows;
	
	write_log($logmsg."\r\n");
	
	while($array = $result->fetch_assoc()) {// loop threough each individual object. 
		$id = $array['id'];
		if($id=='' && $id===false) {
			$log= "Invalid ID (".$id.") returned, skipping row.";
			write_log($logmsg."\r\n");
			continue;
		}
		$processedids[] = $id; // start adding the prcoessed folders (folders taht exist in the corresponding). 
		$object = false; // kill the previous array object. 
		
		$home = false;
		$buildling = false;
		$page = false;
		$agent = false;
		$resource = false;
		
		switch($table) {
			// initialize the object for the right type based on $table value. 
			case 'homes':
			$home = new home;
			$home->initialize($id);
			$subject = $home->fulladdress.' (#'.$home->mls.')';
			$object = $home;
			break;
			
			case 'buildings':
			$building = new building;
			$building->initialize($id);
			$subject = $building->name;
			$object = $building;
			break;
			
			case 'pages':
			$page = new page;
			$page->initialize($id);
			$subject = $page->title;
			$object = $page;
			break;
			
			case 'agents':
			$agent = new agent;
			$agent->initialize($id);
			$subject = $agent->displayname;
			$object = $agent;
			$returnurl = 'agents.php';
			break;
			
			case 'resources':
			$resource = new resource;
			$resource->initialize($id);
			$subject = $resource->title;
			$object = $resource;
			break;
		}
		
		if(!is_object($object) || $object==false) {
			$logmsg = "- Invalid Object returned for ".$table." ID ".$id.", failed.";
			write_log($logmsg."\r\n");
			echo $logmsg."<br />\r\n";
			continue;
		}

		$logmsg = "- Processing ".$subject." for ".$table." from ID ".$id." ID: ".$object->id;
		write_log($logmsg."\r\n");
		echo $logmsg."<br />\r\n";
		
		$objectfolder = '../'.$table.'/'.$object->id; // folder path up to the object ID. 
		
		/* MAIN IMAGE ATTACHMENTS FIRST */
		
		$mainphotocount = 0; // for this home, start existing PDF count at 0.
		$mainphotouploadcount = 0; // for this home, start upload count at 0 as well.
		
		if(is_array($settings[$table.'_mainphotofilename'])!==true) {
			$settings[$table.'_mainphotofilename'] = array('main.jpg'); // default back to OLD sites where first image wa always main.jpg
		}
		
		foreach($settings[$table.'_mainphotofilename'] as $count => $mainphotofilename) {// check for PDF attachments. 
			if($mainphotofilename!='') { // make sure its not blank!! 
				$localpath = $objectfolder."/".$mainphotofilename;
								 
				if(file_exists($localpath)) {
					// upload to S3 bucket,
					$mainphotocount++;
					$s3results = CheckPathAndUploadFile( $settings, $object->id, $table, $localpath, $mainphotofilename, $settings['s3_bucket'], false );
							
					$logmsg = "-- Mainphoto[".$count."] found at ".$localpath.", loaded to ".$s3results[0]['file']['ObjectURL'];
					echo $logmsg.'<br />';
					ob_end_flush();
					write_log($logmsg."\r\n");
					
					// check if it's on S3 properly,
					$s3path = attachment_exists_on_s3($table, $object->id, 'mainphoto', $count);
					
					if($s3path) {
						// then remove it locally ONLY.
						$mainphotouploadcount++;
						// then delete the $localpath one? 

						$logmsg = "- Confirmed load to ".$s3path.", Local to be removed from: ".$localpath;
						write_log($logmsg."\r\n");

						unlink($localpath);
						echo $logmsg.'<br />';ob_end_flush();
					} else {
						// if its not on there, KILL the script, generate an error log and email!
						$logmsg = "- Failed JPG upload returned from ".$s3path;
						write_log($logmsg."\r\n");
					}
					
				}
			}
		}
		
		$logmsg = "- ".$mainphotouploadcount."/".$mainphotocount." MainPhotos processed for ".$object->id;
		write_log($logmsg."\r\n");
		echo $logmsg.'<br />';
		ob_end_flush();

		if($mainphotouploadcount>0) {
			$s3_attachments = check_s3_attachments($table, $object->id, 'mainphoto'); // this also updates the table as well, so MUST run! 
		}

		
		/* THEN PDF ATTACHMENTS NEXT */
		$pdfcount = 0; // for this home, start existing PDF count at 0.
		$pdfuploadcount = 0; // for this home, start upload count at 0 as well.
				
		if(is_array($settings[$table.'_pdffilename'])) {
			// old old sites did not have this set up, so they are all arrays anyway. No need to default. 
			foreach($settings[$table.'_pdffilename'] as $count => $pdffilename) {// check for PDF attachments. 
				if($pdffilename!='') { // make sure its not blank!! 
					$localpath = $objectfolder."/".$pdffilename;
					 
									 
					if(file_exists($localpath)) {
						// upload to S3 bucket,
						$pdfcount++;
						$s3results = CheckPathAndUploadFile( $settings, $object->id, $table, $localpath, $pdffilename, $settings['s3_bucket'], false );
								
						$logmsg = "-- PDF found at ".$localpath.", loaded to ".$s3results[0]['file']['ObjectURL'];
						write_log($logmsg."\r\n");
						
						echo $logmsg.'<br />';ob_end_flush();
						
						// check if it's on S3 properly,
						$s3path = attachment_exists_on_s3($table, $object->id, 'pdf', $count);
						
						if($s3path) {
							// then remove it locally ONLY.
							$pdfuploadcount++;
							// then delete the $localpath one? 

							
							$logmsg = "- PDF on ".$s3path.", Local to be removed from: ".$localpath;
							write_log($logmsg."\r\n");
							
							echo $logmsg.'<br />';ob_end_flush();
							
							unlink($localpath);
							
						} else {
							// if its not on there, KILL the script, generate an error log and email!
							$logmsg = "- Failed PDF upload returned from ".$s3path;
							write_log($logmsg."\r\n");
						}
						
					}
				}
			}
		}
		
		$logmsg = "- ".$pdfuploadcount."/".$pdfcount." PDFs processed for ".$object->id;
		write_log($logmsg."\r\n");
		echo $logmsg.'<br />';ob_end_flush();


		if($pdfuploadcount>0) {
			$s3_attachments = check_s3_attachments($table, $object->id, 'pdf'); // this also updates the table as well.
		}

		$gallerycount = 0; // for this home, start photo gallery count at 0.
		$galleryuploadcount = 0; // for this home, start upload count at 0 as well.
		// this means that if there is no gallery attached, count/uploadcount will both be 0, so deemed successful upon completion even if no gallery photos are uploaded. 
		
		// Now the galleries!
		if($object->photos && is_array($object->photos) && count($object->photos)>0) { // check if attached photo gallery exists. 
			// set zero count for # of photos!
			$logmsg = "--- ".count($object->photos)." photos found.";
			write_log($logmsg."\r\n");
			
			$photoids = array(); // reset array. 
			foreach($object->photos as $photocount=>$photo){// loop through the photos. 
				$uploadimage = true; // by default, we upload the image. 
				
				// get all file paths ready. 
				$originalfilelocation = $objectfolder.'/original/'.$photo['filename'];
				$webfilelocation = $objectfolder.'/'.$photo['filename'];
				$mobilefilelocation = $objectfolder.'/mobile/'.$photo['filename'];
				$thumbnailfilelocation = $objectfolder.'/thumbs/'.$photo['filename'];
				$deletelocal = false;
				$gallerycount++;
				if($photo['s3']==1) {
					// It claims to be on S3 already. 
					// lets trust it - it cannot be set to 1 without being set up properly. 
					$uploadimage = false;
/*
					
					$s3exists = gallery_photo_exists_on_s3($table, $object->id, $photo['filename']);
					if($s3exists!==false) {
						$uploadimage = false; // seems the images are there, so upload is set to false. 
						foreach($s3exists as $s3imagesize=>$s3imageurl) {
							if($s3imageurl===false) {
								// one of the image sizes are missing!
								$logmsg = "--- ".$s3imagesize." size photo NOT found for ID ".$photo['id']." (".$photo['filename'].")";
								write_log($logmsg."\r\n");
								$uploadimage = true;
							} else if($s3imageurl) {
								$logmsg = "--- ".$s3imagesize." size photo for ID ".$photo['id']." found at ".$s3imageurl;
								write_log($logmsg."\r\n");
							}
						}
					} else { // none of the images actually exist!!! 
						$uploadimage = true;
						
						$logmsg = "--- None of the photos found on S3";
						write_log($logmsg."\r\n");
					}
*/
				} else {
					$uploadimage = true;
				}
				
				// $uploadimage = true; // override for testing purposes!
				
				if($uploadimage===true) {
					// even if it says so, it wasn't up there?
					
					
					// find the source file - sometimes its original, sometimes it's the web folde.r
					if(file_exists($originalfilelocation)) {
						// check for original first at homes/[id]/original/____.jpg and set it as source. 
						$sourcefile = $originalfilelocation;
					} else if(file_exists($webfilelocation)) {
						// if not, check the raw web files under homes/[id]/____.jpg.
					
						$sourcefile = $webfilelocation;
					} else {
						$sourcefile = false;
					}
					
					if($sourcefile && is_readable($sourcefile) && is_writable($sourcefile)) {
						
						$logmsg = "--- Found valid upload source file at  ".$sourcefile.".";
						// write_log($logmsg."\r\n");
						echo $logmsg.'<br />';ob_end_flush();
						// detect if the filename contains .jpeg at the end, need to update to .jpg. 
						$filename = strtolower($photo['filename']); // lowercase it all? 
						if(preg_match('/jpeg$/', $filename)) {
							$filename = preg_replace('/jpeg$/', 'jpg', $filename);
							$jpegflag = true;
						} else {
							$jpegflag = false; 
						}
						
						$uploadresult = CheckPathAndUploadFile($settings, $object->id, $table, $sourcefile, $filename, $settings['s3_bucket'], true );
						
						
						
						if($photocount==0 && $table=='homes' && $maseridexists!==true) {
							// this ONLY runs on the MLS sites such as vancouver.brixwork.com etc.
							// photo #1, so update the mls_photo column of `homes` table. 
							// only if masterid column is FALSE, and on homes.. because OWn listings on child sites dont need this. 
							$mainphotoupdatequery = "UPDATE `homes` SET `mls_photo`='".$uploadresult[1]['web']['ObjectURL']."', `modify_date`='".$now."', `timestamp`='".$now."' WHERE `id` = ".$object->id;
							
							$mysqli->query($mainphotoupdatequery);
							$logmsg = "Updating mls_photo and timestamp only on photo sequence ".$photocount;
							echo $logmsg.'<br />';ob_end_flush();
							write_log($logmsg."\r\n");
							
						}
						
						
						
						$successfulupload = 0; // start at 0 and add up to 4 if all 4 sizes went up.
						if(is_array($uploadresult) && $uploadresult!==false) {
							foreach($uploadresult as $ucount=>$sizeresult) {
								
								foreach($sizeresult as $size=>$resultarray) {
									if($resultarray!==false && $resultarray['ObjectURL']!='') {
	//$logmsg = "--- upload sequence ".$ucount." for ".$size." success: ".$resultarray['ObjectURL'].".";
										//write_log($logmsg."\r\n");
										$successfulupload++;
									} else {
										$logmsg = "--- upload sequence ".$ucount." for ".$size." failed: ".$resultarray.".";
										write_log($logmsg."\r\n");
									}
								}
							}
						} else {
							$logmsg = "--- upload sequence ".$photocount." failed entirely?";
							write_log($logmsg."\r\n");
						}
						
						// facilitate update, and count what goes up. 
						if($successfulupload==4) {
							// only if all 4 files went up! 
							$galleryuploadcount++;
							$photoids[] = $photo['id']; // add ID to array of things to update on `photos` table. 
							if($jpegflag==true) {
								$photonamequery = "UPDATE `photos` SET `filename`='".$filename."' WHERE id='".$photo['id']."'";
								$mysqli->query($photonamequery);
								$logmsg = "--- jpeg -> jpg, updating to ".$filename." on photo ID ".$photo['id']." (Home ID ".$object->id.").";
							write_log($logmsg."\r\n");
							}
							
							$logmsg = "--- 4 JPGs success: ".$photo['filename']." (ID ".$photo['id'].") went to ".$uploadresult[1]['web']['ObjectURL'];
							write_log($logmsg."\r\n");
							echo $logmsg.'<br />';ob_end_flush();
							
							$deletelocal = true; 
														
						} else {
							$logmsg = "--- ".$successfulupload." of JPGs worked, failure : ".$photo['filename']." (ID ".$photo['id'].") ";
							write_log($logmsg."\r\n");
						}
							
					} else {
						// no source file found at all, ghost directory? 
						// maybe it was moved to a remote on previous iteration already? 
						$s3exists = gallery_photo_exists_on_s3($table, $object->id, $photo['filename']);
						
						if( file_exists($sourcefile) && ( !is_readable($sourcefile) || !is_writable($sourcefile) ) ) {
							$logmsg = "--- Image permission denied ".$photo['filename']." (#".$photo['id'].", object id ".$object->id.")!";
							write_log($logmsg."\r\n");
							echo $logmsg.'<br />';ob_end_flush();
							$emailbody.="Failed - image exists  ".$table." ID ".$object->id.", photofile ".$photo['filename']." NOT READ OR WRITABLE - fix permissions first!<br />";
							// note that in this case, we do NOT add thsi photo ID to $photoids[] array because this is deemed a complete failure. 
						} else if($s3exists['web']!==false) {
							// image is there! 
							$galleryuploadcount++; // force a +1 here. 
							$logmsg = "--- Image already migrated. ".$photo['filename']." (#".$photo['id'].")!";
							$photoids[] = $photo['id']; // add id to the list of photos to be updated to s3=1
							write_log($logmsg."\r\n");
							echo $logmsg.'<br />';ob_end_flush();
						} else { // none of the images actually exist!!! 
							$galleryuploadcount++; // still count as a galleryuploadcount, since we removed a non-existent photo row. 
							$photodeletesql = "DELETE FROM `photos` WHERE id='".$photo['id']."'";
							$mysqli->query($photodeletesql); 
							
							$logmsg = "--- FAILURE - image missing locally and on S3 - file name: ".$photo['filename']." (#".$photo['id'].")!";
							write_log($logmsg."\r\n");
							
							$emailbody.="Failed - image missing locally and on S3, removing image for ".$table." ID ".$object->id.", photofile ".$photo['filename']." (#".$photo['id']."), removed ".$mysqli->affected_rows." rows.<br />";
							
						}
					}
								 
				} else {
					// files are up there just fine, so let's skip this, and pretend it was uploaded. 
					$galleryuploadcount++;
					$photoids[] = $photo['id']; // add id to the list of photos to be updated to s3=1
					$logmsg = "--- All 4 images found on the S3 cloud for ".$photo['filename'].". Deemed successfully migrated. ";
					$deletelocal = true;
					write_log($logmsg."\r\n");
					echo $logmsg.'<br />';ob_end_flush();
					// delete the API cache for photos (only for the MLS mainframe sites where it feeds the JSON). Path is stored in $photosjsonpath variable. 
					
				}
				if($deletelocal) {
					
					$localdeletecount = 0;
					
					// delete local
					if(file_exists($originalfilelocation)) {
						unlink($originalfilelocation);
						$localdeletecount++;
					}
					
					if(file_exists($webfilelocation)) {
						unlink($webfilelocation);
						$localdeletecount++;
					}
					
					if(file_exists($mobilefilelocation)) {
						unlink($mobilefilelocation);
						$localdeletecount++;
					}
					
					if(file_exists($thumbnailfilelocation)) {
						unlink($thumbnailfilelocation);
						$localdeletecount++;
					}
					
					$logmsg = "---Deleted ".$localdeletecount." local .JPG files (".$photo['filename'].") on sequence ".$photocount." of gallery.";
					write_log($logmsg."\r\n");
					
				}
				
			} // end looping through each photo row on photos table. 
			
			// update the photo row
			$photoidcount = 0;
			$photoupdatesql = "UPDATE `photos` SET `s3`=1, timestamp='".$local."', filename = LOWER(filename)  WHERE ";
			foreach($photoids as $photoidcount=>$photoid) {
				$photoupdatesql.= ($photoidcount>0 ? " OR" : "")." `id`='".$photoid."'";
			}
			$mysqli->query($photoupdatesql);
			write_log($photoupdatesql." being executed for ".$galleryuploadcount." photos and affected ".$mysqli->affected_rows." photo rows.\r\n");
			
			$photosjsonfile = '../admin/api/cache/'.$object->id.'.txt';
			
			if($table=='homes' && file_exists($photosjsonfile)) {
				if(flush_photo_json($object->id)) {
					$logmsg = "--- JSON file at ".$photosjsonfile." zapped.";
					write_log($logmsg."\r\n");
				}
			}
		}
		
				
		// merge all the main JPG, pdf file arrays - if any of these were left behind due to error, we canont delete them in this loop!!!
		$exclude['files'] = array_merge($settings[$table.'_mainphotofilename'], $settings[$table.'_pdffilename']);
		
		$exclude['directories'] = array('.','..');
		
		$folders = array(
			$objectfolder.'/original/',
			$objectfolder.'/',
			$objectfolder.'/mobile/',
			$objectfolder.'/thumbs/',
			$objectfolder.'/folder/',
		);
		
		$orphanedphotos = array(); // empty arrya. 
		
		foreach($folders as $folder) {
			$leftoverfiles = (file_exists($folder) ? list_directory($folder, $exclude, false) : false);
			// looped through original, or / or whatever folder.. see if files exist or not!
			if(is_array($leftoverfiles) && count($leftoverfiles)>0) {
				foreach($leftoverfiles as $leftoverfile) {
					if($leftoverfile['type']=='file') {
						$leftoversql = "SELECT id, filename, s3 FROM `photos` WHERE `".$tablesingular."` = '".$object->id."' AND LOWER(`filename`) = '".strtolower($leftoverfile['name'])."'";
						echo $leftoversql."<br />\r\n";
						$leftoverresult = $mysqli->query($leftoversql);
						if($leftoverresult->num_rows==0) {
							// delete. 
							$orphanedphotos[] = $folder.$leftoverfile['name'];
						}
					}
				}
			}
		}
		
		if(count($orphanedphotos)>0) {
			$orphanedlog = "";
			write_log("Orphaned photos cleanup from ".$table.":\r\n");
			foreach($orphanedphotos as $orphancount => $orphanedphoto) {
				unlink($orphanedphoto);
				$orphanedlog .= ($orphancount>0 ? ", " : "").$orphanedphoto;
			}
			write_log($orphanedlog.".\r\n");
		}
		
		if($galleryuploadcount==$gallerycount && $pdfuploadcount == $pdfcount && $mainphotouploadcount == $mainphotocount) {
			// if these are all true, we deem this as successfully moved over!
			
			$objectsmoved[] = $object->id; // Add object ID to array. 
	
			// remove /agents/21 or /homes/434/ etc. individual object folders. 
			if(file_exists($objectfolder.'/thumbs') && is_dir_empty($objectfolder.'/thumbs')) {
				rmdir($objectfolder.'/thumbs');
			} else if(!file_exists($objectfolder.'/thumbs')) {
				$logmsg = "-- /thumbs dir already removed.";
				write_log($logmsg."\r\n");
			} else {
				$logmsg = "-- /thumbs dir not empty, removal failed.";
				$emailbody .= "Thumbs at ".$objectfolder." failed.<br />\r\n";
				write_log($logmsg."\r\n");
			}
			
			if(file_exists($objectfolder.'/original') && is_dir_empty($objectfolder.'/original')) {
				rmdir($objectfolder.'/original');
			} else if(!file_exists($objectfolder.'/original')) {
				$logmsg = "-- /original dir already removed.";
				write_log($logmsg."\r\n");
			} else {
				$logmsg = "-- /original dir not empty, removal failed.";
				$emailbody .= "Original at ".$objectfolder." failed.<br />\r\n";
				write_log($logmsg."\r\n");
			}
			
			if(file_exists($objectfolder.'/mobile') && is_dir_empty($objectfolder.'/mobile')) {
				rmdir($objectfolder.'/mobile');
			} else if(!file_exists($objectfolder.'/mobile')) {
				$logmsg = "-- /mobile dir already removed.";
				write_log($logmsg."\r\n");
			} else {
				$logmsg = "-- /mobile dir not empty, removal failed.";
				$emailbody .= "Mobile at ".$objectfolder."<br /> failed\r\n";
				write_log($logmsg."\r\n");
			}
			
			if(file_exists($objectfolder.'/folder') && is_dir_empty($objectfolder.'/folder')) {
				rmdir($objectfolder.'/folder');
			} else if(!file_exists($objectfolder.'/folder')) {
				$logmsg = "-- /folder dir already removed.";
				write_log($logmsg."\r\n");
			} else {
				$logmsg = "-- /folder dir not empty, removal failed.";
				$emailbody .= "Folder at ".$objectfolder." failed.<br />\r\n";
				write_log($logmsg."\r\n");
			}
			
			// after sub-folders removed... remove the master folder. 
			if(file_exists($objectfolder) && is_dir_empty($objectfolder)) {
				rmdir($objectfolder);
			} else if(!file_exists($objectfolder)) {
				$logmsg = "- OBJECT dir already removed.";
				write_log($logmsg."\r\n");
			} else {
				$logmsg = "- OBJECT dir removal failed.";
				$emailbody .= "Object dir removal failed at ".$objectfolder." for ".$object->id."<br />\r\n";
				write_log($logmsg."\r\n");
			}
			
			$logmsg = "--- ".$galleryuploadcount."/".$gallerycount." Gallery Photos, ".$pdfuploadcount."/".$pdfcount." PDFs, ".$mainphotouploadcount."/".$mainphotocount." Mainphotos for ".$table." row ID ".$object->id." successful.";
			write_log($logmsg."\r\n\r\n");
			echo $logmsg."<br />";
		} else {
			$logmsg = "Gallery photo migration failed ".$galleryuploadcount."/".$gallerycount.", ".$table." row ID ".$object->id.", what's wrong?";
			write_log($logmsg."\r\n\r\n");
			// email trigger here!!!
			echo $logmsg."<br />";
		}
		
		ob_end_flush();
		
	} // end of looping through each home or page object etc.
	
	$objectsmovedcontent = implode(";", $objectsmoved);
	
	$objectsmovedfile = fopen($objectsmovedfilename, 'w+'); 
	fwrite($objectsmovedfile, $objectsmovedcontent, strlen($objectsmovedcontent)); // log how many objects were removed. 
	
	if(count($objectsmoved)<$objectscount) {
		$repeatscript = true; // Set to repeat again! 
	}
	
	/*
	
	NOW we process the /home/ or /pages/ folder itself.
	Figure out if any sub-folders are orphaned and remove. 
	Then see if folder itself is empty, then flush out. 
	
	*/
	
	$tablefolder = '../'.$table;
	$excludedfromremoval['files'] = array(
		'.',
		'..',
		'admin',
		'includes',
		'cron' // precaution... should never be in a homes or pages folder.
	);
	
	$excludedfromremoval['directories'] = array(
		$processedids 
	); // whatever we procesed, can be excluded so we don't accidentally delete ones that have failed transfer files in there.
	$excludedfromremoval['extensions'] = array(
		'html'
	);
	
	
	if(file_exists($tablefolder.'/.htaccess')) unlink($tablefolder.'/.htaccess');
	if(file_exists($tablefolder.'/index.php')) unlink($tablefolder.'/index.php'); 
	// These are protection files that were there, remove so we can empty the folder.  
	
	if(file_exists($tablefolder)) {
		$itemfolders = list_directory($tablefolder, $excludedfromremoval); // the ones that are NOT removed so far!
		if(is_array($itemfolders) && count($itemfolders)>0) {
			foreach($itemfolders as $itemfolder) {
				if($itemfolder['type']=='directory') {
					$folderid = $itemfolder['name'];
					$targetdirectory = $tablefolder.'/'.$folderid;
					
					if(is_dir_empty($targetdirectory)) {
						$logmsg = "Folder ID ".$folderid." in ".$table." already empty. Removing folder.";
						write_log($logmsg."\r\n\r\n\r\n\r\n");
						
						rmdir_files($targetdirectory, true);
					} else {
						$existssql = "SELECT id FROM `".$table."` WHERE `id`='".$folderid."'".($table=='buildings' ? " AND (`feature`=1 OR `mainid`!='')" : '');
						$existsresult = $mysqli->query($existssql);
						
						if($existsresult->num_rows==0 && $existsresult!==false) {
							// also make sure it doesnt return false. 
							$logmsg = "Folder ID ".$folderid." NOT FOUND on ".$table.", orphaned. Removing folder.";
							write_log($logmsg."\r\n\r\n\r\n\r\n");
							
							rmdir_files($targetdirectory, true);
						}
					}
				} else {
					$logmsg = "What the hell is this file at ".$itemfolder['name']."??";
					write_log($logmsg."\r\n\r\n\r\n\r\n");
				}
			}
		}
		
		if(is_dir_empty($tablefolder)) {
			$logmsg = $tablefolder." is entirely empty, success! Removing.";
			write_log($logmsg."\r\n");
			rmdir($tablefolder);
		} else if(count($objectsmoved)==$objectscount) {
			$logmsg = $tablefolder." is NOT empty failed. Email triggered.";
			// if the counts matched, and the move failed, we have a problem. 
			$emailbody.= $tablefolder." object folder removal failed despite ".count($objectsmoved)."/".$objectscount."<br />\r\n";
			
			write_log($logmsg."\r\n");
		}
	} else {
		// echo "OBject folder did not exist at ".$tablefolder.", skip.<br /><br /> ";
	}
	
	
	ob_end_flush();
	// end of looping through an object block (all homes or all buildings etc.);
}
// end of wrapper that actually lets the scripts run after safety checks pass. 	
}


if($emailbody) { // email body is set, we need to send a warning!
	// Create a message
	$message->setBody($emailbody);
	
	// Send the message
	$result = $mailer->send($message);
}


$s3updatesql = "UPDATE `settings` SET `value`='1' WHERE `name` ='s3_activated'";
$mysqli->query($s3updatesql);

$logmsg = "Settings table to s3_activated=1, ".$mysqli->affected_rows." rows updated.";
write_log($logmsg."\r\n");

if(is_resource($db)) {
	mysql_close($db);
}
$mysqli->close();


$stop_time = time();
$execute_time = ($stop_time - $start_time) / 60;
write_log("Execution time: $execute_time mins.\r\n");
echo "Execution time: $execute_time mins<br />\r\n";

retsrunning_close();
} else {
	echo 'nice try!';
}
?>