<?
/*
foreach($params as $key=>$val) {
	if(!is_array($val)) {
		echo $key.': '.$val.'<br />';
	} else {
		echo $key.': ';
		foreach($val as $subval) {
			echo $subval.', ';
		}
		echo '<br />';
	}
}
*/

// Let's set the variables accordingly to what's set in the Search section on the backend.
// If any of the fields is empty, then just set a fallback.


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price);
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}


$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);
	
if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square);
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}


if((is_array($settings['brixwork_search_type'])) && (count($settings['brixwork_search_type']) > 0)) {
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	$searchtype = $dwelling_type;
}
?>
<form id="listing_search_form" method="post" enctype="multipart/form-data">
<?
if($params['bldg']=='') { // show the standard area/subarea based listing search ONLY if the bldg param is OFF. 
?>
<div class="grid_16 sixteen columns alpha omega bottom_20 slideout <? echo ($slideoutcolour!='' ? $slideoutcolour : 'slideout_light')?>">
	<h4>Customize Your Property Search</h4>
	<div class="grid_16 sixteen columns alpha omega bottom_20 slidedout_drawer <? echo (is_array($params) && $params['pageid']=='' && count($params)>1 ? 'slideout_active':'slideout_inactive');?>" id="listing_search_container" >
	
		<div class="grid_9 nine columns alpha">
			<h6>Select City &amp; Area</h6>
			<div class="grid_9 nine columns alpha omega bottom_10">
				<select id="listing_search_city" name="listing_search_city" autocomplete="off">
					<option value="" rel="">All Cities</option>
					<?
					$activecities = list_cities(true);
					foreach($activecities as $areas) {
						$thisarea = new area;
						$thisarea->initialize($areas['id'], $areas);
                        $selectedtext = '';

                        if(is_string($thisarea->name) && is_string($params['city'])) {
                            if(strtolower($thisarea->name)==strtolower($params['city'])) {
                                $selectedtext = ' selected="selected"';
                            }
						}
						if($lastfeature==1 && $thisarea->feature==0) {
							echo '<option value="" disabled="disabled">-- MORE CITIES --</option>';
						}
						$lastfeature = $thisarea->feature;
						echo '<option '.$selectedtext.' value="'.$thisarea->name.'" rel="'.$thisarea->id.'">'.$thisarea->name.'</option>';
					}
					?>
				</select>
			</div>
			<div class="grid_9 nine columns alpha omega" id="listing_search_subareas">
				<?					
				if($params['city']!='') {
					// load up the sub areas!
					$cityid = get_area_id($params['city'], 'areas');
					$subareas = get_subareas($cityid);

					if(count($subareas)>0) {
						$total = count($subareas);
						$columns = 3;
						$firstcolumn = ceil($total/$columns);
						$secondcolumn = ceil(($total-$firstcolumn)/2);
						$columncount = 0;
						$count = 0;
						foreach($subareas as $subareaid) {
							$subarea = new subarea;
							$subarea->initialize($subareaid);
							
							if( (is_array($params['area']) && in_array($subarea->name,$params['area'])) || $params['area']==$subarea->name) {
								$selectedtext = ' checked';
							} else {
								$selectedtext = '';
							}
							echo '
							<div class="full_grid"><div class="listing_search_checkbox">
									<input type="checkbox" name="listing_search_subarea[]" id="listing_search_subarea_'.$subarea->id.'" value="'.$subarea->name.'" rel="'.$subarea->id.'" '.$selectedtext.' autocomplete="off">
									<label for="listing_search_subarea_'.$subarea->id.'">'.$subarea->name.'</label>
								</div>
							</div>
							';
							$count++;
						}
// 						echo '</div>';
					}
				}
				?>
			</div>
		</div>
		<div class="grid_5 five columns omega">
			<div class="grid_5 five columns alpha omega bottom_10">
				<h6>Property Type</h6>
					<div class="grid_5 five columns alpha omega">
					<select name="listing_search_type" id="listing_search_type" autocomplete="off">
						<option value="">Choose Type</option>
						<?php
						$count = 0;
						$typeid = get_property_type_id($params['type']);
						
						// first get ID of the house type currently selected
						foreach ($searchtype as $id => $title) {
							if($typeid==$id) {
								$selectedtext = ' selected="selected"';
							} else {
								$selectedtext = '';
							}
							?>
							<option rel="<? echo $id; ?>"<? echo $selectedtext; ?> value="<? echo $settings['type'][$id]; ?>" ><? echo $title; ?></option>
						<?php
							$count++;
						} ?>
					</select>
				</div>
			</div>
			<div class="grid_5 five columns alpha omega bottom_10">
				<select name="listing_search_min_bedrooms" id="listing_search_min_bedrooms" autocomplete="off">
					<option value="">--MIN BEDROOMS</option>
					<?php
					
					for ($i = 0; $i <= count($bed); $i++) {
						 if($bed[$i]!='') {
							 if($bed[$i]==$params['min_bedroom'] && isset($params['min_bedroom'])) {
							 	$selectedtext = ' selected="selected"';
							 } else {
							 	$selectedtext = '';
							 }
						?>
							<option value="<?=$bed[$i]?>" <?=$selectedtext?>><?=$bed[$i]?>+</option>
					<?php 
						}
					}
					?>
				</select>
				<select name="listing_search_min_bathrooms" id="listing_search_min_bathrooms" autocomplete="off">
					<option value="">--MIN BATHROOMS</option>
					<?php 
					for ($i = 1; $i <= count($bath) - 1; $i++) { 
						
						if($i==$params['min_bathroom']) {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
						<option value="<?=$i ?>"<?=$selectedtext?>><?=$bath[$i]?>+</option>
					<?php
					}
					?>
				</select>
				<div class="clear"></div>
				<select name="listing_search_min_sqft" id="listing_search_min_sqft" autocomplete="off">
					<option value="">--MIN SQFT</option>
						<?php
						for ($i = 1; $i <= count($square); $i++) { 
							if($i==$params['min_sqft']) {
							 	$selectedtext = ' selected="selected"';
							} else {
							 	$selectedtext = '';
							}
						?>
							<option value="<?=$i ?>"<?=$selectedtext?>><?=number_format($square[$i])?> sqft</option>
						<?php
						}
						?>
				</select><span class="static_text">&nbsp;TO&nbsp;</span>
				<select name="listing_search_max_sqft" id="listing_search_max_sqft" autocomplete="off">
					<option value="">--MAX SQFT</option>
						<?php
						for ($i = 2; $i <= count($square); $i++) { 
							if($i==$params['max_sqft']) {
							 	$selectedtext = ' selected="selected"';
							} else {
							 	$selectedtext = '';
							}
						?>
							<option value="<?=$i?>"<?=$selectedtext?>><?=number_format($square[$i]) ?> sqft</option>
						<?php
						}
						if($params['max_sqft']=='0') {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
						
						?>
						<option value="0"<?=$selectedtext?>>Unlimited</option>
				</select>
			</div>
			
			<div class="grid_5 five columns alpha omega bottom_10">
				<h6>Price Range</h6>
				<select name="listing_search_min_price" id="listing_search_min_price" autocomplete="off">
					<option value="">-- MIN PRICE</option>
					<?php
					for ($i = 1; $i <= count($price); $i++) {
						if($price[$i]==$params['min_price'] && isset($params['min_price'])) {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
						<option value="<?=$price[$i] ?>"<?=$selectedtext?>>$<?=number_format($price[$i])?></option>
					<?php
					}
					?>
				</select>
				<span class="static_text">&nbsp;TO&nbsp;</span>
				<select name="listing_search_max_price" id="listing_search_max_price" autocomplete="off">
					<option value="">-- MAX PRICE</option>
					<?php
					for ($i = 2; $i <= count($price); $i++) {
						if($price[$i]==$params['max_price']) {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
						<option value="<?=$price[$i] ?>"<?=$selectedtext?>>$<?=number_format($price[$i])?></option>
					<?php
					}
					if($params['max_price']=='0') {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
					<option value="0"<?=$selectedtext?>>Unlimited</option>
				</select>
			</div>
		</div>
		<?
		if($listing_custom_filename!='') {
			echo '<input type="hidden" value="'.$listing_custom_filename.'" name="listing_custom_filename" autocomplete="off" />';
		}
		?>
		<div class="grid_2 two columns omega">
			<input type="submit" id="listing_search_submit" value="Search" />
		</div>
		
	</div>
	
	<div class="grid_16 sixteen columns alpha omega slideout_handle">
		<span>advanced listing search form</span>
	</div>
</div>

<div class="grid_16 sixteen columns alpha omega bottom_20" id="listing_order_form" style="background-color:<? echo ($orderformbg!='' ? $orderformbg : '#ddd'); ?>; ">
	<div class="grid_4 four columns alpha"><h6>Display Listings By:</h6></div>
	<div class="grid_4 four columns bottom_10">
		<select name="listing_order_by" id="listing_order_by">
			<option value="">Order By</option>
			<option value="create_date"<? if($params['order_by']=='create_date') { echo ' selected="selected"';}?>>Date Listing Came On Market</option>
			<option value="price"<? if($params['order_by']=='price') { echo ' selected="selected"';}?>>Current Listed Price</option>
			<option value="sqft"<? if($params['order_by']=='sqft') { echo ' selected="selected"';}?>>Size of Home (sqft)</option>
			<option value="bedroom"<? if($params['order_by']=='bedroom') { echo ' selected="selected"';}?>>Number of Bedrooms</option>
			<option value="bathroom"<? if($params['order_by']=='bathroom') { echo ' selected="selected"';}?>>Number of Bathrooms</option>
		</select>
	</div>
	<div class="grid_4 four columns bottom_10">
		<select name="listing_order_direction" id="listing_order_direction">
			<option value="DESC">&gt;- Choose Option</option>
			<option value="ASC"<? if($params['order_direction']=='ASC') { echo ' selected="selected"';}?>>&gt;- Choose Option</option>
		</select>
	</div>
	<div class="grid_4 four columns omega">
		<input type="button" id="listing_order_submit" value="Refresh Display" />
	</div>
</div>
<? } else { ?>
	<input type="hidden" name="listing_bldg" value="<? echo $params['bldg']; ?>" />
	<input type="hidden" name="listing_building" value="<? echo $params['building']; ?>" />
<? } ?>
	<?
	if ($params['keyword'] != '') { ?>
		<input type="hidden" name="keyword" value="<?=$params['keyword']?>" />
	<? } ?>
</form>

<div class="clear"></div>