<?
// this file is for grid_10 width form - has less info than the full grid_16 size. 
// assume that this is called up within a grid_10 grid, no need for extra wrapper.

// Let's set the variables accordingly to what's set in the Search section on the backend.
// If any of the fields is empty, then just set a fallback.


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price);
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}


$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);
	
if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square);
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}


if((is_array($settings['brixwork_search_type'])) && (count($settings['brixwork_search_type']) > 0)) {
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	$searchtype = $dwelling_type;
}
?>

	<form id="listing_search_form" method="post" enctype="multipart/form-data">
		<div class="grid_4 four columns alpha">
			<h6>Select City &amp; Area</h6>
			<div class="grid_4 four columns alpha omega bottom_10">
				<select id="listing_search_city" name="listing_search_city">
					<option value="" rel="">Select A City First</option>
					<?
					$result = $mysqli->query("SHOW COLUMNS FROM `areas` LIKE 'publish'");
					if($result->num_rows){
						// publish field set-  certain areas are hidden!
						$areassql = "SELECT id, name FROM areas WHERE publish=1 AND `name`!='' ORDER BY feature DESC, name ASC";
					} else {
						$areassql = "SELECT id, name FROM areas WHERE `name`!='' ORDER BY feature DESC, name ASC";
					}
					$areasresult = $mysqli->query($areassql);
					while($areas = $areasresult->fetch_assoc()) {
						echo '<option '.$selectedtext.' value="'.$areas['name'].'" rel="'.$areas['id'].'">'.$areas['name'].'</option>';
					}
					?>
				</select>
			</div>
			<div class="grid_4 four columns alpha omega bottom_10">
				
				<h6>Property Type</h6>
				<?
				
				$typeid = get_property_type_id($params['type']);
				?>
				<select name="listing_search_type" id="listing_search_type">
					<?php
					$count = 0;
					// first get ID of the house type currently selected
					foreach ($searchtype as $id => $title) {
						?>
						<option rel="<? echo $id; ?>" value="<? echo $settings['type'][$id]; ?>" ><? echo $title; ?></option>
					<?php
						$count++;
					} ?>
				</select>
				
			</div>
			
		</div>
		<div class="grid_6 six columns omega">
			<div class="grid_6 six columns alpha omega bottom_10">
				<h6>Size &amp; Capacity</h6>
				<select name="listing_search_min_bedrooms" id="listing_search_min_bedrooms">
					<option value="">BEDROOMS</option>
					<?php
					
					for ($i = 0; $i <= count($bed); $i++) {
						 if($bed[$i]!='') {
							 if($bed[$i]==$params['min_bedroom'] && isset($params['min_bedroom'])) {
							 	$selectedtext = ' selected="selected"';
							 } else {
							 	$selectedtext = '';
							 }
						?>
							<option value="<?=$bed[$i]?>" <?=$selectedtext?>><?=$bed[$i]?>+</option>
					<?php 
						}
					}
					?>
				</select>
				<select name="listing_search_min_bathrooms" id="listing_search_min_bathrooms">
					<option value="">BATHROOMS</option>
					<?php 
					for ($i = 1; $i <= count($bath) - 1; $i++) { 
					?>
						<option value="<?=$i ?>"><?=$bath[$i]?>+</option>
					<?php
					}
					?>
				</select>
				<div class="clear"></div>
				<select name="listing_search_min_sqft" id="listing_search_min_sqft">
					<option value="">--MIN SQFT--</option>
						<?php
						for ($i = 1; $i <= count($square); $i++) { 
						?>
							<option value="<?=$i ?>"><?=number_format($square[$i])?> sqft</option>
						<?php
						}
						?>
				</select><span class="static_text">&nbsp;TO&nbsp;</span>
				<select name="listing_search_max_sqft" id="listing_search_max_sqft">
					<option value="">--MAX SQFT--</option>
						<?php
						for ($i = 2; $i <= count($square); $i++) { 
						?>
							<option value="<?=$i?>"><?=number_format($square[$i]) ?> sqft</option>
						<?php
						}
						?>
						<option value="0">Unlimited</option>
				</select>
			</div>
			
			<div class="grid_6 six columns alpha omega bottom_10">
				<h6>Price Range</h6>
				<select name="listing_search_min_price" id="listing_search_min_price">
					<option value="">-- MIN PRICE --</option>
					<?php
					for ($i = 1; $i <= count($price); $i++) {
						
					?>
						<option value="<?=$price[$i] ?>">$<?=number_format($price[$i])?></option>
					<?php
					}
					?>
				</select>
				<span class="static_text">&nbsp;TO&nbsp;</span>
				<select name="listing_search_max_price" id="listing_search_max_price">
					<option value="">-- MAX PRICE --</option>
					<?php
					for ($i = 2; $i <= count($price); $i++) {
					?>
						<option value="<?=$price[$i] ?>">$<?=number_format($price[$i])?></option>
					<?php
					}
					?>
					<option value="0">Unlimited</option>
				</select>
			</div>
			<div class="grid_3 three columns alpha omega">
				<input type="submit" id="listing_search_submit" value="SEARCH FOR HOMES" />
			</div>
		</div>
		
	</form>