<?
/*

Listing search form for 24 grid websites. 
Optimized for wider view. 
Ensure to include demo.brixwork.com/master/js/listing_search_yaletown.js under listings.php using $scriptinclude. 
*/

$listing_search_city_columns = 3;
$listing_search_city_divclass = 'four columns';

// Let's set the variables accordingly to what's set in the Search section on the backend.
// If any of the fields is empty, then just set a fallback.


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price);
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}


$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);
	
if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square);
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}


if((is_array($settings['brixwork_search_type'])) && (count($settings['brixwork_search_type']) > 0)) {
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	$searchtype = $dwelling_type;
}
?>
<script type="text/javascript" src="<?=$settings['master_url']?>js/listing_search_24.js">
</script>


<style type="text/css">
	#listing_search_subareas input[type="checkbox"] {
		display:none;
	}
</style>

<script type="text/javascript">
	window.listing_search_city_columns = <?=$listing_search_city_columns?>;
	window.listing_search_city_divclass = '<?=$listing_search_city_divclass?>';
</script>

	<form id="listing_search_form" method="post" enctype="multipart/form-data">
		<?
		if($params['bldg']=='') { // show the standard area/subarea based listing search ONLY if the bldg param is OFF. 
		?>
		<div class="thirteen columns alpha <? echo ($slideoutcolour!='' ? $slideoutcolour : 'slideout_light')?>">
			<div class="eight columns alpha bottom_10">
				<h6>Select City &amp; Area</h6>
				<div class="eight columns alpha omega bottom_10">
					<select id="listing_search_city" name="listing_search_city">
						<option value="" rel="">All Cities</option>
						<?
						$result = $mysqli->query("SHOW COLUMNS FROM `areas` LIKE 'publish'");
						if($result->num_rows){
							// publish field set-  certain areas are hidden!
							$areassql = "SELECT id, name FROM areas WHERE publish=1 AND `name`!='' ORDER BY feature DESC, name ASC";
						} else {
							$areassql = "SELECT id, name FROM areas WHERE `name`!='' ORDER BY feature DESC, name ASC";
						}
						$areasresult = $mysqli->query($areassql);
						while($areas = $areasresult->fetch_assoc()) {
							$thisarea = new area;
							$thisarea->initialize($areas['id']);
							if(strtolower($thisarea->name)==strtolower($params['city'])) {
								$selectedtext = ' selected="selected"';
							} else {
								$selectedtext = '';
							}
							if($lastfeature==1 && $thisarea->feature==0) {
								echo '<option value="" disabled="disabled">-- MORE CITIES --</option>';
							}
							$lastfeature = $thisarea->feature;
							echo '<option '.$selectedtext.' value="'.$thisarea->name.'" rel="'.$thisarea->id.'">'.$thisarea->name.'</option>';
						}
						?>
					</select>
				</div>
			</div>
			<div class="five columns omega bottom_10">
				<h6>Property Type</h6>
				<div class="five columns alpha omega bottom_10">
					<select name="listing_search_type" id="listing_search_type">
						<option value="">Choose Type</option>
						<?php
						$count = 0;
						$typeid = get_property_type_id($params['type']);
						
						// first get ID of the house type currently selected
						foreach ($searchtype as $id => $title) {
							if($typeid==$id) {
								$selectedtext = ' selected="selected"';
							} else {
								$selectedtext = '';
							}
							?>
							<option rel="<? echo $id; ?>"<? echo $selectedtext; ?> value="<? echo $settings['type'][$id]; ?>" ><? echo $title; ?></option>
						<?php
							$count++;
						} ?>
					</select>
				</div>
			</div>
			<div class="clear"></div>
			<div class="thirteen columns alpha omega" id="listing_search_subareas">
				<?
				if($params['city']!='') {
					// load up the sub areas!
					$citysql = "SELECT id FROM areas WHERE LOWER(`name`)='".strtolower($mysqli->real_escape_string($params['city']))."'";
					$cityresult = $mysqli->query($citysql);
					$cityarray = $cityresult->fetch_assoc();
					$cityid = $cityarray['id'];
					$subareassql = "SELECT id, name FROM subareas WHERE area='".$cityid."' ORDER BY name";
					$subarearesult = $mysqli->query($subareassql);
					if($subarearesult->num_rows>0) {
						$total = $subarearesult->num_rows;
						$columns = $listing_search_city_columns;
						$percolumn = ceil($total/$columns);
						
						$columncount = 0;
						$count = 0;
						while($subareas = $subarearesult->fetch_assoc()) {
							//$subareas['id']
							//$subareas['name']
/*
							if($count==0 && $columncount==0) {
								echo '<div class="'.$listing_search_city_divclass.' alpha">
								';
								$columncount++;
							} else if($count==$percolumn && $columncount<($columns-1)) {
								// hit the max # for first column, close div and open another. 
								echo '</div><div class="'.$listing_search_city_divclass.'">
								';
								$count = 0;
								$columncount++;
							} else if($count==$percolumn && $columncount==($columns-1)) {
								echo '</div><div class="'.$listing_search_city_divclass.' omega">
								';
								$count = 0;
							}
*/
							if(is_array($params['area'])) {
								$subarea_search_array = array_map('strtolower', $params['area']); // if $params['area'] is array, map it to lower-cased mirror array!
								$single_param = false;
							} else {
								$single_param = ( strtolower($params['area'])==strtolower($subareas['name']) );
							}
							
							
							if( (is_array($params['area']) && in_array(strtolower($subareas['name']),$subarea_search_array)) || $single_param) {
								$selectedtext = ' checked';
							} else {
								$selectedtext = '';
							}
							echo '
							<div class="full_grid alpha omega">
								<div class="listing_search_checkbox">
									<input type="checkbox" name="listing_search_subarea[]" id="listing_search_subarea_'.$subareas['id'].'" value="'.$subareas['name'].'" rel="'.$subareas['id'].'" '.$selectedtext.'>
									<label for="listing_search_subarea_'.$subareas['id'].'">'.$subareas['name'].'</label>
								</div>
							</div>
							';
							$count++;
						}
// 						echo '</div>';
					}
				}
				?>
			</div>
			
		</div>
		<div class="eleven columns omega">
			<div class="eight columns alpha bottom_10">
				<h6>Size &amp; Capacity</h6>
				<select name="listing_search_min_bedrooms" id="listing_search_min_bedrooms">
					<option value="">--MIN BEDROOMS</option>
					<?php
					
					for ($i = 0; $i <= count($bed); $i++) {
						 if($bed[$i]!='') {
							 if($bed[$i]==$params['min_bedroom'] && isset($params['min_bedroom'])) {
							 	$selectedtext = ' selected="selected"';
							 } else {
							 	$selectedtext = '';
							 }
						?>
							<option value="<?=$bed[$i]?>" <?=$selectedtext?>><?=$bed[$i]?>+</option>
					<?php 
						}
					}
					?>
				</select>
				<select name="listing_search_min_bathrooms" id="listing_search_min_bathrooms">
					<option value="">--MIN BATHROOMS</option>
					<?php 
					for ($i = 1; $i <= count($bath) - 1; $i++) { 
						
						if($bath[$i]==$params['min_bathroom']) {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
						<option value="<?=$i?>"<?=$selectedtext?>><?=$bath[$i]?>+</option>
					<?php
					}
					?>
				</select>
				<div class="clear"></div>
				<select name="listing_search_min_sqft" id="listing_search_min_sqft">
					<option value="">--MIN SQFT</option>
						<?php
						for ($i = 1; $i <= count($square); $i++) { 
							if($i==$params['min_sqft']) {
							 	$selectedtext = ' selected="selected"';
							} else {
							 	$selectedtext = '';
							}
						?>
							<option value="<?=$i ?>"<?=$selectedtext?>><?=number_format($square[$i])?> sqft</option>
						<?php
						}
						?>
				</select><span class="static_text">&nbsp;TO&nbsp;</span>
				<select name="listing_search_max_sqft" id="listing_search_max_sqft">
					<option value="">--MAX SQFT</option>

					<?php
						for ($i = 2; $i <= count($square); $i++) { 
							if($i==$params['max_sqft']) {
							 	$selectedtext = ' selected="selected"';
							} else {
							 	$selectedtext = '';
							}
						?>
							<option value="<?=$i?>"<?=$selectedtext?>><?=number_format($square[$i]) ?> sqft</option>
						<?php
						}
						if($params['max_sqft']=='0') {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
						
						?>
						<option value="0"<?=$selectedtext?>>Unlimited</option>
				</select>
				<div class="clear"></div>
				<h6>Price Range</h6>
				<select name="listing_search_min_price" id="listing_search_min_price">
					<option value="">-- MIN PRICE</option>
					<?php
					for ($i = 1; $i <= count($price); $i++) {
						if($price[$i]==$params['min_price'] && isset($params['min_price'])) {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
						<option value="<?=$price[$i] ?>"<?=$selectedtext?>>$<?=number_format($price[$i])?></option>
					<?php
					}
					?>
				</select>
				<span class="static_text">&nbsp;TO&nbsp;</span>
				<select name="listing_search_max_price" id="listing_search_max_price">
					<option value="">-- MAX PRICE</option>
					<?php
					for ($i = 2; $i <= count($price); $i++) {
						if($price[$i]==$params['max_price']) {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
						<option value="<?=$price[$i] ?>"<?=$selectedtext?>>$<?=number_format($price[$i])?></option>
					<?php
					}
					if($params['max_price']=='0') {
						 	$selectedtext = ' selected="selected"';
						} else {
						 	$selectedtext = '';
						}
					?>
					<option value="0"<?=$selectedtext?>>Unlimited</option>
				</select>
			</div>
			<?
			if($listing_custom_filename!='') {
				echo '<input type="hidden" value="'.$listing_custom_filename.'" name="listing_custom_filename" />';
			}
			?>
			
			<div class="three columns omega">
				<input type="submit" id="listing_search_submit" value="Search" />
			</div>
			
			<div class="twentyfour columns alpha omega slideout_handle">
				<span>advanced listing search form</span>
			</div>
			
		</div>
		
		<div class="twentyfour columns alpha omega bottom_20" id="listing_order_form" style="background-color:<? echo ($orderformbg!='' ? $orderformbg : '#ddd'); ?>; ">
			<div class="eight columns alpha bottom_10">
				<select name="listing_order_by" id="listing_order_by">
					<option value="">Order By</option>
					<option value="create_date"<? if($params['order_by']=='create_date') { echo ' selected="selected"';}?>>Date Listing Came On Market</option>
					<option value="price"<? if($params['order_by']=='price') { echo ' selected="selected"';}?>>Current Listed Price</option>
					<option value="sqft"<? if($params['order_by']=='sqft') { echo ' selected="selected"';}?> <? if(strpos($settings['mls_import_url'], 'ottawa')!==false) { echo ' disabled="disabled" style="display:none;"';}?>>Size of Home (sqft)</option>
					<option value="bedroom"<? if($params['order_by']=='bedroom') { echo ' selected="selected"';}?>>Number of Bedrooms</option>
					<option value="bathroom"<? if($params['order_by']=='bathroom') { echo ' selected="selected"';}?>>Number of Bathrooms</option>
				</select>
			</div>
			<div class="eight columns bottom_10">
				<select name="listing_order_direction" id="listing_order_direction">
					<option value="DESC">&gt;- Choose Option</option>
					<option value="ASC"<? if($params['order_direction']=='ASC') { echo ' selected="selected"';}?>>&gt;- Choose Option</option>
				</select>
			</div>
			<div class="eight columns omega">
				<input type="button" id="listing_order_submit" value="Refresh" />
			</div>
		</div>
		<? } else { ?>
			<input type="hidden" name="listing_bldg" value="<? echo $params['bldg']; ?>" />
			<input type="hidden" name="listing_building" value="<? echo $params['building']; ?>" />
		<? } ?>
		
		<?
		if ($params['keyword'] != '') { ?>
			<input type="hidden" name="keyword" value="<?=$params['keyword']?>" />
		<? } ?>

	</form>