<?
/*

Listing search form for Bootstrap websites. 
Optimized for wider view. 
has some .JS and other inclues in there. 
*/

// Let's set the variables accordingly to what's set in the Search section on the backend.
// If any of the fields is empty, then just set a fallback.


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price);
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}


$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);
	
if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square);
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}

if($commercial_types != '') {
	$searchtype = $commercial_types;
} else if((is_array($settings['brixwork_search_type'])) && (count($settings['brixwork_search_type']) > 0)) {
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	$searchtype = $dwelling_type;
}
?>
<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
<script type="text/javascript" src="<?=brixwork_core_url('js/bootstrap3-typeahead.min.js')?>"></script>
<script type="text/javascript" src="<?=brixwork_core_url('js/jquery.touuchpunch.js')?>">

</script>

<?
// Disables cdn loading so we can test the forms. If true, then css and js need to be loaded locally
if (!$search_form_test) {
	?>
	<link href="<?= brixwork_core_url('css/listing_search_mainst.css') ?>" rel="stylesheet" />
	<script type="text/javascript" src="<?= brixwork_core_url('js/listing_search_mainst.js') ?>">
	
	</script>
	<?
}
?>


<script type="text/javascript">
<?
if(isset($params['area'])) {
	// var set!
	echo 'window.params_areas = []; // declare array for subareas chosen
	'; 
	if(is_array($params['area'])) {
		// multiple subareas in array format. 
		foreach($params['area'] as $keycount=> $subarea) {
			echo 'window.params_areas['.$keycount.'] = "'.$subarea.'";
			';
		}
	} else {
		// single subarea. 
		echo 'window.params_areas[0] = "'.$params['area'].'";
		';
	}
}
?>


$(document).ready(function(){
	<?
	if($settings['listing_search_skip_to_listings']==1 && ($params===false || !isset($params['pageid']))) {
		?>
		$('html, body').delay(1000).animate({scrollTop: $("#listings_wrapper").offset().top-100}, 2000);
		<?
	}
	?>
	
		
});
</script>

<style type="text/css">
	.slider_wrap .ui-slider .ui-slider-handle {
		width:19px;
		height:19px;
		top:-8px;
		border:none;
		margin-left:-8px;
		z-index:9;
		top:-8px;
	}
	
	.slider_display_value_container {
		text-align: center;
		
		-webkit-transition: all 0.5s;
		-moz-transition: all 0.5s; 
		transition: all 0.5s;
	}
	
	.slider_display_value_container p.slider_display_value {
		margin-left:auto;
		margin-right:auto;
		text-align: center;
		display:inline-block;
		width:auto;
		-webkit-transition: all 0.5s;
		-moz-transition: all 0.5s; 
		transition: all 0.5s;
		margin-bottom:20px;
	}
	
	#listing_search_form .slider_wrap {
		margin-bottom:40px;
	}
	
	#listing_search_form .brixwork_mainst_criterion {
		width: 100%;
	}
	
	#listing_search_form .brixwork_mainst_submit_container #listing_search_submit {
		width: 100%;
		margin: 0;
	}
	
	@media only screen and (min-width: 768px) {
		#listing_search_form .brixwork_mainst_criterion {
			width: 24%;
		}
	}
	
</style>


	<form id="listing_search_form" method="post" enctype="multipart/form-data">
		
		<input type="hidden" name="listing_search_min_sqft" id="listing_search_min_sqft" <?=($params['min_sqft']!='' ? ' value="'.$params['min_sqft'].'"' : '')?> autocomplete="off" />
		<input type="hidden" name="listing_search_max_sqft" id="listing_search_max_sqft" <?=($params['max_sqft']!='' ? ' value="'.$params['max_sqft'].'"' : '')?> autocomplete="off" />
		<input type="hidden" name="listing_search_min_price" id="listing_search_min_price" <?=($params['min_price']!='' ? ' value="'.$params['min_price'].'"' : 'value=""')?> autocomplete="off" />
		<input type="hidden" name="listing_search_max_price" id="listing_search_max_price" <?=($params['max_price']!='' ? ' value="'.$params['max_price'].'"' : 'value=""')?> autocomplete="off" />
					
		<input type="hidden" id="search_min_price" value="<?=$price_param['min']?>" autocomplete="off" />
		<input type="hidden" id="search_max_price" value="<?=$price_param['max']?>" autocomplete="off" />
		<input type="hidden" id="search_price_increments" value="<?=$price_param['increment']?>" autocomplete="off" />
			
		<input type="hidden" id="default_min_price" value="<?=($params['min_price']!='' ? $params['min_price'] : $price_param['min'])?>" autocomplete="off" />
		<input type="hidden" id="default_max_price" value="<?=($params['max_price']!='' ? $params['max_price'] : $price_param['max'])?>" autocomplete="off" />
		
		<div class="col-md-8 col-sm-12">
		<div class="brixwork_mainst_slider_wrap">	
				<div class="brixwork_mainst_search_slider_min" id="brixwork_mainst_price_min_display">&nbsp;</div>
				<div class="brixwork_mainst_search_slider_max" id="brixwork_mainst_price_max_display">&nbsp;</div>
				<div class="brixwork_mainst_slider formcolor" id="brixwork_mainst_price_slider"></div>
				
			</div>
		</div>
		
		<input type="hidden" id="search_min_sqft" value="<?=$sqft_param['min']?>" autocomplete="off" />
		<input type="hidden" id="search_max_sqft" value="<?=$sqft_param['max']?>" autocomplete="off" />
		<input type="hidden" id="search_sqft_increments" value="<?=$sqft_param['increment']?>" autocomplete="off" />
		
		<input type="hidden" id="default_min_sqft" value="<?=($params['min_sqft']!='' ? $params['min_sqft'] : $sqft_param['min'])?>" autocomplete="off" />
		<input type="hidden" id="default_max_sqft" value="<?=($params['max_sqft']!='' ? $params['max_sqft'] : $sqft_param['max'])?>" autocomplete="off" />
		
		<div class="col-md-4 col-sm-12">
			<div class="brixwork_mainst_slider_wrap">	
				<div class="brixwork_mainst_search_slider_min" id="brixwork_mainst_sqft_min_display">&nbsp;</div>
				<div class="brixwork_mainst_search_slider_max" id="brixwork_mainst_sqft_max_display">&nbsp;</div>
				<div class="brixwork_mainst_slider formcolor" id="brixwork_mainst_sqft_slider"></div>
				
			</div>
		</div>
				
		<div class="clearfix"></div>
		
		<div class="col-xs-12">
			<div class="brixwork_mainst_city_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<path d="M4.647,7.657v0.02C4.641,7.785,4.638,7.897,4.638,8.012c0,2.265,1.432,3.885,2.951,5.602
							c0.509,0.577,1.039,1.172,1.527,1.812c1.643,2.137,2.513,5.461,2.885,7.259c0.375-1.798,1.247-5.122,2.888-7.259
							c0.49-0.639,1.016-1.235,1.526-1.812c1.519-1.717,2.95-3.337,2.95-5.602c0-0.113-0.002-0.225-0.009-0.335V7.653
							c-0.183-3.938-3.413-7.097-7.36-7.193C8.058,0.556,4.83,3.717,4.647,7.657 M12.229,24h-0.456c-0.007-0.055-0.806-5.404-3.022-8.292
							c-0.481-0.627-1.005-1.219-1.508-1.789c-1.576-1.783-3.068-3.469-3.068-5.907c0-0.092,0.002-0.179,0.006-0.268L4.168,7.728
							l0.019-0.09C4.378,3.454,7.805,0.101,11.996,0c4.201,0.101,7.628,3.454,7.819,7.639l0.019,0.09l-0.013,0.017
							c0.004,0.09,0.006,0.179,0.006,0.268c0,2.44-1.49,4.124-3.065,5.907c-0.506,0.57-1.029,1.162-1.509,1.789
							C13.034,18.598,12.237,23.947,12.229,24"/>
						<path d="M14.304,7.705c0,1.271-1.031,2.301-2.302,2.301c-1.271,0-2.303-1.03-2.303-2.301
							c0-1.271,1.031-2.302,2.303-2.302C13.273,5.403,14.304,6.434,14.304,7.705"/>
					</g>
				</svg>

				<select name="listing_search_city" id="brixwork_mainst_listing_search_city" class="brixwork_mainst_city_select" data-placeholder="Choose a City" autocomplete="off">
				<option value="" selected="selected">Choose A City</option>
				<?
				$sql = "SELECT `id`, `name` FROM `areas` WHERE `publish`=1 ORDER BY `feature` DESC, `name` ASC";
				$result = $mysqli->query($sql);
				while($cities = $result->fetch_assoc()) {
                    $selectedtext = '';

                   if(is_string($cities['name']) && is_string($params['city'])) {
                        if(strtolower($cities['name'])==strtolower($params['city'])) {
                            $selectedtext = ' selected="selected"';
                        }
					}
					echo '<option rel="'.$cities['id'].'" value="'.$cities['name'].'" '.$selectedtext.'>'.$cities['name'].'</option>';
				}
				?>
				</select>
			</div>
			<div class="brixwork_mainst_area_container">
				<select name="listing_search_subarea[]" id="brixwork_mainst_listing_search_area" class="brixwork_mainst_area_select" multiple data-placeholder="Choose City First" autocomplete="off">
					<option value="" selected="selected">Choose Subareas</option>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_street_search_container">
				<input type="text" name="listing_search_street" id="brixwork_mainst_street_search" class="typeahead" data-provide="typeahead" autocomplete="nope" />
				<input type="hidden" name="listing_search_street_dir" value="" />
				<input type="hidden" name="listing_search_street_name" value="" />
				<input type="hidden" name="listing_search_street_type" value="" />
				<input type="hidden" name="listing_search_street_suffix" value="" />
			</div>
		</div>
		<div class="clearfix"></div>
		
		<div class="col-xs-12">
			<div class="brixwork_mainst_criterion brixwork_mainst_type_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<g>
						<path d="M9.942,17.651h4.119c0.137,0,0.25-0.111,0.25-0.252V14c0-0.137-0.114-0.249-0.25-0.249H9.942
							c-0.139,0-0.25,0.112-0.25,0.249v3.399C9.691,17.54,9.803,17.651,9.942,17.651z M10.19,14.253h3.617v2.898H10.19V14.253z"/>
						<path d="M21.824,10.251l-9.497-8.129c-0.188-0.162-0.465-0.162-0.654,0l-9.499,8.129
							c-0.158,0.138-0.216,0.36-0.143,0.554c0.072,0.2,0.26,0.329,0.47,0.329h2.861v9.637c0,0.275,0.225,0.5,0.501,0.5h12.274
							c0.275,0,0.502-0.225,0.502-0.5v-9.637h2.857c0.211,0,0.398-0.129,0.471-0.329C22.042,10.611,21.984,10.389,21.824,10.251z
							 M17.634,20.266H6.365v-9.132h11.269V20.266z M18.137,10.131H5.864H3.859L12,3.164l8.138,6.968H18.137z"/>
						</g>
						<g>
						<path d="M9.942,17.651h4.119c0.137,0,0.25-0.111,0.25-0.252V14c0-0.137-0.114-0.249-0.25-0.249H9.942
							c-0.139,0-0.25,0.112-0.25,0.249v3.399C9.691,17.54,9.803,17.651,9.942,17.651z M10.19,14.253h3.617v2.898H10.19V14.253z"/>
						<path d="M21.824,10.251l-9.497-8.129c-0.188-0.162-0.465-0.162-0.654,0l-9.499,8.129
							c-0.158,0.138-0.216,0.36-0.143,0.554c0.072,0.2,0.26,0.329,0.47,0.329h2.861v9.637c0,0.275,0.225,0.5,0.501,0.5h12.274
							c0.275,0,0.502-0.225,0.502-0.5v-9.637h2.857c0.211,0,0.398-0.129,0.471-0.329C22.042,10.611,21.984,10.389,21.824,10.251z
							 M17.634,20.266H6.365v-9.132h11.269V20.266z M18.137,10.131H5.864H3.859L12,3.164l8.138,6.968H18.137z"/>
						</g>
					</g>
				</svg>
				<select name="listing_search_type" id="brixwork_mainst_search_type" data-placeholder="Property Type">
					<option value="">Any Type</option>
					<?php
					$count = 0;
					$typeid = get_property_type_id($params['type']);
					
					echo('<br/><br/>TYPE: '.$params['type'].'&nbsp;&nbsp;&nbsp;'.$typeid);
					
					// first get ID of the house type currently selected
					foreach ($searchtype as $id => $title) {
						if($typeid==$id) {
							$selectedtext = ' selected="selected"';
						} else {
							$selectedtext = '';
						}
						?>
						<option rel="<? echo $id; ?>"<? echo $selectedtext; ?> value="<? echo $settings['type'][$id]; ?>" ><? echo $title; ?></option>
						<?php
						$count++;
					} ?>
				</select>
			</div>
			
			<div class="brixwork_mainst_criterion brixwork_mainst_orderby_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<path d="M6.272,15.518h-2.3C3.434,15.518,3,15.954,3,16.491c0,0.535,0.434,0.967,0.972,0.967h2.3V15.518z"/>
						<path d="M20.021,15.518H8.318v1.94h11.703c0.541,0,0.979-0.432,0.979-0.967C21,15.954,20.562,15.518,20.021,15.518z
							"/>
					</g>
					<g>
						<path d="M6.272,11.33h-2.3C3.434,11.33,3,11.766,3,12.307c0,0.539,0.434,0.972,0.972,0.972h2.3V11.33z"/>
						<path d="M20.021,11.33H8.318v1.949h11.703c0.541,0,0.979-0.433,0.979-0.972C21,11.766,20.562,11.33,20.021,11.33z"
							/>
					</g>
					<g>
						<path d="M6.272,7.146h-2.3C3.434,7.146,3,7.581,3,8.12c0,0.542,0.434,0.973,0.972,0.973h2.3V7.146z"/>
						<path d="M20.021,7.146H8.318v1.947h11.703C20.562,9.093,21,8.661,21,8.12C21,7.581,20.562,7.146,20.021,7.146z"/>
					</g>
					
				</svg>
				<select name="listing_order_by" id="brixwork_mainst_listing_order_by" autocomplete="off">
					<option value="create_date"<? if($params['order_by']=='create_date' || !isset($params['order_by'])) { echo ' selected="selected"';}?>>Date Listed</option>
					<option value="price"<? if($params['order_by']=='price') { echo ' selected="selected"';}?>>Listed Price</option>
					<option value="sqft"<? if($params['order_by']=='sqft') { echo ' selected="selected"';}?>>Size of Home</option>
					<option value="bedroom"<? if($params['order_by']=='bedroom') { echo ' selected="selected"';}?>>Bedrooms</option>
					<option value="bathroom"<? if($params['order_by']=='bathroom') { echo ' selected="selected"';}?>>Bathrooms</option>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_orderdir_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<path d="M22.3,11.498l-5.812-6.422c-0.119-0.134-0.293-0.21-0.474-0.21c-0.179,0-0.351,0.076-0.472,0.21l-4.77,5.269
	V5.91c0-0.352-0.285-0.638-0.639-0.638H5.812c-0.354,0-0.638,0.286-0.638,0.638v5.451H2.095c-0.253,0-0.481,0.151-0.585,0.381
	c-0.102,0.232-0.058,0.5,0.111,0.686l5.881,6.499c0.119,0.135,0.291,0.209,0.471,0.209s0.352-0.074,0.474-0.209l4.769-5.27v4.434
	c0,0.354,0.285,0.639,0.635,0.639h4.326c0.353,0,0.637-0.285,0.637-0.639v-5.451h3.08c0.005,0,0.01,0,0.013,0
	c0.353,0,0.638-0.288,0.638-0.638C22.544,11.795,22.446,11.613,22.3,11.498z M7.973,17.547L3.53,12.639h2.282
	c0.354,0,0.637-0.288,0.637-0.638V6.545h3.048V12c0,0.011,0.007,0.021,0.007,0.027c0.002,0.065,0.016,0.134,0.04,0.198
	c0.002,0.01,0.004,0.018,0.006,0.027c0.002,0.003,0.002,0.004,0.002,0.004c0.029,0.068,0.075,0.128,0.122,0.177
	c0.016,0.017,0.027,0.025,0.043,0.04c0.044,0.036,0.088,0.067,0.14,0.092c0.018,0.01,0.036,0.02,0.056,0.025
	c0.07,0.027,0.147,0.047,0.221,0.047h2.284L7.973,17.547z M18.177,11.361c-0.354,0-0.641,0.288-0.641,0.64v5.451h-3.045V12
	c0-0.011-0.006-0.02-0.009-0.029c-0.001-0.065-0.013-0.133-0.038-0.197c-0.002-0.006-0.002-0.017-0.007-0.028
	c-0.003-0.001-0.003-0.003-0.003-0.004c-0.029-0.067-0.07-0.125-0.12-0.179c-0.015-0.012-0.028-0.021-0.044-0.035
	c-0.041-0.037-0.087-0.067-0.137-0.094c-0.021-0.009-0.037-0.018-0.061-0.027c-0.069-0.026-0.143-0.046-0.223-0.046h-2.279
	l4.442-4.906l4.441,4.906H18.177z"/>
				</svg>
				<select name="listing_order_direction" id="brixwork_mainst_listing_order_direction" autocomplete="off" data-placeholder="Order Direction">
					<option value="DESC"> </option>
					<option value="ASC"<? if($params['order_direction']=='ASC') { echo ' selected="selected"';}?>> </option>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_submit_container">
				<input type="button" id="listing_search_submit" value="SEARCH" class="btn-mst" />
			</div>
		</div>
		
		<div class="clearfix"></div>
		
		<?
		if ($params['keyword'] != '') { ?>
			<input type="hidden" name="keyword" value="<?=$params['keyword']?>" />
		<? } ?>
		
		<?
		if($params['bldg']=='') { // show the standard area/subarea based listing search ONLY if the bldg param is OFF. 
		?>
		
		<? } else { ?>
			<input type="hidden" name="listing_bldg" value="<? echo $params['bldg']; ?>" />
			<input type="hidden" name="listing_building" value="<? echo $params['building']; ?>" />
		<? } ?>



		<?
		if($params['bldg']=='') { // ordering not necessary for building based listings yet.  
		?>
	
		
			<div style="display: none;">
	
					
			</div>
		<?
		if($listing_custom_filename!='') {
			echo '<input type="hidden" value="'.$listing_custom_filename.'" name="listing_custom_filename" autocomplete="off" />';
		}
		?>

	<? } else { ?>
			<input type="hidden" name="listing_bldg" value="<? echo $params['bldg']; ?>" />
			<input type="hidden" name="listing_building" value="<? echo $params['building']; ?>" />
	<? } ?>
	

	</form>