<?
if (!isset($gen_carousel_id_count) || !is_numeric($gen_carousel_id_count) ) {
    $gen_carousel_id_count = 0;
}
if ( isset($gen_carousel_id) && $gen_carousel_id === "brix_bootstrap4_carousel_$gen_carousel_id_count" ) {
    $gen_carousel_id_count++;
    $gen_carousel_id = "brix_bootstrap4_carousel_$gen_carousel_id_count";
} else if ( !isset($gen_carousel_id) || $gen_carousel_id == '' ) {
    $gen_carousel_id_count++;
    $gen_carousel_id = 'brix_bootstrap4_carousel';
}

if ( !isset($show_carousel_title) || !is_bool($show_carousel_title) ) {
    $show_carousel_title = false;
}

if ( !isset($show_carousel_indicators) || !is_bool($show_carousel_indicators) ) {
    $show_carousel_indicators = true;
}

if ( $show_carousel_indicators ) {
    if ( !isset($carousel_indicator_type) || !is_string($carousel_indicator_type) || $carousel_indicator_type == '' ) {
        // types are thumbnails or dashes.
        $carousel_indicator_type = 'thumbnails';
    }
}

if ( !isset($carousel_items) || !is_array($carousel_items) ) {
    if ( isset($thispage) ) {
        $thispage->getphotos();
        $carousel_items = array(
            'photos'    =>  generate_bootstrap4_carousel_image_array_yt2($thispage->photos),
            'titles'    =>  generate_bootstrap4_carousel_image_array_yt2($thispage->photos, 'title', $thispage->title),
        );

        if ( $show_carousel_indicators && $carousel_indicator_type == 'thumbnails' ) {
            $carousel_indicators = ( !isset($carousel_indicators) || count($carousel_indicators) !== count($carousel_items) ) ? generate_bootstrap4_carousel_image_array_yt2($thispage->photos, 'thumbnailpath') : $carousel_indicators;
        }
    } else if ( isset($building) ) {
        $building->getphotos();
        $carousel_items = array(
            'photos'    =>  generate_bootstrap4_carousel_image_array_yt2($building->photos),
            'titles'    =>  generate_bootstrap4_carousel_image_array_yt2($building->photos, 'title', $building->name),
        );

        if ( $show_carousel_indicators && $carousel_indicator_type == 'thumbnails' ) {
            $carousel_indicators = ( !isset($carousel_indicators) || count($carousel_indicators) !== count($carousel_items) ) ? generate_bootstrap4_carousel_image_array_yt2($building->photos, 'thumbnailpath') : $carousel_indicators;
        }
    } else if ( isset($bldg) ) {
        $bldg->getphotos();
        $carousel_items = array(
            'photos'    =>  generate_bootstrap4_carousel_image_array_yt2($bldg->photos),
            'titles'    =>  generate_bootstrap4_carousel_image_array_yt2($bldg->photos, 'title', $bldg->name),
        );

        if ( $show_carousel_indicators && $carousel_indicator_type == 'thumbnails' ) {
            $carousel_indicators = ( !isset($carousel_indicators) || count($carousel_indicators) !== count($carousel_items) ) ? generate_bootstrap4_carousel_image_array_yt2($bldg->photos, 'thumbnailpath') : $carousel_indicators;
        }
    } else if ( isset($home) ) {
        $home->getphotos();

        $main_image_path = $home->get_main_images_path(0, '', false);
        $main_image_array = array();

        if ( $main_image_path != '' && $main_image_path != $home->mls_photo) {
            $main_image_array['filepath'] = $main_image_path;
            $main_image_array['thumbnailpath'] = $main_image_path;
            $main_image_array['title'] = $home->fulladdress . " Main Gallery Photo";

            array_unshift($home->photos, $main_image_array);
        }

        $carousel_items = array(
            'photos'    =>  generate_bootstrap4_carousel_image_array_yt2($home->photos),
            'titles'    =>  generate_bootstrap4_carousel_image_array_yt2($home->photos, 'title', $home->fulladdress),
        );

        if ( $show_carousel_indicators && $carousel_indicator_type == 'thumbnails' ) {
            $carousel_indicators = ( !isset($carousel_indicators) || count($carousel_indicators) !== count($carousel_items) ) ? generate_bootstrap4_carousel_image_array_yt2($home->photos, 'thumbnailpath') : $carousel_indicators;
        }
    } else if ( isset($listing) ) {
        $listing->getphotos();

        $main_image_path = $listing->get_main_images_path(1, '', false);
        $main_image_array = array();

        if ( $main_image_path != '' && $main_image_path != $listing->mls_photo) {
            $main_image_array['filepath'] = $main_image_path;
            $main_image_array['thumbnailpath'] = $main_image_path;
            $main_image_array['title'] = $listing->fulladdress . " Main Gallery Photo";

            array_unshift($listing->photos, $main_image_array);
        }

        $carousel_items = array(
            'photos'    =>  generate_bootstrap4_carousel_image_array_yt2($listing->photos),
            'titles'    =>  generate_bootstrap4_carousel_image_array_yt2($listing->photos, 'title', $listing->fulladdress),
        );

        if ( $show_carousel_indicators && $carousel_indicator_type == 'thumbnails' ) {
            $carousel_indicators = ( !isset($carousel_indicators) || count($carousel_indicators) !== count($carousel_items) ) ? generate_bootstrap4_carousel_image_array_yt2($listing->photos, 'thumbnailpath') : $carousel_indicators;
        }
    } else {
        echo '<h1>Can\'t show carousel without $carousel_items</h1>';
        return;
    }
}

if ( !isset($carousel_title) || !is_array($carousel_title) ) {
    if ( isset($thispage) ) {
        $carousel_title = $thispage->title;
    } else if ( isset($building) ) {
        $carousel_title = $building->name;
    } else if ( isset($bldg) ) {
        $carousel_title = $bldg->name;
    } else if ( isset($home) ) {
        $carousel_title = $home->fulladdress;
    } else if ( isset($listing) ) {
        $carousel_title = $listing->fulladdress;
    } else {
        $carousel_title = '';
    }
}

if (count($carousel_items) > 0) {
    ?>
    <style>
        <?
        if ( !isset($yaletown2_include_path_css) || $yaletown2_include_path_css == '' ) {
            $yaletown2_include_path_css = "/includes/yaletown2/";
        }

        include_once $_SERVER['DOCUMENT_ROOT'] . $yaletown2_include_path_css . "brix_bootstrap4_carousel.min.css";
        ?>
    </style>
    <div class="brix_bootstrap4_carousel_wrapper <?= $show_carousel_indicators ? $carousel_indicator_type : '' ?>">
        <?= create_bootstrap4_carousel_yt2($carousel_items, $carousel_indicators) ?>
    </div>
    <script>
        $(document).ready(function() {
            initiate_generic_bootstrap_carousel("<?= $gen_carousel_id ?>", true);
        });
    </script>
<? }