<div class="col-md-12 col-lg-5 col-xl-4 features_section">
    <div class="listing_address d-none d-lg-block">
		<?
		if ( isset($remark) && $remark != '') {
			?>
            <div class="remarks">
				<?= $remark ?>
            </div>
			<?
		}
		$share_link = '';
		if ( $is_share_icon_enabled ) {
			$share_icon = get_svg(file_get_contents($settings['templatepath'].'images/icons/listings_share_icon.svg', false), 'share_icon');

			$share_link = "<a href='#share_social_popup' class='fancybox_share' Title='share $pagetitle'>$share_icon</a>";
		}
		?>
        <h1 class="street"><?= $home->address ?><?= $share_link ?></h1>
        <h2 class="h3_style area_city"><?= $home->areacity ?></h2>
    </div>
    <div class="price d-none d-lg-block">
        <h3 class="h3_style">Listed at <span class="price_text"><?= $home->price ?></span></h3>
    </div>
    <div class="listing_features">
        <h6 class="h4_style title">Features</h6>
		<?= insert_home_features_list($home) ?>
    </div>
</div>

<div class="col-md-12 col-lg-7 col-xl-8 <?= $show_carousel ? 'carousel_wrapper' : 'image_wrapper'?>">
	<?
	if ( $show_carousel ) {
		include $_SERVER['DOCUMENT_ROOT'].'/templates/main/includes/generic_bootstrap_carousel.php';
	} else {
		$main_image =  $home->get_main_images_path(0, '', 0);

		echo "<img class='img-full' alt='$home->fulladdress' title='$home->fulladdress' src='$main_image' />";
	}
	?>


	<? if ($home->sold != 0) { ?>
        <img src="<?=$settings['templatepath']?>images/sold-banner.svg" alt="Sold Banner" title="Sold Banner" class="sold_banner">
	<? } ?>


    <div class="address_section d-lg-none">
        <h6><?= $home->price ?></h6>
        <h2><?= $home->address ?></h2>
		<?
		$bbs = yt2_generate_bbs($home);
		?>
        <h6><?= $bbs ?></h6>
    </div>
    <div class="mobile_buttons_section d-lg-none pb-3">
        <div class="info_wrapper padding_top_20">
            <a href="#showlisting_contact" class="btn btn-yt2">Request<?= ($own_listing ? ' More ' : ' ') ?>Info</a>
            <div class="btn btn-yt2"><?= $share_link ?></div>
        </div>

		<? if ( $home->pdf != '' ) { ?>
            <div class="pdf_wrapper padding_box_20 d-md-none"><?
				$k = 0;
				foreach ($settings['homes_pdffilename'] as $array) {
					if ($home->pdf_file_link($k)) {
						?>
                        <div class="pdf_link btn btn-yt2">
							<?= $home->pdf_file_link($k, "PDF") ?>
                        </div>
						<?
					}
				}
				?>
            </div>
		<? } ?>

		<?
		if ($home->videoembedurl != '' && $home->source==0) { ?>
            <div class="video_section padding_box_medium d-md-none">
				<?
				/*
				 * If client wants video to be FULL WIDTH, remove the div.container altogether,
				 * Then take out .col-sm-12 and only leave .video_wrapper
				 *
				 * */

				$videoembedurl = '';

				if ( $home->vimeo != '' ) {
					$videoembedurl = "//player.vimeo.com/video/$home->vimeo?title=0&byline=0&portrait=0";
				} else {
					$videoembedurl = $home->videoembedurl;
				}
				?>
                <div class="video_wrapper">
                    <iframe loading="lazy" src="<?= $videoembedurl ?>" frameborder="0" allowfullscreen></iframe>
                </div>
            </div>
		<? } ?>

		<?
		// VIRTUAL TOUR SECTION
		if ($home->virtualtour != '' && $home->source==0) {
			// If client wants to show videos for all MLS listings as well, remove the $home->source==0 portoin.
			?>
            <div class="virtualtour_section padding_box_medium d-md-none">
                <div class="video_wrapper">
                    <iframe loading="lazy" class="showlisting_virtualtour" src="<?= $home->virtualtour ?>" frameborder="0" allowfullscreen></iframe>
                </div>
            </div>
		<? } ?>
    </div>
</div>
<div class="col-md-12 col-lg-7 col-xl-8 description_section">
    <div class="desc_features_container">
        <div class="listing_description">
			<?
			$description_default_heading = 'About this ' . ($home->type != ''  ? $home->type : 'property') . ' in ' . ($home->area != '' ? $home->area : $home->city);
			$description_heading = $home->heading != '' ? $home->heading : $description_default_heading;

			$description_content_body = '';
			$max_mobile_length = 484;
			$desc_character_count = strlen(strip_tags($home->desc));

			if ( $desc_character_count > $max_mobile_length ) {
				$allowable_tags = '<h1><h2><h3><h4><h5><h6><p2><span><img><a><br>';
				$from = '/'.preg_quote('<p', '/').'/';
				$home_desc_temp = preg_replace($from, "<p2", $home->desc, 1);
				$home_desc_temp = str_replace('</p>', '<span class="custom_line_height"><br></span>', $home_desc_temp);

				$home_desc = strip_tags($home_desc_temp, $allowable_tags);
				$description_content_body1 = substr($home_desc, 0, $max_mobile_length);
				$description_content_body = str_replace('<p2', '<p', $description_content_body1);
				$description_content_body .= "<span class='ellipsis'>&#8230;</span>";

				$description_content_body2 = substr($home_desc, $max_mobile_length, strlen($home->desc));
				$description_content_body .= "<span class='hide_text'>$description_content_body2</span></p>";
			}  else {
				$description_content_body = $home->desc;
			}
			?>
            <h3 class="description_title"><?= $description_heading ?></h3>
			<? if ( $desc_character_count > $max_mobile_length ) { ?>
                <div class="description_content_mobile d-lg-none"><?= $description_content_body ?></div>
                <div class='d-lg-none btn btn-yt2 description_read_more_mobile d-table mx-auto'>Read More</div>
			<? } ?>
            <div class="<?= $desc_character_count > $max_mobile_length ? 'd-none d-lg-block' : '' ?>"><?= $home->desc ?></div>
			<?
			// hide this if we enable the new share button
			if (!$is_share_popup_enabled) { ?>
                <div>
                    <div>
						<? include $_SERVER['DOCUMENT_ROOT'] . '/includes/social_plugins.php' ?>
                    </div>
                </div>
			<? } ?>
			<?
			if ( !$own_listing ) { ?>
                <div class="padding_box_small">
					<?= brixwork_mls_disclaimer() ?>
                </div>
			<? } else {
				// PDF SECTION
				if ( $home->pdf != '' ) { ?>
                    <div class="pdf_container d-none d-md-flex">
						<?
						$k = 1;
						foreach ($settings['homes_pdffilename'] as $array) {
							if ($home->pdf_file_link($k)) {
								$text = ( $k == 0 ? 'Brochure' : 'Floor Plan '.$k );
								?>
                                <div class="pdf_link<?= $k == 0 ? ' brochure' : '' ?>">
									<?= $home->pdf_file_link($k, $text) ?>
                                </div>
								<?
							}
							if ($k == count($settings['homes_pdffilename']) - 1) {
								$k = 0;
							} else {
								$k++;
							}
						}
						?>
                    </div>
					<?
				}
			}

			?>
            <div class="buttons_wrapper d-none d-md-flex"><?
				if (($home->photos) && (count($home->photos) > 0) && !$show_carousel ) echo '<a href="#photo_gallery_section" title="Browse Photos" class="d-table d-sm-inline-block btn btn-yt2 listing_description_buttons">Browse Photos</a>';
				if ($home->videoembedurl != '' && $home->source==0) echo '<a href="#video_section" title="View Video" class="d-table d-sm-inline-block btn btn-yt2 listing_description_buttons">View Video</a>';
				if ($home->virtualtour != '' && $home->source==0) echo '<a href="#virtualtour_section" title="View Virtual Tour" class="d-table d-sm-inline-block btn btn-yt2 listing_description_buttons">Virtual Tour</a>';
				if ($home->virtualtour != '' && $home->source==1) echo '<a href="'.$home->virtualtour.'" title="View Virtual Tour" target="_blank" class="d-table d-sm-inline-block btn btn-yt2 listing_description_buttons">Virtual Tour</a>';
				?></div><?
			// show virtual tour as target="_blank" link for MLS reciprocity listings.
			// WE cannot be sure that they are embeddable iFrames - could be stand-alone webpages.
			// Also, hide on mobile - can't guarnatee they are flash-free, and on mobile we
			// definitely do not want to take users away from the main tab, easy to lose original site.

			// FAVORITE BUTTON / SHARE BUTTON
			// * Share button is on by default, not an addon anymore.
			// Both are separate add-ons. Enable them on template_variables.php
			// Also, dont forget to enable the addons scss files on layout.scss
			if ($is_favorite_button_enabled || $is_share_button_enabled) {
				?>
                <div class="feat_buttons_wrapper">
					<?
					if ( $is_favorite_button_enabled ) {
						global $visitor;

						$favorite_listings = $visitor->get_listing_history("favorite");
						$favorite_listings_ids = array_map(function ($listing) {
							return $listing['pid'];
						}, $favorite_listings);

						$is_favorite = in_array($home->id, $favorite_listings_ids);

						$fav_btn_text = ($is_favorite ? 'Remove' : 'Add').' Favourite';

						echo '<a id="fav_btn" class="btn btn-yt2 '.($is_favorite ? 'favorited' : '').'" title="'.$fav_btn_text.'">'.$fav_btn_text.'</a>';
					}

					if ( $is_share_button_enabled ) { ?>
                        <a href="#share_social_popup" class="fancybox_share btn btn-yt2" title="Share <?= $pagetitle ?>">Share</a>
					<? } ?>
                </div>
			<? } ?>

			<? if ( $is_share_popup_enabled ) { ?>
                <div style="display: none;">
					<? include $_SERVER['DOCUMENT_ROOT'] . '/templates/main/share_popup.php'; ?>
                </div>
			<? } ?>
        </div>

    </div>
</div>
